
local GameLoadingLayer = class("GameLoadingLayer", function(params)
    local label = cc.Layer:create()
    return label
end)

--[[**************************异步更新 声明 **************************
        异步更新在GameLoadingLayer界面中实现由于异步更新导致
        ！！！注意：异步更新中，可以清除游戏的缓存数据，如果是MAC
        模拟机，缓存数据存放在Documents目录下，如果清除缓存的话清
        除的数据为Documents目录中的 所有 内容，在清除缓存之前请确
        保Documents目录下文件的备份。如果是IOS模拟机，缓存数据存放
        在沙盒中，清除缓存是清除沙盒中的内容。
    **************************异步更新 声明 **************************]]
local BG_TAY = 1000

function GameLoadingLayer:create(params)
    return GameLoadingLayer.new(params)
end

function GameLoadingLayer:ctor( sParams )
    performWithDelay(self, function()
        self:init(sParams)
    end, 0.2)
end

function GameLoadingLayer:init(sParams)
    if APP_SERVER ~= 0 and (GAME_SDK == GAMESDK.SDK_ZHANYOU or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ
        or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_XM or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_360 
        or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_BD or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_HW
        or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_LX or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_OP
        or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_VV or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX
        or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_UC) then
        APP_SERVER = 1
    end
    
    if APP_SERVER == 2 then
        CHECK_TABLE_UPDATA = false
    end
    self._status = 0
    local params = sParams == nil and {} or sParams

    local _color = display.COLOR_WHITE
    local _flag = 1 -- 1qlzj, 2qlwz, 3jzws

    local _logoId = zc.getAndroidChangedPackageId() 
    if _logoId == 5 or _logoId == 6 then
        -- _flag = 2
        _flag = 1
    elseif _logoId == 10 or _logoId == 11 then
        _flag = 3
    end

    if APP_REVIEW then
        _flag = 2
    end

    -- 增加判断是各种android渠道的包，将logo改为青龙战纪
    -- if _logoId == 5 and (GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_XM 
    --     or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_360 
    --     or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_BD or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_HW
    --     or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_LX or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_OP
    --     or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_VV or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX
    --     or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_UC or GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ) then
    --     _flag = 1
    -- end

    -- _logoId = 6 的时候，全部变成青龙战纪
    -- if _logoId == 6 then
    --     _flag = 1
    -- end
    
    local _bgPath, _iconPath, _color
    if _flag == 1 then
        if zc.isGt() then
            _iconPath = "res/image/update/logo_qinglong_gt.png"
        else
            _iconPath = "res/image/update/logo_qinglong.png"
        end
    elseif _flag == 2 then
        _bgPath = "res/image/update/logo_qlwz.jpg"
        _iconPath = "res/image/update/logo_qlwz_icon.png"
        _color = cc.c3b(185,185,185)
    elseif _flag == 3 then
        _bgPath = "res/image/update/logo_jzws.jpg"
        _iconPath = "res/image/update/logo_jzws_icon.png"
    end
    if _bgPath then
        local logoSprite = zc.createSprite(_bgPath)
        logoSprite:setAnchorPoint(0.5, 0.5)
        logoSprite:setPosition(zc.width/2, zc.height/2)
        self:addChild(logoSprite)
        zc.setBgSize(logoSprite)
        logoSprite:setOpacity(0)
        logoSprite:runAction(cc.Sequence:create(cc.FadeIn:create(0.5)))
        logoSprite:setCascadeOpacityEnabled(true)
        self._logoSprite = logoSprite
    end

    local logoIcon = zc.createSprite(_iconPath)
    logoIcon:setAnchorPoint(0.5, 0.5)
    logoIcon:setPosition(zc.width/2, zc.height/2 + 100)
    if _flag == 3 then
        logoIcon:setPosition(zc.width/2, zc.height/2)
    else
        logoIcon:setPosition(zc.width/2, zc.height/2 + 100)
    end
    self:addChild(logoIcon)
    logoIcon:setOpacity(0)
    logoIcon:runAction(cc.Sequence:create(cc.FadeIn:create(0.5)))
    self._logoIcon = logoIcon
   
    if not zc.isGt() then
        local _label = zc.createLabel({
            text = LANGUAGE_GAME_EIGHT_WORDS.title,
            pos = cc.p(zc.width/2, zc.height/2 - 140),
            size = 22,
            color = _color,
        })
        _label:setOpacity(0)
        _label:runAction(cc.Sequence:create(cc.FadeIn:create(0.5)))
        self:addChild(_label)
        self._label1 = _label
        local _label = zc.createLabel({
            text = LANGUAGE_GAME_EIGHT_WORDS.desc,
            pos = cc.p(zc.width/2, zc.height/2 - 200),
            size = 22,
            color = _color,
        })
        _label:setOpacity(0)
        _label:runAction(cc.Sequence:create(cc.FadeIn:create(0.5)))
        self:addChild(_label)
        self._label2 = _label
    end

    local function _doCheck()
        if not tolua.isnull(self._googleLayer) then
            self._googleLayer:removeFromParent()
        end
        self._googleLayer = nil
        self:doCheck(params)
    end

    -- local fileUtils = cc.FileUtils:getInstance()
    -- local cachedManifest = zc.getWritablePath() 
    -- if cc.FileUtils:getInstance():isFileExist(cachedManifest .. "res/project.manifest") then
    --     _doCheck()
    --     return
    -- end
    local _doStartLogic
     _doStartLogic =  function()
        if GAME_CHANNEL ~= CHANNEL.Android.CHANNEL_CODE_AD_GOOGLE then
            _doCheck()
            return
        end
        self._googleLayer = requires("src/TableLoadingLayer.lua"):create({
            par = self,
            onlyLoading = false,
            googleFlag = true,
            successCallback = function()
                _doCheck()
            end,
            failedCallback = function( noUpdate )
                local _noUpdate = tonumber(noUpdate) or 0
                if _noUpdate == 0 then
                    _doCheck()
                else
                    local _tip_ = _noUpdate == 1 and LANGUAGE_TIPS_WEBERROR or LANGUAGE_TIPS_UPDATEERROR
                    local comfirm = ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        msg = _tip_,
                        showDi = true,
                        isHide = false,
                        leftVisible = false,
                        rightText = zc.lang("retry_2"),
                        rightCallback = function()
                            if not tolua.isnull(self._checkComfirm) then
                                self._checkComfirm:removeFromParent()
                            end
                            self._checkComfirm = nil
                            performWithDelay(self, _doStartLogic, 0.3)
                        end
                    })
                    comfirm:getCloseButton():removeFromParent()
                    comfirm:getContainerLayer():setTouchEndedCallback(function() end)
                    self:addChild(comfirm, 11)
                    self._checkComfirm = comfirm
                end
            end
        })
    end
    
    local function _checkNetWork()
        if cc.Application:getInstance():getTargetPlatform() ~= cc.PLATFORM_OS_ANDROID then 
            local _network = requires("src/framework/network.lua")
            local _netWorkStatus = _network.getInternetConnectionStatus()
            print("wm---_netWorkStatus : ", _netWorkStatus)
            if _netWorkStatus == 0 then
                return false
            end
        end
        if not tolua.isnull(self._checkComfirm) then
            self._checkComfirm:removeFromParent()
        end
        self._checkComfirm = nil
        _doStartLogic()
        return true
    end

    if not _checkNetWork() then
        local comfirm = ZCConfirmDialog:createWithParams({
            title = zc.lang("prompt"),
            msg = zc.lang("tips_network_not_reachable"),
            showDi = true,
            isHide = false,
            leftVisible = false,
            rightText = zc.lang("retry_2"),
            rightCallback = function()
                _checkNetWork()
            end
        })
        comfirm:getCloseButton():removeFromParent()
        comfirm:getContainerLayer():setTouchEndedCallback(function() end)
        self:addChild(comfirm, 11)
        self._checkComfirm = comfirm
    end

end

function GameLoadingLayer:doCheck(params)
    self._lastTime = os.time()
    local function _goCheckUpdate()
        if CHECK_UPDATA and params.checkDatas then
            self:showAnnouncement(params.checkDatas)
        elseif CHECK_UPDATA then
            self:checkUpdate()
        else
            self:switchScene()
        end
    end
    local function _failCall( status )
        if cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_ANDROID then
            APPSTORE_REVIEW = false
        end
        if APPSTORE_REVIEW or status == 0 then
            CHECK_UPDATA = false
        elseif cc.Application:getInstance():getTargetPlatform() ~= cc.PLATFORM_OS_ANDROID then
            local comfirm = ZCConfirmDialog:createWithParams({
                title = zc.lang("prompt"),
                msg = LANGUAGE_TIPS_WEBERROR,
                showDi = true,
                leftVisible = false,
                rightText = zc.lang("retry_2"),
                rightCallback = function()
                    self:doCheck(params)
                end
            })
            comfirm:getCloseButton():removeFromParent()
            comfirm:getContainerLayer():setTouchEndedCallback(function() end)
            self:addChild(comfirm, 11)
            return
        else
            CHECK_UPDATA = true
        end

        _goCheckUpdate()
    end

    local _delayTime = APP_REVIEW and 6 or 2
    performWithDelay(self, function()
        local _id = zc.getChannelPackageId()
        if APP_REVIEW or _id == 0 or APP_SERVER == 0 then
            if APP_REVIEW then
                APPSTORE_REVIEW = false
                CHECK_UPDATA = false
            end
            if APP_SERVER == 2 then
                APPSTORE_REVIEW = false
            end 
            if APP_SERVER == 0 then
                APPSTORE_REVIEW = false
            end
            _goCheckUpdate()
            return
        end
        local _gameUrl = zc.config.server.url_server_list
        if APP_REVIEW then
            _gameUrl = zc.config.server.url_server_listReview
        elseif APP_SERVER == 0 then
            _gameUrl = zc.config.server.url_server_listDev
        end
        local _version = tostring(PACKAGE_VERSION) or "0.1"
        local _checkParams = {
            url = _gameUrl,
            postData = ("op=3&id=" .. _id .. "&version=" .. _version),
            successCallback = function(result)
                local _result = result or {}
                _result = result.data or {}
                local _status = tonumber(_result.update) or 0
                local _inReview = tonumber(_result.inReview) or 0
                APPSTORE_REVIEW = _inReview == 1 and true or false
                print("wm----_inReview : ", _inReview, " , ", _status)
                if _status == 1 then
                    CHECK_UPDATA = true
                    _goCheckUpdate()
                elseif _status == 2 then
                    print("wxm----_version=".._version)
                    local _notice = _result.notice or ""
                    local _tipStr = _notice == "" and zc.lang("tips_game_version_low") or _notice
                    local comfirm =  ZCConfirmDialog:createWithParams({
                        title = zc.lang("prompt"),
                        msg = _tipStr,
                        showDi = true,
                        isHide = false,
                        leftVisible = false,
                        rightCallback = function()
                            local _url = _result.updateURL
                            if _url ~= "" and string.len(_url) ~= 0 then
                                cc.Application:getInstance():openURL(_url)
                            end
                            if cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_ANDROID then
                                zc.doSdkExit(function()
                                    cc.Director:getInstance():endToLua()
                                    comfirm = nil
                                end)
                            end
                        end
                    })
                    comfirm:getContainerLayer():setTouchEndedCallback(function() end)
                    comfirm:getCloseButton():removeFromParent()
                    self:addChild(comfirm, 11)
                else
                    _failCall(_status)
                end
            end,
            failedCallback = function()
                _failCall()
            end,
            errorCallback = function()
                _failCall()
            end,
            targetNeedsToRetain = self,
            loadingParent = self,
        }
        ZCHttp:requestAsyncWithParams(_checkParams)
    end, _delayTime)
end

function GameLoadingLayer:switchScene()
    local function _gotoLogin()
        do
            zc.gotoLogin()
            return
        end
        print("in gameing -------------------------------------- ")
        local function _doHide()
            if self._logoSprite then
                self._logoSprite:runAction(cc.Sequence:create(
                    cc.FadeOut:create(0.2),
                    cc.RemoveSelf:create(true)))
            end
            self._logoIcon:runAction(cc.Sequence:create(
                cc.FadeOut:create(0.2),
                cc.CallFunc:create(function()
                    zc.gotoLogin()
                end),
                cc.RemoveSelf:create(true)))
            if self._label1 then
                self._label1:runAction(cc.Sequence:create(
                    cc.FadeOut:create(0.2),
                    cc.RemoveSelf:create(true)))
            end
            if self._label2 then
                self._label2:runAction(cc.Sequence:create(
                    cc.FadeOut:create(0.2),
                    cc.RemoveSelf:create(true)))
            end
        end
        self:runAction(cc.Sequence:create(cc.DelayTime:create(1), cc.CallFunc:create(function()
            if (os.time() - self._lastTime) < 2 then
                performWithDelay(self, _doHide, 2 - (os.time() - self._lastTime))
            else
                _doHide()
            end
        end)))
    end

    if self._checkTable then
        zc.preLoadLogin(_gotoLogin)
        return
    end
    self._checkTable = true
    if CHECK_UPDATA and CHECK_TABLE_UPDATA then
        requires("src/TableLoadingLayer.lua"):create({
            par = self,
            onlyLoading = false,
            successCallback = function()
                zc.preLoadLogin(_gotoLogin)
            end,
            failedCallback = function()
                zc.preLoadLogin(_gotoLogin)
            end
        })
    else
        zc.preLoadLogin(_gotoLogin)
    end
end

--检查版本更新  hezhitao
function GameLoadingLayer:checkUpdate()
    print("－－－－－－－－checkUpdate")
    --解析本地Manifest文件
    local params = {
        par = self, 
        loadingType = HTTP_LOADING_TYPE.NONE,
        succCall = function( data )
            if tolua.isnull(self) then
                return
            end
            self:showAnnouncement(data)
        end, 
        failCall = function()
            if tolua.isnull(self) then
                return
            end
            self:switchScene()
        end
    }
    local manifest = zc.checkUpdate(params)
    if manifest == nil then
        return
    end
    
    local versionId = zc.createVersionBtn()
    self:addChild(versionId, 3)
end

function GameLoadingLayer:initUI()

    local width = cc.Director:getInstance():getWinSize().width
    local height = cc.Director:getInstance():getWinSize().height
    
    local bg = zc.createSprite("res/image/update/bg.jpg")
    -- bg:setContentSize(zc.visibleSize)
    bg:setPosition(zc.width/2, zc.height/2)
    zc.setBgSize(bg)
    self:addChild(bg)

    width = zc.visibleSize.width
    height = zc.visibleSize.height

    local bar_bg = zc.createSprite("res/image/update/barBg.png")
    bar_bg:setPosition(cc.p(zc.width / 2, 73))
    self:addChild(bar_bg)

    local loadingProgress = cc.ProgressTimer:create(cc.Sprite:create("res/image/update/bar.png"))
    loadingProgress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    loadingProgress:setMidpoint(cc.p(0, 0))
    loadingProgress:setBarChangeRate(cc.p(1, 0))
    loadingProgress:setPosition(cc.p(bar_bg:getContentSize().width / 2, bar_bg:getContentSize().height / 2))
    loadingProgress:setPercentage(0)
    bar_bg:addChild(loadingProgress)
    self._loadingProgress = loadingProgress

    --loading标签
    if not APP_REVIEW then
        local loading = zc.createSprite("res/image/update/LOADING.png")
        loading:setAnchorPoint(0.5, 0.5)
        loading:setPosition(zc.width/2, 50)
        self:addChild(loading)
    end
end
--显示最新版本信息提示页面
function GameLoadingLayer:showAnnouncement(data)

    self:initUI()
    -- dump(data, "data====")
    self._loadingProgress:setVisible(false)
    --创建提示层Layout
    local noticeLayout = cc.LayerColor:create(cc.c4b(0,0,0,150))
    noticeLayout:setTouchEnabled(true)
    noticeLayout:setAnchorPoint(cc.p(0, 0))
    noticeLayout:setPosition(cc.p(0, 0))
    noticeLayout:registerScriptTouchHandler(function ( eventType, x, y )
        if (eventType == "began") then
            return true
        end
    end)
    self:addChild(noticeLayout, BG_TAY)

    --增加提示背景框
    local bg = cc.Sprite:create("res/Main/common/popBg/popup_Bg_blue.png")
    bg:setPosition(cc.p(noticeLayout:getContentSize().width*0.5 , noticeLayout:getContentSize().height*0.5))
    noticeLayout:addChild(bg)
    
    -- 中间背景
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(bg:getContentSize().width*0.5, bg:getContentSize().height*0.5 + 30)
    middleBg:setName("middleBg")
    bg:addChild(middleBg)



    local bgWidth = bg:getContentSize().width
    local bgHeight = bg:getContentSize().height
    
    local paSize = ""
    --增加滚动控件
    local wm_test = true -- 添加scrollview与WebView方式的切换， addBy wangming 20150812
    if (wm_test and ccexp and ccexp.WebView) then
        local view = ccexp.WebView:create()
        local _size = cc.size(bgWidth - 130 * 2,bgHeight - 58 - 85)
        view:setContentSize(_size)
        view:setPosition(cc.p(bgWidth / 2, bgHeight - 58 - _size.height*0.5))
        view:setScalesPageToFit(true)
        -- view:loadURL("http://www.zol.com.cn")--直接加载地址显示

        -- html代码加载
        -- 添加项目对web view中直接加载loadHTMLString的支持，修改了GameLoadingLayer中得调用实例，替换了部分3.7版本代码进项目。
        -- 具体修改了包括cocos2dx底层c++代码 3个文件，libcocos2dx中得java代码 2个文件。
        -- 需要生效请重新编译，打底包，否则ios版本不能生效，安卓版本可能报错卡死（jni会error找不到方法）。
        
        local patchSize = ""
        --处理更新大小
        if data.patchsize ~= nil and data.patchsize > 0 then
            if data.patchsize > (1024 * 1024) then
                self._sizeNum = string.format("%.1f", data.patchsize / (1024 * 1024))
                patchSize = patchSize .. self._sizeNum .. " MB"
            else
                self._sizeNum = string.format("%.1f", data.patchsize / 1024)
                patchSize = patchSize .. self._sizeNum .. " KB"
            end
            paSize = patchSize
            patchSize = LANGUAGE_OTHER_TXTPACKAGESIZE .. patchSize 
        end

        -- local string = "<body style=\"font-size:50px\">Hello World" 
        --             .. "<img src=\"http://newpub.hanjiangsanguo.com/hj3.2/static/img/pop/tradepop_th.png\"/>"--网络图片资源
        --             .. "<img src=\"res/avatar/avatar_000.jpg\"/> </body>" -- 本地图片资源
        -- local _head = "<head><metahttp-equiv = \"charset=utf-8\"></head>"
        local string = "<body \"background-color\"=transparent>"..data.announcement.. "<br/><br/><font color=\"#25810F\">" .. patchSize.."</font></body>"
        local baseurl = "" -- 本地地址路径，可以不填写
        view:loadHTMLString(string, baseurl)--加载页面
        -- bg:addChild(view)
        -- self._webview = view
    else
        local _bgSize = bg:getContentSize()
        local _size = cc.size(_bgSize.width - 130 * 2, _bgSize.height- 58 - 85)
        local scrollView = ccui.ScrollView:create()
        scrollView:setAnchorPoint(0.5, 1)
        scrollView:setTouchEnabled(true)
        scrollView:setBounceEnabled(true)
        scrollView:setContentSize(_size)
        scrollView:setPosition(cc.p(_bgSize.width*0.5, _bgSize.height - 58))
        scrollView:setName("scrollView")

        bg:addChild(scrollView)
        local patchSize = ""
        --处理更新大小
        if data.patchsize ~= nil and data.patchsize > 0 then
            if data.patchsize > (1024 * 1024) then
                self._sizeNum = string.format("%.1f", data.patchsize / (1024 * 1024))
                patchSize = patchSize .. self._sizeNum .. " MB"
            else
                self._sizeNum = string.format("%.1f", data.patchsize / 1024)
                patchSize = patchSize .. self._sizeNum .. " KB"
            end
            paSize = patchSize
            patchSize = LANGUAGE_OTHER_TXTPACKAGESIZE .. patchSize 
        end

        --提示文字
        local announcement = ZCLabel:createWithParams({
            text = "\n" .. data.announcement .. "\n\n" .. patchSize,
            fontSize = 18,
            ttf = zc.getFont(1),
            color = cc.c3b(156, 240, 250),
            anchor = cc.p(0, 1)
        })
        announcement:setAnchorPoint(0, 1)
        announcement:setDimensions(_size.width - 20, 0)
        -- scrollView:addChild(announcement)
        local textHeight = announcement:getBoundingBox().height
        announcement:setDimensions(_size.width - 20, textHeight)

        local innerSize = cc.size(_size.width, _size.height + 10)
        if textHeight < _size.height then--文本高度小于背景高度
            scrollView:setInnerContainerSize(innerSize)
        else--文本高度大于背景高度
            innerSize.height = textHeight + 10
            scrollView:setInnerContainerSize(innerSize)
        end
        announcement:setPosition(10, innerSize.height)
    end
    print("paSize ----> ", paSize)

    local tipLab_1 = zc.createLabel({
        text = LANGUAGE_UPDATE_INFO.tip1,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(30, middleBg:getContentSize().height/2+10),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        -- align = kCCTextAlignmentCenter,
        pixel = 1.3,
        -- width = 375,
    })
    middleBg:addChild(tipLab_1)
    local tipLab_2 = zc.createLabel({
        text = paSize,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(tipLab_1:getPositionX() + tipLab_1:getContentSize().width + 5, tipLab_1:getPositionY()),
        color = zc.COLOR_YELLOW,
        color2 = display.COLOR_BLACK,
        -- align = kCCTextAlignmentCenter,
        pixel = 1.3,
        -- width = 375,
    })
    middleBg:addChild(tipLab_2)
    local tipLab_3 = zc.createLabel({
        text = LANGUAGE_UPDATE_INFO.tip2,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(tipLab_2:getPositionX() + tipLab_2:getContentSize().width + 5, tipLab_2:getPositionY()),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        -- align = kCCTextAlignmentCenter,
        pixel = 1.3,
        -- width = 375,
    })
    middleBg:addChild(tipLab_3)
    local tipLab_4 = zc.createLabel({
        text = LANGUAGE_UPDATE_INFO.tip3,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(tipLab_1:getPositionX(), tipLab_1:getPositionY()-30),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        -- align = kCCTextAlignmentCenter,
        pixel = 1.3,
        -- width = 375,
    })
    middleBg:addChild(tipLab_4)
    
    --
    local updateLab = zc.createLabel({
        text = LANGUAGE_UPDATE_INFO.tip4 .. " ",
        stroke = true,
        fontSize = 18,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(zc.width/2, 100),
        -- color = display.COLOR_WHITE, cc.c3b(62,196,209),
        color = cc.c3b(62,196,209),
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    self:addChild(updateLab)
    self._paSize = paSize
    local updateNumLab = zc.createLabel({
        text = "0/"..paSize,
        stroke = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(updateLab:getPositionX()+updateLab:getContentSize().width/2, 100),
        color = cc.c3b(62,196,209),
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    self:addChild(updateNumLab)
    self._updateNumLab = updateNumLab
    updateLab:setPositionX(zc.width/2-updateNumLab:getContentSize().width/2)
    updateNumLab:setPositionX(updateLab:getPositionX()+updateLab:getContentSize().width/2)
    

    local btnTitle = ""

    if tonumber(data.status) == 5 then   --status == 1 可以更新 ；status == 3已经是最新版本；status == 5强制更新
        btnTitle = LANGUAGE_UPDATE_INFO.tip5
    else
        btnTitle = LANGUAGE_UPDATE_INFO.tip6
    end

    local url_tab = nil
    local url = ""
    --[[
        注意：在管理平台上如果需要输入强制更新的链接，首先需要输入Android的链接，接着输入IOS的链接，两个链接之间用“;”分开，“;”用英文的
        输入格式为：  http://pre.im/gfcqios;http://pre.im/gfcqand
    ]]
    if data["addr"] ~= nil and string.len(data["addr"]) ~= 0 then
        url_tab = string.split(data["addr"],";")
    
        if (cc.PLATFORM_OS_ANDROID == ZC_targetPlatform) then
            url = url_tab[1]
        elseif (cc.PLATFORM_OS_IPHONE == ZC_targetPlatform) or (cc.PLATFORM_OS_IPAD == ZC_targetPlatform) or (cc.PLATFORM_OS_MAC == ZC_targetPlatform)  then
            -- url = "http://pre.im/gfcqios"
            url = url_tab[2]
        end
    end
    local confirmButton = zc.createCommomBtn({
        tag = 1,
        text = btnTitle,
        needSwallow = true,
        endCallback = function()
            print("data.status ========== ", data.status)

            if tonumber(data.status) == 1 then
                if (self._webview) then
                    self._webview:removeFromParent()
                    self._webview = nil
                end
                noticeLayout:setVisible(false)
                self:updateLua()
            elseif tonumber(data.status) == 5 then
                if url ~= "" and string.len(url) ~= 0 then
                    cc.Application:getInstance():openURL(url)
                    --用户一旦选择强制更新，则删除本地缓存数据
                    cc.FileUtils:getInstance():removeDirectory(zc.getWritablePath())
                end
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(bgWidth / 2, 70)
    })
    

    bg:addChild(confirmButton)

end

function GameLoadingLayer:updateLua()
    local _localFile = "src/project.manifest"
    local am = cc.AssetsManagerEx:create(_localFile, zc.getWritablePath())
    am:setPackageUrl(self._status)
    am:retain()

    local listener = nil
    local function _goNormalGo()
        if listener then
            cc.Director:getInstance():getEventDispatcher():removeEventListener(listener)
        end
        am:release()
        local isTryAgain = false
        if self._status ~= 1 then
            self._status = 1 
            isTryAgain = true
        end
        if isTryAgain then
            performWithDelay(self, function()
                self:updateLua()
            end, 0.1)
        else
            self:switchScene()
        end
    end
    self._loadingProgress:setVisible(true)
    local loadingProgressInAction = false
    if not am:getLocalManifest():isLoaded() then
        self._status = 1 
       _goNormalGo()
    else
        local function onUpdateEvent(event)
            local eventCode = event:getEventCode()
            if eventCode == cc.EventAssetsManagerEx.EventCode.ERROR_NO_LOCAL_MANIFEST
              or eventCode == cc.EventAssetsManagerEx.EventCode.ERROR_DOWNLOAD_MANIFEST
              or eventCode == cc.EventAssetsManagerEx.EventCode.ERROR_PARSE_MANIFEST 
              or eventCode == cc.EventAssetsManagerEx.EventCode.ERROR_UPDATING 
              or eventCode == cc.EventAssetsManagerEx.EventCode.ERROR_DECOMPRESS
              or eventCode == cc.EventAssetsManagerEx.EventCode.UPDATE_FAILED
              then
                print("更新出错["..tostring(eventCode).."],event:getCURLECode()=["..event:getCURLECode().."],event:getCURLMCode()=["..event:getCURLMCode().."],event:getMessage()=["..tostring(event:getMessage()).."]")
                _goNormalGo()

            elseif  eventCode == cc.EventAssetsManagerEx.EventCode.UPDATE_PROGRESSION then
                local assetId = event:getAssetId()
                local percent = event:getPercent()

                if assetId ~= cc.AssetsManagerExStatic.VERSION_ID and assetId ~= cc.AssetsManagerExStatic.MANIFEST_ID then
                    if loadingProgressInAction == false then
                        cc.Director:getInstance():getActionManager():removeAllActionsFromTarget(self._loadingProgress)
                        loadingProgressInAction = true
                    end
                    self._loadingProgress:setPercentage(tonumber(percent))
                    local nowSize = string.format("%.1f", tonumber(percent)/100*tonumber(self._sizeNum))
                    self._updateNumLab:setText(nowSize.."/"..self._paSize)
                    
                    if percent > 99 then
                        cc.Director:getInstance():getActionManager():removeAllActionsFromTarget(self._loadingProgress)
                        self._loadingProgress:setPercentage(100)
                        self._updateNumLab:setText(self._sizeNum.."/"..self._paSize)
                    end
                end
            elseif eventCode == cc.EventAssetsManagerEx.EventCode.ALREADY_UP_TO_DATE or
                eventCode == cc.EventAssetsManagerEx.EventCode.UPDATE_FINISHED then
                print("更新完成")
                am:release()
                helper.reloadAllFile()
                requires("src/main.lua")
            else
                print("*******************更新未完成["..tostring(eventCode).."],event:getCURLECode()=["..event:getCURLECode().."],event:getCURLMCode()=["..event:getCURLMCode().."],event:getMessage()=["..tostring(event:getMessage()).."]")
            end
        end

        listener = cc.EventListenerAssetsManagerEx:create(am,onUpdateEvent)
        cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)

        am:update()
    end
end

return GameLoadingLayer




