--[[
    核心数据对象：用户信息
    全局静态数据表对象为 
]]

PlayerData = nil



local Player = class("Player")
function Player:ctor()

    -- 在这里定义Player里的属性
    -- 玩家资料信息
    self.info = {}
    --布阵信息
    self.formationsinfo = {}
    --武将信息
	self.generalinfo = {}
	--地域羁绊信息
	self._fetterRegionalInfo = {}
	--背包信息
    self.baginfo = {}
    --副本信息
    self.copyinfo = {}
    --建筑
    self.houseinfo = {}
    --资源
    self.resourcesInfo = {}
    --饰品信息
    self.trinketsInfo = {}
    --兵器信息
    self.weapons = {}
    --兵器成就
    self.weaponsBook = {}
    --最近聊天信息
    self.chatDataInfo = {}
    -- 次数信息
    self.limitInfo = {}
    --未读邮件数量
    self.unReadMailNum = 0
    --好友信息
    self.friendInfo = {}
    -- 活动开启状态信息
    self.activeInfo = {}
    -- 七日活动开启状态
    self._sevenDayStatus = 0
    self._secondDayStatus = 0
    -- 装备
    self.equipinfo = {}
    -- 宝石
    self.gemInfo = {}
    self.arenaChampionInfo = {}
    -- session
    self.session = nil
    self.authkey = nil

    --服务器时间
    self.time = nil
    self.timediff = nil--时间差    
    --服务器信息
    self.serverInfo = {}

    --服务器id
    self.serverId = nil

    self.activityReds = {}

    --国家抢矿信息
    self._countryMineInfo = {}
    --武将碎片
    self._fragmentList = {}
    self._cardExtrData = {}
    self._heroSoul = {}

    --红点状态。
    self.redDotList = {}

    self.heroTrain = {}
    -- 限时热点信息
    self.activeEntrance2 = {}
    self.HeroCopyDetailPop = true
    self.targetFromSever = 0
    -- 猜拳
    self.intergral = 0
    self.guessingGameTicket = 0
end


--全部信息
function Player:setAllInfo(info)
	-- dump(info,"++++++++++++")
	-- 玩家资料信息
	self:setBaseInfo(info["base"])
	--红点数据
	self:setRedDotData(info["redDot"])
	--武将信息
	self:setGeneralInfo(info["heros"])
	--武将信息
	self:setFettersRegionalInfo(info["mapGroup"])
	--任务信息
	self:setTaskData(info["taskList"])
	--背包信息
	self:setBagInfo(info["items"])
    --副本信息
	self:setCopyInfo(info["chapters"])
    --精英副本购买信息
	self:setEliteBuyInfo(info["eliteTollgate"])
	--玩家资源信息
	self:setResourcesInfo(info["resources"])
	--建筑
	self:setHouseInfo(info["houses"])
	--饰品信息
	self:setTrinketsInfo(info["trinkets"])
	--兵器信息
	self:setWeaponsInfo(info["weapons"])
	-- 装备信息
	self:setEquipsInfo(info["equipments"])
	-- 宝石信息
	self:setGemInfo(info["gems"])
	--布阵信息
	self:setFormationsInfo(info["formations"])
	--聊天信息
	self:setChatDataInfo(info["chats"])
	--未读邮件数量
	self:setUnReadMailNum(info["unReadMailNum"])
	-- 次数信息
	self:setLimitInfo(info["limitInfo"])
	--好友信息
	self:setFriendInfo(info["friendInfo"])
	--公告信息
	self:setAnnouncement(info["announcements"])
	-- 活动信息
	self:setActivityInfo(info["activeInfo"])
	-- 七日活动开启状态
	self:setSevenDayStatus(info["sevenDay"])
	self:setSecondDaySignStatus(info["signStatus"])
   	self:setFreeLeyv(info.freeLeyv)
   	-- 恢复体力
   	self:energyRecovery(true)

   	self:setArenaTime(info["arenaTime"])
    -- 商店气泡
    self:initShopCanDo( info["houseShop"] )
    -- 校场气泡
    self:setDrillFieldCanDo( info["training"] )
    -- 初始显示信息气泡
    self:setArenaChampionInfo( info["arenaChampion"] )
    -- 武将列表
    self:setFragmentList( info["heroFragmentList"] )
    -- 将魂
	self:setHeroSoul(info["heroSoul"])

	-- 英雄试炼副本
	self:setHeroTrain(info["heroTrain"])

	-- 限时热点
	self:setActiveEntrance2(info["activeEntrance2"])
	-- print("setRedDotData ...")
	-- dump(info["redDot"])
	self:setRedDotData(info["redDot"])

    -- 气泡数据
	self:setDataBubble(info["bubbleData"])

	self:freshCardExtrData(info["nextDrawHeroFreeTime"] )

	self:setUserServerId(info["serverId"])

    -- 开始气泡计时器，在各气泡数据初始化完成之后开始计时
	self:startBubbleTimer()

   	--通用数据设置和检查
   	self:setPublicDat() 

   	local _timeData = gameData.getDataFromCacheWithPrimaryKey("vip", 19)
   	BATTLE_SUPERSKIP_VIP = tonumber(_timeData["vip"..PlayerData.info.vip]) or 0
   	-- getGuideManager():setCurrentGID(GuideKey.KEY_OVER)
   	-- 目标活动
   	-- dump(info.targetFromSever)
   	self.targetFromSever = info.targetFromSever.status
   	self.taskId = info.targetFromSever.taskId

   	-- 分享
   	self:setShareReceived(info["shareReceived"])
end

function Player:setShareReceived( data )
	self.shareReceived = data
end
function Player:setActiveEntrance2(data)
	self.activeEntrance2 = data
end

function Player:getActiveEntrance2()
	-- dump(self.activeEntrance2)
	local sign = false
	if self.activeEntrance2 then
		local active = {}
		for k,v in pairs(self.activeEntrance2) do
			if v then
				local entrance = tonumber(v.entrance)
				if entrance == 2 then
					table.insert(active,v)
				end
			end
		end
		if #active == 0 then
			return false
		end
		table.sort(active,function (a,b)
			if not a or not b then return end
            local timea = tonumber(a.endTime)
            local timeb = tonumber(b.endTime)
            return timea > timeb
        end)
		-- dump(active)
		local endtime = tonumber(PlayerData:getTssTime())
		-- print("endtime:",endtime)
		local time = active[1]
		local time_distance
		if time then
			time_distance = tonumber(time.endTime) - endtime
			print("endtime:",endtime,"time_distance:",time_distance)
			if time_distance > 0 then
				sign = true
			else
				sign = false
			end
		end
		return sign,time_distance
	end
end

function Player:setCreateTime( time )
	self._createTime = time
end

function Player:getCreateTime()
	return self._createTime
end

function Player:setTssTime( time )
	self._tssTime = time
end

function Player:getTssTime()
	return self._tssTime
end

--通用数据设置和检查
function Player:setPublicDat()
	--设置游戏主角
	self:setMainRole()
	--判断当前神兵是否可以强化、进阶、升级
	self:checkGodWeaponRedDotState()
	--设置兵器铺数据
	self:setWeaponsBook()
	--计算获得体力的数量
	self:calcFriendSendEnergyNum()
end

--设置扫荡次数选择状态
function Player:setCopySweepSelectTimes(_state)
	self._copySweepSelectTimes = _state
end
--获取扫荡次数选择
function Player:getCopySweepSelectTimes(_state)
	return self._copySweepSelectTimes
end
--设置游戏主角
function Player:setMainRole()
	print("BATTLE_NOW_MAINROLE --------> ", BATTLE_NOW_MAINROLE)
	local baseInfo = self:getBaseInfo()
	local _roleId = baseInfo["heroId"]
	local _nowRoleWeapon = self:getWeaponsInfoById(_roleId)
	local _roleWeapon = gameData.getDataFromCacheWithPrimaryKey("weapon", _nowRoleWeapon["weaponId"])
	--{"长柄","钝器","法杖","剑","扇子","法球"}
	local _typeToRole = {
		[1]={
			[1]="nanzhu",[2]="",[3]="",[4]="",[5]="nanzhu_shan",[6]=""
		},
		[2]={
			[1]="nvzhuqiang",[2]="",[3]="",[4]="",[5]="nvzhujue",[6]=""
		}
	}
	local _sexId = tonumber(baseInfo["seigniorId"]) or 1
	local _weaponType = tonumber(_roleWeapon["type"]) or 1
	local _nowRole = _typeToRole[_sexId][_weaponType]
	BATTLE_NOW_MAINROLE = _nowRole or "nanzhu"
	print("BATTLE_NOW_MAINROLE --------> ", BATTLE_NOW_MAINROLE)
end

function Player:getMainRoleHeadImg()
	local modelToImg = {
		["nanzhu"] = {head="res/Main/hero/head/hero_head_101.png",body="res/Main/hero/body/101.png",list="res/Main/hero/list/101.png",headId=101},
		["nanzhu_shan"] = {head="res/Main/hero/head/hero_head_103.png",body="res/Main/hero/body/103.png",list="res/Main/hero/list/103.png",headId=103},
		["nvzhuqiang"] = {head="res/Main/hero/head/hero_head_104.png",body="res/Main/hero/body/104.png",list="res/Main/hero/list/104.png",headId=104},
		["nvzhujue"] = {head="res/Main/hero/head/hero_head_102.png",body="res/Main/hero/body/102.png",list="res/Main/hero/list/102.png",headId=102},
	}
	local _head = modelToImg[BATTLE_NOW_MAINROLE]["head"]
	local _body = modelToImg[BATTLE_NOW_MAINROLE]["body"]
	local _list = modelToImg[BATTLE_NOW_MAINROLE]["list"]
	local _headId = modelToImg[BATTLE_NOW_MAINROLE]["headId"]
	return _head,_body,_list,_headId
end

function Player:setServerInfo(info)
	local info = info or {}
	self.serverInfo["serverName"] = info["serverName"] or ""
	self.serverInfo["serverId"]   = info["serverId"] or ""
	self.serverInfo["token"]      = info["token"] or ""
	self.serverInfo["tab"]      = info["tab"] or ""
end
function Player:getServerInfo(info)
	return self.serverInfo
end
function Player:updateLiveness(data)
    if data ~= nil then
        if data.active_info ~= nil then
            self.liveness = data.active_info
        end
        if data.active_new then
        end
    end
end
--[[
基本信息
]]
function Player:setBaseInfo(info)
    self.info = info
	-- 服务器时间
	self:setTime(info["now"])
    -- 主城大气泡
    self:setMainBubble( info["bubble"] )
end
function Player:getBaseInfo()
	return self.info
end

function Player:setUserServerId(info)
	self.serverId = tonumber(info)
end

function Player:getUserServerId()
	return self.serverId
end

function Player:setAnnouncement(info)
    self.announcement = info
end
function Player:getAnnouncement()
	return self.announcement
end
function Player:setBaseInfoByTag(tag, newvalue)
    self.info[tag] = newvalue
end
function Player:getBaseInfoByTag(tag)
	return self.info[tag]
end

function Player:updatePayInfo( idx, num )
	local _idx = tonumber(idx) or 0
	local _num = tonumber(num) or 1
    local _payInfo = PlayerData:getBaseInfoByTag("firstPayGold") or {}
    if type(_payInfo) ~= "table" then
        _payInfo = {}
    end
    local _num2 = tonumber(_payInfo[tostring(_idx)]) or 0
    _payInfo[tostring(_idx)] = _num2 + _num
    self.info["firstPayGold"] = _payInfo
end

function Player:getUserLevel()
	local _level = self:getBaseInfoByTag("level")
	_level = tonumber(_level) or 1
	return _level
end

function Player:setSkilful( data )
	self.info["skilful"] = data
	self:getSkilfulAddInfo(true)
end
--获取武器熟练度属性加成
function Player:getSkilfulAddInfo(isForce)
	if not self._addSkilfulData or isForce then
		self._addSkilfulData = {}
		local _data = self.info["skilful"] or {}
		-- dump(_data, self.info["skilful"])
		self._addSkilfulData[1] = {} --基础属性
		for i=1,3 do
			local _skilful = gameData.getDataFromCache("skilful", {effect = i, level = _data["lv"..i]} )
			-- local _skilfulDatas = gameData.getDataFromCache("skilful", {effect = i})
			-- table.sort(_skilfulDatas, function(a, b)
			-- 	return a.id < b.id
			-- end)
			-- local _skilful = _skilfulDatas[_data["lv"..i]] or {}
			if _skilful.effectType and _skilful.effectValue then
				self._addSkilfulData[1][_skilful.effectType] = tonumber(_skilful.effectValue) or 0
			end
		end
		self._addSkilfulData[2] = {} --附加属性
		for i=4,6 do
			local _skilful = gameData.getDataFromCache("skilful", {effect = i, level = _data["lv"..i]} )
			-- local _skilfulDatas = gameData.getDataFromCache("skilful", {effect = i})
			-- table.sort(_skilfulDatas, function(a, b)
			-- 	return a.id < b.id
			-- end)
			-- local _skilful = _skilfulDatas[_data["lv"..i]] or {}
			if _skilful.effectType and _skilful.effectValue then
				self._addSkilfulData[2][_skilful.effectType] = tonumber(_skilful.effectValue) or 0
			end
		end
	end
	-- dump(self._addSkilfulData, "wm---self._addSkilfulData")
	return self._addSkilfulData
end
-- 根据属性类型和id查询熟练度加成, (quality后面加的参数，武器的附加属性根据武器的品质有加成比，品质高的加成比高)
function Player:getSkilfulAddInfoByEffectId( type, effectType, quality )
	local _addSkilfulData = self:getSkilfulAddInfo()
	local _type = tonumber(type) or 0
	local _quality = tonumber(quality) or 1
    local _skilfulLevelInfo = gameData.getDataFromCacheWithPrimaryKey("skilfulLevel", _quality) or {}
    local _skilfulAdd = tonumber(_skilfulLevelInfo["income"]) or 0

	local _effectType = tonumber( effectType ) or 0
	if _effectType == 6 or _effectType == 10 then
        _effectType = 30
    elseif _effectType == 8 or _effectType == 12 then
        _effectType = 31
    end
	if _type == 1 then
		-- 基础属性
		return math.floor( (tonumber(_addSkilfulData[1][_effectType]) or 0 ) *_skilfulAdd/100 ) or 0
	elseif _type == 2 then
		-- 附加属性
		return math.floor( (tonumber(_addSkilfulData[2][_effectType]) or 0 ) *_skilfulAdd/100 ) or 0
	end
	return 0
end

--设置功能引导完成
function Player:setFuncGuideInfo(_id)
	if type(self.info.functionsSteps) == "table" then
		table.insert(self.info.functionsSteps,_id)
	else
		self.info.functionsSteps = {}
		table.insert(self.info.functionsSteps,_id)
	end
end

--获取功能引导是否完成
function Player:getFuncGuideInfo(_id)
	if type(self.info.functionsSteps) == "table" then
		for k,v in pairs(self.info.functionsSteps) do
			if v == _id then
				return true
			end
		end
	end
	return false
end

--[[
	好友信息
]]
function Player:setFriendInfo(info, tag)
	if not info then
		return
	end
	if tag then
		if tag == "blacklists" then --黑名单
			self.friendInfo["blacklists"] = info
		elseif tag == "friends" then --好友
			self.friendInfo["friends"] = info
		elseif tag == "pendings" then --申请
			self.friendInfo["pendings"] = info
		end
	else
		self.friendInfo = info
	end
	--分发消息
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "friend"}})
end
function Player:addFriendInfoByTag(_info, tag)
	local function checkAlreadyHave(_finfo, _uid)
		local _finfo = _finfo or {}
		for k,v in pairs(_finfo) do
			if v and v.userId then
				if tonumber(_uid) and tonumber(_uid) == tonumber(v.userId) then
					return true
				end
			end
		end
		return false
	end
	if _info and tag then
		if tag == "blacklists" then --黑名单
			if not checkAlreadyHave(self.friendInfo["blacklists"], _info.userId) then
				self.friendInfo["blacklists"][#self.friendInfo["blacklists"]+1] = _info
			end
		elseif tag == "friends" then --好友
			if not checkAlreadyHave(self.friendInfo["friends"], _info.userId) then
				self.friendInfo["friends"][#self.friendInfo["friends"]+1] = _info
			end
		elseif tag == "pendings" then --申请
			if not checkAlreadyHave(self.friendInfo["pendings"], _info.userId) then
				self.friendInfo["pendings"][#self.friendInfo["pendings"]+1] = _info
			end
		end
	end
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "friend"}})
end
function Player:deleteFriendInfoById(_userId, tag)
	local friendInfo = {}
	if tag then
		if tag == "blacklists" then --黑名单
			friendInfo = self.friendInfo["blacklists"]
		elseif tag == "friends" then --好友
			friendInfo = self.friendInfo["friends"]
		elseif tag == "pendings" then --申请
			friendInfo = self.friendInfo["pendings"]
		end
	end
	for i = 1, #friendInfo do
		if tonumber(_userId) == tonumber(friendInfo[i]["userId"]) then
			table.remove(friendInfo,i)
			break
		end
	end
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "friend"}})
end
function Player:getFriendInfo()
	return self.friendInfo
end
--刷新好友信息
function Player:updateFriendInfoByType(_data, _type)
    if _data and _data.userId and _type then
        local friendInfo = PlayerData:getFriendInfo()
        local friends = friendInfo[_type] or {}
        for i = 1, #friends do
            local v = friends[i]
            if tonumber(v.userId) == tonumber(_data.userId) then
                for m,n in pairs(_data) do
                    v[m] = _data[m]
                end
                break
            end
        end
    end
end
--好友送的体力数量
function Player:calcFriendSendEnergyNum()
	local friends = self.friendInfo["friends"] or {}
	self._friendSendEnergyNum = 0
	for i = 1, #friends do
		local v = friends[i]
		if v and tonumber(v.getEnergyStatus) and tonumber(v.getEnergyStatus) == 1 then
			self:addFriendSendEnergyNum(1)
		end
	end
end
function Player:addFriendSendEnergyNum(_num)
	self._friendSendEnergyNum = self._friendSendEnergyNum + _num
end
function Player:getFriendSendEnergyNum()
	return self._friendSendEnergyNum or 0
end
--国家信息
function Player:setCountryInfo(_data)
	self.countryInfo = _data 
end

function Player:getCountryInfo()
	return self.countryInfo
end


--聊天信息
function Player:setChatDataInfo(info)
	self.chatDataInfo = info
end
function Player:getChatDataInfo()
	return self.chatDataInfo
end

--未读邮件
function Player:setUnReadMailNum(info)
	self.unReadMailNum = info
	--分发消息
    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "mail"}})
end
function Player:getUnReadMailNum()
	return tonumber(self.unReadMailNum) or 0
end

--[[
饰品信息
]]
function Player:setTrinketsInfo(info)
	self.trinketsInfo = info
end
--获取饰品信息
function Player:getTrinketsInfo(info)
	return self.trinketsInfo 
end
--更新饰品状态
function Player:updateTrinketStatus(id,status)
	for k,v in pairs(self.trinketsInfo) do
		if tonumber(v.id) == tonumber(id) then
			self.trinketsInfo[k]["status"] = status
		end
	end
end
--洗练更新饰品信息
function Player:updateTrinketsInfo(id,data)
	for k,v in pairs(self.trinketsInfo) do
		if tonumber(v.id) == tonumber(id) then
			local str_color = "effectColor" .. data.targetIndx
			local str_value = "effectValue" .. data.targetIndx
			local str_id = "effectId" .. data.targetIndx
			self.trinketsInfo[k][str_color] = data.effectColor
			self.trinketsInfo[k][str_value] = data.effectValue
			self.trinketsInfo[k][str_id] = data.effectId
		end
	end
end
--转移更新饰品信息
function Player:updateTrinketsTransferInfo(curItem,item)
	--找到这两个要交换的饰品的idx
	for k,v in pairs(self.trinketsInfo) do
		if tonumber(v.id) == tonumber(curItem.id) then
			_original_key = k
		end
		if tonumber(v.id) == tonumber(item.id) then
			_new_key = k
		end 
	end
	--交换值
	local function exchange(_title)
		for i = 1, 6 do
			local _str = _title..i
			local _temp = self.trinketsInfo[_original_key][_str]
			self.trinketsInfo[_original_key][_str] = self.trinketsInfo[_new_key][_str]
			self.trinketsInfo[_new_key][_str] = _temp
		end
	end
	exchange("effectId") 	 	-- effectId1~effectId6
	exchange("effectColor")		-- effectColor1~effectColor6
	exchange("effectValue")		-- effectValue1~effectValue6
end
--饰品减少
function Player:subTrinketsInfo(id)
	for k,v in pairs(self.trinketsInfo) do
		if tonumber(v.id) == tonumber(id) then
			table.remove(self.trinketsInfo,k)
		end
	end
end
--饰品获得
function Player:addTrinketsInfo(data)
	table.insert(self.trinketsInfo,data)
end


--[[
布阵信息
]]
function Player:setFormationsInfo(info)
    self.formationsinfo = {}
    local formationInfo = gameData.getDataFromCache("formation")
    for k,v in pairs(formationInfo) do
    	self.formationsinfo[#self.formationsinfo+1] = v
    end
    local function getInfoByFormationId(formationId)
    	for i=1,#info do
    		if tonumber(formationId) == tonumber(info[i]["formationId"]) then 
    			return info[i]
    		end
    	end
    	return nil
    end
    local normalFormationsinfo = {id=0,status=0,level=1,needGold=0,location1="0",
									location2="0",location3="0",location4="0",location5="0",
									location6="0",location7="0",location8="0",location9="0",}
    for k,v in pairs(self.formationsinfo) do
    	local FormationsInfo = getInfoByFormationId(v.id)
    	if FormationsInfo ~= nil then 
	    	for key,value in pairs(FormationsInfo) do
	    		v[key] = value
	    	end
	    	v["open"] = 1--能布阵
	    else
			for key,value in pairs(normalFormationsinfo) do
				if key == "id" then 
					v.formationId = v.id
					v.id = value
				else
		    		v[key] = value
		    	end
	    	end
	    	v["open"] = 0--不能布阵
	    end
	    v.map = self:getFormationsMap(v.formationId)
    end
    -- table.sort(self.formationsinfo,function(a,b)
        -- local qQuanzhi = tonumber(a["needVip"])*100 + tonumber(a["needLevel"])
        -- local bQuanzhi = tonumber(b["needVip"])*100 + tonumber(b["needLevel"])
        -- return qQuanzhi < bQuanzhi 
    --     return tonumber(a.formationId) < tonumber(b.formationId) 
    -- end)

    --将阵法上的武将保存到文件中，在登录游戏的时候异步加载
    self:saveFormationsMapToFile()
    --阵法排序
    self:sortFormations()
end
function Player:sortFormations()
    table.sort(self.formationsinfo, function(a,b)
        if tonumber(a.open) ~= tonumber(b.open) then
            return tonumber(a.open) > tonumber(b.open)
        else
            if tonumber(a.needVip) ~= tonumber(b.needVip) then
                return tonumber(a.needVip) < tonumber(b.needVip)
            else
            	if tonumber(a.needLevel) ~= tonumber(b.needLevel) then
                	return tonumber(a.needLevel) < tonumber(b.needLevel)
                else
                	return tonumber(a.formationId) < tonumber(b.formationId)
                end
            end
        end
    end)
end

function Player:saveFormationsMapToFile()
	local nowForm = self:getNowFormationsInfo()
	if nowForm and nowForm["status"] then
		local _nowFormationFile = {}
		
        for i = 1, 9 do
        	local _locat = tonumber(nowForm["location"..i]) or 0
            if _locat > 0 then
                local hero = self:getGeneralInfoById(_locat)
                local _weaponId = 0
                if hero.modelId == "nanzhu" or hero.modelId == "nvzhujue" then
                	_weaponId = tonumber(self:getRoleUserWeapons().weaponId) or 0
                end
                local _file, _resourceId = zc.battle.getHeroArmaturePathByResId(hero.modelId, _weaponId)
            	_nowFormationFile[_resourceId] = _file
            end
        end
        self._nowFormationFile = _nowFormationFile
        zc.SaveTable("formationInfo", _nowFormationFile)
	end
end

function Player:getNowFormationFiles()
	if not self._nowFormationFile then
		self._nowFormationFile = {}
	end
	return self._nowFormationFile
end

function Player:getFormationsMap(formationId)
	local FormationMaxLevel = 40
	return self:getFormationsOpenMap(formationId, FormationMaxLevel)
end

function Player:getFormationsOpenMap(formationId, curLevel)
	local _data = gameData.getDataFromCache("formation_level", {formationId = formationId, level = curLevel})
	if next(_data) ~= nil then
		return _data.map
	end
	return ""
end
function Player:getFormationsInfo()
	return self.formationsinfo
end

--获取当前阵法
function Player:getNowFormationsInfo()
	if self.formationsinfo then
		-- for i = 1, #self.formationsinfo do
		for k,v in pairs(self.formationsinfo) do
			if tonumber(v.status) == 1 then
				return v
			end
		end
	end
	return nil
end
--根据formationId 获取阵法信息
function Player:getFormationsInfoByFormationId(formationId)
	-- for i=1,#self.formationsinfo do 
	for k,v in pairs(self.formationsinfo) do
		if tonumber(formationId) == tonumber(v.formationId) then 
			return v
		end
	end
	return nil
end
--返回一个阵法信息能不能升级
function Player:getFormationsCanLevelUp(formationId)
	local _selfLevel = tonumber(self.info.level) 
	-- for i=1,#self.formationsinfo do 
	for k,v in pairs(self.formationsinfo) do
		if tonumber(formationId) == tonumber(v.formationId) then 
			local _level = tonumber(v.level) or 0
			local _data = gameData.getDataFromCache("formation_level", {formationId = formationId, level = _level + 1})
			if next(_data) ~= nil then
				local _needlevel = tonumber(_data.needLevel)
				if _selfLevel >= _needlevel then
					return 1
				else
					return 0
				end
			end
		end
	end
	return 0
end
function Player:getFormationsReds()
	local FormationsReds = {}
    -- for i=1,#self.formationsinfo do 
	for k,v in pairs(self.formationsinfo) do
		local red = self:getFormationsCanLevelUp(v.formationId)
		local fid = v.formationId

		FormationsReds[tostring(fid)] = red
	end
	return FormationsReds
end
--根据formationId 修改阵法信息
function Player:updateFormationsInfoByFormationId(formationId, newparams)
	-- for i=1,#self.formationsinfo do 
	for k,v in pairs(self.formationsinfo) do
		if tonumber(formationId) == tonumber(v.formationId) then 
			for key,value in pairs(newparams) do
				v[key] = value
			end
		end
	end
end
--根据id 修改阵法信息
function Player:updateFormationsInfoById(id, newparams)
	-- for i=1,#self.formationsinfo do 
	for k,v in pairs(self.formationsinfo) do
		if tonumber(id) == tonumber(v.id) then 
			for key,value in pairs(newparams) do
				v[key] = value
			end
		end
	end
end
--下阵 修改开启的阵法
function Player:downGeneral(gid)
	for k,v in pairs(self.formationsinfo) do
		if tonumber(v.status) == 1 then 
			for s=1,9 do 
				if tonumber(v["location"..s]) == tonumber(gid) then
				    v["location"..s] = "0" 
				    break
				end
			end
		end
	end
end
--阵法红点（可以升级）
function Player:getFormationRedState( )
	local playerLevel = tonumber(PlayerData.info.level)
	local playerVip = tonumber(PlayerData.info.vip)
	local ownGold = tonumber( PlayerData:getResourcesInfoById(1) )
    local nowF = PlayerData:getNowFormationsInfo()
    local needVip = tonumber(nowF["needVip"])
    if playerVip < needVip then
    	return false
    end
    local nextLevel = (tonumber(nowF["level"]) or 0) + 1
    local _data = gameData.getDataFromCache("formation_level", {formationId = nowF["formationId"], level = nextLevel})
    if _data and _data["needLevel"] then
	    local needLevel = tonumber(_data["needLevel"])
	    if playerLevel < needLevel then
	    	return false
	    end
	    local consume_price = gameData.getDataFromCache("consume_price", {type = 1})
	    local needGoldInfo = consume_price[nextLevel]
	    local needGold = needGoldInfo["price"] or 0 
	    if ownGold < needGold then
	    	return false
	    else
	    	return true
	    end
	else
		return false
	end
end

--[[
背包信息
]]
function Player:addOneBagDb(baginfo)
	local _id = tonumber(baginfo["itemId"])
	local oneBagInfo = gameData.getDataFromCacheWithPrimaryKey("item", _id)
	if next(oneBagInfo) ~= nil then
		for k,v in pairs(oneBagInfo) do 
			if k ~= "id" and k ~= "subType" and k ~= "type" then 
    			baginfo[k] = v
    		end
		end
		baginfo.mainType = zc.mainTypeProp
	end
end
function Player:setBagInfo(info)
    self.baginfo = info
    for i=1,#self.baginfo do
    	self:addOneBagDb(self.baginfo[i])
    end
end
function Player:getBagDBInfoByID(id)
	local _data = gameData.getDataFromCacheWithPrimaryKey("item", id)
	if next(_data) ~= nil then
		return _data
	end 
    return nil
end
function Player:getBagInfoByID(id)
    for i=1,#self.baginfo do
    	if tonumber(self.baginfo[i].itemId) == tonumber(id) then
    		return self.baginfo[i]
    	end
    end
    return nil
end
function Player:getBagInfo()
	return self.baginfo
end

function Player:getBagByType(typevalue)
	local baginfotype = {}
	for i=1,#self.baginfo do
    	if tonumber(self.baginfo[i].type) == tonumber(typevalue) then
    		baginfotype[#baginfotype+1] = self.baginfo[i]
    	end
    end
    return baginfotype
end
function Player:setBagInfoById(id, params, itemData)
	if id == nil then 
		return 
	end
	id = tonumber(id)
	-- print(id)
	for i=1,#self.baginfo do
        if tonumber(self.baginfo[i].itemId) == id then 
        	self.baginfo[i]["num"] = tonumber(params.num)
    		if self.baginfo[i]["num"] == 0 then 
	            table.remove(self.baginfo, i)
    		end
        	return
        end
    end
    if not itemData then
    	return
    end
    --如果道具不存在则增加
    local _data = gameData.getDataFromCacheWithPrimaryKey("item", itemData.itemId)
    local _subType = _data.subType
    local _type = _data.type
    local _itemData = {id = itemData.primaryId,type = _type,subType = _subType,itemId = itemData.itemId,num = itemData.currentNum}
    self:addOneBagDb(_itemData)
    table.insert(self.baginfo, _itemData)
end
--获取背包红点，武器碎片可合成
function Player:getBagRedState()
	return self._can_synthesis_fragment
end
--检查背包红点，武器碎片可合成
function Player:checkBagRedState()
	self._can_synthesis_fragment = false
	--合成静态数据(碎片静态id对应为key)
	if not self._static_fragment_weapon then
	    local synth_weaponinfo = gameData.getDataFromCache("synth_weapon")
	    local fragment_weapon = {}
	    for k,v in pairs(synth_weaponinfo) do
	    	if v and v.stuffId then
	    		fragment_weapon[tonumber(v.stuffId)] = v
	    	end
	    end
	    self._static_fragment_weapon = fragment_weapon
	end
    local bagInfo = self:getBagInfo()
    for i = 1, table.nums(bagInfo) do
        local v = bagInfo[i]
        if v["type"] and tonumber(v["type"]) == 5 then
            local itemId = tonumber(v["itemId"])
            local _staticInfo = self._static_fragment_weapon[itemId]
            if _staticInfo then
            	local costNum = tonumber(_staticInfo["num"]) or 0
            	if v["num"] then
            		if tonumber(v["num"]) >= costNum then
            			local costRes = _staticInfo["costRes"] or string.split(_staticInfo.cost,"|")
            			if costRes and costRes[2] then
            				_staticInfo["costRes"] = costResf
            				local ownRes = self:getResourcesInfoById(costRes[2])
            				if tonumber(ownRes) >= tonumber(costRes[3]) then
            					self._can_synthesis_fragment = true
            					break
            				end
            			else
            				self._can_synthesis_fragment = true
            				break
            			end
            		end
            	end
            end
        end
    end
    return self._can_synthesis_fragment
end


--道具增加
function Player:addPropToBag(dataInfo)
	for k,v in pairs(self.baginfo) do
		if tonumber(v.id) == tonumber(dataInfo.id) then
			v.num = tonumber(dataInfo.num)
			return
		end
	end
	table.insert(self.baginfo,dataInfo)
end

--道具消耗
function Player:subPropFromBag(id,subNums)
	for k,v in pairs(self.baginfo) do
		if tonumber(v.id) == tonumber(id) then
			v.num = tonumber(v.num) - tonumber(subNums)
			if tonumber(v.num) == 0 then 
				table.remove(self.baginfo,k)
			end
			break
		end
	end
	--dump(self.baginfo)
end
--获取背包道具根据主类型和子类型
function Player:getPropByMainTypeAndSubType(mainType,subType)
	for k,v in pairs(self.baginfo) do
		if tonumber(v.type) == tonumber(mainType) and tonumber(v.subType) == tonumber(subType) then 
			return v
		end
	end
	return nil
end

--判断铁匠铺是否有兵器可打造
function Player:isHaveWeaponCanMake()
	do
		return false
	end
	self._showInfo = {}
	self._houseInfo = PlayerData:getHouseInfoByHouseId(11)
	if self._houseInfo then
	    local weapon_foundry_itemDB = gameData.getDataFromCache("weapon_foundry_item") 
	   	local _color = 1
	    local _data = gameData.getDataFromCache("house_level", {houseId = self._houseInfo.houseId, level = self._houseInfo.level})
	    if next(_data) ~= nil then
	        effectid = _data.effectId
	    end
	    if effectid ~= 0 then 
	        local _data = gameData.getDataFromCacheWithPrimaryKey("houseEffect_smith", effectid)
	        if next(_data) ~= nil then
	            _color = tonumber(_data.color)
	        end
	    end
	    local _weaponList = {}
	    for k,v in pairs(weapon_foundry_itemDB) do
	    	if tonumber(_color) >= tonumber(v.color) then
	    		_weaponList[#_weaponList+1] = v
	    	end
	    end
	    for k,v in pairs(_weaponList) do
	    	local synthInfo = {}
		    local trsSynthInfo = self:canAKeyMake(v, 1, synthInfo)
		    local canAKeySynthesisFlag = true
		    for i=1,#trsSynthInfo do 
		        for j=1,4 do 
		            if trsSynthInfo[i]["stuff"..j] and tonumber(trsSynthInfo[i]["stuff"..j]) == -1 then 
		                canAKeySynthesisFlag = false
		                break
		            end
		        end
		    end
		    if canAKeySynthesisFlag == true then 
		        return true
		    end
	    end
	end
	return false
end

--[[
这个物品能不能合成
]]
function Player:canSynthesis(goodid)
	local _data = gameData.getDataFromCacheWithPrimaryKey("synth_item", goodid)
	if next(_data) ~= nil then
		return _data
	end
	return nil
end
--[[
能不能一键打造
]]
function Player:canAKeyMake(itemCost, num, synthInfo, bagInfoTmp)
	local bagInfo = nil
	if bagInfoTmp == nil then 
		bagInfo = table.copy(self.baginfo)
	else
		bagInfo = bagInfoTmp
	end

	local canySynthesis = true
	num = tonumber(num)
	local synthInfoOne = {}
	synthInfoOne = {step = 0, targetItemId = itemCost.id, targetItemNum = num}
	local itemname = {"itemId", "itemId1", "itemId2", "itemId3", "itemId4"}
	local itemnumname = {"itemNum", "itemNum1", "itemNum2", "itemNum3", "itemNum4"}
	for i=1,5 do 
		local curname = itemname[i]
		local curnumname = itemnumname[i]
        if itemCost[curname] and tonumber(itemCost[curname]) ~= 0 then 
            --查看数量够吗
            local array = {zc.mainTypeProp, itemCost[curname], itemCost[curnumname]}
            local synthesisTable = self:MakeWeapon(array, num, synthInfo, bagInfo)
            if synthesisTable ~= nil then 
                synthInfoOne["stuff"..i] = synthesisTable
    		else
    			synthInfoOne["stuff"..i] = -1
    		end
        end
    end
    synthInfo[#synthInfo + 1] = synthInfoOne
    synthInfoOne.step = #synthInfo

	return synthInfo
end

--能不能打造
function Player:MakeWeapon(array, num, synthInfo, bagInfoTmp)
	--合成 如果数量够  返回 true  不够返回一个table
	local function getBagTmpInfo(id)
		for i=1,#bagInfoTmp do
	    	if tonumber(bagInfoTmp[i].itemId) == tonumber(id) then
	    		return bagInfoTmp[i]
	    	end
	    end
	    return nil
	end
	local function MinusBagTmpInfoNum(id, num)
		for i=1,#bagInfoTmp do
	    	if tonumber(bagInfoTmp[i].itemId) == tonumber(id) then
	    		bagInfoTmp[i].num = tonumber(bagInfoTmp[i].num) - tonumber(num)
	    		break
	    	end
	    end
	end
	local itemInBag = getBagTmpInfo(array[2]) or {}
	if itemInBag.num and tonumber(itemInBag.num) >= tonumber(array[3]) then 
	    --数量够
	    MinusBagTmpInfoNum(array[2], array[3] * num)
	    return {type = array[1], id = array[2], primaryId = itemInBag.id, num = array[3] * num}
	else
		--数量不够
		local SynthesisTable = self:canSynthesis(array[2])
		if SynthesisTable == nil then 
    		--不能合成 
    		return nil
    	else
    		local itemBagNum = 0
    		if itemInBag.num then
    			itemBagNum = tonumber(itemInBag.num)
    		end
    		--能合成一部分  有一部分
    		local hechengnum = tonumber(array[3]) - itemBagNum
    		if itemInBag.num then
    			MinusBagTmpInfoNum(array[2], itemBagNum)
    		end
    		self:canAKeySynthesis(SynthesisTable, hechengnum, synthInfo, bagInfoTmp)
    		return {type = array[1], id = array[2], primaryId = itemInBag.id or 0 , num = array[3]}
    	end
	end
end
--[[
能不能一键合成
]]
function Player:canAKeySynthesis(itemCost, num, synthInfo, bagInfoTmp)
	local bagInfo = nil
	if bagInfoTmp == nil then 
		bagInfo = table.copy(self.baginfo)
	else
		bagInfo = bagInfoTmp
	end
	local canySynthesis = true
	num = tonumber(num)
	local synthInfoOne = {}
	synthInfoOne = {step = 0, targetItemId = itemCost.id, targetItemNum = num}
	for i=1,4 do 
        if itemCost["stuff"..i] and tonumber(itemCost["stuff"..i]) ~= 0 then 
            local array = string.split(itemCost["stuff"..i], "|")
            -- array[1]:主type、array[2]:id或副类型、array[3]:num
            if array then 
            	if tonumber(array[1]) == 1 and tonumber(array[2]) == 2 then 
            		--银币
            		synthInfoOne["stuff"..i] = {type = array[1], id = array[2], num = tonumber(array[3]) * num, primaryId = 0}
            	else
	                --查看数量够吗
	                local synthesisTable = self:Synthesis(array, num, synthInfo, bagInfo)
	                if synthesisTable ~= nil then
		                synthInfoOne["stuff"..i] = synthesisTable
		    		else
		    			synthInfoOne["stuff"..i] = -1
		    		end
		    	end
		    end
        end
    end
    synthInfo[#synthInfo + 1] = synthInfoOne
    synthInfoOne.step = #synthInfo
    
	return synthInfo
end
--物品能不能合成
function Player:Synthesis(array, num, synthInfo, bagInfoTmp)
	--合成 如果数量够  返回 true  不够返回一个table
	local function getBagTmpInfo(id)
		for i=1,#bagInfoTmp do
	    	if tonumber(bagInfoTmp[i].itemId) == tonumber(id) then
	    		return bagInfoTmp[i]
	    	end
	    end
	    return nil
	end
	local function MinusBagTmpInfoNum(id, num)
		for i=1,#bagInfoTmp do
	    	if tonumber(bagInfoTmp[i].itemId) == tonumber(id) then
	    		bagInfoTmp[i].num = tonumber(bagInfoTmp[i].num) - tonumber(num)
	    		break
	    	end
	    end
	end
	local itemInBag = getBagTmpInfo(array[2]) or {}
	if itemInBag.num and tonumber(itemInBag.num) >= tonumber(array[3]) * num then 
	    --数量够
	    MinusBagTmpInfoNum(array[2], array[3] * num)
	    return {type = array[1], id = array[2], primaryId = itemInBag.id, num = array[3] * num}
	else
		--数量不够
		local SynthesisTable = self:canSynthesis(array[2])
		if SynthesisTable == nil then 
    		--不能合成 
    		return nil
    	else
    		--能合成一部分  有一部分
    		local itemNum = 0 
    		if itemInBag.num then
    			itemNum = tonumber(itemInBag.num)
    		end
    		local hechengnum = tonumber(array[3]) * num - itemNum
    		if itemInBag.num then
    			MinusBagTmpInfoNum(array[2], itemNum)
    		end
    		self:canAKeySynthesis(SynthesisTable, hechengnum, synthInfo, bagInfoTmp)
    		return {type = array[1], id = array[2], primaryId = itemInBag.id or 0, num = array[3] * num}
    	end
	end
end

--道具藏宝图品质变更
function Player:upgradeTreasureMapQuality(id,itemId)
	local _data = gameData.getDataFromCacheWithPrimaryKey("item", itemId)
	for k,v in pairs(self.baginfo) do
		if tonumber(v.id) == tonumber(id) then
			v.itemId = itemId
			v.price = _data.price
			v.color = _data.color
			v.desc = _data.desc
			v.name = _data.name
			v.subType = _data.subType
			v.effectIds = _data.effectIds
			break
		end
	end
end

--[[
精英副本购买信息
"eliteTollgate" = {
	"buyTollgateChallenge" = 今日已购买挑战次数0
	"challengeTimes"       = 可用挑战次数
	"challengeTimesLimit"  = 可用挑战次数上限
}
]]
function Player:setEliteBuyInfo( info )
	-- dump(info, "setEliteBuyInfo")
	self._eliteBuyInfo = info
end
function Player:getEliteBuyInfo()
	return self._eliteBuyInfo
end
--[[
副本信息
]]
function Player:setCopyInfo(info)
	self.copyinfo = {
		{},--1普通
		{},--2精英
	}
	if #info > 0 then
		for i=1, #info do
			local _chapterId = info[i].chapterId
			local _tolls = info[i].tollgates
			for _k,_v in pairs(_tolls) do
				_v.status = 2
			end
			local _data = gameData.getDataFromCacheWithPrimaryKey("chapter", _chapterId)
			local _type = tonumber(_data.nationId)
			self.copyinfo[_type] = self.copyinfo[_type] or {}
			self.copyinfo[_type][_chapterId] = info[i]
		end
	end
	self:freshNextOpenInfo()
	-- dump(self.copyinfo, "wm----copyInfo")
end
function Player:getCopyInfo()
	return self.copyinfo
end

function Player:setRouteId( chapterId, routeId )
	local _chapterId = tonumber(chapterId)
	local _data = gameData.getDataFromCacheWithPrimaryKey("chapter", _chapterId)
	local _type = tonumber(_data.nationId)
	local _tb = self.copyinfo[_type]
	if table.nums(_tb) > 0 then
		for k,v in pairs(_tb) do
			if v.chapterId == _chapterId then
				self.copyinfo[_type][_chapterId].routeId = tonumber(routeId)
			end
		end
	end
	self:freshNextOpenInfo()
end

--获取某一关卡的状态
--返回2  
function Player:getCurTollGateStatus(gid)
	local status = 0
	local _data = self:getCurTollGateData(gid)
	if _data and next(_data) ~= nil then
		status = tonumber(_data.status)
	end
	return status
end

function Player:getCurTollGateData(gid)
	local _gid = tonumber(gid)
	local _tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", _gid)
	local status = 0
	if next(_tollDb) ~= nil then
		local _chapterId = _tollDb.chapterId
		local _chapterData = self:getCopyInfoByChapterId(_chapterId)
		if _chapterData then
			local _tolls = _chapterData.tollgates
			for _k,_v in pairs(_tolls) do
				if tonumber(_v.tollgateId) == _gid then
					return _v
				end
			end
		end
	end
	return nil
end

--根据章节id获取章节数据
function Player:getCopyInfoByChapterId( chapterId )
	local _chapterId = tonumber(chapterId)
	local _data = gameData.getDataFromCacheWithPrimaryKey("chapter", _chapterId)
	local _type = tonumber(_data.nationId)
	local _tb = self.copyinfo[_type]
	if table.nums(_tb) > 0 then
		for k,v in pairs(_tb) do
			if v.chapterId == _chapterId then
				return v
			end
		end
	end
	return nil
end

function Player:isChapterOver( chapterId )
	if tonumber(chapterId) == 0 then
		return true
	end
	local _chapterData = self:getCopyInfoByChapterId(chapterId)
	if _chapterData then
		local _tolls = _chapterData.tollgates
		local _lastToll = _tolls[#_tolls]
		local datas = gameData.getDataFromCache("tollgate", {chapterId = chapterId})
		if #_tolls == #datas and _lastToll.status == 2 then
			return true
		end
	end
	return false
end

--添加下一关可攻打的数据
function Player:freshNextOpenInfo()
	for i=1, #self.copyinfo do
		local _typeInfo = self.copyinfo[i]
		local _count = table.nums(_typeInfo)
		if _count > 0 then--关卡类型里有东西
			local _chapterData
			local _tmpId, keyNum = 0, 0
			for k,v in pairs(_typeInfo) do
				keyNum = tonumber(k) or 0
				if keyNum > _tmpId then
					_tmpId = keyNum
				end
			end
			_chapterData = _typeInfo[_tmpId]
			if self:isChapterOver(_chapterData.chapterId) then--章节已经完成了，可以去检查下一章节了
				local _chapterDb = gameData.getDataFromCacheWithPrimaryKey("chapter", _chapterData.chapterId + 1)
				if next(_chapterDb) ~= nil then
					local _chapterId = tonumber(_chapterDb.id)
					local _data2 = gameData.getDataFromCache("tollgate", {chapterId = _chapterId, line = 0})
					if next(_data2) ~= nil then
						local _tb = {
							chapterId = _chapterId,
							routeId = 0,
							tollgates = {
								{
									star = 0,
									num = 0,
									tollgateId = tonumber(_data2.id),
									status = 1
								}
							}
						}
						self.copyinfo[i][_chapterId] = _tb
					end
				end
			else--章节里还没完成，预添加下一个可进攻的关卡
				local _tolls = _chapterData.tollgates
				local datas = gameData.getDataFromCache("tollgate", {chapterId = _chapterData.chapterId})
				for k,v in pairs(datas) do
					local _have = false
					local _id = tonumber(v.id)
					for _k,_v in pairs(_tolls) do
						if _v.tollgateId == _id then
							_have = true
							break
						end
					end
					if not _have then
						local array = string.split(v.activateId, ",")
						local statusFlag = 1--前置关卡都开启了
						for _k, _v in pairs (array) do 
				            if self:getCurTollGateStatus(_v) ~= 2 then 
				                statusFlag = 0
				                break
				            end
				        end
				        if statusFlag == 1 then
				            local _tb = {
				            	star = 0,
								num = 0,
								tollgateId = _id,
								status = 1
							}
							-- self.copyinfo[i][_chapterData.chapterId].tollgates
							_tolls[#_tolls + 1] = _tb
				        end
				    end
				end	 
			end
		else--关卡类型里初始没东西
			local _chapterDbs = gameData.getDataFromCache("chapter", {nationId = i})
			local _firstData = _chapterDbs[1]
			local array = string.split(_firstData.activateId, ",")
			local statusFlag = 1
			for _k, _v in pairs (array) do 
	            if not self:isChapterOver(_v) then 
	                statusFlag = 0
	                break
	            end
	        end
	        if statusFlag == 1 then
	        	local _chapterId = tonumber(_firstData.id)
	        	local _datas = gameData.getDataFromCache("tollgate", {chapterId = _chapterId})
	        	self.copyinfo[i][_chapterId] = {
					chapterId = _chapterId,
					routeId = 0,
					tollgates = {
						{
							star = 0,
							num = 0,
							tollgateId = tonumber(_datas[1].id),
							status = 1
						}
					}
				}
	        end
		end
	end
end

--获取下一个开启的关卡
function Player:getNextOpenTollGate( copyType )
	local _type = copyType == nil and 1 or tonumber(copyType)
	local _info = self.copyinfo[_type]
	if not _info then
		return _type, 1, 1
	end
	local _maxK = 0
	for k,v in pairs(_info) do
		_maxK = v.chapterId > _maxK and v.chapterId or _maxK
	end
	_info = _info[_maxK]
	local _tollDatas = gameData.getDataFromCache("tollgate", {chapterId = _maxK}) 
	local _tolls = _info.tollgates
	local _line = _info.routeId
	if _type ~= 1 or (_line and _line ~= 0) or #_tollDatas < 10 then
		local _bossData = gameData.getDataFromCache("tollgate", {line = 3, chapterId = _maxK}) 
        if next(_bossData) ~= nil then
            if self:getCurTollGateStatus(_bossData.id) == 2 then
                return _type, _maxK, #_tolls
            end 
        end
		local _lineTollData = gameData.getDataFromCacheWithPrimaryKey("tollgate", _line) 
        local _haveSame = false
		for k,v in pairs(_tolls) do
			if v.status == 1 then
				local _data = gameData.getDataFromCacheWithPrimaryKey("tollgate", v.tollgateId) 
	        	if _lineTollData.line == _data.line then
	        		return _type, _maxK, tonumber(k)
	        	end
	        end
		end
		for k,v in pairs(_tolls) do
			if v.status == 1 then
        		return _type, _maxK, tonumber(k)
	        end
		end
	else
		return _type, _maxK, 1
	end
	return _type, _maxK, 1
end

function Player:getNextOpenTollGateData( copyType )
	local i,j,k = self:getNextOpenTollGate(copyType)
	return self.copyinfo[i][j].tollgates[k], j, k
end

--状态  2通关
function Player:setCurTollGateStatus(gid, params, freshState)
	local _gid = tonumber(gid)
	local _haveChanged = false
	local _tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", _gid)
	if next(_tollDb) ~= nil then
		local _chapterId = tonumber(_tollDb.chapterId)
		local _chapterData = self:getCopyInfoByChapterId(_chapterId) --章节关卡后端数据(设置关卡战斗的数据或状态)
		if _chapterData then
			local _tolls = _chapterData.tollgates
			for _k,_v in pairs(_tolls) do
				if tonumber(_v.tollgateId) == _gid then
					local _status = tonumber(params.status)
					if _status then
						_v.status = _status
					end
					local _numadd = tonumber(params.numadd)
					if _numadd then
						_v.num = _v.num + _numadd
					end
					local _num = tonumber(params.num)
					if _num then
						_v.num = _num
					end
					local _buyNum = tonumber(params.buyNum)
					if _buyNum then
						_v.buyNum = _buyNum
					end
					local _star = tonumber(params.star)
					if _star and _star > tonumber(_v.star) then
						_v.star = _star
					end
					_haveChanged = true
					break
				end
			end
		end

		if not _haveChanged then
			local _data = gameData.getDataFromCacheWithPrimaryKey("chapter", _chapterId)
			local _type = tonumber(_data.nationId) 
			self.copyinfo[_type] = self.copyinfo[_type] or {}
			self.copyinfo[_type][_chapterId] = self.copyinfo[_type][_chapterId] or {}
			self.copyinfo[_type][_chapterId].tollgates = self.copyinfo[_type][_chapterId].tollgates or {}
			local _tb = {
				buyNum = 0,
            	star = 0,
				num = 0,
				tollgateId = tonumber(_tollDb.id),
				status = 1
			}
			local _status = tonumber(params.status)
			if _status then
				_tb.status = _status
			end
			local _numadd = tonumber(params.numadd)
			if _numadd then
				_tb.num = _tb.num + _numadd
			end
			local _num = tonumber(params.num)
			if _num then
				_tb.num = _num
			end
			local _buyNum = tonumber(params.buyNum)
			if _buyNum then
				_tb.buyNum = _buyNum
			end
			local _star = tonumber(params.star)
			if _star then
				_tb.star = _star
			end
			table.insert(self.copyinfo[_type][_chapterId].tollgates, _tb)
			_haveChanged = true
		end
	end

	local _freshState = freshState == nil and true or freshState
	if _haveChanged and _freshState then
		self:freshNextOpenInfo()
	end
end
--根据关卡id返回副本及势力
function Player:getChapterIdByEnemyId(id)
	local _data = self:getEnemyInfoByEnemyId(id)
	if _data and next(_data) ~= nil then
		return _data.chapterId
	end
	return nil
end
--
function Player:getEnemyInfoByEnemyId(id)
	local _data = gameData.getDataFromCacheWithPrimaryKey("tollgate", id)
	if next(_data) ~= nil then
		return _data
	end
	return nil
end

--[[
武将信息
]]
function Player:addGeneralDBInfo(newginfo)
	local ginfo = gameData.getDataFromCacheWithPrimaryKey("hero", newginfo.heroId)
	if next(ginfo) ~= nil then
		newginfo["name"] = ginfo.name
		newginfo["region"] = ginfo.region
		newginfo["title"] = ginfo.title
		newginfo["weaponType"] = ginfo.weaponType--兵器类型
		newginfo["force"] = ginfo.force
		newginfo["intelligence"] = ginfo.wisdom
		newginfo["strength"] = ginfo.soma
		newginfo["type"] = ginfo.type
		newginfo["picture"] = ginfo.picture 
		newginfo["modelId"] = ginfo.modelId 
		newginfo["iconId"] = ginfo.iconId
		newginfo["beforeexp"] = newginfo.exp
		newginfo["beforelevel"] = newginfo.level
		newginfo["feature"] = ginfo.feature
		newginfo["talentId"] = newginfo["talentId"] or ginfo.talentId--天赋类型
		local _qualifications = gameData.getDataFromCache( "hero_talent", {convertId = newginfo["talentId"]}).convertQuality
        _qualifications = tonumber( _qualifications ) or 0
        if _qualifications == 0 then
            _qualifications = ginfo.qualifications
        end
		newginfo["qualifications"] = _qualifications
		newginfo["light"] = ginfo.light
		local _newAdvance = tonumber(newginfo.newAdvance) or 0
		local _dbs = zc.getBreakThroughInfo({
			id = newginfo.id,
			heroId = newginfo.heroId,
			stageLevel = _newAdvance,
			qualifications = _qualifications
		})
		newginfo["quality"] = tonumber(_dbs.quality) or 1
	end
end
function Player:setGeneralInfo(info)
    self.generalinfo = info

    for i=1,#self.generalinfo do
    	self:addGeneralDBInfo(self.generalinfo[i])
    end
end
function Player:getGeneralInfo()
	return self.generalinfo
end

--通过唯一iD 获取单个英雄信息
function Player:getSignGeneralById(id)
	for i, v in ipairs( self:getGeneralInfo() ) do
		-- print("v.id:",v.id)
		if tonumber( id ) == tonumber(v.id) then
			return v
		end
	end
	return nil
end
-- 返回附加属性
function Player:getDesc(params,skillData)
	local desc_list = {}
	local hitType = skillData.hitType
	local zhanfa_data = gameData.getDataFromCache("tactics_hero")
	for k,v in pairs(params) do
		if not desc_list[v.id] then
			local roleData = self:getSignGeneralById(v.id)
			local weaponType = tonumber(roleData.weaponType)
			local qualifications = tonumber(roleData.qualifications)
			for t,h in pairs(zhanfa_data) do
				if weaponType == tonumber(h.weaponType) and tonumber(h.qualifications) == qualifications and tonumber(hitType) == tonumber(h.skillType) then
					local t_h_data = h
					local str_list = {}
					local tab_ = string.split(t_h_data.desc,"$")
				    for s,o in pairs(tab_) do
				    	local n,m = string.find(o,"|")
				    	if n then
				    		local gongshi = string.split(o,"|")
				    		local func = loadstring("return "..string.gsub(gongshi[2],"lv",v.lv))
				    		local str2 = func()
				    		local baifenhao = string.split(o,"%")
				    		if baifenhao[2] == "" then
				    			str2 = str2.."%"
							end
				    		table.insert(str_list,str2)
				    	else
				    		table.insert(str_list,o)
				    	end
				    end
				    local _desc = ""
				    for i = 1,#str_list do
				    	local str = str_list[i]
				    	if i%2 == 0 then
				    		_desc = _desc.."[color=ff00FF00]"..str.."[/color]"
				    	else
				    		_desc = _desc.."[color=ffcc9933]"..str.."[/color]"
				    	end
				    end
				    print("_desc:",_desc)
				    desc_list[v.id] = _desc
				end
			end
		end
	end
	return desc_list
end

-- 武将重生时检查是否有镶嵌的战法，并且修改
function Player:setRoleStatics(id)
	local info = self:getGeneralInfo()
	local list = {}
	local index = {
		"tplace11","tplace12","tplace13","tplace14",
		"tplace21","tplace22","tplace23","tplace24",
		"tplace25","tplace26","tplace27","tplace28",
	}
	for k,v in pairs(info) do
		if tonumber(v.id) == tonumber(id) then
			dump(v,"0000000")
			local statics = v.tactics
			for i = 1,#index do
				if tonumber(statics[index[i]]) ~= 0 then
					table.insert(list,tonumber(statics[index[i]]))
				end
			end
		end
	end
	for i,v in pairs(info) do
		for k,data in pairs(list) do
			if tonumber(v.id) == tonumber(data) then
				print("--------------")
				v.tactics.tactics = "0"
				break
			end
		end
	end
	local _inde = self:getGeneralInfo()
	-- dump(_inde,"-----////----")
	-- for k,v in pairs(_inde) do
	-- 	for c,data in pairs(list) do
	-- 		if tonumber(v.id) == tonumber(data) then
	-- 			dump(v,"test")
	-- 			break
	-- 		end
	-- 	end
	-- end
end


function Player:setGeneralInfoById(id, params)
	local params = params or {}
	for i=1,#self.generalinfo do 
		if tonumber(self.generalinfo[i].id) == tonumber(id) then
			local _newAdvance = 0
			if params.newAdvance then
				_newAdvance = tonumber(params.newAdvance) or 0
			else
				_newAdvance = self.generalinfo[i].newAdvance
			end
			local _qualifications = tonumber(self.generalinfo[i].qualifications) or 1
			local _dbs = zc.getBreakThroughInfo({
				id = id,
				heroId = self.generalinfo[i].heroId,
				stageLevel = _newAdvance,
				qualifications = _qualifications
			})
			params.quality = tonumber(_dbs.quality) or 1 	
			for k,v in pairs(params) do 
				if k == "fighting" and tonumber(id) == tonumber( self.info.heroId ) then
					self._lastFighting = self.generalinfo[i][k]
				end
				self.generalinfo[i][k] = v
			end
			break
		end
    end
end
--增加武将
function Player:addGeneral(newGeneral)
    self:addGeneralDBInfo(newGeneral)
	self.generalinfo[#self.generalinfo+1] = table.copy(newGeneral)
end
function Player:getGeneralInfoById(id)
	for i=1,#self.generalinfo do
    	if tonumber(self.generalinfo[i].id) == tonumber(id) then
			return self.generalinfo[i]
		end
    end
    return nil
end

function Player:getPlayerHero()
	local _heroId = self:getBaseInfoByTag("heroId")
	return self:getGeneralInfoById(_heroId)
end

--更新武将信息
function Player:updateGeneralInfo(heroData)
	for k,v in pairs(self.generalinfo) do
		if tonumber(v.id) == tonumber(heroData.id) then
			local _newAdvance = 0
			if heroData.newAdvance then
				_newAdvance = tonumber(heroData.newAdvance) or 0
			else
				_newAdvance = v.newAdvance
			end
			local _qualifications = tonumber(v.qualifications) or 1
			local _dbs = zc.getBreakThroughInfo({
				id = v.id,
				heroId = v.heroId,
				stageLevel = _newAdvance,
				qualifications = _qualifications
			})
			heroData["quality"] = tonumber(_dbs.quality) or 1
			for _k,_v in pairs(heroData) do
				self.generalinfo[k][_k] = _v
			end
			break
		end
	end
end

--是否有相同的武将
function Player:getGeneralInfoByHeroId(heroId)
	for i=1,#self.generalinfo do 
    	if tonumber(self.generalinfo[i].heroId) == tonumber(heroId) then
    		return self.generalinfo[i]
		end
    end
    return nil
end


--是否有相同的武将
function Player:hasSameGeneral(heroId)
	local _heroData = self:getGeneralInfoByHeroId(heroId)
	local _have = _heroData and true or false
	return _have
end

function Player:canBreaktrough( heroData )
	local _heroData = heroData
	local _newAdvance = tonumber(_heroData.newAdvance) or 0
	local _dbData = zc.getBreakThroughInfo({
		id = _heroData.id,
		heroId = _heroData.heroId,
		stageLevel = _newAdvance,
		qualifications = _heroData.qualifications
	})
	local _status = true
	if next(_dbData) ~= nil then
		for i=1, 3 do
			if string.len(_dbData["needStuff" .. i] or "") > 0 then
				local _info = string.split(_dbData["needStuff" .. i], "|")
				local _cost = tonumber(_info[3]) or 0
				local _have = tonumber(zc.getNumByTypeId(_info[1], _info[2])) or 0
				if _have < _cost then
					_status = false
					break
				end
			end
		end
		if _status then
			local _flag = true
			local _sameCardNum = tonumber(_dbData.sameCardNum) or 0
			if _sameCardNum > 0 then
				local _have = tonumber(zc.getNumByTypeId(zc.mainTypeSoldierFragment, _heroData.heroId)) or 0
				if _have < _sameCardNum then
					_flag = false
				end
			end
			if not _flag then
				if _dbData.generalCardNum and string.len(_dbData.generalCardNum) > 0 then
					local _info = string.split(_dbData.generalCardNum, "|")
					local _num = tonumber(_info[3]) or 0
					local _have = tonumber(zc.getNumByTypeId(_info[1], _info[2])) or 0
					if _have < _num then
						_status = false
					end
				end
			end
		end
	else
		_status = false
	end
	return _status
end

--------------------地域羁绊信息 start------------
function Player:setFettersRegionalInfo( info )
	self._fetterRegionalInfo = info or {}
	for k,v in pairs(self._fetterRegionalInfo) do
		local _level = tonumber(v.level) or 0
		v.upgradeInfo = gameData.getDataFromCache("fetters_upgrade", {fettersId = v.fettersId, color = _level})
		v.nextLevelInfo = gameData.getDataFromCache("fetters_upgrade", {fettersId = v.fettersId, color = _level + 1})
		local _db = gameData.getDataFromCacheWithPrimaryKey("region_fetters", v.fettersId)
		v.rank = tonumber(_db.rank) or 1
		v.show = tonumber(_db.show) or 0
	end
	self:freshRegionalFlag()
end

function Player:updateOneFetterRegionalInfoById( id, data )
	local _level = tonumber(data.level) or 0
	data.upgradeInfo = gameData.getDataFromCache("fetters_upgrade", {fettersId = data.fettersId, color = _level})
	data.nextLevelInfo = gameData.getDataFromCache("fetters_upgrade", {fettersId = data.fettersId, color = _level + 1})
	local _db = gameData.getDataFromCacheWithPrimaryKey("region_fetters", data.fettersId)
	data.rank = tonumber(_db.rank) or 1
	data.show = tonumber(_db.show) or 0
	
	local _id = tonumber(id) or 0
	local _have = false
	for k,v in pairs(self._fetterRegionalInfo) do
		if tonumber(v.id) == _id then
			self._fetterRegionalInfo[k] = data
			_have = true
			break
		end
	end
	if not _have then
		table.insert(self._fetterRegionalInfo, data)
	end
	self:freshRegionalFlag()
end

function Player:getOneFetterRegionalInfoByDbId( id )
	local _id = tonumber(id) or 0
	for k,v in pairs(self._fetterRegionalInfo) do
		if tonumber(v.fettersId) == _id then
			return v
		end
	end
	return nil
end

function Player:getOneFetterRegionalInfosByRegionId( id )
	local _id = tonumber(id) or 0
	local _tb = {}
	for k,v in pairs(self._fetterRegionalInfo) do
		if tonumber(v.regionId) == _id and v.show == 0 then
			table.insert(_tb, v)
		end
	end
	return _tb
end

function Player:freshRegionalFlag()
	self._regionalFlag = {false, false, false, false}
	for i=1, 4 do
		local _tb = PlayerData:getOneFetterRegionalInfosByRegionId(i)
		local _flag = false
		for k,v in pairs(_tb) do
			local _status = tonumber(v.status) or 0
			local _award = tonumber(v.award) or 1
			print(v.fettersId, " , ", _status, " , ", _award)
			if _status == 1 and _award == 1 then
				_flag = true
				break
			end
		end
		self._regionalFlag[i] = _flag
	end
end

function Player:getRegionalFlag(idx)
	local _idx = tonumber(idx) or 0
	if _idx ~= 0 then
		return self._regionalFlag[_idx]
	end
	for k,v in pairs(self._regionalFlag) do
		if v then
			return true
		end
	end
	return false
end

--[[
    兵器成就
]]
function Player:setWeaponsBook()
	--判断兵器铺是否开启
    local _flag = zc.getFunctionStatus(12) 
    if not _flag then
    	return
    end
    zc.sendHttp({
    	apiName = "Weapon_achievementInfo", 
    	successCallback = function (net_data)
	        self.weaponsBook = net_data["achievements"]
	        self:checkSmithBookState()
	    end,
    })
end
function Player:getWeaponsBook(info)
	return self.weaponsBook
end
function Player:setWeaponsBookById(id, params)
	-- body
	for i=1,#self.weaponsBook do 
		if tonumber(self.weaponsBook[i].id) == tonumber(id) then 
			for k,v in pairs(params) do
				self.weaponsBook[i][k] = v
		    end
		end
	end
end
function Player:setWeaponsBookByAchievementId(id, params)
	-- body
	for i=1,#self.weaponsBook do 
		if tonumber(self.weaponsBook[i].achievementId) == tonumber(id) then 
			for k,v in pairs(params) do
				self.weaponsBook[i][k] = v
		    end
		end
	end
end
--[[
建筑信息
]]
function Player:setHouseInfo(info)
	self.houseinfo = info
end
function Player:getHouseInfo()
	return self.houseinfo
end
function Player:getHouseInfoByHouseId( id )
	local _id = tonumber(id) or 0
	local _house = nil
	for k,v in pairs(self.houseinfo.houses) do
		if v and v.houseId == _id then
			if _id ~= 6 and _id ~= 7 then
				return v
			end
			if _house then
				if _house.level < v.level then
					_house = v
				end
			else
				_house = v
			end
		end
	end
	return _house
end
--获取正在建筑的建筑信息
function Player:getCurBuildingInfo()
	return self.houseinfo["queueInfo"]
end
--修改正在建筑的信息
function Player:setCurBuildingInfo(newdata)
	for k,v in pairs(newdata) do 
		self.houseinfo["queueInfo"][k] = v
	end
end
--购买付费队列
function Player:setPayEffectEndTime(payEffectEndTime)
	self.houseinfo["queueInfo"]["payEffectEndTime"] = payEffectEndTime
end
--拆除建筑
function Player:deleteHouseInfo(id)
	for k,v in pairs(self.houseinfo["houses"]) do
		if tonumber(v.id) == tonumber(id) then 
			table.remove(self.houseinfo["houses"], k)
		end
	end
end
--增加建筑
function Player:addHouseInfo(newhouse)
	if self.houseinfo["houses"] == nil then 
		self.houseinfo["houses"] = {}
	end
	self.houseinfo["houses"][#self.houseinfo["houses"] + 1] = newhouse
end
--更新建筑
function Player:updateHouseInfo(houseData)
	for k,v in pairs(self.houseinfo["houses"]) do
		if tonumber(v.id) == tonumber(houseData.id) then
		    self.houseinfo["houses"][k] = houseData
		    if v.houseId == 1 then
		    	self:checkTalentCanDo()
		    end
		end
	end
end

--玩家资源信息
function Player:setResourcesInfo(info)
	self.resourcesInfo = info
end

--获取玩家资源信息
function Player:getResourcesInfo()
	return self.resourcesInfo
end
-- 通过id获取玩家资源信息
function Player:getResourcesInfoById( id )
	return self.resourcesInfo[zc.getTypeByType( id )]
end

--资源变更--根据资源类型变更
function Player:updateResourcesInfo(_type,_nums,_addOrSub)
	if _addOrSub == "add" then
		self.resourcesInfo[_type] = self.resourcesInfo[_type] + tonumber(_nums)
	else
		self.resourcesInfo[_type] = self.resourcesInfo[_type] - tonumber(_nums)
	end
	--更新UI
	self:updataData({resources = {_type = self.resourcesInfo[_type]}})
end

--[[
兵器信息
]]
--兵器信息
function Player:setWeaponsInfo(info)
	self.weapons = info
	for i=1,#self.weapons do 
		local weaponInfo = gameData.getDataFromCacheWithPrimaryKey("weapon", self.weapons[i].weaponId)
		if next(weaponInfo) ~= nil then 
			for k,v in pairs (weaponInfo) do
				if k ~= "id" then 
					self.weapons[i][k] = v
				end
			end
			self.weapons[i].mainType = zc.mainTypeWeapon
			self.weapons[i].num = 1
		end
	end	
end
--获取兵器
function Player:getWeaponsInfo()
	local selfweapons = {}
	for i=1,#self.weapons do 
		-- local timeDiff = tonumber(self.weapons[i]["createTime"]) - self:getTime()
  --       if timeDiff <= 0 then --说明已经打造完成
  --       	--领取状态值为0表示已经领取过,1表示未领取
  --       	if self.weapons[i]["status"] and tonumber(self.weapons[i]["status"]) == 0 then
  --          		selfweapons[#selfweapons+1] = self.weapons[i]
  --          	end
  --       end
	    --领取状态值为0表示已经领取过（可以使用或者显示）,1表示未领取
    	if self.weapons[i]["status"] and tonumber(self.weapons[i]["status"]) == 0 then
       		selfweapons[#selfweapons+1] = self.weapons[i]
       	end
	end
	return selfweapons
end
--获取是否有未领取的兵器
function Player:getCanGetWeapons()
	local canGetWeapons = {}
	for i = 1, #self.weapons do
    	--领取状态值为0表示已经领取过,1表示未领取
    	if self.weapons[i]["status"] and tonumber(self.weapons[i]["status"]) == 1 then
			local timeDiff = tonumber(self.weapons[i]["createTime"]) - self:getTime()
        	if timeDiff <= 0 then --说明已经打造完成,还未领取
       			canGetWeapons[#canGetWeapons+1] = self.weapons[i]
        	end
       	end
	end
	if not next(canGetWeapons) then
		canGetWeapons = nil
	end
	--test
	-- canGetWeapons = {}
	return canGetWeapons
end

--是否可强化兵器(状态值)
function Player:canCastingWeapons()
	return self._canCastingWeapons
end

--是否有可打造的兵器(状态值)
function Player:canMakeWeapons()
	return self._canMakeWeapons
end

--当前神兵的红点状态（主角当前穿戴的神兵)
function Player:getGodWeaponRedDotState()
	return self._godWeaponRedDotState
end
--判断当前神兵是否可以强化、进阶、升级
function Player:checkGodWeaponRedDotState()
	self._godWeaponRedDotState = false
	local heroId = tonumber(self.info["heroId"]) or 0
	if heroId == 0 then
		return
	end
	local _canStrength = false
	local function getOwnNumIsEnougth(_conTa)
		local _enouch = true
        if _conTa and _conTa[2] then
            local _mainType 	= tonumber(_conTa[1])
            local _type 		= tonumber(_conTa[2])
            local _itemid 		= tonumber(_conTa[2])
            local _consumeNum 	= tonumber(_conTa[3])
            if _mainType then
            	local _ownNum = 0
            	if _mainType == zc.mainTypeResource then
            		_ownNum = tonumber( PlayerData:getResourcesInfoById(_type) )
            	elseif _mainType == zc.mainTypeProp then
            		local bagInfo = PlayerData:getBagInfoByID(_itemid) or {}
            		_ownNum = tonumber(bagInfo["num"]) or 0
            	end
            	if _ownNum < _consumeNum then
            		_enouch = false
            	end
           	end
        end
        return _enouch
	end
	for i = 1, #self.weapons do
		local _v = self.weapons[i]
		if _v["heroId"] and tonumber(_v["heroId"]) == heroId then
		    local jinjieTable = gameData.getDataFromCacheWithPrimaryKey("weapon_advanced", _v.weaponId)
			local _nowStrengthenId = tonumber(_v["beforeStrengthen"]) or 0
			local _nowStrengthenInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_beforestrengthen", _nowStrengthenId or 1)
    		local _nowStrengthenGroup = gameData.getDataFromCache("weapon_beforestrengthen", {group = _nowStrengthenInfo["group"] or 1} )
			if _v["strengthenLevel"] and jinjieTable["needStrengthen"] then
		        if tonumber(_v["strengthenLevel"]) < tonumber(jinjieTable["needStrengthen"]) then
		            if _nowStrengthenId == tonumber(_nowStrengthenGroup[#_nowStrengthenGroup]["id"]) and
		                tonumber(_v["beforeStrengthenGroup"]) ~= 0 then
		                --需要升级
                        local curLevel = tonumber(_v["strengthenLevel"])
                        local _strdata = gameData.getDataFromCacheWithPrimaryKey("weapon_strengthen", curLevel+1)
                        if _strdata and _strdata["id"] then
                        	local _levelUPConsume = _strdata["item"..(tonumber(_v["advancedNum"])+1)]
	                        if _levelUPConsume and _levelUPConsume ~= 0 then
	                            local _levelUPConsumeTable = string.split(_levelUPConsume, ",")
	                            local _isEnouch = true
	                            for j = 1, #_levelUPConsumeTable do
	                                local _conTa = string.split(_levelUPConsumeTable[j], "|")
			                        _isEnouch = getOwnNumIsEnougth(_conTa)
			                        if not _isEnouch then
			                        	break
			                        end
	                            end
	                			self._godWeaponRedDotState = _isEnouch
	                        end
                        end
		            else
		            	--可以强化
						local _nextStrengthenInfo = gameData.getDataFromCacheWithPrimaryKey("weapon_beforestrengthen", _nowStrengthenId+1)
						if _nextStrengthenInfo and _nextStrengthenInfo["constMoney"] then
							--强化消耗
							local _consumeResouce = {
								[1]={[1]=1,[2]=zc.dataTypeMoney,[3]=_nextStrengthenInfo["constMoney"]},
								[2]={[1]=1,[2]=zc.dataMineral,[3]=_nextStrengthenInfo["constOre"]},
							}
							local _isEnouch = true
							for j = 1,#_consumeResouce do
		                        _isEnouch = getOwnNumIsEnougth(_consumeResouce[j])
		                        if not _isEnouch then
		                        	break
		                        end
							end						
		            		self._godWeaponRedDotState = _isEnouch
						end
		            end
		        else
		        	--需要进阶
		        	local _isEnouch = true
	                for j = 1, 7 do
	                    if jinjieTable["stuff"..j] and jinjieTable["stuff"..j] ~= 0 and jinjieTable["stuff"..j] ~= "" then
	                        local _conTa = string.split(jinjieTable["stuff"..j], "|")
	                        _isEnouch = getOwnNumIsEnougth(_conTa)
	                        if not _isEnouch then
	                        	break
	                        end
	                    end
	                end
	                self._godWeaponRedDotState = _isEnouch
		        end
			end
			break
		end
	end
end
--检查可洗练的兵器
function Player:checkCanClearWeapons()
    local _flag = zc.getFunctionStatus(29) 
    if not _flag then
        return false
    end
	local _hasWeaponHero = false --是否有兵器装备在武将身上
	local _hasNoUseWeapon = false --是否有可用的兵器
	local weaponsInfo = self:getWeaponsInfo()
	if weaponsInfo then
		for i = 1, #weaponsInfo do
			local v = weaponsInfo[i]
			if v["isUser"] and tonumber(v["isUser"]) ~= 1 then
				if v["heroId"] and tonumber(v["heroId"]) > 0 then
					if _hasNoUseWeapon then
						return true
					else
						_hasWeaponHero = true
					end
				elseif v["heroId"] and tonumber(v["heroId"]) == 0 then
					if _hasWeaponHero then
						return true
					else
						_hasNoUseWeapon = true
					end
				end
			end
		end
	end
	return false
end
--检查单个武将是否可洗练
function Player:checkCanClearWeaponsByHeroId(_heroId)
    local _flag = zc.getFunctionStatus(29) 
    if not _flag then
        return false
    end
	if not _heroId then
		return false
	end
	local _heroHaseWeaponed = false
	local _hasNoUseWeapon = false
	local weaponsInfo = self:getWeaponsInfo()
	if weaponsInfo then
		for i = 1, #weaponsInfo do
			local v = weaponsInfo[i]
			if v["isUser"] and tonumber(v["isUser"]) ~= 1 then
				if v["heroId"] and tonumber(v["heroId"]) == tonumber(_heroId) then
					if _hasNoUseWeapon then
						return true
					else
						_heroHaseWeaponed = true
					end
				elseif v["heroId"] and tonumber(v["heroId"]) == 0 then
					if _heroHaseWeaponed then
						return true
					else
						_hasNoUseWeapon = true
					end
				end
			end
		end
	end
	return false
end
--获取兵器谱开启成就信息（铁匠铺升级需要更新） _froce强制刷新
function Player:getSmithyBookAchievement(_froce)
	if _froce then
		self._bookAchilevementInfo = nil
	end
	if not self._bookAchilevementInfo then
		local _houseInfo = self:getHouseInfoByHouseId( 11 )
	    local houseEffect = gameData.getDataFromCacheWithPrimaryKey("houseEffect_smith", _houseInfo["level"])
	    local achievementInfo = gameData.getAllDataWithNoClone("weapon_achievement")
	    local canAchieveInfo = {}
	    local _nums = table.nums(achievementInfo)
	    for i = 1, _nums do
	    	local _v = achievementInfo[tostring(i)]
	    	if _v["spectraId"] and tonumber(_v["spectraId"]) <= tonumber(houseEffect["spectraId"]) then
	    		canAchieveInfo[#canAchieveInfo+1] = clone(_v)
	    	end
	    end
	    self._bookAchilevementInfo = canAchieveInfo
	end
	return self._bookAchilevementInfo
end
--获取兵器铺红点状态
function Player:getSmithBookRedDotState()
	return self._smithBookRedDotState
end
--检查兵器铺状态 (初始、兵器装备、兵器卸下、兵器增加、兵器减少)
function Player:checkSmithBookState()
	self._smithBookRedDotState = false
	--2判断兵器铺是否开启
    local _flag = zc.getFunctionStatus(12) 
    if not _flag then
    	return
    end
	--3判断状态
	local canActivityInfo = self:getSmithyBookAchievement()
	--成就数据
	local achieve =  self:getWeaponsBook()
	local achieveToId = {}
	for i = 1, #achieve do
		local achievementId = tonumber(achieve[i]["achievementId"])
		achieveToId[achievementId] = achieve[i]
	end
	local weaponsInfo = self:getWeaponsInfo()
	local canUseWeapon = {}
	for i = 1, #weaponsInfo do
		local _v = weaponsInfo[i]
		if _v["isUser"] and tonumber(_v["isUser"]) ~= 1 then
			if _v["heroId"] and tonumber(_v["heroId"]) == 0 then
				local weaponId = tonumber(_v["weaponId"])
				if not canUseWeapon[weaponId] then
					canUseWeapon[weaponId] = true
				end
			end
		end
	end
	if not next(canUseWeapon) then
		return
	end
	for i = 1, #canActivityInfo do
		local _v = canActivityInfo[i]
		local achievementId = tonumber(_v["id"])
		--如果已经激活检查升级
		if achieveToId[achievementId] then
			local _ach = achieveToId[achievementId]
			if _ach["level"] and tonumber(_ach["level"]) < 5 then
				local bookLevelUp = gameData.getDataFromCache("weapon_achievement_level", {achievementId = achievementId,level=_ach["level"]})
				if bookLevelUp and bookLevelUp["spendItems"] then
					local _canLevelUp = true
		            local spendRes = string.split(bookLevelUp["spendItems"], ",")
		            for j=1,#spendRes do
		                local spendItem = string.split(spendRes[j], "|")
		                if spendItem and spendItem[1] and tonumber(spendItem[1]) == 3 then
		                	local weaponId = tonumber(spendItem[2])
		                	if not canUseWeapon[weaponId] then
		                		_canLevelUp = false
		                		break
		                	end
		               	else --如果消耗的不是兵器，暂时处理为false
	                		_canLevelUp = false
	                		break		
		               	end
		            end
		            if _canLevelUp then
		            	self._smithBookRedDotState = true
		            	return
		            end
		        end
		    end

		else --没有激活检查激活
			local _canActivity = true
			for j = 1, 5 do
				if _v["weaponId"..j] and tonumber(_v["weaponId"..j]) > 0 then
					local weaponId = tonumber(_v["weaponId"..j])
					if not canUseWeapon[weaponId] then
						_canActivity = false
						break
					end
				end
			end
			if _canActivity then
				self._smithBookRedDotState = true
				return
			end
		end
	end
end
--获取熟练度红点（可升级）
function Player:getSmithPracticeRedDotState()
    local _flag = zc.getFunctionStatus(35) 
	if not _flag then
		return
	end
    local houseInfo = PlayerData:getHouseInfoByHouseId(11) or {}
	--等级上限：不超过主角等级、不超过铁匠铺等级3倍
    local nowLevelMax = (tonumber(houseInfo["level"]) or 0 ) * 3
    local playerLevel = tonumber(PlayerData:getUserLevel())
    if playerLevel < nowLevelMax then
        nowLevelMax = playerLevel
    end

	local skillInfo = PlayerData:getBaseInfoByTag("skilful") or {}
    local minSkillLevel = 99999999999
    local minSkillIndex = 1
    for i = 1, 6 do
    	local lv = tonumber(skillInfo["lv"..i]) or 0
    	if lv < minSkillLevel then
    		minSkillLevel = lv
    		minSkillIndex = i
    	end
    end
    --等级达到上限
    if minSkillLevel >= nowLevelMax then
    	return false
    else
    	local skillLevel = gameData.getDataFromCache( "skilful",{effect=minSkillIndex} )
    	local skillLevelInfo = skillLevel[minSkillLevel+1] or {}
    	if skillLevelInfo and skillLevelInfo["cost"] then
	    	local cost = skillLevelInfo["cost"] or ""
	    	local costInfo = string.split(cost, "|")
	    	if costInfo and costInfo[2] then
	    		local ownRes = PlayerData:getResourcesInfoById(costInfo[2])
	    		local costNum = costInfo[3] or 0
	    		if tonumber(costNum) > tonumber(ownRes) then
	    			return false
	    		else
	    			return true
	    		end
	    	else
	    		return false
	    	end
	    else
	    	return false
	    end
    end

end
--获取正在打造的普通兵器
function Player:getCurMakeWeapon()
	local curMakeWeapons = {}
	for i=1,#self.weapons do
		local weaponId = tonumber(self.weapons[i]["weaponId"]) or 0 
		if weaponId ~= 1001 and weaponId ~= 2001 then
	    	if self.weapons[i]["status"] and tonumber(self.weapons[i]["status"]) == 1 then
				local timeDiff = tonumber(self.weapons[i]["createTime"]) - self:getTime()
		        if timeDiff > 0 then 
		        	local oneMakeWeapon = table.copy(self.weapons[i])
		        	oneMakeWeapon.time = timeDiff
		            curMakeWeapons[#curMakeWeapons+1] = oneMakeWeapon
		        end
	       	end
	    end
	end
	return curMakeWeapons
end
--获取正在打造的神兵兵器
function Player:getCurMakeGodWeapon()
	local curMakeWeapons = {}
	for i=1,#self.weapons do
		local weaponId = tonumber(self.weapons[i]["weaponId"]) or 0 
		if weaponId == 1001 or weaponId == 2001 then
	    	if self.weapons[i]["status"] and tonumber(self.weapons[i]["status"]) == 1 then
				local timeDiff = tonumber(self.weapons[i]["createTime"]) - self:getTime()
		        if timeDiff > 0 then 
		        	local oneMakeWeapon = table.copy(self.weapons[i])
		        	oneMakeWeapon.time = timeDiff
		            curMakeWeapons[#curMakeWeapons+1] = oneMakeWeapon
		        end
		    end
	    end
	end
	return curMakeWeapons
end


--根据heroid获取兵器信息
function Player:getWeaponsInfoById(heroid)
	for i=1,#self.weapons do
		if tonumber(self.weapons[i].heroId) == tonumber(heroid) then 
			return self.weapons[i]
		end
	end
	return nil
end
--获取主角兵器
function Player:getRoleWeapons()
	local roleWeapons = {}
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].isUser) == 1 then 
			roleWeapons[#roleWeapons+1] = self.weapons[i]
		end
	end
	return roleWeapons
end
--获取当前主角正在使用的兵器
function Player:getRoleUserWeapons()
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].isUser) == 1 then 
			if tonumber(self.weapons[i].heroId) > 0 then
				return self.weapons[i]
			end
		end
	end
	return nil
end
function Player:updateWeaponsInfoById(params)
	local _params = params or {}
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].id) == tonumber(_params.id) then 
			for k,v in pairs(_params) do 
				self.weapons[i][k] = v
			end
			break
		end
	end
	--兵器改变，刷新兵器铺状态
	self:checkSmithBookState()
end

--通过主键id
function Player:getWeaponInfoInfoById(id)
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].id) == tonumber(id) then 
			return self.weapons[i]
		end
	end
	return nil
end
--通过静态id
function Player:getWeaponInfoInfoByItemid(_itemId)
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].weaponId) == tonumber(_itemId) then 
			return self.weapons[i]
		end
	end
	return nil
end
function Player:addWeapon(newweapon)
	local weaponInfo = gameData.getDataFromCacheWithPrimaryKey("weapon", newweapon.weaponId)
	if next(weaponInfo) ~= nil then 
		for k,v in pairs (weaponInfo) do
			if k ~= "id" then 
				newweapon[k] = v
			end
		end
	end
	newweapon.mainType = zc.mainTypeWeapon
	self.weapons[#self.weapons + 1] = newweapon
	--兵器改变，刷新兵器铺状态
	self:checkSmithBookState()
end

function Player:subWeapon(id)
	for k,v in pairs(self.weapons) do
		if tonumber(v.id) == tonumber(id) then 
			table.remove(self.weapons,k)
			break
		end
	end
	--兵器改变，刷新兵器铺状态
	self:checkSmithBookState()
end

function Player:getWeaponsDBInfoById(weaponId)
	local _data = gameData.getDataFromCacheWithPrimaryKey("weapon", weaponId)
	if next(_data) ~= nil then
		return _data
	end
 	return nil
end

--查看兵器数量
function Player:getWeaponNumInBagById(weaponId)
	local num = 0
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].weaponId) == tonumber(weaponId) then 
			num = num + 1
		end
	end
	return num
end

--兵器更换后更新兵器数据
function Player:updateWeaponsByHeroIdAndWeaponId(heroId,weaponId)
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].heroId) == tonumber(heroId) then 
			self.weapons[i].heroId = 0
			break
		end
	end
	for i=1,#self.weapons do 
		if tonumber(self.weapons[i].id) == tonumber(weaponId) then 
			self.weapons[i].heroId = heroId
			break
		end
	end
	--兵器改变，刷新兵器铺状态
	self:checkSmithBookState()
end
--[[
装备信息
]]
function Player:setEquipsInfo( equipInfo )
	self.equipinfo = equipInfo
end
function Player:getEquipInfo()
	return self.equipinfo
end
function Player:getEquipInfoByHeroIdAndPos( heroId, pos )
	if self.equipinfo then
		local _heroId = tonumber( heroId ) or 0
		local _pos = tonumber( pos ) or 0
		for i, v in ipairs( self.equipinfo ) do
			local __heroId = tonumber( v.heroId ) or 0
			local __pos = tonumber( v.position ) or 0
			if _heroId == __heroId and _pos == __pos then
				return v
			end
		end
		return nil
	else
		return nil
	end
end
function Player:addEquip( equipInfo )
	self.equipinfo[#self.equipinfo + 1] = equipInfo
end
function Player:updateEquip( equipInfo )
	local _id = tonumber( equipInfo.id ) or 0
	for i, v in ipairs( self.equipinfo ) do
		local __id = tonumber( v.id ) or 0
		if _id == __id then
			self.equipinfo[i] = equipInfo
			break
		end
	end
end
--[[
宝石信息
]]
function Player:setGemInfo( gemInfo )
	self.gemInfo = {}
	local _gemInfo = gemInfo or {}
	for k, v in pairs( _gemInfo ) do
		self:addGem( v )
	end
end
function Player:addGem( gemInfo )
	local _id = tostring( gemInfo.id )
	local _data = gameData.getDataFromCacheWithPrimaryKey("gem", gemInfo.gemId)
	for k, v in pairs( _data ) do
		if not gemInfo[k] then
			gemInfo[k] = v
		end
	end
	self.gemInfo[_id] = gemInfo
end
function Player:getGemInfo()
	return self.gemInfo
end
function Player:getGemInfoById( id )
	local _id = tostring(id)
	return self.gemInfo[_id]
end
-- 更新，直接替换以前的数据
function Player:updateGem( gemInfo )
	self:addGem( gemInfo )
end
-- 删除
function Player:deleteGem( gemInfo )
	local _id = tostring(gemInfo.id)
	self.gemInfo[_id] = nil
end
--[[
技能信息
]]
--兵器信息
function Player:getSkillDBInfo(skillid)
	local _data = gameData.getDataFromCacheWithPrimaryKey("skill", skillid)
	if next(_data) ~= nil then
		return _data
	end
	return nil
end
--[[
	次数信息
]]
function Player:setLimitInfo( info )
	-- dump(info, "----info----")
	self.limitInfo = info
end
function Player:getLimitInfo()
	return self.limitInfo
end
function Player:getLimitInfoById( id )
	return self.limitInfo[id]
end
function Player:setLimitInfoById( id, data )
	self.limitInfo[id] = data
end
--[[
进入战斗后记录数据
]]
function Player:setLastSceneData(params)
	self._lastSceneData = params
end
function Player:getLastSceneData(params)
	return self._lastSceneData
end
--[[
服务器时间
]]
function Player:setTime(time)
	local _time = tonumber(time) or 0
	local curTime = os.time()--当前设备的时间
	local timeDiff = _time - tonumber(curTime)
	self.timediff = timeDiff
end
function Player:getTime()
	if self.timediff == nil then 
		self.timediff = 0
	end
	local curTime = os.time() + tonumber(self.timediff) 
	return math.floor(curTime)--当前手机的时间 和服务器是一致的
end
-- 体力恢复倒计时
function Player:energyRecovery( _init )
	local _energy = tonumber( self.resourcesInfo.energy ) or 0
	local _energyLimit = tonumber( self.resourcesInfo.energyLimit ) or 0
	if _energy < _energyLimit then
		local _energyInterval = tonumber( self.resourcesInfo.energyInterval ) or 0
		if _init then
			-- 初始化
			local timeDiff = tonumber( self.resourcesInfo.energyTime ) - tonumber( self:getTime() )
			self._energyInterval = timeDiff%_energyInterval
		else
			-- 恢复一点
			self.resourcesInfo.energy = _energy + 1
			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_BASEINFOCHANGE})
			self._energyInterval = _energyInterval
		end
		-- 重开计时器
		self:stopEnergyTimer()
		self._energyTimer = scheduler.performWithDelayGlobal(function()
			self:energyRecovery()
		end, self._energyInterval)
	else
		-- 停止计时器
		self:stopEnergyTimer()
	end
end
function Player:stopEnergyTimer()
	if self._energyTimer then
		scheduler.unscheduleGlobal( self._energyTimer )
		self._energyTimer = nil
	end
end
function Player:setArenaTime( info )
	self._arenaTime = info
end

function Player:getArenaTime()
	return self._arenaTime or {}
end
--[[
免费征收次数
]]
function Player:setFreeLeyv( num )
	self._freeLeyv = tonumber(num) or 0 
end

function Player:getFreeLeyv()
	return self._freeLeyv 
end
--[[
活动开启状态
]]
function Player:setActivityInfo( data )
	self.activeInfo = {}
	local _myTime = self:getTime()
	local _have9Flag = false
	local _haveLimitShop = false

	for k, v in pairs( data or {} ) do
		local _startTime = tonumber( v.openTime ) or 0
		local _endTime = tonumber( v.endTime ) or 0
		local _activeId = tonumber( v.activeId ) or 0
		local _flag = true
		if _startTime > _myTime or _myTime > _endTime then
			_flag = false
		else
			-- 竞速，时间前3天
			if _activeId == 2 then
				local _startTime2 = tonumber( self:getCreateTime() ) or 0
	            local _endTime2 = _startTime2 + 3*24*60*60
	            if _startTime2 > _myTime or _myTime >= _endTime2 then
	            	_flag = false
		        end
			end
		end
		if _flag then
			table.insert(self.activeInfo, v)
		end
		if _activeId == 9 then
			_have9Flag = _flag
		end
		if _activeId == 13 then
			_haveLimitShop = true
		end
	end
	if _have9Flag then
		self:setFirstRechargeShowFlag(true)
	end
	if _haveLimitShop then
		zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activityShow"}})
	end
end
function Player:getActivityInfo()
	return self.activeInfo or {}
end

function Player:getActivityInfoById( id )
	for k,v in pairs(PlayerData:getActivityInfo()) do
		if v and tonumber(v.activeId) == id then
			local _myTime = PlayerData:getTime()
	        local _pLevel = PlayerData:getUserLevel()
	        local _level = tonumber(v.level) or 1
	        local _startTime = tonumber( v.openTime ) or 0
	        local _endTime = tonumber( v.endTime ) or 0
	        if _pLevel >= _level and _startTime <= _myTime and _myTime <= _endTime then
	        	return v
	        end
		end
	end
	return {}
end

function Player:getLimitActiveInfoByID(id)
	for k,v in pairs(PlayerData:getLimitActivityInfo()) do
		if v and tonumber(v.activeId) == id then
			local _myTime = PlayerData:getTime()
	        local _pLevel = PlayerData:getUserLevel()
	        local _level = tonumber(v.level) or 1
	        local _startTime = tonumber( v.openTime ) or 0
	        local _endTime = tonumber( v.endTime ) or 0
	        if _pLevel >= _level and _startTime <= _myTime and _myTime <= _endTime then
	        	return v
	        end
		end
	end
	return {}
end

function Player:checkActivityOpenState( id )
	local _open = false
	local _info = PlayerData:getActivityInfoById(id)
    if _info and next(_info) ~= nil then
        _open = true
    end
    return _open
end

function Player:checkKaiFuActivityShowFlag()
	local _pLevel = PlayerData:getUserLevel()
	local _myTime = self:getTime()
	for k,v in pairs(PlayerData:getActivityInfo()) do
		local _type = tonumber(v.type) or 0
		local _level = tonumber(v.level) or 1
		local entrance = tonumber(v.entrance) or 1
		if  _pLevel >= _level and _type == 1 then
			local _startTime = tonumber( v.openTime ) or 0
			local _endTime = tonumber( v.endTime ) or 0
			if _startTime <= _myTime and _myTime <= _endTime then
				return true
			end
		end
	end
    return false
end

function Player:getFirstRechargeShowFlag()
	return self._fisrtRechargeShowFlag
end

function Player:setFirstRechargeShowFlag( flag )
	if APP_REVIEW or APP_SERVER == 2 then
		self._fisrtRechargeShowFlag = false
	else
		self._fisrtRechargeShowFlag = flag
	end
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activityShow"}})	
end
--[[
七日活动开启状态
]]
function Player:setSevenDayStatus( data )
	if data and next(data) then
		self._sevenDayStatus = 1
	else
		self._sevenDayStatus = 0
	end
end

function Player:getSevenDayStatus()
	return self._sevenDayStatus
end

--七日签到
function Player:setSecondDaySignStatus( data )
	local _data = data or {}
	self._secondDayStatus = tonumber(_data["2"]) or 0
end

function Player:getSecondDaySignStatus()
	local _info = self:getActivityInfoById(1)
	if next(_info) == nil then
		return 2
	end
	return self._secondDayStatus
end

function Player:setLimitActivityInfo(data)
	self.activeLimitInfo = {}
	local _myTime = self:getTime()
	local _have9Flag = false
	local _haveLimitShop = false

	for k, v in pairs( data or {} ) do
		local _startTime = tonumber( v.openTime ) or 0
		local _endTime = tonumber( v.endTime ) or 0
		local _activeId = tonumber( v.activeId ) or 0
		local _flag = true
		if _startTime > _myTime or _myTime > _endTime then
			_flag = false
		else
			-- 竞速，时间前3天
			if _activeId == 2 then
				local _startTime2 = tonumber( self:getCreateTime() ) or 0
	            local _endTime2 = _startTime2 + 3*24*60*60
	            if _startTime2 > _myTime or _myTime >= _endTime2 then
	            	_flag = false
		        end
			end
		end
		if _flag then
			table.insert(self.activeLimitInfo, v)
		end
		if _activeId == 9 then
			_have9Flag = _flag
		end
		if _activeId == 13 then
			_haveLimitShop = true
		end
	end
	if _have9Flag then
		self:setFirstRechargeShowFlag(true)
	end
	if _haveLimitShop then
		zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activityShow"}})
	end
end

function Player:getLimitActivityInfo( ... )
	return self.activeLimitInfo or {}
end

function Player:getShowIconDatas( data )
	local _data = data or {}
    local _items = {}
    local _flag = true
    if _data.clientItems then
	    for i, v in ipairs(_data.clientItems) do
	        local itemType = tonumber(v.type) or 0
            if itemType == 1 then--资源
                local _num = tonumber(v.num) or 0
                if _num > 0 and v.id ~= zc.dataGridPoint then
                    _flag = false
                    _items[#_items + 1] = {
                        itemType = itemType,
                        itemId = v.id,
                        changeNum = _num,
                    }
                end
            elseif itemType ~= zc.mainTypeSoldierExp-- 经验 
	          and itemType ~= zc.mainTypePlayerExp
	          and itemType ~= zc.mainTypeEquip then
                -- 非经验
                if v.changeNum and tonumber(v.changeNum) > 0 then
	                _items[#_items + 1] = {
	                    itemType = itemType,
	                    itemId = v.itemId,
	                    changeNum = v.changeNum,
	                    model = v.model,
	                    trans = v.trans,
	                }
	            end
	        end
	    end
	end
    if _flag and _data.clientResources then
        for k, v in pairs(_data.clientResources) do 
            local changeNum = tonumber(v) - tonumber(PlayerData.resourcesInfo[k])
            if changeNum > 0 then 
                local itemId = zc.getItemIdByName(k)
                if itemId then
                    if itemId ~= zc.dataTypeEnergy then
                        -- 体力，后端一起返回，没法分辨是否显示，过滤
                        _items[#_items + 1] = {
                            itemType = zc.mainTypeResource,
                        	itemId = itemId,
                        	changeNum = changeNum,
                        }
                    end
                end
            end
        end
    end
    return _items
end
--[[
获取物资  武将 物品 统一方法
]]
function Player:updataData(changeData,heroData)

	local tipData = {}

	local needCheck1 			= false --是否需要检查可强化兵器、开打造兵器
	local needCheck2 			= false --是否需要检查神兵红点状态（更新道具、银币、矿石时需要刷新）
	local needRefreshTopBar 	= false --是否需要刷新顶部条

	-- 如果有改名就更新
	local change_name = changeData.userName or nil
	if change_name ~= nil then
		self.info.userName = change_name
	end
	-- 下次可以改名的时间
	local next_time = changeData.time or nil
	if next_time ~= nil then
		self.info.editUserNameTime = next_time
	end

	local _flag = false--true -- 屏蔽物资变化对比，改成全由后端返回
	if changeData.clientItems then 
		--物品
		for k,v in pairs(changeData.clientItems) do 
			local _type = tonumber(v.type) or 0
			if _type == 1 then
				if v.id == zc.dataTypeMoney then
	        		needCheck1 = true
	        		needCheck2 = true
	        	elseif v.id == zc.dataMineral then
					needCheck1 = true
					needCheck2 = true
				elseif v.id == zc.dataGridPoint then
					self:checkTalentCanDo()	
				end
				local _num = tonumber(v.num) or 0    
				if _num > 0 and v.id ~= zc.dataGridPoint and v.id ~= zc.dataTypeCaptainEnergy then --奖励中不显示的物资
					_flag = false
					tipData[#tipData + 1] = {
		                itemType = zc.mainTypeResource,
		            	itemId = v.id,
		            	changeNum = _num,
		            }
		        end
			elseif _type == 4 then 
				--背包的道具
				local _num = tonumber(v.changeNum) or 0 
				if _num > 0 then 
					--增加
					self:setBagInfoById(v.itemId, {num = v.currentNum}, v)
				else
					--删除
					self:setBagInfoById(v.itemId, {num = v.currentNum})
				end
				local _itemId = tonumber(v.itemId) or 1
				if _num > 0 and 
				  (_itemId == 1 or _itemId == zc.cardExtractPopId or _itemId == zc.cardExtractPopFragmentId) then
					-- 突飞卡
					tipData[#tipData + 1] = {
	                    itemType = zc.mainTypeProp,
	                	itemId = tonumber(v.itemId),
	                	changeNum = _num,
	                }
				end
        		needCheck1 = true
        		needCheck2 = true
			elseif _type == 3 then 
				--兵器
				if tonumber(v.currentNum) == 1 then 
					--增加
					self:addWeapon(v.model)
				else
					--删除
				end
			elseif _type == 9 then 
				--饰品
				if tonumber(v.currentNum) == 1 then 
					--增加
					self:addTrinketsInfo(v.model)
				else
					--删除
				end
			elseif _type == 2 then 
				--英雄
				if tonumber(v.currentNum) == 1 then 
					--增加
					self:addGeneral(v.model)
				else
					--删除
				end
			elseif _type == 6 then 
				--经验
				local exp = v.model.exp
				if tonumber(v.model.exp) >= tonumber(v.model.expLimit) then 
					exp = tonumber(exp) - tonumber(v.model.expLimit)
				end
				self.info.exp = exp
				self.info.expLimit = v.model.expLimit
				self.info.fighting = v.model.fighting
				local _nowLevel = self.info.level
				self.info.level = v.model.level
				if self.info.level ~= _nowLevel then
					zc.loginSuccessCallback()
				end
			elseif _type == 11 then
				-- 装备
				if tonumber(v.currentNum) == 1 then 
					--增加
					self:addEquip(v.model)
				else
					--删除
				end
			elseif _type == 12 then
				-- 宝石
				if tonumber(v.currentNum) == 0 then
					-- 删除
					self:deleteGem( v.model )
				else
					self:updateGem( v.model )
				end
			elseif _type == 13 then
				-- 武将碎片
				self:updateFragment(v.itemId, v.currentNum, v.primaryId)
				if heroData then
					local changeNum_ = v.changeNum
					if changeNum_ > 0 then
						tipData[#tipData + 1] = {
		                    itemType = zc.mainTypeSoldierFragment,
		                	itemId = tonumber(v.itemId),
		                	changeNum = changeNum_,
		                	heroData = heroData,
		                }
					end
				end
			elseif _type == 14 then
				-- 将魂
				if tonumber(v.currentNum) == 0 then
					-- 删除
					self:deleteHeroSoul( v.model )
				else
					self:updateHeroSoul( v.model )
				end
			end
		end
        needRefreshTopBar = true
	end
	if changeData.clientResources then
		--物资信息改变
		for k,v in pairs(changeData.clientResources) do
			local changeNum = tonumber(v) - tonumber(self.resourcesInfo[k])
			if k == "energyLimit" then
				self._lastEnergyLimit = self.resourcesInfo[k]
			elseif k == "energy" then	
				self._lastEnergy = self.resourcesInfo[k]
			end
			self.resourcesInfo[k] = v
			--如果不等于0，说明资源改变,需要刷新
			if _flag then
	            local itemId = zc.getItemIdByName(k)
				if changeNum ~= 0 then
					if itemId == zc.dataTypeMoney then
	            		needCheck1 = true
	            		needCheck2 = true
	            	elseif itemId == zc.dataMineral then
						needCheck1 = true
						needCheck2 = true
					end
				end
		        if changeNum > 0 then
		            if itemId then
		            	if itemId == zc.dataTypeEnergy then
		            		-- 体力，后端一起返回，没法分辨是否显示，只能简单过滤增加1的不显示
		            		if changeNum > 1 then
				                tipData[#tipData + 1] = {
				                    itemType = zc.mainTypeResource,
				                	itemId = itemId,
				                	changeNum = changeNum,
				                }
		            		end
	            		elseif itemId == zc.dataTypeCaptainEnergy then
		            		-- 名将册体力
	            		elseif itemId == zc.dataMilitarySkillPoints then
		            		-- 武将技能点
	            		elseif itemId == zc.dataGridPoint then--关卡星数，命格用货币
	            			self:checkTalentCanDo()
		            	else
		            		if changeNum > 0 then
				                tipData[#tipData + 1] = {
				                    itemType = zc.mainTypeResource,
				                	itemId = itemId,
				                	changeNum = changeNum,
				                }
				            end
			            end
		            end
		        end
		    end
		end
        needRefreshTopBar = true
	end
	if changeData.eliteTollgate then--精英副本次数信息
		self:setEliteBuyInfo(changeData.eliteTollgate)
	end
	if needRefreshTopBar then
		--发消息,刷新顶部条
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_BASEINFOCHANGE})
	end
	-- 体力定时恢复
	self:energyRecovery(true)
	-- 获得资源提示
	if not changeData.noAnimation then
		zc.tipResource( tipData )
	end

	if needCheck1 then
    	-------------------------------资源更新刷新数据-------------------------------------
		----------------------------------------------------------------------------------
	end
	if needCheck2 then
    	-------------------------------资源更新刷新数据-------------------------------------
		--判断当前神兵是否可以强化、进阶、升级
		self:checkGodWeaponRedDotState()
	end

	--更新战法信息

	--战法，吃将的将
	if changeData.heroEtt then
		for k,v in pairs(self:getGeneralInfo()) do
			if tonumber(v.id) == tonumber(changeData.heroEtt.id) then
				for key,val in pairs(changeData.heroEtt) do
					if v[key] then
						v[key] = val
					end
				end

				break
			end
		end
	end

	--战法，被吃的将
	if changeData.targetHeroEtt then
		for k,v in pairs(self:getGeneralInfo()) do
			if tonumber(v.id) == tonumber(changeData.targetHeroEtt.id) then
				for key,val in pairs(changeData.targetHeroEtt) do
					if v[key] then
						v[key] = val
					end
				end

				break
			end
		end
	end
	
	return tipData
end
---------------气泡---------------
-- 命格
function Player:getTalentCanDo(build)
	local _mainCity = zc.getScene("mainCity")
    if not _mainCity or not _mainCity.talentData then
		self._canTalentDo = 0
		local _flag = zc.getFunctionStatus(21,false) --命格是否开启
    	if _flag then
			zc.sendHttp({
				apiName = "Talent_Info",
				successCallback = function(data)
			        local _mainCity = zc.getScene("mainCity")
				    if _mainCity then
				        _mainCity.talentData = data.grids
				    end
				    self:checkTalentCanDo()
				    if build.checkHouseBubble then
					    build:checkHouseBubble()
					end
			    end,
			    isSilent = true
		   	})
		end
	end
	return self._canTalentDo or 0
end
function Player:checkTalentCanDo()
	self._canTalentDo = 0
	local mHouseInfo = self:getHouseInfoByHouseId(1)
	local _openCen = 1
    if mHouseInfo then
        local _houseData = gameData.getDataFromCache("house_level", {houseId = 1, level = mHouseInfo.level})
        local _effId = tonumber(_houseData.effectId) or 1
        local _data = gameData.getDataFromCacheWithPrimaryKey("houseEffect_castle", _effId)  
        _openCen = tonumber(_data.layerId) or 1
    end
    local _datas = gameData.getDataFromCache("castle_grid")
	local _newData = {}

    local _pageNum = 0
	for k,v in pairs(_datas) do
        local _page = tonumber(v.page) or 1
        if not _newData[_page] then
            _pageNum = _pageNum + 1
            _newData[_page] = {}
        end
        local _layerId = tonumber(v.layerId) or 1
        local _tb
        for _k, _v in pairs(_newData[_page]) do
            if _v and _v.layerId == _layerId then
                _tb = _v
                break
            end
        end
        if not _tb then
            _tb = {layerId = _layerId}
            table.insert(_newData[_page], _tb)
        end
        table.insert(_tb, v)
	end

    for k,v in pairs(_newData) do
        table.sort(v, function( a, b )
            local aceng, bceng
            for k,v in pairs(a) do
                aceng = tonumber(v.layerId) or 0
                break
            end
            for k,v in pairs(b) do
                bceng = tonumber(v.layerId) or 0
                break
            end
            return aceng < bceng
        end)
    end
    -- self._datas = _newData
    -- 只显示解锁了的层和将解锁的
    local _datas = {}
    for i = 1,#_newData do
        _datas[i] = {}
        for k = 1,#_newData[i] do
            _datas[i][k] = {}
            if _newData[i][k].layerId <= _openCen then
                _datas[i][k] = _newData[i][k]
            else
                _datas[i][k] = nil
                break
            end
        end 
    end

    local _mainCity = zc.getScene("mainCity")

    local function getTalentNowData( id )
    	local _data = nil
    	if _mainCity then
    		_data = _mainCity.talentData
    	end
	    if not _data or #_data < 0 then
	        return nil
	    end
	    local _id = tonumber(id) or 0
	    for k,v in pairs(_data) do
	        if v.gridId == _id then
	            return v
	        end
	    end
	    return nil
	end

	local function getActiveInfo( id )
	    local _id = tonumber(id) or 0
	    if _id == 0 then
	        return true
	    end
    	local _dataT = nil
    	if _mainCity then
    		_dataT = _mainCity.talentData
    	end
	    if not _dataT or #_dataT < 0 then
	        return false
	    end
	    local _data = gameData.getDataFromCacheWithPrimaryKey("castle_grid", _id)
	    local _ceng = tonumber(_data.layerId) or 1
	    -- if  then
	    -- end
	    for k,v in pairs(_dataT) do
	        if v.gridId == _id then
	            local _max = tonumber(_data.maxLevel) or 5
	            if _max <= v.level then
	                return true
	            else
	                return false
	            end
	        end
	    end
	    return false
	end

    for i=1, _pageNum do
    	local _pageData = _datas[i]
    	for k,v in pairs(_pageData) do
    		-- dump(v, "wm----_pageData : " .. k)
	        local _num = tonumber(k)
	        local _ceng = tonumber(v.layerId) or 1
	        local _activeIds
	        for key,value in pairs(v) do
	        	if tonumber(key) then
		        	_ceng = tonumber(value.layerId) or 1
		        	local _activeStatus = 2
	                _activeIds = string.split(value.activateId, ",")
	                if _openCen < _ceng then
	                    _activeStatus = 1
	                else
	                    local _flag = false
	                    for i=1,#_activeIds do
	                        if not getActiveInfo(_activeIds[i]) then
	                            _flag = true
	                            break
	                        end
	                    end
	                    if not _flag then
	                        _activeStatus = 0
	                    end
	                end
	                local _nowData = getTalentNowData(value.id) or {}
				    local _now = tonumber(_nowData.level) or 0
				    local _max = tonumber(value.maxLevel) or 5 
				    _now = _now > _max and _max or _now
				    local _flag1 = (_activeStatus == 2 and _now == 0)
				    local _flag2 = (_now > 0 and _now < _max)
				    if _flag1 or _flag2 then
					  	local nowLevelData = gameData.getDataFromCache("castle_grid_level", {gridId = value.id, level = _now})
	    				local nextLevelData = gameData.getDataFromCache("castle_grid_level", {gridId = value.id, level = _now + 1})
					  	if next(nextLevelData) == nil then
					        nextLevelData = nowLevelData
					    end
					  	local _num = tonumber(self:getResourcesInfoById(zc.dataGridPoint)) or 0
					  	if _num >= nextLevelData.expendNum1 then
					  		if _flag1 then 
					  			self._canTalentDo = 2
						  		return
						  	else
						  		self._canTalentDo = 1
						  	end
					  	end
				    end
				end
	        end
    	end
    end
end
-- 商店
function Player:initShopCanDo( data )
	-- 倒计时，每个商店一个倒计时，刷新之后重新计算最短时间
	self._shopCanDoTime = {}
	-- 商店信息为空
	if not data then
		return
	end
	-- 建筑商店
	local _houseId = ( PlayerData:getHouseInfoByHouseId( 12 ) or {} ).id
	if _houseId then
		-- 建筑商店开启(暂未开启)
		-- self:setShopCanDo( 1, data["1"] )
		self._shopCanDoTime[1] = nil
	end
	-- 演武榜商店
    local _arenaHouseId = ( PlayerData:getHouseInfoByHouseId( 13 ) or {} ).id
	if _houseId and _arenaHouseId then
		-- 演武榜商店开启
		-- self:setShopCanDo( 2, data["2"] )
		-- 无刷新
		self._shopCanDoTime[1] = nil
	end
end
function Player:setShopCanDo( index, data )
	if not data then
		return
	end
	if index == 1 then
		-- 总刷新次数上限
		local _totalNum = tonumber( data.flushNumLimit ) or 0
		-- 已刷新次数
		local _flushNum = tonumber( data.goodsFlushNum ) or 0
		if _flushNum >= _totalNum then
			-- 没有刷新次数了
			self._shopCanDoTime[1] = nil
		else
			-- 免费刷新次数
			local _freeNum = tonumber( data.freeFlushNum ) or 0
			if _freeNum > 0 then
				-- 如果还有免费次数
				self._shopCanDoTime[1] = 0
			else
				-- 间隔
				local _interval = ( tonumber( data.recoverInterval ) or 0 )
				self._shopCanDoTime[1] = ( tonumber( data.flushNumTime ) or 0 ) + _interval - PlayerData:getTime()
				self._shopCanDoTime[1] = self._shopCanDoTime[1]%_interval
			end
		end
	elseif index == 2 then
		-- 总刷新次数上限
		local _timeData = gameData.getDataFromCacheWithPrimaryKey("vip", 18)
		local _totalNum = tonumber( _timeData["vip"..PlayerData.info.vip] ) or 0
		-- 已刷新次数
		local _flushNum = tonumber( data.goodsFlushNum ) or 0
		if _flushNum >= _totalNum then
			-- 没有刷新次数了
			self._shopCanDoTime[2] = nil
		else
			-- 免费刷新次数
			local _freeNum = ( tonumber( data.flushLimit ) or 0 ) + ( tonumber( data.flushNum ) or 0 ) + ( tonumber( data.arenaShopGoldFlush ) or 0 ) - _flushNum
			if _freeNum > 0 then
				-- 如果还有免费次数
				self._shopCanDoTime[2] = 0
			else
				-- 间隔
				local _interval = ( tonumber( data.goodsFlushNumInterval ) or 0 )
				self._shopCanDoTime[2] = ( tonumber( data.shopFlushTime ) or 0 ) + _interval - PlayerData:getTime()
				self._shopCanDoTime[2] = self._shopCanDoTime[2]%_interval
			end
		end
	end

	self:startBubbleTimer()
end
function Player:getShopCanDo()
	-- for k, v in pairs( self._shopCanDoTime ) do
	-- 	if v <= 0 then
	-- 		return k
	-- 	end
	-- end
	return 0
end
-- 校场
function Player:setDrillFieldCanDo( data )
	-- dump(data,"setDrillFieldCanDo")
	self._drillFieldCanDoTime = nil
	for k, v in pairs( data or {} ) do
		local _status = tonumber( v.status ) or 0
		if _status == 1 then
			-- 训练位开启
			local _id = tonumber( ( v.hero or {} ).id ) or 0
			if _id == 0 then
				self._drillFieldCanDoTime = 0
				break
			else
				local _time = tonumber( v.endTime ) or 0
				if self._drillFieldCanDoTime then
					self._drillFieldCanDoTime = self._drillFieldCanDoTime > _time and _time or self._drillFieldCanDoTime
				else
					self._drillFieldCanDoTime = _time
				end
			end
		end
	end
	if self._drillFieldCanDoTime and self._drillFieldCanDoTime ~= 0 then
		self._drillFieldCanDoTime = self._drillFieldCanDoTime - PlayerData:getTime()
	end

	self:startBubbleTimer()
end
function Player:getDrillFieldCanDo()
	return self._drillFieldCanDoTime
end

-- 抽将数据更新
function Player:freshCardExtrData( data )
	self._cardExtrData = {}
	local _houseInfo = self:getHouseInfoByHouseId(9) or {}
    local _houseLevel = tonumber(_houseInfo.level) or 1
    local _playerLevel = tonumber(self.info.level) or 1
    for k,v in pairs(data or {}) do
    	local _db = gameData.getDataFromCacheWithPrimaryKey("hero_handbook_card", k)
        local _hLv = tonumber(_db.level) or 1
        local _pLv = tonumber(_db.plevel) or 1
        if _houseLevel >= _hLv and _playerLevel >= _pLv then
	        table.insert(self._cardExtrData, {key = k, value = v})
        end
    end
end

function Player:getCardExtrFlag()
	for k,v in pairs(self._cardExtrData) do
		local _nextFreeTime = tonumber(v.value) or 0
		local _time = _nextFreeTime - PlayerData:getTime()
        _time = _time ~= 0 and _time + 2 or _time
        if _time <= 0 then 
        	return tonumber(v.key) or 0
        end
	end
	return 0
end

--红点数据
function Player:setRedDotData(data)
	self.redDotList = {}
	dump(data)
	if data == nil then return end
	for k,v in pairs(data) do
		self.redDotList[tostring(k)] = v
	end
end

-- 获取对应红点Id的状态 --1，2.      id为3的比较特殊
function Player:getRedState(redId)
	local value = self.redDotList[tostring(redId)]
	if value == nil then
		-- print("___未找到对应的红点Id：" .. redId)
		return false
	else
		-- if tonumber(redId) == 3 then
		-- 	return tonumber(value)
		-- else
		-- 	if tonumber(value) == 0 then
		-- 		return false
		-- 	elseif tonumber(value) == 1 then
		-- 		return true
		-- 	end
		-- end

		return tonumber(value)
	end
end

--更新红点数据
function Player:updateRedDotData(redId, value)
	if self.redDotList[tostring(redId)] then
		self.redDotList[tostring(redId)] = tonumber(value)
	else
		-- print("___未找到对应的红点Id：" .. redId)
	end
end

-- 鉴定
function Player:setTenEvenPumpRedDot( data )
	self._tenEvenPumpTime = nil

	self:startBubbleTimer()
end
function Player:getTenEvenPumpRedDot()
	return self._tenEvenPumpTime
end
-- 活动
-- 领体力
function Player:setActivityFoodRedDot()
	self._activityFoodStatus = 0
	self._activityFoodTime = 0
	zc.sendHttp({
		apiName = "ReceiveEnergy_main",
		successCallback = function( data )
	        -- 当前时间段
	        local _slot = tonumber( data.slot ) or 0
	        -- 能否免费领取
	        local _free = data.free or false
	        -- 是否已经领取
	        local _current = data.current or false
	        -- 类型
	        local _time = 1
	        local _type = 1
	        if _slot == 0 then
	            -- 在做
	            _time = 1
	            _type = 1
	        else
	            if _current then
	                -- 已经领取
	                _time = ( _slot%3 ) + 1
	                _type = 1
	            elseif _free then
	                -- 可以免费领取
	                _time = _slot
	                _type = 2
	            else
	                -- 补领
	                _time = _slot
	                _type = 3
	            end
	        end
	        if _type == 1 then
	        	-- 等cd
	    		self._activityFoodStatus = 1
	    		self._activityFoodTime = tonumber( data.nextTime.start ) - PlayerData:getTime()
	        elseif _type == 2 then
	        	-- 可以领
	        	self._activityFoodStatus = 2
	    		self._activityFoodTime = 0
	        elseif _type == 3 then
	        	-- 可以补
	        	self._activityFoodStatus = 3
	    		self._activityFoodTime = tonumber( data.nextTime.start ) - PlayerData:getTime()
	        end

			self:startBubbleTimer()
			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity"}})
	    end, 
	    isSilent = true,
	})
end

-- 竞速
function Player:setActivitySpeedRedDot()
	self._activitySpeedStatus = false
	if self:getRedState(4) == 1 then
		self._activitySpeedStatus = true
	end
	local _datas = self:getActivityInfo()
    for i, v in pairs( _datas ) do
        local _activeId = tonumber(v.activeId) or 0
        -- 竞速
        if _activeId == 2 then
            local _myTime = PlayerData:getTime()
            local _startTime = tonumber( v.openTime ) or 0
            local _startTime2 = tonumber(PlayerData:getCreateTime()) or 0
            local _endTime = tonumber( v.endTime ) or 0
            local _endTime2 = _startTime2 + 3*24*60*60
            if _startTime <= _myTime and _myTime <= _endTime
				and _startTime2 <= _myTime and _myTime <= _endTime2 then
				-- 活动开启
                zc.sendHttp({
                	apiName = "Speed_main",
                	successCallback = function( data )
	                    local _data = data.status or {}
	                    for k,value in pairs(_data) do
	                        if tonumber(value) == 1 then
	                        	self._activitySpeedStatus = true
	                        	-- 默认红点不显示，只有显示的时候需要设置
	                			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity"}})
	                            break
	                        end
	                    end
	                end,
                 	isSilent = true,
                })
            end
            break
        end
    end
end

-- 气泡计时器
function Player:startBubbleTimer()
	if not self._bubbleTimer then
		self._bubbleTimer = scheduler.scheduleGlobal(function()
			self:bubbleTick()
		end, 1)
		self:bubbleTick()
	end
end
function Player:bubbleTick()
	local _continue = false

	-- 商店
	for k, v in pairs( self._shopCanDoTime ) do
		if v <= 0 then
			-- 当前商店可以刷新
			self._shopCanDoTime[k] = 0
		else
			-- 当前商店不可以刷新，继续倒计时
			self._shopCanDoTime[k] = v - 1
			if self._shopCanDoTime[k] == 0 then
				-- 状态变化，刷新商店
				zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 12}})
			else
				_continue = true
			end
		end
	end

	-- 校场
	if self._drillFieldCanDoTime then
		if self._drillFieldCanDoTime <= 0 then
			-- 可训练
			self._drillFieldCanDoTime = 0
		else
			self._drillFieldCanDoTime = self._drillFieldCanDoTime - 1
			if self._drillFieldCanDoTime == 0 then
				zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 8}})
			else
				_continue = true
			end
		end
	end

	-- 鉴定
	if self._tenEvenPumpTime then
		if self._tenEvenPumpTime <= 0 then
			-- 可鉴定
			self._tenEvenPumpTime = 0
		else
			self._tenEvenPumpTime = self._tenEvenPumpTime - 1
			if self._tenEvenPumpTime == 0 then
				zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "tenEvenPump"}})
			else
				_continue = true
			end
		end
	end

	-- 领取体力
	if self._activityFoodTime then
		if self._activityFoodTime <= 0 then
			-- 可领取
			self._activityFoodStatus = 2
			self._activityFoodTime = 0
		else
			self._activityFoodTime = self._activityFoodTime - 1
			if self._activityFoodTime == 0 then
				self._activityFoodStatus = 2
				self._activityFoodTime = 0
				zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity"}})
			else
				_continue = true
			end
		end
	end

	if self:getRedState(10) then
		--铁匠铺打造红点
		if self:getRedState(10) > 1 then
			self:updateRedDotData(10, self:getRedState(10) - 1)
			_continue = true
		elseif self:getRedState(10) == 1 then
			self:updateRedDotData(10, 1)
			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 11}})
		end
	end

	if self:getRedState(2) then
		--粮草抢夺红点。
		if self:getRedState(2) > 1 then
			self:updateRedDotData(2, self:getRedState(2) - 1)
			_continue = true
		elseif self:getRedState(2) == 1 then
			self:updateRedDotData(2, 1)
		end
	end

	if self:getRedState(3) then
		--粮草成就红点。
		if self:getRedState(3) > 1 then
			self:updateRedDotData(3, self:getRedState(3) - 1)
			_continue = true
		elseif self:getRedState(3) == 1 then
			self:updateRedDotData(3, 1)
			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_FOODSRED, data = {}
			})
		end
	end

	-- 没有需要倒计时，停止计时器
	if not _continue then
		self:stopBubbleTimer()
	end
end
function Player:stopBubbleTimer()
	if self._bubbleTimer then
		scheduler.unscheduleGlobal( self._bubbleTimer )
		self._bubbleTimer = nil
	end
end

-------------主城大气泡-----------------
function Player:setMainBubble( datas )
	self._mainBubble = datas or {}
end

function Player:getMainBubble()
	return self._mainBubble or {}
end

function Player:freshMainBubbleShow()
	local mainCity = zc.getScene(LAYER_NAME_TAG.LAYER_MAINCITY)
	if not mainCity then
		return
	end
	self._mainBubble = self._mainBubble or {}
	local _flag = tonumber(self._mainBubble["1"]) or 0
    if _flag > 0 then
    	zc.dispatchEvent({
            name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, 
            data = {
            	tag = "bubble",
                sType = "Bubble_fight",
        }})
    end
    _flag = tonumber(self._mainBubble["2"]) or 0
    if _flag > 0 then
        zc.dispatchEvent({
            name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, 
            data = {
            	tag = "bubble",
                sType = "Bubble_challange",
        }})
    end
    _flag = tonumber(self._mainBubble["3"]) or 0
    if _flag > 0 then
        zc.dispatchEvent({
            name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, 
            data = {
            	tag = "bubble",
                sType = "Bubble_mine_wasChallenged",
        }})
    end
	self._dataBubble = self._dataBubble or {}
	_flag = tonumber(self._dataBubble["5"]) or 0
	if _flag > 0 then
    	zc.dispatchEvent({
            name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, 
            data = {
            	tag = "bubble",
                sType = "Bubble_gidFight",
        }})
    end
    _flag = tonumber(self._dataBubble["7"]) or 0
	if _flag > 0 then
    	zc.dispatchEvent({
            name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, 
            data = {
            	tag = "grabFood",
            	bubbleData = _flag,
        }})
    end
end

function Player:setDataBubble( datas )
	self._dataBubble = datas or {}
end

function Player:getDataBubble()
	return self._dataBubble or {}
end

-------------初始显示滚屏信息-----------------
function Player:setArenaChampionInfo( datas )
	self.arenaChampionInfo = datas or {}
end

function Player:getArenaChampionInfo()
	return self.arenaChampionInfo or {}
end

-------------任务模块相关-----------------
function Player:setTaskData( datas )
	local _datas = datas or {}
	-- dump(datas, "wm----setTaskData")
	self:setTaskActivityValue(_datas.activity)
	self:setTaskActivityDrawIds(_datas.activityDrawIds)
	self._downTaskDatas = _datas.tasks or {}
	self:freshMyTaskDatas()
end
function Player:freshMyTaskDatas()
	local _data = self._downTaskDatas
	self._taskData = {}
	if table.nums(_data) > 0 then
		for k,v in pairs(_data) do
			local _tag = tonumber(v.type) or 1
			if v.status == 1 or v.status == 2 or _tag == 2 then
				if self._taskData[_tag] == nil then
					self._taskData[_tag] = {}
				end
				table.insert(self._taskData[_tag], v)
			end
		end

		local function cmp(a,b)
			local _statusA = tonumber(a.status)
			local _statusB = tonumber(b.status)
			if _statusA ~= _statusB then
				if _statusA == 2 then
					return true
				elseif _statusB == 2 then
					return false
				elseif _statusA == 3 then
					return false
				elseif _statusB == 3 then
					return true
				end
			end
			return tonumber(a.taskId) < tonumber(b.taskId)
		end
		for k,v in pairs(self._taskData) do
			table.sort(v, cmp)
		end

		local _currentList = self._taskData[2] or {}
        local _list = {}
        for k,v in pairs(_currentList) do
            local _taskTemplate = gameData.getDataFromCacheWithPrimaryKey("task", v.taskId)
            if not _list[_taskTemplate.level] then
                _list[_taskTemplate.level] = {}
            end
        	v._template = _taskTemplate
            table.insert(_list[_taskTemplate.level], v)
        end
        self._achieveData = _list
	end
end
function Player:setTaskActivityValue( value )
	self._taskActivityValue = tonumber(value) or 0
end
function Player:getTaskActivityValue()
	return self._taskActivityValue or 0
end
function Player:setTaskActivityDrawIds( data )
	self._taskActivityDrawIds = data or {}
end
function Player:getTaskActivityDrawIds()
	return self._taskActivityDrawIds or {}
end
function Player:getTaskData()
	return self._taskData or {}
end

function Player:getAchieveTask()
	return self._achieveData or {}
end
--押镖国家帮助
function Player:setDartCountryHelp(_info)
	if not self._dartCountryHelpInfo then
		self._dartCountryHelpInfo = {}
	end
	local addUserid = tonumber(_info.userId) or 0
	local _alreadyHave = false
	for i = 1, #self._dartCountryHelpInfo do
		local v = self._dartCountryHelpInfo[i]
		if v and v.userId and tonumber(v.userId) == addUserid then
			_alreadyHave = true
			self._dartCountryHelpInfo[i] = _info
			break
		end
	end
	if not _alreadyHave then
		self._dartCountryHelpInfo[#self._dartCountryHelpInfo+1] = _info
	end
end
function Player:getDartCountryHelp()
	return self._dartCountryHelpInfo or {}
end
function Player:deletDartHelpByTime(_time)
	if self._dartCountryHelpInfo then
		for i = 1, #self._dartCountryHelpInfo do
			if _time == self._dartCountryHelpInfo[i]["createTime"] then
				table.remove(self._dartCountryHelpInfo,i)
				break
			end
		end
	end
end

--国家抢矿数据
function Player:getCountryMineData()
	return self._countryMineInfo._mineData or nil
end
--获取自己国家占领的矿
function Player:getSelfCountryOccupy()
	return self._countryMineInfo._countryOccupyData or nil
end
--获取自己占领的矿
function Player:getSelfOccupyedMine()
	return self._countryMineInfo._selfOccupy or nil
end
--获取次数
function Player:getCountryMineFightTimes()
	local times = {
		freeTimes = 0, 
		timesLimit = 0,
	}
	times.freeTimes = tonumber(self._countryMineInfo._freeTimes) or 0 
	times.timesLimit = tonumber(self._countryMineInfo._timesLimit) or 0
	return times
end
--设置挑战次数
function Player:setCountryMineFightTimes(_data)
	if not _data then
		return
	end
	if self._countryMineInfo and 
		self._countryMineInfo._freeTimes and 
		self._countryMineInfo._timesLimit then
		if _data.freeTimes then
			self._countryMineInfo._freeTimes = _data.freeTimes
		end
		if _data.timesLimit then
			self._countryMineInfo._timesLimit = _data.timesLimit
		end
	end
end
function Player:setCountryMineData(_data)
end

--进入抢矿主页面，初始化数据
function Player:initCountryMineData(_data)
	-- 国家矿总信息
	self._countryMineInfo = {
		_mineData = {},          --矿信息列表
		_countryOccupyData = {}, --自己国家占领列表(矿id做为key)
		_selfOccupy = {},        --自己占领的列表(现在只能占一个，但是写成列表形式，以后可以会改成占几个)
		_freeTimes = 0,
		_timesLimit = 0,
	}

	local _mineData = {}
	local _selfCountryOccupy = {}
	local _countryInfo = self:getCountryInfo() or {}
	local _selfCountryId = tostring(_countryInfo.id)
	for k, v in pairs(_data) do
		if v and type(v) == "table" and next(v) then
			local _index = #_mineData + 1 
			_mineData[_index] = {}
            _mineData[_index].countryArea = tonumber(k)
            local _list = {}
            for m,n in pairs(v) do
            	if n and n.countryId then
            		local _lIndex = #_list + 1
            		 _list[_lIndex] = {}
            		 _list[_lIndex] = n
            		 _list[_lIndex].countryMineId = tonumber(m)
            		 _list[_lIndex].countryArea = tonumber(k)

	             	--如果是自己的国家占领的，存入自己国家已占领列表
	            	if _selfCountryId and _selfCountryId == tostring(n.countryId) then
	            		_selfCountryOccupy[tonumber(m)] = "1"
	            		--检查是不是自己占领的矿
	            		if not self._countryMineInfo._selfOccupy[1] then
	            			self:checkSelfOccupyed(_list[_lIndex])
	            		end
	            	end
            	end
            end
            table.sort( _list, function(a,b)
            	return tonumber(a.countryMineId) < tonumber(b.countryMineId)
            end)
			_mineData[_index].mineList = _list
		end
	end
    table.sort( _mineData, function(a,b)
    	return tonumber(a.countryArea) < tonumber(b.countryArea)
    end)

	self._countryMineInfo._countryOccupyData = _selfCountryOccupy
	self._countryMineInfo._mineData = _mineData
	self._countryMineInfo._freeTimes = _data["freeTimes"] or 0
	self._countryMineInfo._timesLimit = _data["timesLimit"] or 0

end
--接受推送，矿信息改变
function Player:refreshCountryMineData(_data)
	--如果当前不在抢矿界面，直接返回
	if not zc.getScene("GrabMineMapFirstLayer") then
		return
	end

	if _data and _data.mineId then
		local _areaId = tonumber(_data.mineId) or 0 --区域id
		local _mineId = tonumber(_data.mid) or 0    --矿id
		local _mineAllData = self:getCountryMineData() or {}
		local _mineListInfo = _mineAllData[_areaId] or {} --矿列表信息
		local _mineList = _mineListInfo["mineList"] or {} --矿列表
		local _mineInfo = {}
		for i = 1, #_mineList do
			if _mineList[i] and _mineId == tonumber(_mineList[i]["countryMineId"]) then
				_mineInfo = _mineList[i]
				--刷新数据, 检查国家占领情况
				self:setCountryOneMineInfo(_mineList[i], _data)
				break
			end
		end
	end

	--检查自己占领情况
	self:checkSelfOccupyedInCountrry()
end
function Player:setCountryOneMineInfo(own, change, _selfMine)
	if next(own) and next(change) then
	    for k,v in pairs(own) do
	        if change[k] then
	            own[k] = change[k]
	        end
	    end
	    --检查国家占矿情况
		if own["countryId"] then
			local _countryInfo = self:getCountryInfo() or {}
			local _selfCountryId = tostring(_countryInfo.id)
			local _mineId = tonumber(own["countryMineId"])
			if _selfCountryId and _selfCountryId == tostring(own["countryId"]) then
				self._countryMineInfo._countryOccupyData[_mineId] = _mineId
			else
				if self._countryMineInfo._countryOccupyData[_mineId] then
					self._countryMineInfo._countryOccupyData[_mineId] = nil
				end
			end
		end
	end

	if _selfMine then --如果是操作自己的矿
		--检查自己占领情况
		self:checkSelfOccupyed(own, _selfMine)
	end

end
--检查自己在国家占矿列表中，是不有自己占领的矿
function Player:checkSelfOccupyedInCountrry()
	local _countryOccupy = self._countryMineInfo._countryOccupyData
	local _mineAllData = self:getCountryMineData() or {}
	self._countryMineInfo._selfOccupy = {}
	local _areaNum = 5 --5个区域
	for i = 1,_areaNum do
		local _mineListInfo = _mineAllData[i] or {} --矿列表信息
		local _mineList = _mineListInfo["mineList"] or {} --矿列表
		for i = 1, #_mineList do
			if _mineList[i] and tonumber(_mineList[i]["countryMineId"]) then
				local _mineId = tonumber(_mineList[i]["countryMineId"]) or 0    --矿id
				local _selfIsOccupy = self:checkSelfOccupyed(_mineList[i])
				if _selfIsOccupy then
					break
				end
			end
		end
	end
end
--检查是否有自己占领的队伍, _isSelf 如果是操作自己的矿
function Player:checkSelfOccupyed(_info, _isSelf)
	if not _info then return false end
    local _userId = tonumber(PlayerData.info.userId)
    local _teamUserNum = 3 --现在固定为3人队伍
    for i = 1, _teamUserNum do
    	if _info["userId"..i] and tonumber(_info["userId"..i]) and tonumber(_info["userId"..i]) > 0 then
    		if _userId == tonumber(_info["userId"..i]) then
        		self._countryMineInfo._selfOccupy[1] = _info.countryMineId
    			return true
    		end
    	end
    end

    if _isSelf then --如果只是操作自己的矿，放弃时，设置自己占领为空
    	self._countryMineInfo._selfOccupy[1] = nil
    end

    return false
end
--设置占领额外奖励数据
function Player:setOccupyExtraResData(_have)
	self._occupyExtraResData = {}
	local _have = _have or false
	self._occupyExtraResData.have = _have
	self._occupyExtraResData.time = os.time()
end
--设置抢夺额外奖励数据
function Player:setRobExtraResData(_data)
	self._robExtraResData = _data or {}
end

--保存解锁武将
function Player:setTollgateUnlockHero(_info)
	self._tollgateUnlockHero = _info or {}
end
--获取解锁武将
function Player:getTollgateUnlockHero()
	return self._tollgateUnlockHero
end

function Player:recordNowSockteTime()
	self._recordNowSockteTime = math.modf(socket.gettime())
end
function Player:getRecordNowSockteTime()
	return self._recordNowSockteTime or 0
end
-------------任务over-----------------

-------------武将列表---------------
function Player:setFragmentList( list )
	local _list = list or {}
	self._fragmentList = {}
	for k,v in pairs(_list) do
		self._fragmentList[tostring(v.heroFragmentId)] = v
	end
end

function Player:getFragmentInfoByHeroId( heroId )
	return self._fragmentList[tostring(heroId)]
end

function Player:getFragmentNumByHeroId( heroId )
	local _info = self._fragmentList[tostring(heroId)] or {}
	return tonumber(_info.num) or 0
end

function Player:updateFragment( heroId, curNum, id )
	if not self._fragmentList[tostring(heroId)] then
		self._fragmentList[tostring(heroId)] = {
			heroFragmentId = heroId,
			id = id,
			num = curNum,
		}
	else
		self._fragmentList[tostring(heroId)].num = curNum
	end
end
--设置兑换数据
function Player:setFragmentExchangeData(_data)
	self._fragmentExchangeData = _data or {}
end
function Player:getFragmentExchangeData()
	return self._fragmentExchangeData or {}
end
-------------武将列表over---------------

-- 返回附加属性
function Player:getDesc(params,skillData)
	local desc_list = {}
	local hitType = skillData.hitType
	local zhanfa_data = gameData.getDataFromCache("tactics_hero")
	for k,v in pairs(params) do
		-- if not desc_list[params.id] then
			local roleData = self:getSignGeneralById(params.id)
			local weaponType = tonumber(roleData.weaponType)
			local qualifications = tonumber(roleData.qualifications)
			for t,h in pairs(zhanfa_data) do
				if weaponType == tonumber(h.weaponType) and tonumber(h.qualifications) == qualifications and tonumber(hitType) == tonumber(h.skillType) then
					local t_h_data = h
					local str_list = {}
					-- print("t_h_data.desc:",t_h_data.desc)
					local tab_ = string.split(t_h_data.desc,"$")
				    for s,o in pairs(tab_) do
				    	local n,m = string.find(o,"|")
				    	if n then
				    		local gongshi = string.split(o,"|")
				    		local func = loadstring("return "..string.gsub(gongshi[2],"lv",params.lv))
				    		local str2 = func()
				    		local baifenhao = string.split(o,"%")
				    		if baifenhao[2] == "" then
				    			str2 = str2.."%"
							end
				    		table.insert(str_list,str2)
				    	else
				    		table.insert(str_list,o)
				    	end
				    end
				    local _desc = ""
				    for i = 1,#str_list do
				    	local str = str_list[i]
				    	if i%2 == 0 then
				    		_desc = _desc.."[color=ff00FF00]"..str.."[/color]"
				    	else
				    		_desc = _desc.."[color=ffcc9933]"..str.."[/color]"
				    	end
				    end
				    print("_desc:",_desc)
				    desc_list[params.id] = _desc
				end
			end
		-- end
	end
	return desc_list
end

-------------将魂---------------
function Player:setHeroSoul(data)
	self._heroSoul = {}
	local _data = data or {}
	for k, v in pairs(_data) do
		self:addHeroSoul(v)
	end
end

function Player:addHeroSoul(soulInfo )
	local _id = tostring( soulInfo.id )
	local _data = gameData.getDataFromCacheWithPrimaryKey("heroSoul", soulInfo.heroSoulId)
	for k, v in pairs( _data ) do
		if not soulInfo[k] then
			soulInfo[k] = v
		end
	end
	self._heroSoul[_id] = soulInfo
end

function Player:getHeroSoul()
	return self._heroSoul
end

function Player:getHeroSoulInfoById( id )
	local _id = tostring(id)
	return self._heroSoul[_id]
end
function Player:getHeroSoulInfoByHeroId( id )
	local _id = tonumber(id) or -1
	local _tb = {}
	for k, v in pairs( self._heroSoul ) do
		if tonumber(v.heroId) == _id then
			_tb[tostring(v.index)] = v
		end
	end
	return _tb
end
-- 更新，直接替换以前的数据
function Player:updateHeroSoul( soulInfo )
	self:addHeroSoul( soulInfo )
end
-- 删除
function Player:deleteHeroSoul( soulInfo )
	local _id = tostring(soulInfo.id)
	self._heroSoul[_id] = nil
end
-------------将魂 over---------------

----英雄试炼
function Player:setHeroTrain( data )
	self.heroTrain = data
end

function Player:getHeroTrain()
	return self.heroTrain
end

--获取掉落信息
function Player:getDropInfo(tollgateId)

	local staticInfo = gameData.getDataFromCache("heroTrainTollgate",{id = tonumber(tollgateId)})
	local headInfo =  gameData.getDataFromCache("heroTrainChapter",{id = tonumber(staticInfo.chapterId)})
	print("tollgateId: " .. tollgateId)
	dump(staticInfo)
	dump(headInfo)
	print("self.heroTrain")
	dump(self.heroTrain)

	local chapterId = tonumber(staticInfo.chapterId)
	local limitLevel = tonumber(staticInfo.levelLimit)
	local guankaIdx = tonumber(string.sub(tostring(tollgateId), -1,-1))
	local status = false

	local lv = self:getBaseInfoByTag("level")

	if tonumber(tollgateId) == 1001001 then
		status = true
	end

	for k,v in pairs(self.heroTrain) do
		if type(v) == "table" then
			for key,val in pairs(v.chapterInfo) do
				if tonumber(staticInfo.activateId) == tonumber(key) then
					status = true 
					break
				end
			end
		end
	end

	if lv < limitLevel then
		status = false
	end

	if not zc.getFunctionStatus(50) then
        status = false
    end

	local data = {
		chapterId = chapterId,
		status = status,
		guankaIdx = guankaIdx,
		data = self.heroTrain,
		headId = headInfo.chapterArchitecture
	}
	return data
end


function Player:updateHeroTrain(data)
	self.heroTrain = data
end
---

-------------全局数据，优化-------------
-- 武将列表用，酒馆的武将
function Player:setPubHeroList( data )
	self._pubHeroList = data
end
function Player:getPubHeroList()
	return self._pubHeroList
end

function Player:setSession( session, authkey )
	self.session = session
	self.authkey = authkey
end
function Player:getSession()
	return self.session, self.authkey
end

function Player:setCardExtracting( _flag )
	self._cardExtracting = _flag
	if self._cardExtracting == false then
        local node = cc.Director:getInstance():getNotificationNode()    
        local announce = node:getChildByName("announcement")    
        if not tolua.isnull(announce) then 
            announce:run()
        end 
	end
end
-------------全局数据over--------------
--[[
退出前，清理数据
]] 
function Player:clean()
	BATTLE_NOW_MAINROLE = ""
	BATTLE_SPEED_START = BATTLE_SPEED.X1
	-- 玩家资料信息
    self.info = {}
    self._addSkilfulData = nil
    --布阵信息
    self.formationsinfo = {}
    --武将信息
	self.generalinfo = {}
	--地域羁绊信息
	self._fetterRegionalInfo = {}
	--背包信息
    self.baginfo = {}
    --副本信息
    self.copyinfo = {}
    --建筑
    self.houseinfo = {}
    --资源
    self.resourcesInfo = {}
    --饰品信息
    self.trinketsInfo = {}
    --兵器信息
    self.weapons = {}
    --兵器成就
    self.weaponsBook = {}
    --最近聊天信息
    self.chatDataInfo = {}
    -- 次数信息
    self.limitInfo = {}
    --未读邮件数量
    self.unReadMailNum = 0
    --好友信息
    self.friendInfo = {}
    -- 活动开启状态信息
    self.activeInfo = {}
    -- 七日
    self._sevenDayStatus = 0
    self._secondDayStatus = 0
    -- 竞速
    self._activitySpeedStatus = false
    self._activityFoodStatus = false
    self._activityFoodTime = 0
    -- 装备
    self.equipinfo = {}
    self.gemInfo = {}
    self.arenaChampionInfo = {}
    --服务器时间
    self.time = nil
    self.timediff = nil--时间差
    --引导
    g_GuideManager = nil

    -- 体力恢复倒计时清除
    self:stopEnergyTimer()

	-- 气泡倒计时清除
	self:stopBubbleTimer()
	self._canTalentDo = 0
	self._shopCanDoTime = {}
	self._drillFieldCanDoTime = 0
	self._tenEvenPumpTime = 0
    self._nowFormationFile = {}

    self._lastFighting = nil
    self._lastEnergy = nil
    self._lastEnergyLimit = nil
    
    -- SDKData
    self.SDKData = nil
    -- session
    self.session = nil
    self.authkey = nil
    self.serverInfo = {}
    self.activityReds = {}
    --武将碎片
    self._fragmentList = {}
    self._cardExtrData = {}
    self._heroSoul = {}

    --服务器id
    self.serverId = nil
    --红点
    self.redDotList = {}
    self.heroTrain = {}
    BATTLE_SUPERSKIP_VIP = 0
    self._cardExtracting = false
end

PlayerData = Player.new()