local ChouJiangChengjiu = class( "ChouJiangChengjiu", function ()
    return ZCPopLayer:create({opacityValue = 200, hideCallback = nil})
end)

function ChouJiangChengjiu:create(params)
	return ChouJiangChengjiu.new(params)
end

function ChouJiangChengjiu:ctor(params)
	self:initData(params)
	self:initUI()
	self:show()
end

function ChouJiangChengjiu:initData(params)
	local params = params or {}
	-- self._alreadGet = params.turnTableInfo.received or {}
	self.achievementData1 = {}
	local achievementData = params.achievementData
	for k,v in pairs(achievementData) do
		table.insert(self.achievementData1,v)
	end
    self.received = {}
    local received = params.turnTableInfo.received
    for k,v in pairs(received) do
        self.received[(v)] = v
    end
	self.turnTableInfo = params.turnTableInfo
	self:sortData()
end

function ChouJiangChengjiu:sortData()
    local list = {}
    local list1 = {}
    self.achievementData = {}
    for k,v in pairs(self.achievementData1) do
        if self.received[v.id] then
            table.insert(list,v)
        else
            table.insert(list1,v)
        end
    end
	table.sort(list,function (a,b)
		local aprizeDrawNum = tonumber(a.prizeDrawNum) or 1
		local bprizeDrawNum = tonumber(b.prizeDrawNum) or 1
        local stateA = (self.received[a.id])
        local stateB = (self.received[b.id])
		return aprizeDrawNum < bprizeDrawNum
	end)
    table.sort(list1,function (a,b)
        local aprizeDrawNum = tonumber(a.prizeDrawNum) or 1
        local bprizeDrawNum = tonumber(b.prizeDrawNum) or 1
        local stateA = (self.received[a.id])
        local stateB = (self.received[b.id])
        return aprizeDrawNum < bprizeDrawNum
    end)
    for k,v in pairs(list1) do
        table.insert(self.achievementData,v)
    end
    for k,v in pairs(list) do
        table.insert(self.achievementData,v)
    end
end

function ChouJiangChengjiu:initUI()
	local popBg = zc.createNormalPop({
    	tag = 4,
    	height = 490,
    	width = 530,
	})
	popBg:setPosition(zc.width/2, zc.height/2)
	self:addContent(popBg)
	self.popBg = popBg
    local titleBg = zc.createSprite('res/Main/common/popBg/tipDi.png')
    titleBg:setPosition(320,430)
    popBg:addChild(titleBg,10)

	local title = zc.createSprite('res/Main/target/choujiang.png')
	title:setPosition(titleBg:getContentSize().width/2,titleBg:getContentSize().height/2)
	titleBg:addChild(title,10)

	local popSize = popBg:getContentSize()
	local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width, popBg:getContentSize().height),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close,10)
    self:initTableView()
end

function ChouJiangChengjiu:initTableView()
	local tableSize = cc.size(500,388)
    local tableView = zc.ZCTableView:create(tableSize)
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableView:setPosition(15,10)
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN) --kTableViewFillBottomUp  kTableViewFillTopDown
    local _cellWidth = 500
    local _cellHeight = 137
    -- dump(self._data)
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildRightCell(cell,cellIndex + 1,_cellHeight,_cellWidth)
        end
        self:updateRightCell(cell, cellIndex + 1,_cellHeight,_cellWidth)
        return cell
    end
    local _num = #self.achievementData
    local function numberOfCellsInTableView()
        return _num
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self.popBg:addChild( tableView )
    tableView:reloadData()

    self.right_tableView = tableView
end

function ChouJiangChengjiu:buildRightCell( cell,cellIndex,_cellHeight,_cellWidth )
	-- bg
	cell._item_bg = zc.getScaleNode("res/Main/grabFood/cellDi.png", cc.size(500, 132))
	cell._item_bg:setPosition(_cellWidth/2,_cellHeight/2)
    cell:addChild(cell._item_bg)

    local _nameDi1 = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(200, 30))
    _nameDi1:setAnchorPoint(0.5, 0.5)
    _nameDi1:setPosition(120, 105)
    cell._item_bg:addChild(_nameDi1)
    for i = 1,3 do
    	local _icon = zc.createIconByData({
            data = {
                mainType = 1,
                type = 1,
                id = 1,
                num = 1,
            },
            showCount = true,
            scale = 0.6,
            pos = cc.p(60 + (i - 1)*90, _cellHeight*0.5 - 20),
        })
        cell["_icon"..i] = _icon
        cell._item_bg:addChild(_icon)
    end

	--描述
    cell._task_desc_label = zc.createLabel({
        text = "累计抽奖",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(20, _nameDi1:getContentSize().height/2),
        color = cc.c3b(228,164,169),
    })
    _nameDi1:addChild(cell._task_desc_label)
    --num
    cell.numlabel = zc.createLabel({
        text = "10",
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(cell._task_desc_label:getPositionX() + cell._task_desc_label:getContentSize().width, _nameDi1:getContentSize().height/2),
    })
    _nameDi1:addChild(cell.numlabel)
    --ci
    cell.ci = zc.createLabel({
        text = zc.lang("ci"),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        color = cc.c3b(228,164,169),
        pos = cc.p(cell.numlabel:getPositionX() + cell.numlabel:getContentSize().width, _nameDi1:getContentSize().height/2),
    })
    _nameDi1:addChild(cell.ci)
    -- 前往
    cell._task_goto = zc.createCommomBtn({
        tag = 2,
        ap = cc.p(0.5,0.5),
        pos = cc.p(cell._item_bg:getContentSize().width - 90, 50),
        text = zc.lang("qianwang_2"),
    })
    cell:addChild(cell._task_goto)
    -- 领取
    cell.getTask = zc.createCommomBtn({
        tag = 1,
        ap = cc.p(0.5,0.5),
        pos = cc.p(cell._item_bg:getContentSize().width - 90, 50),
        text = zc.lang("fetch_2"),
    })
    cell:addChild(cell.getTask)

    cell.yilingqu = zc.createSprite("res/Main/activity/monthSign/fetched.png")
    cell.yilingqu:setPosition(cell.getTask:getPositionX(),cell.getTask:getPositionY() + 20)
    cell:addChild(cell.yilingqu)

     --完成度数据
    cell._completionDegree_label = zc.createLabel({
    	text = "10/",
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(cell._item_bg:getContentSize().width - 90, 95),
        outLine = true,
        pixel = 1.3,
        color = display.COLOR_GREEN,
        color2 = cc.c3b( 87, 0, 0 ),
    })
    cell._item_bg:addChild(cell._completionDegree_label)
end
function ChouJiangChengjiu:updateRightCell(cell,cellIndex,_cellHeight,_cellWidth )
	local data = self.achievementData[cellIndex]
	if not data then return end
	local total_num = tonumber(data.prizeDrawNum ) or 1
	cell.numlabel:setString(tostring(total_num))
	local current_nums = tonumber(self.turnTableInfo.turnTimes) or 1
	local str_num = current_nums.."/"..total_num
	cell._completionDegree_label:setString(str_num)
	cell._completionDegree_label:setColor(current_nums >= total_num and display.COLOR_GREEN or display.COLOR_RED)
	local rewardData = data.awards
	local list = string.split(rewardData,",")
    cell.numlabel:setPositionX(cell._task_desc_label:getPositionX() + cell._task_desc_label:getContentSize().width+3)
    cell.ci:setPositionX(cell.numlabel:getPositionX() + cell.numlabel:getContentSize().width+3)
	-- dump(list)
	for i = 1,3 do
		if list[i] then
			local _cont = string.split(list[i],"|")
            local _item,info = zc.updateIconByData(cell["_icon"..i],{
                data = {
                    mainType = _cont[1],
                    type = _cont[2],
                    id = _cont[2],
                    num = _cont[3],
                },
                showCount = true,
            })
            cell["_icon"..i]:setVisible(true)
		else
			cell["_icon"..i]:setVisible(false)
		end
	end
    local state = (self.received[data.id])
    -- print("id ",data.id,"state ",state)
    if current_nums >= total_num then
        cell._task_goto:setVisible(false)
        cell.getTask:setVisible(true)
    else
        cell.getTask:setVisible(false)
        cell._task_goto:setVisible(true)
    end
    
    if not state then
        cell.yilingqu:setVisible(false)
        cell._completionDegree_label:setVisible(true)
    else
        cell._completionDegree_label:setVisible(false)
        cell.yilingqu:setVisible(true)
        cell._task_goto:setVisible(false)
        cell.getTask:setVisible(false)
    end
    cell.getTask:setTouchEndedCall(function()
        zc.sendHttp({
            apiName = "TurnTable_refresh",
            params = {id = data.id},
            successCallback = function( net_data )
                dump(net_data)
                net_data.noAnimation = true
                PlayerData:updataData(net_data)
                zc.createShowReward(net_data)
                self.received[data.id] = data.id
                self:sortData()
                self.right_tableView:reloadData()
                zc.dispatchEvent({name = CUSTOM_EVENT.EVET_GET_REWARD, data = {id = data.id}})
            end
        })
    end)
    cell._task_goto:setTouchEndedCall(function()
        self:hide()
    end)
end

return ChouJiangChengjiu