-- FileName: FightEnterLayer.lua
-- Author: wangming
-- Date: 2016-09-29
-- Purpose: 征战界面
--[[TODO List]]
local FightEnterLayer = class("FightEnterLayer", function()
	return zc.createNormalDialog()
end)

function FightEnterLayer:create( params )
	return FightEnterLayer.new( params )
end

function FightEnterLayer:ctor( params )
	local _db = gameData.getAllDataWithNoClone("fight")
	self._dataNum = table.nums(_db)
	self._staticDatas = {}
	for k, v in pairs(_db) do
		local _value = clone(v)
		_value.httpData = params[k] or {}
		_value.isLimitTime = _value.httpData.time ~= ""
		_value.openFlag = zc.getFunctionStatus(v.functionId) and _value.httpData.isOpen == 1
		local data = gameData.getDataFromCacheWithPrimaryKey("functions", _value.functionId)
		_value.openLevel = data.userLevel
		_value.openTollgateId = data.tollgateId
		_value.funcIcon = data.icon
		if v.functionId == 24 then
		    if tonumber(PlayerData:getBaseInfoByTag("countryId")) == 0 or PlayerData:getBaseInfoByTag("countryName") == ""  then 
		        _value.openFlag = false
		    end
		end
		self._staticDatas[#self._staticDatas + 1] = _value
	end
	table.sort(self._staticDatas, function( a, b )
		if not a or not b then
			return false
		end
		if a.openFlag ~= b.openFlag then
			return a.openFlag
		end
		if a.isLimitTime ~= b.isLimitTime then
			return a.isLimitTime
		end
		if a.openLevel ~= b.openLevel then
			return a.openLevel < b.openLevel
		end
		return a.id < b.id
	end)

	self._nowIdx = 1
	self:initUI()
end

function FightEnterLayer:initUI()
    local _bgSp = zc.createNormalPop({
    	tag = 2,
    	width = 970,
	})
	self:addChild(_bgSp)
	local _bgSize = _bgSp:getContentSize()

    local _titleImg = _bgSp:getChildByName("titleImg")
	local _title = zc.getSprite({
		src = "res/Main/activity/fightEnter/title.png",
        ap = cc.p(0.5, 0),
        pos = cc.p(120, _bgSize.height - _titleImg:getContentSize().height - 15)
	})
    _bgSp:addChild(_title, 5)


	-- tableview
	local _tbSize = cc.size(615, 450)
	local _tableview = zc.ZCTableView:create(_tbSize)
    _tableview:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
	_tableview:setDelegate()
	_tableview:setPosition(10, 10)

    local _cellSize = cc.size(_tbSize.width, 140)
    local function cellSizeForTable(table, index) 
    	if index == 0 then
        	return _cellSize.height + 20, _cellSize.width
    	else
    		
        	return _cellSize.height, _cellSize.width
    	end
    end
    local function numberOfCellsInTableView()
    	return self._dataNum
    end
    local function tableCellAtIndex(table, index)
        local _cell = table:dequeueCell()
        -- 创建模板
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
            self:createCell(_cell, _cellSize)
        end
        self:updateCell(_cell, index)
        

        return _cell
    end
    _tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
	_bgSp:addChild(_tableview)
	self._tableview = _tableview

	-- right
	local _rightBg = zc.createNormalPop({
        width = 342,
        height  = _bgSize.height - 15,
        showSide = false,
        src = "res/Main/activity/fightEnter/rightBg.jpg"
    })
    _rightBg:setAnchorPoint(0, 0)
    _rightBg:setPosition(625, 0)
    _bgSp:addChild(_rightBg, 1)
    self._rightBg = _rightBg
    self:initRight()
	_tableview:reloadData()
	self:freshRight()
end

function FightEnterLayer:initRight()
	local _rightBg = self._rightBg
    local _rightSize = _rightBg:getContentSize()
    local _height = 263
	local _pic = zc.getSprite({
		ap = cc.p(0, 0),
		pos = cc.p(0, _height),
	})
	_rightBg:addChild(_pic)
	self._nowPicImg = _pic

	local _descLab = zc.createLabel({
		text = "",
		width = 310,
		fontSize = 18,
		color = cc.c3b(144, 144, 144),
		ap = cc.p(0, 1),
		pos = cc.p(18, _height - 6),
		outLine = true,
	})
	_rightBg:addChild(_descLab)
	self._nowDescLab = _descLab

	local _dropDi = zc.getSprite({
		src = "res/Main/matrix/matrix_bar1.png",
		ap = cc.p(0, 1),
		pos = cc.p(0, _height - 75),
	})
	_rightBg:addChild(_dropDi)
	local _label = zc.createRichLabel({
		text = zc.lang("activity_reward"),
		fontSize = 22,
		anchor = cc.p(0, 0.5),
		pos = cc.p(16, _dropDi:getContentSize().height*0.5 + 5),
	})
	_label:setGradientColor(cc.c4b(244, 159, 8, 255), cc.c4b(255, 255, 124, 255), cc.p(0, -1))
	_dropDi:addChild(_label) 

	local _dropViewSize = cc.size(_rightSize.width, 80)
	local _view = zc.createScrollview({
        size = _dropViewSize,
        innerSize = _dropViewSize,
        pos = cc.p(0, 80),
    }) 
    self._dropView = _view
    _rightBg:addChild(_view)

	local _btn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("join2"),
        pos = cc.p(_rightSize.width*0.5, 45),
        endCallback = function()
	        local _nowData = self._staticDatas[self._nowIdx] or {}
	        LayerManager.backToMainCity(false)
			local _idx = _nowData.id
        	if _idx == 1 then
        		zc.createCountryDartMainLayer()
    		elseif _idx == 2 then
    			zc.createWorldBossLayer()
    		elseif _idx == 3 then
    			zc.createTollgateHeroMainLayer()
    		elseif _idx == 4 then
    			zc.createResearchQunXiong()
    		elseif _idx == 5 then
    			zc.createMultiCopyMainScene()
    		elseif _idx == 6 then
    			zc.createWeaponCopy()
    		elseif _idx == 7 then
    			zc.createWushenshilian()
    		elseif _idx == 8 then
	            zc.createLimitChallengeCopy()
    		end
	    end
	})
	_rightBg:addChild(_btn)
	self._goBtn = _btn
end

function FightEnterLayer:createCell( _cell, _cellSize )
	local _di = zc.getSprite({
    	src = "res/Main/activity/fightEnter/cellDi.png",
    	ap = cc.p(0.5, 0),
		pos = cc.p(_cellSize.width*0.5, 0),
	})
	_cell._di = _di
	_cell:addChild(_di)

	local _diSize = _di:getContentSize()

	local _cellBody = zc.getSprite({
		ap = cc.p(1, 0),
		pos = cc.p(_diSize.width - 5, 10),
	})
	_cell._cellBody = _cellBody
	_di:addChild(_cellBody)
	local _cellName = zc.getSprite({
		ap = cc.p(1, 0),
		pos = cc.p(_diSize.width - 15, 10),
	})
	_cell._cellName = _cellName
	_di:addChild(_cellName)

	local _headDi = zc.getSprite({
		src = "res/Main/hero/hero_item1.png",
		ap = cc.p(0, 0.5),
		pos = cc.p(30, _diSize.height*0.5),
		scale = 0.8
	})
	_di:addChild(_headDi)
	_cell._headDi = _headDi
	local _headIcon = zc.getSprite({
		ap = cc.p(0.5, 0.5),
		pos = cc.p(_headDi:getContentSize().width*0.5, _headDi:getContentSize().height*0.5),
		scale = 0.7,
	})
	_cell._headIcon = _headIcon
	_headDi:addChild(_headIcon)

	local _openLabel = zc.createLabel({
		fontSize = 18,
		pos = cc.p(245, 110),
		outLine = true,
	})
	_openLabel.isLable = true
	_cell._openLabel = _openLabel
	_di:addChild(_openLabel)
	local _leftLace = zc.getSprite({
		src = "res/Main/common/lace.png",
		ap = cc.p(1, 0.5),
		pos = cc.p(0, _openLabel:getPositionY()),
	})
	_cell._leftLace = _leftLace
	_di:addChild(_leftLace)
	local _rightLace = zc.getSprite({
		src = "res/Main/common/lace.png",
		ap = cc.p(1, 0.5),
		pos = cc.p(0, _openLabel:getPositionY()),
	})
	_rightLace:setScaleX(-1)
	_cell._rightLace = _rightLace
	_di:addChild(_rightLace)

	local _timeDi = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(220, 32))
	_timeDi:setAnchorPoint(0.5, 0.5)
    _timeDi:setPosition(_openLabel:getPositionX(), 80)
	_di:addChild(_timeDi)
	local _dot = zc.getSprite({
		src = "res/Main/vip/vip_dot.png",
		pos = cc.p(20, _timeDi:getContentSize().height*0.5)
	})
	_timeDi:addChild(_dot)
	local _tipLab = zc.createLabel({
		text = zc.lang("time") .. ":",
		fontSize = 18,
		color = cc.c3b(255, 236, 203),
		ap = cc.p(0, 0.5),
		pos = cc.p(30, _timeDi:getContentSize().height*0.5),
	})
	_tipLab.isLable = true
	_timeDi:addChild(_tipLab)
	local _timeLab = zc.createLabel({
		fontSize = 18,
		ap = cc.p(1, 0.5),
		color = display.COLOR_GREEN,
		pos = cc.p(_timeDi:getContentSize().width - 5, _timeDi:getContentSize().height*0.5),
	})
	_timeLab.isLable = true
	_cell._timeLab = _timeLab
	_timeDi:addChild(_timeLab)



	_timeDi = zc.getScaleNode("res/Main/role/trinket/attrDi.png", cc.size(220, 32))
	_timeDi:setAnchorPoint(0.5, 0.5)
    _timeDi:setPosition(_openLabel:getPositionX(), 40)
	_di:addChild(_timeDi)
	_dot = zc.getSprite({
		src = "res/Main/vip/vip_dot.png",
		pos = cc.p(20, _timeDi:getContentSize().height*0.5)
	})
	_timeDi:addChild(_dot)
	_tipLab = zc.createLabel({
		text = zc.lang("cishu") .. ":",
		fontSize = 18,
		color = cc.c3b(255, 236, 203),
		ap = cc.p(0, 0.5),
		pos = cc.p(30, _timeDi:getContentSize().height*0.5),
	})
	_tipLab.isLable = true
	_timeDi:addChild(_tipLab)
	local _timesLab = zc.createLabel({
		fontSize = 18,
		ap = cc.p(1, 0.5),
		color = display.COLOR_GREEN,
		pos = cc.p(_timeDi:getContentSize().width - 5, _timeDi:getContentSize().height*0.5),
	})
	_timesLab.isLable = true
	_cell._timesLab = _timesLab
	_timeDi:addChild(_timesLab)


	local _touchBtn = zc.createPushButton({
		normalFile = "res/Main/activity/fightEnter/cellBtn_u.png",
		selectedFile = "res/Main/activity/fightEnter/cellBtn_d.png",
		noScaleAction = true,
		needSwallow = false,
		needEnableWhenMoving = true,
		pos = cc.p(_cellSize.width*0.5, _di:getPositionY() + _diSize.height*0.5),
	})
	_cell._touchBtn = _touchBtn
	_cell:addChild(_touchBtn, 5)

	local _timeLimit = zc.getSprite({
    	src = "res/Main/activity/fightEnter/timeLimit.png",
    	ap = cc.p(0, 1),
		pos = cc.p(0, _touchBtn:getContentSize().height),
	})
	_cell._timeLimit = _timeLimit
	_touchBtn:addChild(_timeLimit)
	_timeLimit:setVisible(false)
end

function FightEnterLayer:updateCell( _cell, index )
	local _idx = index + 1
	local _nowData = self._staticDatas[_idx] or {}

    _cell._touchBtn:setTouchEndedCallback(function()
    	self._nowIdx = _idx
    	self._nowFlag = _nowData.openFlag
    	if not tolua.isnull(self._nowSelected) then
        	self._nowSelected:setSelected(false)
        	self._nowSelected:setEnable(true)
    	end
    	self._nowSelected = _cell._touchBtn
    	_cell._touchBtn:setSelected(true)
    	_cell._touchBtn:setEnable(false)
    	self:freshRight()
    end)

    --icon
    local _color = tonumber(_nowData.color) or 1
    _cell._headDi:setTexture("res/Main/hero/hero_item" .. _color .. ".png")
    if _nowData.functionId == 24 then
    	_cell._headIcon:setTexture("res/Main/common/common_icon_zhulu.png")
    else
    	_cell._headIcon:setTexture("res/Main/common/common_icon_" .. _nowData.funcIcon ..".png")
    end
    --条件
    if _nowData.functionId == 24 or _nowData.functionId == 33 then
    	_cell._openLabel:setString(zc.lang("need_join_country"))
    else
    	if tonumber(_nowData.openLevel) == 1 then
    		local _id = tonumber(_nowData.openTollgateId) or 1001001
	    	_id = _id - 1000000
	    	local _z  = math.modf(_id/1000)
	    	local _g  = _id%100
	    	_cell._openLabel:setString(LANGUAGE_UNLOCK_FUNCTION_TIP(_z, _g))
	    else
	    	_cell._openLabel:setString(LANGUAGE_UNLOCK_FUNCTION_TIP(nil, nil, _nowData.openLevel) )
	    end
    end
    _cell._openLabel:setColor(cc.c3b(62, 50, 26))
    local _width = _cell._openLabel:getContentSize().width
     _cell._leftLace:setPositionX(_cell._openLabel:getPositionX() - _width*0.5 - 2)
    _cell._rightLace:setPositionX(_cell._openLabel:getPositionX() + _width*0.5 + 2)
    --时间
    _nowData.httpData = _nowData.httpData or {}
    local _string = _nowData.isLimitTime and tostring(_nowData.httpData.time) or zc.lang("hole_day")
    _cell._timeLab:setColor(display.COLOR_GREEN)
    _cell._timeLab:setString(_string)
    --次数
    _string = tonumber(_nowData.httpData.timesLimit) == 0 and zc.lang("no_limit") or (tostring(_nowData.httpData.times) .. "/" .. tostring(_nowData.httpData.timesLimit))
    _cell._timesLab:setColor(display.COLOR_GREEN)
    _cell._timesLab:setString(_string)
    --人物图
    _cell._cellBody:setTexture("res/Main/hero/list/" .. _nowData.icon .. ".png")
    _cell._cellBody:setScale(0.4436)
	--名字
	_cell._cellName:setTexture("res/Main/activity/fightEnter/funcPic/name_" .. _nowData.id .. ".png")
	--限时
	_cell._timeLimit:setVisible(_nowData.isLimitTime)
	--开启状态的处理
	zc.doFuncForAllChild(_cell._di, function( child )
		if not child.isLable then
    		zc.setGray(child, not _nowData.openFlag)
    	else
    		child:setColor(display.COLOR_WHITE)
    	end
	end)

    if _idx == self._nowIdx then
    	self._nowFlag = _nowData.openFlag
    	_cell._touchBtn:setSelected(true)
    	_cell._touchBtn:setEnable(false)
    	if not tolua.isnull(self._nowSelected) then
        	self._nowSelected:setSelected(false)
        	self._nowSelected:setEnable(true)
    	end
    	self._nowSelected = _cell._touchBtn
    else
    	_cell._touchBtn:setSelected(false)
    	_cell._touchBtn:setEnable(true)
    end
end

function FightEnterLayer:freshRight()
	local _nowData = self._staticDatas[self._nowIdx] or {}
	self._nowPicImg:setTexture("res/Main/activity/fightEnter/funcPic/pic_" .. tostring(_nowData.id) .. ".jpg")
	self._nowDescLab:setString(_nowData.desc)
	self._goBtn:setEnable(self._nowFlag)

	self._dropView:removeAllChildren()
	local _innerSizeW = 10
	local _innerSizeH = self._dropView:getContentSize().height
	local _tb = string.split(_nowData.drop or "", ",")
	local _num = #_tb
	if _num > 0 then
		for i = 1, _num do
			local _info = string.split(_tb[i], "|")
			local item = zc.createIconByData({
	            data = {
	                mainType = _info[1],
	                type = _info[2], 
	                id = _info[2],
	                num = 1,
	            }, 
	            showDetailPop = true,
	            pos = cc.p(_innerSizeW + 40, _innerSizeH*0.5), 
	        })
	        item:setScale(0.55)
	        self._dropView:addChild(item)
	        _innerSizeW = _innerSizeW + 80
		end
	end

    self._dropView:setInnerContainerSize(cc.size(_innerSizeW, _innerSizeH))

end

return FightEnterLayer
