--[[
	领取体力活动
	唐实聪
	2016.6.15
]]
local ReceiveEnergyLayer = class("ReceiveEnergyLayer", function()
	local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function ReceiveEnergyLayer:create( params )
	return ReceiveEnergyLayer.new( params )
end

function ReceiveEnergyLayer:ctor( params )
	self:initData( params )
	self:initUI()
	self:refresh()
	self._food:getAnimation():play("start_"..tostring(self._type), -1, 0)
end

function ReceiveEnergyLayer:initData( params )
	self._data = params or {}

	self._word = {}

	self._size = self:getContentSize()

	-- 红点
	if PlayerData._activityFoodStatus == 3 then
		PlayerData._activityFoodStatus = 1
		zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 11}})
		zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity"}})
	end
end

function ReceiveEnergyLayer:initUI()
	-- 背景
	local bg = cc.Sprite:create( "res/Main/activity/receiveEnergy/bg.png" )
	bg:setAnchorPoint( 0.5, 1 )
	bg:setPosition( self._size.width/2, self._size.height )
	self:addChild( bg )
	
	-- 妇女
	local woman = cc.Sprite:create( "res/Main/activity/receiveEnergy/woman.png" )
	woman:setPosition( self._size.width/2 - 40, self._size.height/2 + 65 )
	self:addChild( woman )
	-- 话背景
	local word_bg = cc.Sprite:create( "res/Main/levy/kuang2.png" )
	word_bg:setAnchorPoint( 0, 1 )
	word_bg:setPosition( woman:getContentSize().width - 20, woman:getContentSize().height )
	woman:addChild( word_bg )
	-- 话
	for i = 1, 3 do
		local word = zc.createLabel({
	        fontSize = 20,
	        ap = cc.p( 0, 0.5 ),
	        pos = cc.p( 23, 120 - 30*i ),
	        color = display.COLOR_BLACK,
	        color2 = display.COLOR_BLACK,
	        align = kCCTextAlignmentLeft,
	    })
	    word_bg:addChild( word )
	    self._word[i] = word
	end
	
	-- 桌子
	local desk = cc.Sprite:create( "res/Main/activity/receiveEnergy/desk.png" )
	desk:setAnchorPoint( 0.5, 0 )
	desk:setPosition( self._size.width/2, 60 )
	self:addChild( desk )
	-- 食物
	local _armature = nil
	_armature = zc.createArmature({
        parentPath = "res/animation/roukuai/",
        fileName = "roukuai",
        eventCallback = function() end,
    })
    _armature:setPosition( desk:getContentSize().width/2 + 0, 80 )
	desk:addChild( _armature )
	self._food = _armature
	-- 按钮
	local foodBtn = zc.createPushButton({
		touchSize = cc.size( 350, 110 ),
		pos = cc.p( desk:getContentSize().width/2, 80 ),
		endCallback = function()
			if self._type == 2 then
				-- 正常领取体力
				zc.sendHttp({
					apiName = "ReceiveEnergy_receive",
					successCallback = function( backData )
						if tolua.isnull(self) then
							return
						end
					-- dump( backData, "ReceiveEnergyLayer" )
                        PlayerData:updataData( backData )
                        self._food:getAnimation():play("over_2", -1, 0)
                        self._data = backData
                        self:refresh()
                        self:updateRedDot()
                    end,
                })
			elseif self._type == 3 then
				-- 补领体力
				zc.createSourcePop("ReceiveEnergyPop", "src/layer/activity/ReceiveEnergyPop.lua", {
					price = self._data.price,
					callback = function( backData )
						self._food:getAnimation():play("over_3", -1, 0)
						self._data = backData
	                    self:refresh()
                        self:updateRedDot()
	                end
				})
			end
		end
	})
	desk:addChild( foodBtn )

	-- 底部
	local bottom = ccui.Scale9Sprite:create( cc.rect( 20, 10, 549, 71 ), "res/Main/role/trinket/sellDi.png" )
    bottom:setContentSize( 728, 68 )
    bottom:setAnchorPoint( 0, 0 )
    bottom:setPosition( -2, -5 )
    self:addChild( bottom )
    self._bottom = bottom
    -- 底部文字
    local tip = zc.createLabel({
        fontSize = 21,
        outLine = true,
        pixel = 1,
        color = display.COLOR_TAB_NORMAL_COLOR1,
        color2 = display.COLOR_TAB_NORMAL_COLOR2,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( bottom:getContentSize().width/2, 45 ),
	})
	bottom:addChild( tip )
	self._tip = tip
    -- 元宝图片
	local gold = cc.Sprite:create( "res/Main/common/common_icon_gold.png" )
	gold:setPosition( bottom:getContentSize().width/2 - 10, tip:getPositionY() )
	bottom:addChild( gold )
	self._gold = gold
	-- 体力图片
	local energy = cc.Sprite:create( "res/Main/common/common_icon_energy.png" )
	energy:setPosition( bottom:getContentSize().width/2 + 75, tip:getPositionY() )
	bottom:addChild( energy )
	self._energy = energy
	-- 活动时间
	local time = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1,
        color = zc.COLOR_GREEN,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( bottom:getContentSize().width/2, 18 ),
	})
	bottom:addChild( time )
	self._time = time
end

function ReceiveEnergyLayer:refresh()
	-- 当前时间段
	local _slot = tonumber( self._data.slot ) or 0
	-- 能否免费领取
	local _free = self._data.free or false
	-- 是否已经领取
	local _current = self._data.current or false
	-- 领取体力的时间段
	local _next = string.split( tostring( self._data.next ), "-" )

	-- 类型
	local _time = 1
	local _type = 1
	if _slot == 0 then
		-- 在做
		_time = 1
		_type = 1
	else
		if _current then
			-- 已经领取
			_time = ( _slot%3 ) + 1
			_type = 1
		elseif _free then
			-- 可以免费领取
			_time = _slot
			_type = 2
		else
			-- 补领
			_time = _slot
			_type = 3
		end
	end
	self._type = _type
	if _type == 1 then
		-- 已领取
		local _wordData = LANGUAGE_RECIEVEENERGY_TIPS.tip_group1
		for i = 1, 3 do
			self._word[i]:setText( _wordData[i] )
		end
		local _tipData = LANGUAGE_RECIEVEENERGY_TIPS.tip_1
		self._tip:setText( _tipData[_time] )
		self._tip:setPositionY( 45 )
		self._gold:setVisible( false )
		self._gold:setPositionY( 45 )
		self._energy:setVisible( false )
		self._energy:setPositionY( 45 )
		self._time:setText( zc.lang("activity_time") .. "：  "..tostring( _next[1] )..":00 - "..tostring( _next[2] )..":00" )
	elseif _type == 2 then
		-- 可领取
		local _wordData = LANGUAGE_RECIEVEENERGY_TIPS.tip_group2
		for i = 1, 3 do
			self._word[i]:setText( _wordData[i] )
		end
		local _tipData = LANGUAGE_RECIEVEENERGY_TIPS.tip_2
		self._tip:setText( _tipData[_time] )
		self._tip:setPositionY( 45 )
		local _middleX = self._bottom:getContentSize().width/2
		local _width = self._tip:getContentSize().width/2
		self._gold:setVisible( false )
		self._gold:setPositionY( 45 )
		self._energy:setVisible( true )
		self._energy:setPositionY( 45 )
		self._energy:setPositionX( _middleX + _width - 45 )
		self._time:setText( zc.lang("activity_time") .. "：  "..tostring( _next[1] )..":00 - "..tostring( _next[2] )..":00" )
	elseif _type == 3 then
		-- 补领
		local _wordData = LANGUAGE_RECIEVEENERGY_TIPS.tip_group3
		
		for i = 1, 3 do
			local _text = _wordData[i]
			if i == 2 then
				_text = string.format(_text, tostring(_next[1]), tostring(_next[2]))
			end
			self._word[i]:setText(_text)
		end
		self._tip:setText(string.format(LANGUAGE_RECIEVEENERGY_TIPS.tip_3, tostring(self._data.price)))
		self._tip:setPositionY( 30 )
		local _middleX = self._bottom:getContentSize().width/2
		local _width = self._tip:getContentSize().width/2
		self._gold:setVisible( true )
		self._gold:setPositionY( 30 )
		self._gold:setPositionX( _middleX - _width + 65 )
		self._energy:setVisible( true )
		self._energy:setPositionY( 30 )
		self._energy:setPositionX( _middleX + _width - 45 )
		self._time:setText( "" )
	end
end

-- 刷新player数据，红点相关
function ReceiveEnergyLayer:updateRedDot()
	PlayerData._activityFoodStatus = 1
	PlayerData._activityFoodTime = tonumber( self._data.nextTime.start ) - PlayerData:getTime()
	PlayerData:startBubbleTimer()
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ACTIVITY_REDDOT, data = {id = 11}})
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "activity"}})
end

return ReceiveEnergyLayer