--[[
	招募积累活动首页弹出页
]]

local RecruitAccumulationPop = class("RecruitAccumulationPop", function()
	return ZCDialog:create(155)
end)

function RecruitAccumulationPop:create( params )
	return RecruitAccumulationPop.new( params )
end

function RecruitAccumulationPop:ctor( params )
	self._callback = params.callback
	local _spine = zc.createSpine({
		fileName = "zhaomu_machao",
        actName = "animation",
        loop = false,
	})
	_spine:setPosition(zc.width*0.5, zc.height*0.5 - 40)
	self:addChild(_spine)

	local close_btn = zc.createBackButton({
		pos = cc.p(zc.width - 50, zc.height - 50),
		listener = function()
        	LayerManager.removeLayout(true)
		end
	})
	self:addChild(close_btn)
	-- 描述文字
	local _discribeDi = zc.getScaleNode("res/Main/weaponCopy/tipsDi.png", cc.size(380, 75))
	_discribeDi:setAnchorPoint(cc.p(0, 0.5))
	_discribeDi:setPosition(cc.p(180, zc.height * 0.5 - 145))
	self:addChild(_discribeDi)
	_discribeDi:setOpacity(155)

	local _txtDiscribe1 = zc.createLabel({
		text = zc.lang("zhaomujilei_pop_discribe_1"),
		width = 300,
		fontSize = 18,
		color = cc.c3b(199, 120, 67),
		pos = cc.p(_discribeDi:getContentSize().width * 0.5, _discribeDi:getContentSize().height * 0.5 + 15),
		})
	_discribeDi:addChild(_txtDiscribe1)

	local _txtDiscribe2 = zc.createLabel({
		text = zc.lang("zhaomujilei_pop_discribe_2"),
		fontSize = 18,
		color = cc.c3b(199, 120, 67),
		pos = cc.p(_txtDiscribe1:getPositionX() - _txtDiscribe1:getContentSize().width * 0.5, _discribeDi:getContentSize().height * 0.5 - 15),
		})
	_txtDiscribe2:setAnchorPoint(cc.p(0, 0.5))
	_discribeDi:addChild(_txtDiscribe2)

	local _heroName = zc.createLabel({
		text = zc.lang("zhaomujilei_pop_dis_name"),
		width = 50,
		fontSize = 23,
		outLine = true,
		pos = cc.p(_discribeDi:getContentSize().width * 0.5 - 13, _discribeDi:getContentSize().height * 0.5 - 13),
		color = cc.c3b(255, 167, 48),
		})
	_discribeDi:addChild(_heroName)

	local _heroChenghao = zc.createLabel({
		text = zc.lang("zhaomujilei_pop_dis_chenghao"),
		fontSize = 18,
		pos = cc.p(_discribeDi:getContentSize().width * 0.5 + 75, _discribeDi:getContentSize().height * 0.5 - 15),
		color = cc.c3b(255, 167, 48),
		})
	_discribeDi:addChild(_heroChenghao)
	-- 前往
	local _btnGoNow = zc.createPushButton({
		normalFile = "res/Main/activity/recruitAccumulation/go_now.png",
        endCallback = function()
        	self._goFlag = true
        	LayerManager.removeLayout(true)
        	zc.createActivityPop({idx = 14})
        end,
        pos = cc.p(355, zc.height * 0.5 - 225)
		})
	self:addChild(_btnGoNow)
	-- 将领详情
	local _infoText = zc.createLabel({
		text = zc.lang("hero_detail"),
		pos = cc.p(950, zc.height * 0.5 - 186),
		needSwallow = true,
		fontSize = 24,
		color = cc.c3b(255, 167, 48),
		outLine = true,
		pixel = 2,
		endCallback = function ()
			zc.createHeroInfoPop({heroId = 51, showHero = true})
		end
	})
	self:addChild(_infoText)
	local _color = cc.c3b(0, 0, 0)
	local _line_1 = cc.DrawNode:create()
	local _underLineH = 2
	_line_1:drawPolygon({
        cc.p(-1, _underLineH),
        cc.p(_infoText:getContentSize().width + 1, _underLineH),
        cc.p(_infoText:getContentSize().width + 1, -_underLineH),
        cc.p(-1, -_underLineH ),
    }, 4, cc.c4f(_color.r/255, _color.g/255, _color.b/255, 1), 1, cc.c4f(_color.r/255, _color.g/255, _color.b/255, 1))
	_infoText:addChild(_line_1)
    -- 正常线
	local _color2 = cc.c3b(255, 167, 48)
	local _line_1 = cc.DrawNode:create()
    _line_1:drawLine(
        cc.p(0, 0), 
        cc.p(_infoText:getContentSize().width, 0), 
        cc.c4f(_color2.r/255, _color2.g/255, _color2.b/255, 1))
    _infoText:addChild(_line_1)
end

function RecruitAccumulationPop:onCleanup()
	local _cache = cc.Director:getInstance():getTextureCache()
	_cache:removeTextureForKey("res/animation/zhaomu_machao/zhaomu_machao.png")	
	if not self._goFlag and self._callback then
		self._callback()
	end
end

return RecruitAccumulationPop