--[[
背包页面
jiangyan 2016-05-05

tag 1全部 2装备 3消耗品 4材料 5天赋卷轴
type 1. 消耗品 2. 材料 3. 卷轴 4. 藏宝图
]]
local BagLayer = class("BagLayer", function ()
    return zc.createNormalDialog()
end)

function BagLayer:create(data) 
    return BagLayer.new(data)
end
function BagLayer:onCleanup()
    zc.removeEventListener(CUSTOM_EVENT.EVENT_REFRESH_FORM_SWEEP)
end
function BagLayer:ctor(data)
    -- 数据处理
    self:initData(data)
    -- 创建主界面
    self:initUI()
end
function BagLayer:onEnter()
    if self._secondIn then

        self:resetAllInfo()
        local oldData = table.copy(self._lastSelectInfo)
        self:setTabData()
        local nowIdx = self:findNowIdx(oldData)
        self:refreshTableView()
        self:setTabRedPoint()

    end
    self._secondIn = true
end
function BagLayer:setTabRedPoint()
    if self._tabRedPoint then
        local _flag = PlayerData:checkBagRedState()
        self._tabRedPoint:setVisible( _flag )
    end
end
function BagLayer:initData(data)
    
    self._tag = 1--默认是全部
    self._lastSelectInfo = {}
    self._baginfo = PlayerData:getBagInfo()

    --只显示武将的兵器
    local myAllWeapons = PlayerData:getWeaponsInfo()
    self._weapons = {}
    for i=1,#myAllWeapons do 
        if tonumber(myAllWeapons[i]["isUser"]) == 0 then 
            self._weapons[#self._weapons + 1] = myAllWeapons[i]
        end
    end
    --宝石信息
    self:setGemInfo()

    self._showBagInfo = {}--显示的数据，看在哪一个tab
    self._selectBagIndex = 1--选中的第几个
    -- self._tagNames = {"全部", "兵器", "兵器碎片","装备","消耗品", "材料"}
    self._tagNames = LANGUAGE_get_bag_tabs()
    self._tagButtons = {}
    if data and data.tag then 
        self._tag  = data.tag
    else
        self._tag = 1
    end
    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_REFRESH_FORM_SWEEP ,
        callback = function()
            self:resetAllInfo()
            local oldData = table.copy(self._lastSelectInfo)
            self:setTabData()
            local nowIdx = self:findNowIdx(oldData)
            self:refreshTableView()
            self:setTabRedPoint()
        end,
    })
end
function BagLayer:setGemInfo()
    local gemInfo = PlayerData:getGemInfo()
    self._gemInfo = {}
    self._allGemInfo = {}
    local gemLvelMap = {}
    for k,v in pairs(gemInfo) do
        local place = tonumber(v.place) or 0 --place==0表示没有镶嵌
        if place == 0 then
            local gemLvel = tonumber(v.level) or 1
            local gemId = tonumber(v.gemId)
            local exp = tonumber(v.exp)
            if not gemLvelMap[gemLvel] then
                gemLvelMap[gemLvel] = {}
            end
            local levelInfo = gemLvelMap[gemLvel]
            if not levelInfo[exp] then
                levelInfo[exp] = {}
            end
            local expInfo = levelInfo[exp]

            if not expInfo[gemId] then
                local idx = #self._gemInfo+1
                self._gemInfo[idx] = {}
                self._gemInfo[idx] = table.copy(v)
                self._gemInfo[idx].mainType = 12
                self._gemInfo[idx].itemId = v.gemId
                self._gemInfo[idx].num = 1

                expInfo[gemId] = idx
            else
                local idx = expInfo[gemId]
                self._gemInfo[idx].num = self._gemInfo[idx].num + 1
            end
            self._allGemInfo[#self._allGemInfo+1] = v
        end
    end
end
function BagLayer:initUI()

    local bg = zc.createSprite()
    bg:setContentSize( cc.size(1100,550) )
    bg:setPosition(zc.width/2+15, zc.height/2-20)
    self:addChild(bg, 6)

    local left_bg = zc.createNormalPop({
        srcTag = 1,
        width = 432,
        height = 522+31,
    })
    left_bg:setAnchorPoint(0, 0.5)
    left_bg:setPosition(0, 550/2)
    bg:addChild(left_bg)
    self._left_bg = left_bg
    local leftTitlebg = zc.createSprite("res/Main/common/popBg/titleBg4.jpg")
    leftTitlebg:setAnchorPoint(0.5, 1)
    leftTitlebg:setPosition(432/2, 522-3)
    left_bg:addChild(leftTitlebg)
    leftTitlebg:setScaleX(432/486)

    local middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = 410,
        height = 335,
    })
    middleBg:setAnchorPoint(cc.p(0.5, 0))
    middleBg:setPosition(cc.p(432/2, 7))
    left_bg:addChild(middleBg)
    left_bg._middleBg = middleBg

    local right_bg = zc.createNormalPop({
        srcTag = 2,
        width = 518,
        height = 522+31,
    })
    right_bg:setAnchorPoint(cc.p(0, 0.5))
    right_bg:setPosition(cc.p(left_bg:getPositionX()+left_bg:getContentSize().width+40, 550/2))
    bg:addChild(right_bg, 10)
    self._rightBg = right_bg
    
    local itemEmpty = zc.createSprite("res/Main/common/empty.png")
    itemEmpty:setPosition(right_bg:getContentSize().width/2, right_bg:getContentSize().height/2)
    right_bg:addChild(itemEmpty)
    itemEmpty:setVisible(false)
    self._itemEmpty = itemEmpty
    --
    self:createTabBtn()
end
function BagLayer:createTabBtn()

    local initPosY = 480-70/2
    for i=1,#self._tagNames do
        local tabBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/tab_btn_noraml.png",
            needSwallow = false,
            touchScale = 0.9,
            anchor = cc.p(0, 0.5),
            pos = cc.p(self._rightBg:getContentSize().width, initPosY-(i-1)*75),
            endCallback = function() end,
        })
        tabBtn:setTag(i)
        self._rightBg:addChild(tabBtn)
        local normalLab = zc.createLabel({
            text = self._tagNames[i],
            fontSize = 23,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(50, 36),
            outLine = true,
            color = zc.tabLabNormalColor1,
            -- color2 = zc.tabLabNormalColor2,
            color2 = display.COLOR_WHITE,
            pixel = 0.5,
        })
        tabBtn:addChild(normalLab, 2)
        local selectedLab = zc.createLabel({
            text = self._tagNames[i],
            fontSize = 23,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(50, 36),
            outLine = true,
            color = display.COLOR_WHITE,
            color2 = zc.tabLabselectColor2 ,
            pixel = 1,
        })
        tabBtn:addChild(selectedLab, 2)
        selectedLab:setVisible(false)
        tabBtn._normalLab = normalLab
        tabBtn._selectLab = selectedLab

        if i == 3 then
            --添加红点
            local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
            tabBtn:addChild(_redPoint, 1)
            self._tabRedPoint = _redPoint
            self:setTabRedPoint()
            _redPoint:setPosition(tabBtn:getContentSize().width-5, tabBtn:getContentSize().height-10)
        end

        tabBtn:setTouchEndedCall(function()
            self:changeTab(tabBtn)
        end)
        if self._tag == i then 
            self:changeTab(tabBtn)
        end

    end
end

function BagLayer:changeTab(_node)
    local function getNormal()
        return zc.createSprite("res/Main/common/button/tab_btn_noraml.png")
    end
    local function getSelect()
        return zc.createSprite("res/Main/common/button/tab_btn_select.png")
    end
    if not self._selectedBtn or self._selectedBtn ~= _node then
        local _tag = _node:getTag()
        if not self._selectedBtn then
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        else
            self._selectedBtn:setStateNormal( getNormal() )
            self._selectedBtn._normalLab:setVisible(true)
            self._selectedBtn._selectLab:setVisible(false)
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        end
        self._tag = _tag
        self._selectBagIndex = 1
        self:updateRightInfo()
    end
end

--刷新右界面信息
function BagLayer:updateRightInfo()
    local _tag = self._tag
    --刷新数据
    self:setTabData()
    if not next(self._showBagInfo) then
        self._itemEmpty:setVisible(true)
        self:updateLeftInfo()
    else
        self._itemEmpty:setVisible(false)
    end
    if not self._rightTableview then
        self:initTableview()
    else
        self._rightTableview:reloadData()
        self._rightTableview:scrollToCell(0,false)
    end
end

function BagLayer:initTableview()
    local tableSize = cc.size(self._rightBg:getContentSize().width-2, self._rightBg:getContentSize().height-10)
    local myTableView = zc.ZCTableView:create( tableSize )
    myTableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    myTableView:setPosition(cc.p(1, 5))
    myTableView:setDelegate()
    myTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)--kTableViewFillBottomUp  kTableViewFillTopDown

    local function cellSizeForTable(table, idx) 
        return  110,tableSize.width
    end
    local function numberOfCellsInTableView()
        return math.floor((#self._showBagInfo + 4)/5)
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = myTableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell(cell, cellIndex)
        end
        -- 更新界面
        if cell:getChildByName("selectEffect") then
            cell:getChildByName("selectEffect"):removeFromParent()
            self._selectEffect = nil
        end
        self:updateCell(cell, cellIndex)
        return cell
    end

    myTableView:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    myTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    myTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    myTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self._rightBg:addChild(myTableView)
    self._rightTableview = myTableView
    myTableView:reloadData()
end
---------------- 创建和更新背包物品图标列表---------------------------
function BagLayer:buildCell(cell, cellIndex)
    cell._item = {}
    for i=1,5 do
        local posx =  59+(i-1)*99
        local item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeProp,
                type = 1, 
                id = 1,
                num = 1,
                quality = 1,
            }, 
            pos = cc.p(posx, 55), 
        })
        item:setScale(87/120)
        cell:addChild(item, 1)
        cell._item[i] = item
    end
end
function BagLayer:getWeaponLevelById(_id) --主键id
    if not self._weaponLevelInfo then
        self._weaponLevelInfo = {}
    end
    if self._weaponLevelInfo[tonumber(_id)] then
        return self._weaponLevelInfo[tonumber(_id)]
    else
        local _level = zc.getWeaponLevel(_id)
        self._weaponLevelInfo[tonumber(_id)] = _level
        return _level
    end
end
function BagLayer:updateCell(cell, cellIndex)
    local itemList = cell._item
    for i = 1, 5 do
        local item = itemList[i]
        local index = (cellIndex-1)*5 + i
        local itmeData = self._showBagInfo[index]
        if itmeData and itmeData["id"] then
            item:setVisible(true)
            local _mainType = tonumber(itmeData["mainType"]) or 0
            local _subType  = tonumber(itmeData["subType"]) or 0
            local _effectType = 2 --点击效果类型，2正常类型 和 1碎片类型
            if _mainType == zc.mainTypeWeapon then
            else
                if _subType == zc.subTypeFragment or _subType == zc.subTypeWeaponFragment then
                    _effectType = 1
                end
            end
            local newParams = {
                data = {
                    mainType = _mainType,
                    type = 1, 
                    id = _mainType == zc.mainTypeWeapon and itmeData["weaponId"] or itmeData["itemId"],
                    num = _mainType == zc.mainTypeWeapon and 1 or itmeData["num"],
                    quality = itmeData["color"],
                    grade = _mainType == zc.mainTypeWeapon and itmeData.grade or nil,
                    level = _mainType == zc.mainTypeWeapon and (zc.getLevelTipShow()..self:getWeaponLevelById(itmeData.id)) or nil,
                },
                showLevel = _mainType == zc.mainTypeWeapon and true or false,
                listener = function () 
                    if self._selectBagIndex ~= index then
                        self._selectBagIndex = index
                        self:createSelectEffect(cell,item,_effectType)
                        self:updateLeftInfo()
                    end
                end
            }
            zc.updateIconByData( item, newParams )
            if not self._selectBagIndex and index == 1 then
                self._selectBagIndex = 1
            end
            if self._selectBagIndex == index then
                self:createSelectEffect(cell,item,_effectType)
                self:updateLeftInfo()
            end
        else
            item:setVisible(false)
        end

    end
end
--创建选中效果
function BagLayer:createSelectEffect(cell, item, _type)
    if not tolua.isnull(self._selectEffect) then
        self._selectEffect:removeFromParent()
    end
    self._selectEffect = nil
    local effect = zc.getItemClickEffect(_type)
    effect:setPosition( cc.p(item:getPositionX(), item:getPositionY()) )
    cell:addChild(effect, 1)
    effect:setScale(87/120)
    effect:setName("selectEffect")
    self._selectEffect = effect
end
--初始化左界面
function BagLayer:initLeftItemInfo()
    if not self._left_bg._item then
        local leftBg = self._left_bg
        local leftSize = cc.size(432, 522)

        -- 武器图标
        local _weaponIconBg = cc.Sprite:create( "res/Main/role/common/weapon_icon_bg.png" )
        _weaponIconBg:setAnchorPoint( 1, 1 )
        _weaponIconBg:setPosition( leftSize.width-10, leftSize.height-13 )
        leftBg:addChild( _weaponIconBg ,1)
        local _weaponIcon = cc.Sprite:create()
        _weaponIcon:setPosition( _weaponIconBg:getContentSize().width/2 + 2, -10 )
        _weaponIconBg:addChild( _weaponIcon )
        _weaponIconBg._weaponIcon = _weaponIcon
        self._weaponIconBg = _weaponIconBg

        local itemBg = zc.createSprite("res/Main/role/fetter/fetterItemBg.png")
        local justY = 32
        local justX = 10
        itemBg:setPosition( cc.p(85-justX, 410+25 - justY) )
        leftBg:addChild(itemBg)
        local leftDetailIcon = zc.createIconByData({
            data = {
                mainType = zc.mainTypeProp,
                type = 1, 
                id = 1,
                quality = 1
            }, 
            pos = cc.p(itemBg:getContentSize().width/2, itemBg:getContentSize().height/2+2), 
        })
        itemBg:addChild(leftDetailIcon)
        leftDetailIcon:setScale(100/120)
        leftDetailIcon:setCascadeOpacityEnabled( true )
        local nameLab = zc.createLabel({
            text = zc.lang("weapon") .. LANGUAGE_ARENA.name,
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(150 + 10-justX, 475- justY),
        })
        leftBg:addChild(nameLab)
        
        for i=1,3 do 
            local dot = zc.getSprite({
                src = "res/Main/vip/vip_dot.png",
                pos = cc.p(150 + 20-justX, 470 - i*25- justY),
            })
            leftBg:addChild(dot)
            dot:setName("dot"..i)
            local leftnameX = 190-justX
            --名字
            local titleDes =  zc.createLabel({
                fontSize = 20,
                outLine = true,
                ap = cc.p(0, 1),
                pos = cc.p(leftnameX, dot:getPositionY() + 12),
                width = 228,
            })
            titleDes:setName("titleDes"..i)
            leftBg:addChild(titleDes)
        end
        local contentbg = zc.createGeneralPopScale({
            tag = 2,
            width = 398,
            height = 215,
        })
        contentbg:setAnchorPoint(cc.p(0.5, 1))
        contentbg:setPosition(cc.p(leftBg._middleBg:getContentSize().width/2, leftBg._middleBg:getContentSize().height-8))
        contentbg:setName("contentbg")
        leftBg._middleBg:addChild(contentbg)
        self._contentBg = contentbg

        --描述
        local leftcontent = zc.createLabel({
            fontSize = 22,
            ap = cc.p(0, 1),
            pos = cc.p(10, contentbg:getContentSize().height - 20),
            width = 380,
            color = cc.c3b(171, 152, 92),
            outLine = true
        })
        contentbg:addChild(leftcontent)

        local leftpriceImg = zc.getSprite({
            src = "res/Main/common/common_icon_money.png",
            pos = cc.p(290, 95),
            scale = 0.9,
        })
        leftBg:addChild(leftpriceImg)
        local leftprice =  zc.createLabel({
            fontSize = 22,
            ap = cc.p(0, 0.5),
            outLine = true,
            pos = cc.p(leftpriceImg:getPositionX() + 20, 95),
        })
        leftBg:addChild(leftprice)
        --出售/强化按钮
        local rightBtn = zc.createCommomBtn({
            pos = cc.p(leftBg:getContentSize().width - 120, 50), 
            text = "right",
            tag = 1,
            endCallback = function() end,
        })
        leftBg:addChild(rightBtn)
        --使用按钮
        local leftBtn = zc.createCommomBtn({
            tag = 2,
            pos = cc.p(120, 50), 
            text = "left",
            endCallback = function() end,
        })
        leftBg:addChild(leftBtn)


        local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
        _redPoint:setVisible(false)
        _redPoint:setPosition(leftBtn:getContentSize().width-20, leftBtn:getContentSize().height-10)
        leftBtn:addChild(_redPoint, 1)
        leftBtn._buttonRedPoint = _redPoint
        
        --
        leftBg._item            = leftDetailIcon
        leftBg._nameLab         = nameLab
        leftBg._leftcontent     = leftcontent
        leftBg._leftpriceImg    = leftpriceImg
        leftBg._leftprice       = leftprice
        leftBg._rightBtn        = rightBtn
        leftBg._leftBtn         = leftBtn
    end
end
--刷新左界面信息
function BagLayer:updateLeftInfo()

    local nowItemInfo = self._showBagInfo[self._selectBagIndex]

    if nowItemInfo and self._lastSelectInfo and tonumber(self._lastSelectInfo.id) == tonumber(nowItemInfo.id) then
        return
    end
    if self._attrScrollView then
        self._attrScrollView:removeFromParent()
        self._attrScrollView = nil
    end

    self._lastSelectInfo = nowItemInfo
    --创建左界面
    if not self._left_bg._item then
        self:initLeftItemInfo()
    end

    local leftDetailIcon    = self._left_bg._item        
    local nameLab           = self._left_bg._nameLab     
    local leftcontent       = self._left_bg._leftcontent 
    local leftpriceImg      = self._left_bg._leftpriceImg
    local leftprice         = self._left_bg._leftprice   
    local rightBtn          = self._left_bg._rightBtn    
    local leftBtn           = self._left_bg._leftBtn     
    --刷新左界面
    leftBtn._buttonRedPoint:setVisible(false)
    local _isVisible = false
    self._left_bg:stopAllActions()
    local leftPosx = self._left_bg:getPositionX()
    if not nowItemInfo then
        self._left_bg:runAction(cc.Sequence:create( cc.MoveBy:create(0.3*( (500-leftPosx)/500 ), cc.p(500-leftPosx, 0)) ))
        for i = 1,3 do
            local dot = self._left_bg:getChildByName("dot"..i)
            local titleDes = self._left_bg:getChildByName("titleDes"..i)
            dot:setVisible(false)
            titleDes:setVisible(false)
        end
        leftpriceImg:setVisible(false)
        leftprice:setVisible(false)
    else
        self._left_bg:runAction(cc.Sequence:create( cc.MoveBy:create(0.1*( leftPosx/500 ), cc.p(-leftPosx, 0)) ))
        _isVisible = true
        local _mainType = tonumber(nowItemInfo["mainType"]) or 0
        local _subType  = tonumber(nowItemInfo["subType"]) or 0

        local newParams = {
            data = {
                mainType = _mainType,
                type = 1, 
                id = _mainType == zc.mainTypeWeapon and nowItemInfo["weaponId"] or nowItemInfo["itemId"],
                level = _mainType == zc.mainTypeWeapon and (zc.getLevelTipShow()..self:getWeaponLevelById(nowItemInfo.id)) or nil,
            },
            showLevel = _mainType == zc.mainTypeWeapon and true or false,
        }
        zc.updateIconByData( leftDetailIcon, newParams )
        leftcontent:setString(nowItemInfo["desc"] or "")
        local nameStr = nowItemInfo["name"] or ""
        if _mainType == zc.mainTypeWeapon then
            local _grade = tonumber(nowItemInfo["grade"]) or 0
            if _grade > 0 then
                nameStr = nameStr .. " +" .. _grade
            end
            if nowItemInfo["heroId"] and tonumber(nowItemInfo["heroId"]) > 0 then
                nameStr = nameStr.."(" .. zc.lang("equiped") .. ")"
            end
            leftpriceImg:setVisible(false)
            leftprice:setVisible(false)
            leftcontent:setVisible(false)
            self._weaponIconBg:setVisible(true)
            local heroTypeImg = zc.getHeroTypeBigImg( nowItemInfo["type"] )
            self._weaponIconBg._weaponIcon:setTexture(heroTypeImg)
            self:createWeaponAtrrInfo(nowItemInfo)
        elseif _mainType == zc.mainTypeGem then
            self._weaponIconBg:setVisible(false)
            leftcontent:setVisible(false)
            leftpriceImg:setVisible(true)
            leftprice:setVisible(true)
            leftprice:setString(nowItemInfo.price)

            self:createGemAttrInfo(nowItemInfo)
        else
            self._weaponIconBg:setVisible(false)
            leftcontent:setVisible(true)
            leftpriceImg:setVisible(true)
            leftprice:setVisible(true)
            leftprice:setString(nowItemInfo.price)

            local _type = tonumber(nowItemInfo.type)
            if _type and _type == 5 then --武器碎片
                leftcontent:setVisible(false)
                self._weaponIconBg:setVisible(true)
                local sysInfo = PlayerData._static_fragment_weapon[tonumber(nowItemInfo.itemId)]
                local staticWeapon = gameData.getDataFromCacheWithPrimaryKey("weapon", sysInfo.id )
                local heroTypeImg = zc.getHeroTypeBigImg( staticWeapon["type"] )
                self._weaponIconBg._weaponIcon:setTexture(heroTypeImg)
                self:createWeaponTeffectInfo(nowItemInfo)
                if nowItemInfo["weapon_cansys"] then
                    leftBtn._buttonRedPoint:setVisible(true)
                end
            end
        end
        nameLab:setString(nameStr)
        nameLab:setColor(zc.getColorByQuality(nowItemInfo["color"]))
        for i = 1, 3 do
            local dot = self._left_bg:getChildByName("dot"..i)
            local titleDes = self._left_bg:getChildByName("titleDes"..i)
            local _dotVis = true
            if _mainType == zc.mainTypeWeapon then
                _dotVis = true
                if i == 1 then
                    local _str = zc.lang("need_level") .. "：" .. self._lastSelectInfo.needLevel .. zc.lang("level_1")
                    if nowItemInfo.needReincarnate and tonumber(nowItemInfo.needReincarnate) > 0 then
                        _str = zc.lang("need_level") .. "：" .. nowItemInfo.needReincarnate .. zc.lang("turn") .. nowItemInfo.needLevel .. zc.lang("level_1")
                    end
                    titleDes:setString(_str)
                elseif i == 2 then
                    local _str = "武器资质："..self:getWeaponLevelById(nowItemInfo.id)
                    titleDes:setString(_str)
                elseif i == 3 then
                    titleDes:setString(zc.lang("combatValue") .. "："..zc.calculateCombatValue(nowItemInfo))
                end
            elseif _mainType == zc.mainTypeGem then --宝石
                if i == 1 then
                    _dotVis = true
                    titleDes:setString(zc.lang("curr_have") .. "："..(nowItemInfo.num or 1))
                elseif i == 2 then
                    _dotVis = true
                    if not self._gemExpData then
                        self._gemExpData = gameData.getDataFromCache("gem_experience")
                    end
                    local gemLevel = tonumber(nowItemInfo.level) or 1
                    if gemLevel > table.nums(self._gemExpData) then
                        titleDes:setString( zc.lang("exp") .. "：" .. zc.lang("full") )
                    else
                        local levelExp = self._gemExpData[tostring(gemLevel)] or {}
                        titleDes:setString( zc.lang("exp") .. "："..nowItemInfo.exp.."/"..(levelExp.levelUpEx or 99999) )
                    end
                else
                    _dotVis = false
                end
            else
                local _type = tonumber(nowItemInfo.type)
                if i == 1 then
                    _dotVis = true
                    titleDes:setString(zc.lang("curr_have") .. "："..(nowItemInfo.num or 1))
                    if _type and _type == 5 then --武器碎片
                        local sysInfo = PlayerData._static_fragment_weapon[tonumber(nowItemInfo.itemId)]
                        titleDes:setString(zc.lang("curr_have") .. "："..nowItemInfo.num.."/"..sysInfo["num"])
                    end
                elseif i == 2 then
                    if _type and _type == 5 then --武器碎片
                        _dotVis = true
                        titleDes:setString(nowItemInfo.desc or "")
                    else
                        _dotVis = false
                    end
                else
                    _dotVis = false
                end
            end
            dot:setVisible(_dotVis)
            titleDes:setVisible(_dotVis)
            if _dotVis then
                -- dot:stopAllActions()
                titleDes:stopAllActions()
                -- dot:setOpacity(0)
                -- dot:runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
                titleDes:setOpacity(0)
                titleDes:runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
            end
        end

        --
        leftDetailIcon:stopAllActions()
        nameLab:stopAllActions()
        leftcontent:stopAllActions()
        --
        leftDetailIcon:setOpacity(0)
        leftDetailIcon:runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
        nameLab:setOpacity(0)
        nameLab:runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
        leftcontent:setOpacity(0)
        leftcontent:runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))

        self:setLeftAndRightTouchState(leftBtn, rightBtn)
    end

    --设置可视
    leftDetailIcon:setVisible(_isVisible)
    nameLab:setVisible(_isVisible)
    -- leftcontent:setVisible(_isVisible)
    rightBtn:setVisible(_isVisible)
    leftBtn:setVisible(_isVisible)

    if self._lastSelectInfo == nil then
        leftprice:setVisible(true)
        leftpriceImg:setVisible(true)
        leftBtn:setPositionX(120)
        rightBtn:setVisible(true)
    elseif tonumber(self._lastSelectInfo["subType"]) == 1002 then
        leftBtn:setPositionX(210)
        rightBtn:setVisible(false)
        leftpriceImg:setVisible(false)
        leftprice:setVisible(false)
    else
        leftprice:setVisible(true)
        leftpriceImg:setVisible(true)
        leftBtn:setPositionX(120)
        rightBtn:setVisible(true)
    end
    
    -- if tonumber(self._lastSelectInfo["subType"]) == 1002 then
    --     leftBtn:setPositionX(210)
    --     rightBtn:setVisible(false)
    --     leftpriceImg:setVisible(false)
    --     leftprice:setVisible(false)
    -- else
    --     leftprice:setVisible(true)
    --     leftpriceImg:setVisible(true)
    --     leftBtn:setPositionX(120)
    --     rightBtn:setVisible(true)
    -- end
end

--武器主属性
function BagLayer:createWeaponAtrrInfo(nowItemInfo)
    self._attrScrollView = self:createScrollveiw()
    --组织数据
    local weaponData = nowItemInfo
    local effectInfoList = {}
    local teffectInfoList = {}
    for i = 1, 6 do
        local effectInfo = weaponData["effectInfo"..i]
        if effectInfo and  effectInfo["effectId"] then
            local idx = #effectInfoList + 1
            effectInfoList[idx] = {}
            effectInfoList[idx].effectId    = effectInfo["effectId"]
            effectInfoList[idx].effectValue = weaponData["effectValue"..i]
        end
    end
    for i = 1, 6 do
        local teffectId = weaponData["teffectId"..i]
        if teffectId and tonumber(teffectId) > 0 then
            local idx = #teffectInfoList + 1
            teffectInfoList[idx] = {}
            teffectInfoList[idx].teffectId    = weaponData["teffectId"..i]
            teffectInfoList[idx].teffectValue = weaponData["teffectValue"..i]
            teffectInfoList[idx].teffectColor = weaponData["teffectColor"..i]
        end
    end

    local innerHeight = 30 * (table.nums(effectInfoList)+table.nums(teffectInfoList)+2) + 40
    self._attrScrollView:setContentSize( cc.size(398, innerHeight) )

    local posH = innerHeight - 20
    local baseEffTitle = zc.createSprite("res/Main/role/equip/baseAttr.png")
    baseEffTitle:setPosition(398/2, posH)
    self._attrScrollView:addChild(baseEffTitle)
    self:createLace(baseEffTitle)
    posH = posH - 40
    for i = 1, #effectInfoList do
        local effectInfo = effectInfoList[i]
        local effectId = effectInfo["effectId"]
        local effectValue = effectInfo["effectValue"] or 0
        local effectStr = LANGUAGE_getAttributeTextById(effectId)
        local effectNum = zc.getAttributeNumById(effectId,effectValue)
        local effectLab = zc.createLabel({
            text = effectStr.."："..effectNum,
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(35, posH),
            color = cc.c3b(238,98,3),
            pixel = 1.3
        })
        self._attrScrollView:addChild(effectLab)
        local _skilfulAddVaule = PlayerData:getSkilfulAddInfoByEffectId(1, effectId, weaponData.quality)
        if _skilfulAddVaule and _skilfulAddVaule > 0 then
            local effectLab = zc.createLabel({
                text = "（" .. zc.lang("proficiency") .. "＋" .. _skilfulAddVaule .. "）",
                outLine = true,
                fontSize = 18,
                ap = cc.p(0, 0.5),
                pos = cc.p(200, posH),
                color = display.COLOR_GREEN,
                pixel = 1.3
            })
            self._attrScrollView:addChild(effectLab)
        end
        posH = posH - 30
    end
    posH = posH - 10
    local additionalEffectTitle = zc.createSprite("res/Main/role/equip/addAttr.png")
    additionalEffectTitle:setAnchorPoint(0.5, 0.5)
    additionalEffectTitle:setPosition(398/2, posH)
    self._attrScrollView:addChild(additionalEffectTitle)
    self:createLace(additionalEffectTitle)
    posH = posH - 40
    for i = 1, #teffectInfoList do
        local teffectInfo = teffectInfoList[i]

        local teffectId     = teffectInfo["teffectId"]
        local teffectValue  = teffectInfo["teffectValue"]
        local teffectColor  = teffectInfo["teffectColor"]

        local effectStr = LANGUAGE_getAttributeTextById(teffectId)
        local effectNum = zc.getAttributeNumById(teffectId,teffectValue)
        local effectLab = zc.createLabel({
            text = effectStr.."："..effectNum,
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(35, posH ),
            color = zc.getColorByQuality(teffectColor),
            pixel = 1.3
        })
        self._attrScrollView:addChild(effectLab)
        local _skilfulAddVaule = PlayerData:getSkilfulAddInfoByEffectId(2, teffectId, weaponData.quality)
        if _skilfulAddVaule and _skilfulAddVaule > 0 then
            local effectLab = zc.createLabel({
                text = "（"  .. zc.lang("proficiency") .. "＋" .. _skilfulAddVaule .. "）",
                outLine = true,
                fontSize = 18,
                ap = cc.p(0, 0.5),
                pos = cc.p(200, posH),
                color = display.COLOR_GREEN,
                pixel = 1.3
            })
            self._attrScrollView:addChild(effectLab)
        end
        posH = posH - 30
    end
    self._attrScrollView:setContentOffset(self._attrScrollView:minContainerOffset()) 
end
--宝石属性
function BagLayer:createGemAttrInfo(nowItemInfo)
    self._attrScrollView = self:createScrollveiw()
    self._attrScrollView:setBounceable(false)
    local innerHeight = self._attrScrollView:getContentSize().height
    local posH = innerHeight - 20
    local baseEffTitle = zc.createSprite("res/Main/role/equip/baseAttr.png")
    baseEffTitle:setPosition(398/2, posH)
    self._attrScrollView:addChild(baseEffTitle)
    self:createLace(baseEffTitle)

    local effectInfoList = {}
    local idx = #effectInfoList + 1
    effectInfoList[idx] = {}
    effectInfoList[idx].effectId    = nowItemInfo["effectId"]
    effectInfoList[idx].effectValue = nowItemInfo["value"]

    posH = posH - 40
    for i = 1, #effectInfoList do
        local effectInfo = effectInfoList[i]
        local effectId = effectInfo["effectId"]
        local effectValue = effectInfo["effectValue"] or 0
        local effectStr = LANGUAGE_getAttributeTextById(effectId)
        local effectNum = zc.getAttributeNumById(effectId,effectValue)
        local effectLab = zc.createLabel({
            text = effectStr.."："..effectNum,
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(35, posH),
            color = cc.c3b(238,98,3),
            pixel = 1.3
        })
        self._attrScrollView:addChild(effectLab)
        posH = posH - 30
    end
end
--附加属性
function BagLayer:createWeaponTeffectInfo(nowItemInfo)
    self._attrScrollView = self:createScrollveiw()
    --从数据库读
    local weaponEffTable = {} 
    local sysInfo = PlayerData._static_fragment_weapon[tonumber(nowItemInfo.itemId)]
    local _data = gameData.getDataFromCache("weapon_effect", {weaponId = sysInfo.id})
    if #_data < 1 and next(_data) ~= nil then
        _data = {}
    end
    for k,v in pairs(_data) do
        weaponEffTable[#weaponEffTable+1] = v
    end
    local sysWeaponInfo = {}
    for i=1,#weaponEffTable do 
        sysWeaponInfo["effectId"..i] =  weaponEffTable[i].effectId
        sysWeaponInfo["effectValue"..i] = weaponEffTable[i].valueMin
        sysWeaponInfo["effectInfo"..i] = { effectId = weaponEffTable[i].effectId, 
        valueLimit = weaponEffTable[i].valueLimit}
    end
    local colorInfo = {
        [1] = {2,1},
        [2] = {2,1},
        [3] = {3,7,7},
        [4] = {4,7,7},
        [5] = {5,7,7},
        [6] = {6,7,7},
    }
    local nowColor = colorInfo[tonumber(nowItemInfo.color)] or {}

    local innerHeight = 30 * (table.nums(weaponEffTable)+table.nums(nowColor)+2) + 40
    self._attrScrollView:setContentSize( cc.size(398, innerHeight) )

    local _skilfulAdd = PlayerData:getSkilfulAddInfo()
    local posH = innerHeight - 20
    local baseEffTitle = zc.createSprite("res/Main/role/equip/baseAttr.png")
    baseEffTitle:setPosition(398/2, posH)
    self._attrScrollView:addChild(baseEffTitle)
    self:createLace(baseEffTitle)
    posH = posH - 40
    for i = 1, #weaponEffTable do
        local effectInfo = sysWeaponInfo["effectInfo"..i]
        local effectId = effectInfo["effectId"]
        local effectValue = sysWeaponInfo["effectValue"..i] or 0
        local effectStr = LANGUAGE_getAttributeTextById(effectId)
        local effectNum = zc.getAttributeNumById(effectId,effectValue)
        effectStr = effectStr.."："..effectNum
        local effectLimit =  effectInfo["valueLimit"] or 0
        local effectLimitNum = zc.getAttributeNumById(effectId,effectLimit)
        effectStr = effectStr.."~"..effectLimitNum
        local effectLab = zc.createLabel({
            text = effectStr,
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(35, posH),
            color = cc.c3b(238,98,3),
            pixel = 1.3
        })
        self._attrScrollView:addChild(effectLab)
        posH = posH - 30
    end
    posH = posH - 10
    local additionalEffectTitle = zc.createSprite("res/Main/role/equip/addAttr.png")
    additionalEffectTitle:setAnchorPoint(0.5, 0.5)
    additionalEffectTitle:setPosition(398/2, posH)
    self._attrScrollView:addChild(additionalEffectTitle)
    self:createLace(additionalEffectTitle)
    posH = posH - 40

    for i = 1, #nowColor do
        local effectColor = nowColor[i]
        local effectStr = LANGUAGE_get_weapon_random_effect_name(effectColor)
        if effectColor == 7 then effectColor = 1 end
        local effectLab = zc.createLabel({
            text = effectStr ,
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(35, posH ),
            color = zc.getColorByQuality(effectColor),
        })
        self._attrScrollView:addChild(effectLab)
        posH = posH - 30
    end
    self._attrScrollView:setContentOffset(self._attrScrollView:minContainerOffset()) 
end

function BagLayer:createLace(_node)
    local lace_left = zc.createSprite("res/Main/common/lace.png")
    lace_left:setAnchorPoint(1, 0.5)
    lace_left:setPosition(0, _node:getContentSize().height/2 )
    _node:addChild(lace_left)

    local lace_right = zc.createSprite("res/Main/common/lace.png")
    lace_right:setAnchorPoint(0, 0.5)
    lace_right:setPosition(_node:getContentSize().width, lace_left:getPositionY() )
    lace_right:setFlipX(true)
    _node:addChild(lace_right)
end

function BagLayer:createScrollveiw()
    local _attrScrollView = cc.ScrollView:create()
    _attrScrollView:setViewSize(cc.size(398, 210))
    _attrScrollView:setContentSize(cc.size(398, 210))
    _attrScrollView:setPosition(cc.p(0,3))
    _attrScrollView:ignoreAnchorPointForPosition(true)
    _attrScrollView:updateInset()
    _attrScrollView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL) 
    _attrScrollView:setClippingToBounds(true)
    _attrScrollView:setBounceable(true)
    _attrScrollView:setContentOffset(_attrScrollView:minContainerOffset())
    self._contentBg:addChild(_attrScrollView)
    return _attrScrollView
end
function BagLayer:setLeftAndRightTouchState(leftBtn,rightBtn)
    --按钮
    local useselltype1, useText1 = self:getItemSellOrUse("left")
    --左按钮
    leftBtn:setString(useText1)
    leftBtn:setTouchEndedCall(function()
        if useselltype1 == 4 then 
            --熔炼
            if self._lastSelectInfo["heroId"] and tonumber(self._lastSelectInfo["heroId"]) > 0 then
                zc.tipInfo(zc.lang("weapon") .. zc.lang("equiped") .. "!")
                return
            end
            local function doRongLian()
                zc.sendHttp({
                    apiName = "Weapon_smelt",
                    params = {ids = self._lastSelectInfo["id"]},
                    successCallback = function (data) 
                        PlayerData:updataData(data)
                        PlayerData:subWeapon(self._lastSelectInfo["id"])
                        self:resetAllInfo()
                        self:setTabData()
                        self:refreshTableView()
                    end,
                })
            end
            local getItemString = tostring(self._lastSelectInfo["items"])
            local getItem = string.split(getItemString,"|")
            local getItemName = ""
            if getItem and getItem[1] then
                if tonumber(getItem[1]) == 1 then
                    getItemName = LANGUAGE_getReousrceNameById(getItem[2])
                    getItemName = getItemName..getItem[3]
                elseif tonumber(getItem[1]) == 4 then
                    local bagInfo = gameData.getDataFromCacheWithPrimaryKey("item", getItem[2])
                    getItemName = bagInfo["name"] or ""
                    getItemName = getItemName..getItem[3]
                end
            end
            local comfirm = ZCConfirmDialog:createWithParams({
                title = zc.lang("prompt"),
                msg = zc.lang("smelt_weapon_will_get") .. getItemName,
                showDi = true,
                rightCallback = function()
                    doRongLian()
                end
            })
            self:addChild(comfirm, 11)
        elseif useselltype1 == 2 then
            --如果是宝箱就使用
            if tonumber(self._lastSelectInfo["subType"]) == zc.subTypeBox then
                local function sellFunc(_num, selectedIdx)
                    local _params = {id=self._lastSelectInfo.id,num=_num}
                    if selectedIdx then
                        _params.tid = selectedIdx
                    end
                    zc.sendHttp({
                        apiName = "Bag_useItem",
                        params = _params,
                        successCallback = function (data)
                            --刷新数据，更新tableview
                            if not data.clientItems then
                                data.clientItems = {}
                            end
                            local _heroId = 0
                            if data.info and data.info.items then
                                for i = 1, #data.info.items do
                                    local v = data.info.items[i]
                                    data.clientItems[#data.clientItems+1] = v
                                    if tonumber(v.type) == zc.mainTypeSoldier then
                                        _heroId = v.itemId
                                    end
                                end
                            end
                            zc.createShowReward({
                                clientItems = data.info.items,
                                clientResources = data.clientResources,
                            })
                            data.noAnimation = true
                            PlayerData:updataData(data)
                            self._baginfo = PlayerData:getBagInfo()
                            self:setTabData()
                            self:refreshTableView()
                            if _heroId ~= 0 then
                                zc.createPubShowGetHero({
                                    id = _heroId,
                                })
                            end
                        end,
                    })
                end

                local _tmpDb = gameData.getDataFromCacheWithPrimaryKey("treasure", self._lastSelectInfo.itemId)
                local __tmpType = tonumber(_tmpDb.type) or 0

                if __tmpType == 3 then
                    zc.createSourcePop("BagChoosePop", "src/layer/bag/BagChoosePop.lua", {
                        info = self._lastSelectInfo,
                        callback = sellFunc
                    })
                else
                    -- dump(self._lastSelectInfo)
                    if tonumber(self._lastSelectInfo["subType"]) == 1002 then
                        sellFunc(1)
                    else
                        if tonumber(self._lastSelectInfo["num"]) == 1 then
                            sellFunc(1)
                        else
                            zc.createSourcePop("UsePop", "src/layer/bag/UsePop.lua", {
                                rightFunc = sellFunc, 
                                maxNum = self._lastSelectInfo["num"], 
                                info = self._lastSelectInfo
                            })
                        end
                    end
                end

            elseif tonumber(self._lastSelectInfo["subType"]) == zc.subTypeWeaponFragment then
                zc.createWeaponSynthesisPop({
                    itemType = self._lastSelectInfo.mainType,
                    itemId = self._lastSelectInfo.itemId,
                    callback = function( selectOld )
                        local oldData = table.copy(self._lastSelectInfo)
                        self:resetAllInfo()
                        self:setTabData()
                        if selectOld then
                            self:findNowIdx(oldData)
                        else
                            self._selectBagIndex = 1
                        end
                        self:refreshTableView()
                        self:setTabRedPoint()
                    end,
                })
            else
                --详情
                zc.createItemSynthesisPop({
                    itemType = self._lastSelectInfo.mainType,
                    itemId = self._lastSelectInfo.itemId,
                    costNum = 0, --需要消耗的数量
                    callback = function()
                        self._baginfo = PlayerData:getBagInfo()
                        local oldData = table.copy(self._lastSelectInfo)
                        self:setTabData()
                        local nowIdx = self:findNowIdx(oldData)
                        self:refreshTableView()
                    end,
                })
            end
        end
    end)
    
    --右按钮
    local useselltype2, useText2 = self:getItemSellOrUse("right")
    rightBtn:setString(useText2)
    rightBtn:setTouchEndedCall(function()
        if useselltype2 == 3 then
            --洗练
            zc.createSmithClearLayer()
        elseif useselltype2 == 1 then
            --显示出售
            local sellgood = self._lastSelectInfo
            local _maxNum = self._lastSelectInfo["num"]
            local _sellMainType = "4"
            if sellgood["gemId"] then
                _sellMainType = "12"
            end
            local function sellFunc(num)
                --info :1|2|3,1|2|3 // 出售物品信息(物品类型|主键id|数量,物品类型|主键id|数量)
                local selldata = _sellMainType.."|".. sellgood["id"] .."|"..num
                if _sellMainType == "12" then
                    if tonumber(num) > 1 then
                        local _sellGemId = tonumber(sellgood["gemId"])
                        local _sellLevel = tonumber(sellgood["level"])
                        local _sellExp = tonumber(sellgood["exp"])
                        selldata = ""
                        if self._allGemInfo then
                            for i = 1, #self._allGemInfo do
                                local v = self._allGemInfo[i]

                                if tonumber(v["gemId"]) == _sellGemId and
                                    tonumber(v["level"]) == _sellLevel and
                                    tonumber(v["exp"]) == _sellExp then
                                    if selldata == "" then
                                        selldata = "12|"..v["id"].."|1"
                                    else
                                        selldata = selldata ..",".."12|"..v["id"].."|1" 
                                    end
                                    num = num - 1
                                end
                                if num <= 0 then
                                    break
                                end
                            end

                        end
                    end
                end
                zc.sendHttp({
                    apiName = "Bag_sell",
                    params = {info = selldata},
                    successCallback = function (data)
                        --刷新数据，更新tableview
                        PlayerData:updataData(data)
                        if _sellMainType == "4" then
                            self._baginfo = PlayerData:getBagInfo()
                        elseif _sellMainType == "12" then
                            self:setGemInfo()
                        end
                        self:setTabData()
                        self:refreshTableView()
                        if sellgood["type"] and tonumber(sellgood["type"]) == 5 then
                            self:setTabRedPoint()
                        end
                    end,
                })
            end
            zc.createSourcePop("Sell", "src/layer/bag/SellPop.lua", {rightFunc = sellFunc, maxNum = _maxNum, 
                info = self._lastSelectInfo})
        end
    end)
end


--获取按钮是出售还是使用  
--如果是兵器     右 3洗练 左 4熔炼
--如果不是兵器   右 1出售 左 2详情
--如果是宝箱     右 1出售 左 2使用
function BagLayer:getItemSellOrUse(whichbtn)
    if tonumber(self._lastSelectInfo["mainType"]) == zc.mainTypeWeapon then 
        --兵器
        if whichbtn == "right" then 
            return 3, zc.lang("smithy_clear")
        else
            return 4, zc.lang("smelt")
        end
    else
        --非兵器
        if whichbtn == "right" then 
            return 1, zc.lang("sell")
        else
            local _subType = tonumber(self._lastSelectInfo["subType"]) or 0
            if _subType == zc.subTypeBox then 
                return 2, zc.lang("use")
            elseif _subType == zc.subTypeWeaponFragment then
                return 2, zc.lang("compose")
            else
                return 2, zc.lang("details")
            end
        end
    end
end
function BagLayer:resetAllInfo()
    self._baginfo = PlayerData:getBagInfo()
    --只显示武将的兵器
    local myAllWeapons = PlayerData:getWeaponsInfo()
    self._weapons = {}
    for i=1,#myAllWeapons do 
        if tonumber(myAllWeapons[i]["isUser"]) == 0 then 
            self._weapons[#self._weapons + 1] = myAllWeapons[i]
        end
    end
    --宝石信息
    self:setGemInfo()
end
function BagLayer:findNowIdx(_info)
    local idx = 1
    if _info and _info.itemId then
        if self._showBagInfo then
            for i = 1, #self._showBagInfo do
                if self._showBagInfo[i]["itemId"] and tonumber(self._showBagInfo[i]["itemId"]) == tonumber(_info.itemId) then
                    idx = i
                    break
                end
            end
        end
    end
    print("-----------log--------ad-----------------------------------------------------new idx11 ", idx)
    self._selectBagIndex = idx
    local nowCellIndex = math.floor((self._selectBagIndex - 1)/5) + 1
    self._nowCellIndex = nowCellIndex
    print("-----------log--------ad-----------------------------------------------------new idx22 ", nowCellIndex)
    return idx
end
------------------- tableView出售后刷新 ----------------------------
function BagLayer:refreshTableView(_neednt) --_neednt是否在这里刷新数据
    if self._selectBagIndex > table.nums(self._showBagInfo) then --如果选中的是最后一个，使用后仍然选中当前最后一个
        self._selectBagIndex = table.nums(self._showBagInfo)
    end
    if not next(self._showBagInfo) then
        self._itemEmpty:setVisible(true)
        self:updateLeftInfo()
    else
        self._itemEmpty:setVisible(false)
    end
    self._lastSelectInfo = nil
    self._rightTableview:reloadDataAndScrollToCurrentCell()
    if self._nowCellIndex then
        self._rightTableview:scrollToCell(self._nowCellIndex-1, false)
        self._nowCellIndex = nil
    end
end

-- 对每个tab里的数据进行分类
function BagLayer:setTabData()
    self._showBagInfo = {}
    -- 根据类型获取相应tab的内容
    local function getCurList(typenum)
        for i=1,#self._baginfo do 
            if tonumber(self._baginfo[i]["type"]) == typenum then 
                self._showBagInfo[#self._showBagInfo + 1] = self._baginfo[i]
            end
        end
    end
    if self._tag == 1 then 
        --全部
        self._showBagInfo = table.copy(self._baginfo)
        if self._weapons then
            for i=1,#self._weapons do 
                self._showBagInfo[#self._showBagInfo+1] = self._weapons[i]
            end
        end
        if self._gemInfo then
            for i = 1, #self._gemInfo do
                self._showBagInfo[#self._showBagInfo+1] = self._gemInfo[i]
            end
        end
    elseif self._tag == 2 then
        --兵器
        self._showBagInfo = self._weapons
    elseif self._tag == 3 then
        --兵器碎片
        getCurList(5)
    elseif self._tag == 4 then
        --1. 消耗品
        getCurList(1)
    elseif self._tag == 5 then
        -- 2. 材料
        getCurList(2)
    elseif self._tag == 6 then
        self._showBagInfo = self._gemInfo
    end

    --设置权重
    --排序规则 
--[[
    1.道具子标签1002
    2.1001
    3.1003
    4.兵器
    5.道具类型3
    6.道具类型4
    7.道具类型1
    8.道具类型2
]]--
    
    --碎片合成列表
    local player_weapon_fragment = PlayerData._static_fragment_weapon or {}
    --
    local gemSort = {[30]=4,[8]=3,[12]=2,[4]=1}
    for i = 1, #self._showBagInfo do
        local v = self._showBagInfo[i]
        local weight = 0
        if not v["gemId"] and not v["weaponId"] and v["subType"] and inArray(tonumber(v["subType"]),{1002,1001,1003}) then
            if tonumber(v["subType"]) == 1002 then --宝箱
                weight = 10000010
            elseif tonumber(v["subType"]) == 1001 then --突飞卡
                weight = 10000002
            elseif tonumber(v["subType"]) == 1003 then --建筑加速卡
                weight = 10000001
            end
        else 
            if v["weaponId"] then --武器
                weight = 100000*tonumber(v["color"]) + (tonumber(v["weaponId"]) or 0)
            elseif v["gemId"] then --宝石
                local gemEffectId = tonumber(v.effectId)
                weight = (gemSort[gemEffectId] or 0) * 10000 + (tonumber(v.level) or 0) + tonumber(v.exp) / 1000000
            else --其它背包物品
                if v["type"] then
                    if tonumber(v["type"]) == 3 then --卷轴
                        weight = 10
                    elseif tonumber(v["type"]) == 4 then --藏宝图
                        weight = 9
                    elseif tonumber(v["type"]) == 1 then --消耗品
                        weight = 8
                    elseif tonumber(v["type"]) == 2 then --材料
                        weight = 7
                    elseif tonumber(v["type"]) == 5 then --武器碎片
                        v["weapon_cansys"] = false
                        local _fragmentInfo = player_weapon_fragment[tonumber(v.itemId)]
                        if _fragmentInfo then
                            if tonumber(v["num"]) >= tonumber(_fragmentInfo["num"]) then
                                local costRes = _fragmentInfo["costRes"] or string.split(_fragmentInfo.cost,"|")
                                _fragmentInfo["costRes"] = costRes
                                if costRes and costRes[2] then
                                    local ownRes = PlayerData:getResourcesInfoById(costRes[2])
                                    if tonumber(ownRes) >= (tonumber(costRes[3]) or 0) then
                                        weight = 10000003
                                    end
                                    v["weapon_cansys"] = true
                                else
                                    weight = 10000003
                                    v["weapon_cansys"] = true
                                end
                            end
                        end
                    end
                end   
            end
        end
        self._showBagInfo[i]["sortWeight"] = weight
    end

    table.sort(self._showBagInfo,function(a,b)
        local _sortWeightA = tonumber(a.sortWeight) or 0
        local _sortWeightB = tonumber(b.sortWeight) or 0
        local _colorA = tonumber(a.color) or 0
        local _colorB = tonumber(b.color) or 0
        local _qualityA = tonumber(a.quality) or 0
        local _qualityB = tonumber(b.quality) or 0
        if _sortWeightA == _sortWeightB then
            if _sortWeightA < 10000 and _sortWeightB < 10000 then
                if _colorA ~= _colorB then
                    return _colorA > _colorB
                else
                    return _qualityA > _qualityB
                end
            else
                if _colorA == _colorB then
                    return _qualityA > _qualityB
                else
                    return _colorA > _colorB
                end
            end
        else
            if _sortWeightA < 10000 and _sortWeightB < 10000 then
                if _sortWeightA ~= _sortWeightB then
                    return _sortWeightA > _sortWeightB
                else
                    if _colorA ~= _colorB then
                        return _colorA > _colorB
                    else
                        return _qualityA > _qualityB
                    end
                end
            else
                return _sortWeightA > _sortWeightB
            end
        end
    end)
end


return BagLayer