--  Created by wangming on 17-04-20.
local gaolan = class("gaolan", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function gaolan:create(params)
	return gaolan.new(params)
end

function gaolan:getSkillHurtCount(skillType)
	local count = 2
	if skillType == 2 then
		count = 7
	elseif skillType == 3 then
		count = 5
	end
	return count
end

function gaolan:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function gaolan:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = false
	end
	return ret
end

function gaolan:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local targetHero = hurtTargets[1]
		local armature = zc.battle.createBattleEffect({fileName = "gaolan", actName = "eff_atk3", autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
        	zc.battle.doShockAndFlash(evt)
        	if self:isAttackEvent(evt) then
				self:doHurt(params)
        	end
        end})

        local _position = targetHero:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5, 6}) then
			_position = 5
		else
			_position = 8
		end
	    armature:setPosition(zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position}))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = targetHero:getLocalZOrder() + 1},
		})
	else
		self:doHurt(params)
	end
end

return gaolan




