--  Created by zhangchao on 16-03-29.
local hanfu = class("hanfu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function hanfu:create(params)
	return hanfu.new(params)
end

local csbs = nil
function hanfu:ctor(params)
	csbs = {"hanfu_atk3_1"}
	self:preloadCsbs(csbs)
end

function hanfu:getCsbFiles()
	return csbs
end

function hanfu:doAttack(params)
	local skillType 	= params.skillType
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local _deadHeroes 	= {}
	local times 		= 0

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _fileName = "hanfu_atk3_1"
		local _actName  = "atk"
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName, loop = true , moveCallback = function (armatureBack,movementType,movementID)
	            if movementType == ccs.MovementEventType.complete and movementID == "atk_1" then
	                xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
	            end
	        end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
		    local runningScene 		= cc.Director:getInstance():getRunningScene()
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_1")
	    		if ret and _tmp_ == 1 then
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end


function hanfu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 3 then
		count = 3
	end
	return count
end

function hanfu:doAnimationEvent(evt)
	local armature = nil
	if evt == "do_atk3_hit" then
		armature = zc.battle.createBattleEffect({fileName = "hanfu_atk3_1" , actName = "atk3_1" , moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                    xpcall(function() armature:removeFromParent() end, function ()
                            print("armature已被删除")
                        end)
                end
            end})
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end

	    --获取位置，敌人前排中间位置
	    local tmp_side = self:getSide()
	    if tmp_side == BATTLE_SIDE.LEFT then
	    	tmp_side = BATTLE_SIDE.RIGHT
	    else
	    	tmp_side = BATTLE_SIDE.LEFT
	    end
  		local pos = zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6})
  		pos.y = self:getPositionY()
	    -- obj.__PARENT_CLASS_NAME__:methodInParent()
	    armature:setPosition(pos)
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = self:getLocalZOrder() + 1},
		})
	end
end


function hanfu:shouldMoveAttack(atkName)
	local ret = true
	local _type_ = self:getHeroType()
	if _type_ == 2 then--[[--谋士]]
		ret = false
	end
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end 
	return ret
end
return hanfu




