--  Created by wangming on 17-03-08.
local weiyan = class("weiyan", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function weiyan:create(params)
	return weiyan.new(params)
end

function weiyan:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 5
	elseif skillType == 3 then
		count = 9
	end
	return count
end

function weiyan:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local _actName = "atk3_1"
		local _plus = 0
		if evt == "do_atk3_hit2" then
			_plus = 3
		elseif evt == "do_atk3_hit3" then
			_actName = "atk3_2"
			_plus = 6
		end

		local _evts = {}
		for k,hero in pairs(hurtTargets) do
			local _arrow = zc.battle.createBattleEffect({fileName = "weiyan", actName = _actName, autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	zc.battle.doShockAndFlash(evt)
            	if self:isAttackEvent(evt) then
            		if inArray(evt, _evts) then
	            		return
	            	end
	            	table.insert(_evts, evt)
	            	local _empEvt = "do_atk3_hit" .. (_plus + #_evts)
	            	params.evt = _empEvt
					self:doHurt(params)
            	end
            end})
            if self:getSide() == BATTLE_SIDE.LEFT then
		    	_arrow:setScaleX(-1 * _arrow:getScaleX())
		    end
		    _arrow:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function weiyan:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == 1 then
		self:showCommonDefenseEffect(params)
	else
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end

return weiyan




