--  Created by zhangchao on 16-03-29.
local zhangfei = class("zhangfei", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhangfei:create(params)
	local _zhangfei = zhangfei.new(params)
	_zhangfei._fit2SkillId = 341
	return _zhangfei
end


function zhangfei:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    --[[zhangbao大招给自己加血，所以如果对象是自身，就不需要播放受击动作]]
    if skillType == BATTLE_SKILL_TYPE.FIT then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    else
    	self:showCommonDefenseEffect(params)
    end
end

function zhangfei:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 7
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = self._isFit2 and 6 or 10
	end
	return count
end

function zhangfei:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end

			local weaponId = self:getWeaponId()
			zc.soldierChangeWeapon(armature, weaponId)
	    end
	end
end

function zhangfei:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	if skillType == 3 then
	    local tmp_side 	= self:getSide()
	    local _pos		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 2})
	    pos.y 			= _pos.y
	end
	return pos
end

function zhangfei:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local hurtTargets   = params.hurtTargets
	local endFunction   = params.endFunction
	print("!!!!!!!!!!!!asdfaesdf")
	print("skillType: " .. skillType)
	-- print("self._isFit2: " .. self._isFit2)
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType ~= BATTLE_SKILL_TYPE.FIT or self._isFit2 then
		print("skillType", skillType)
		self:doHurt(params)
		return
	end
	print("!!!!!!!!!!!!asdfaesdf1")
	local _target_ = hurtTargets[1]
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	local armature_fit = zc.battle.createBattleEffect({fileName = "zhangfei_fit", actName = "Fit_1", autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
		zc.battle.doShockAndFlash(evt)
    	if self:isAttackEvent(evt) then
        	params.evt = evt
			self:doHurt(params)
		elseif string.find(evt, "back") then
			performWithDelay(self, endFunction, 0.5)
		end
    end})

    local _tarSide = BATTLE_SIDE.LEFT
	if self:getSide() == BATTLE_SIDE.LEFT then
		_tarSide = BATTLE_SIDE.RIGHT
    	armature_fit:setScaleX(-1 * armature_fit:getScaleX())
    end

	local _position = 1
	if _target_ then
		_position = _target_:getBattlePosition()
	end
	if inArray(_position, {1,2,3}) then
		_position = 2
	elseif inArray(_position, {4,5, 6}) then
		_position = 5
	else
		_position = 8
	end

    armature_fit:setPosition(zc.battle.getInitialMatrixPoint({side = _tarSide, position = _position}))
    zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		data = {node = armature_fit , zorder = self:getLocalZOrder() + 30},
	})
end

function zhangfei:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "bejing",
		skeletonActName = "zhangfei",
		name = "zhangfei",
		heroActName = "idle",

		fileName = "zhangfei_fit",
		actName = "Fit_1"
	}
	if self._isFit2 then
		fitSrc.fileName = "zhangfei_fit_A2"
		fitSrc.actName = "Fit2"
		fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
	end
	return fitSrc
end

function zhangfei:_doFitSkill(params, fitSrc)
	if self._isFit2 then
		self:doFitNormalSkill(params, fitSrc)
		return
	end
	local data 	= {}
	zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_ALL_HEROES,data = data})
	local all_heroes 	= data.heroes
	local firstTarget 	= params.firstTarget
	local skillType 	= params.skillType
	local skillId 		= params.skillId
	local _targets_ = {}
	local processInfo 	= params.processInfo
	local process = nil
	local hurtTargets = {}
	if processInfo then
		process 		= processInfo.process
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= process_item[2]
			local data 					= {id = action_model_id}
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
				data = data,
			})
			local hero = data.target
			if action_type == 5 then
		    	local skill_id 				= process_item[3]
				local skill_level			= process_item[4]--技能的等级
				local skill_type			= process_item[5]--技能类型（ 1 士气技能(大招),2 默认技能 3 组合技能）
				local skill_status			= process_item[6]--技能是否释放成功 1 成功 0  释放失败
				local skill_cover_targets	= process_item[7]--技能所覆盖的目标(战斗单元id列表) 
				local skill_mix_targets		= process_item[8]--参与辅助组合技能的战斗单元列表(战斗单元id列表)
				if skill_mix_targets ~= nil then
					for k,id in pairs(skill_mix_targets) do
						local data 				= {id = id}
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
							data = data,
						})
						local hero 			= data.target
						hero:setVisible(true)
						hero:getRectBuffNode():setVisible(false)
						local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" ,fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function()
								hero:setColor(cc.c3b(255,255,255))
								hero:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
								local tmp_side 	= hero:getSide()
							    local pos 		= cc.p(zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7}).x , zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6}).y)

							    local pos_delta = cc.pGetDistance(pos, cc.p(hero:getPositionX(),hero:getPositionY()))
								local dt 		= zc.getDynamicTime(pos_delta, 3000)
								hero:runAction(cc.MoveTo:create(dt, pos ))
							end})
						armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero:getArmature()))
						hero:getRectEffectNode():addChild(armature,1)
						_targets_[#_targets_ + 1] = hero
					end
				end
			elseif action_type == 3 then
				local hp_change_value 		= process_item[3]
				local hp_change_source 		= process_item[4]--血量或者伤害变化来源(对应下面的类型)
				if tonumber(hp_change_value) and tonumber(hp_change_value) < 0 then
					hurtTargets[#hurtTargets + 1] = hero
				end
			end
		end--[[--for end]]
	end
	self.__nowFitAllHeroes = all_heroes
	self.__nowFitType = skillType
	self.__nowFitProgress = process
	self.__nowFitTargets = _targets_

	local _data_ 	= {}
	zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_GET_BG,
		data = _data_,
	})
	local bg = _data_.bg

	local director = cc.Director:getInstance()
    local winSize = director:getWinSize();
    local winWidth = winSize.width;
    local winHeight = winSize.height;

	local runningScene 	= director:getRunningScene()
	--[[自身也需要往上飞起]]
	local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/", fileName = "dazhao_ef", actName = "dazhao", completeCallback = function( )
		local fit_bg
		--合击技1.2的背景不一样。
		if self._isFit2 then
			fit_bg = zc.createSprite("res/image/battle/fit2.jpg")
		else
			fit_bg = zc.createSprite("res/image/battle/fit.jpg")
		end
		
		zc.setBgSize(fit_bg)
		fit_bg:setPosition(winWidth / 2 , winHeight / 2)
		bg:addChild(fit_bg)
		fit_bg:runAction(cc.FadeIn:create(3.5))
		fit_bg:setName(BATTLE_FIT_BG_NAME)

		if all_heroes then
			for k,hero in pairs(all_heroes) do
				if hero:getSide() == self:getSide() then
					hero:setVisible(false)
				else
					hero:setColor(BATTLE_DIM_COLOR)
				end
			end
		end
		for k,hero in pairs(_targets_) do
			hero:setVisible(true)
		end
		self:setVisible(true)

		for k,hero in pairs(hurtTargets) do
			hero:setColor(cc.c3b(255,255,255))
		end

		local tmp_side 	= self:getSide()
	    local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7})

	    local pos_delta = cc.pGetDistance(pos, cc.p(self:getPositionX(),self:getPositionY()))
		local dt = zc.getDynamicTime(pos_delta, 3000)

		self:runAction(cc.Sequence:create(cc.MoveTo:create(dt, pos ), cc.CallFunc:create(function()
			self:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
			local armature = zc.battle.createBattleEffect({fileName = "zhangfei_fit", actName = "Fit_2", autoRemove = true, completeCallback = function()
				-- [[大闪屏]]
				local node = BattleNodeFitSkill:createWithParams({beijing = fitSrc.beijing,skeletonActName = fitSrc.skeletonActName, heroActName = fitSrc.heroActName,name = fitSrc.name,completeCallback = function( ... )
					self:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					for k,hero in pairs(_targets_) do
						hero:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					end
					--[[攻击特效]]
					performWithDelay(self, function()
						self:doAttack({skillType = skillType, process = process, hurtTargets = hurtTargets, endFunction = function()
							if not tolua.isnull(fit_bg) then
								fit_bg:removeFromParent()
							end
							self:_endFitSkill(all_heroes, _targets_)
						end})
					end, 0.3)
				end})
				runningScene:addChild(node)
			end})
			armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = self:getLocalZOrder() + 30},
			})
			for k,hero in pairs(_targets_) do
				local armature = zc.battle.createBattleEffect({fileName = "zhangfei_fit_A2", actName = "Fit_2", autoRemove = true})
				armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
			    if hero:getSide() == BATTLE_SIDE.LEFT then
			    	armature:setScaleX(-1 * armature:getScaleX())
			    end
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 30},
				})
			end
		end) ))
	end})
	armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,self:getArmature()))
	self:getRectEffectNode():addChild(armature,1)
end


function zhangfei:doFitSkillHitEff(params)

	print(self._isFit2, "self._isFit2")

	if not self._isFit2 then
		self:_doNormalFitEff(params)
		return
	end

	print("zhafnfei : data")
	dump(params)
	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	performWithDelay(self, function()

		print("do_fit_hit......zhang - 1")
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		if self._isFit2 then
			_actName = _actName .. "_A2"
		end

		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end

		local runningScene 	= cc.Director:getInstance():getRunningScene()

		print(fitSrc.fileName, "fitSrc.fileName")
		print(fitSrc.actName, "fitSrc.actName")

		for k,v in pairs(hurtTargets) do
			local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
				zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
				fit_bg:removeFromParent()
			end})
		    if self:getSide() == BATTLE_SIDE.RIGHT then
		    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
		    end
		    if k == 1 then
			    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
			    	zc.battle.doShockAndFlash(evt)
			    	--[[每次受击]]
			        if string.find(evt,"do_fit_hit") then
						self:doAttack({skillType = skillType, process = process, evt = evt})
					elseif string.find(evt,"back") then
						self:_endFitSkill(all_heroes, _targets_)
			        end
			    end)
			end

			local _pos = v:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene)
			_pos.y = _pos.y + 30
	    	armature_fit2:setPosition(_pos)

			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature_fit2 , zorder = v:getLocalZOrder() + 30},
			})
		end
		-- 对面闪避处理
		if #hurtTargets < 1 then
			local parentPath = "res/image/battle/hero/" 
			local armature_fit2 = zc.battle.createBattleEffect({parentPath = parentPath, fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
				zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
				fit_bg:removeFromParent()
			end})
		    if self:getSide() == BATTLE_SIDE.RIGHT then
		    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
		    end
		    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
		    	zc.battle.doShockAndFlash(evt)
		    	--[[每次受击]]
		        if string.find(evt,"do_fit_hit") then
					self:doAttack({skillType = skillType, process = process, evt = evt})
				elseif string.find(evt,"back") then
					self:_endFitSkill(all_heroes, _targets_)
		        end
		    end)
		    local _pos = params.firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene)
		    _pos.y = _pos.y + 30
	    	armature_fit2:setPosition(_pos)
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
			})
		end
	end,0)
end

return zhangfei