-- FileName: ChapterMainLayer.lua
-- Author: wangming
-- Date: 2016-09-26
-- Purpose: 新主线章节列表界面
--[[TODO List]]

local ChapterMainLayer = class("ChapterMainLayer", function()
	return zc.createNormalDialog({
		src = "",
        showYun = true,
        yunZorder = {4, 4},
        yunOffY = {30, -30},
		floweZorder = {5, 3, 5, 5},
		closeCallBack = function()
	        local _currentGID = getGuideManager():getCurrentGID()
	        if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then
	            zc.setGuideFuncNextStep(_currentGID)
	            LayerManager.backToMainCity()
	            return
	        end
	        LayerManager.removeLayout()
		end
	})
end)

function ChapterMainLayer:create( params )
    return ChapterMainLayer.new(params)
end

function ChapterMainLayer:ctor( data )
    self._bgSpineIndex = {
        [1] = {
            name = "bule_liuxing",
            pics = {
                "bule_liuxing",
            },
        },
        [3] = {
            name = "huohai",
            pics = {
                "huohai",
            }
        },
        [5] = {
            name = "huohai",
            pics = {
                "huohai",
            }
        },
        [6] = {
            name = "huohai",
            pics = {
                "huohai",
            }
        },
        [9] = {
            name = "huohai",
            pics = {
                "huohai",
            }
        },
    }
    self._heroSpineIndex = {
        [1] = {
            name = "sunjian",
            pics = {
                "sunjian",
                "sunjian2",
            },
        },
        [3] = {
            name = "huaxiong",
            pics = {
                "huaxiong",
                "huaxiong2",
            },
        },
        [10] = {
            name = "dongzhuo",
            pics = {
                "dongzhuo",
                "dongzhuo2",
            },
        },
        [11] = {
            name = "zhangjiao",
            pics = {
                "zhangjiao",
                "zhangjiao2",
            },
        },
        [16] = {
            name = "caocao",
            pics = {
                "caocao",
                "caocao2",
            },
        },
        [22] = {
            name = "lvbu",
            pics = {
                "lvbu",
                "lvbu2",
            },
        },
        [26] = {
            name = "zhangbao",
            pics = {
                "zhangbao",
                "zhangbao2",
            },
        },
        [27] = {
            name = "liru",
            pics = {
                "liru",
                "liru2",
            },
        },
        [37] = { 
            name = "xunyu",
            pics = {
                "xunyu",
            },
            pos = ccp(zc.width/2+200, 0),
            scale = 0.9,
        },
        [42] = {
            name = "lvqilin",
            pics = {
                "lvqilin",
                "lvqilin2",
            },
        },
        [63] = {
            name = "tiaoqian",
            pics = {
                "tiaoqian",
            },
            pos = ccp(zc.width/2 + 100, -100)
        },
        [66] = { 
            name = "pangtong",
            pics = {
                "pangtong",
            },
            pos = ccp(zc.width/2, 0),
            scale = 0.8,
        },
        [86] = { 
            name = "weiyan",
            pics = {
                "weiyan",
            },
            pos = ccp(zc.width/2+100, -50)
        },
        [87] = { 
            name = "guanping",
            pics = {
                "guanping",
            },
            pos = ccp(zc.width/2+100, -50)
        },
        [91] = {
            name = "lusu",
            pics = {
                "lusu",
                "lusu2",
            },
            pos = ccp(zc.width/2, 0)
        },
        [92] = {
            name = "sunquan",
            pics = {
                "sunquan",
            },
            pos = ccp(zc.width/2 + 100, -50)
        },
        [90] = {
            name = "huangzhong",
            pics = {
                "huangzhong",
            },
            pos = ccp(zc.width/2, 0)
        },
        [93] = {  
            name = "ganning",
            pics = {
                "ganning",
            },
            pos = ccp(zc.width/2+150, -50)
        },
        [109] = { 
            name = "xuhuang",
            pics = {
                "xuhuang",
            },
            pos = ccp(zc.width/2 +100, -100),
            scale = 0.9,
        },
        [123] = { 
            name = "sunshangxiang",
            pics = {
                "sunshangxiang",
            },
            pos = ccp(zc.width/2 +100, -150)
        },
    }
	self._params = data or {}
    self._nationId = data.nationId == 2 and 2 or 1
    self._seatNum = 0

    if self._params.tollgateId then 
        self._curSeatId = tonumber(self._params.tollgateId) + 1
    end

	cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
    local _mainBtn, _eliteBtn

    local function _onMainClick()
        self._nationId = 1
        _mainBtn:setStateSelected(zc.getSprite({
        	src = "res/Main/chapterMain/chapterTypeBtn.png",
        }))
        _mainBtn:setEnable(false)
        _mainBtn:setSelected(true)
        _eliteBtn:setStateSelected(zc.getSprite({
        	src = "house_entityDi_normal.png",
        	plist = true,
        }))
        _eliteBtn:setEnable(true)
        _eliteBtn:setSelected(false)
        -- bgImg:setTexture("res/Main/chapterMain/chapterBg/1.jpg")
        if self:getActionByTag(1999) then
            self:stopActionByTag(1999)
        end
        self._isRunaction = false
        self:freshData()
        self:freshChapterInfo(true)
        if not self._starArmature then
            self:createStarTreasure() --星级宝箱
        end
    end

    local function _onEliteClick()
        --功能引导
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_11502 then
            zc.setGuideFuncNextStep(_currentGID)
        end
        --精英FB开启条件
        local _flag = zc.getFunctionStatus(15,true) --精英FB
        if _flag then
            self._nationId = 2
	        _eliteBtn:setStateSelected(zc.getSprite({
	        	src = "res/Main/chapterMain/chapterTypeBtn.png",
	        }))
            _eliteBtn:setEnable(false)
	        _eliteBtn:setSelected(true)
	        _mainBtn:setStateSelected(zc.getSprite({
	        	src = "house_entityDi_normal.png",
	        	plist = true,
	        }))
	        _mainBtn:setEnable(true)
	        _mainBtn:setSelected(false)
	        -- bgImg:setTexture("res/Main/chapterMain/chapterBg/1.jpg")
            if self:getActionByTag(1999) then
                self:stopActionByTag(1999)
            end
            self._isRunaction = false
            self:freshData()
            self:freshChapterInfo(true)
        end 
    end

    _eliteBtn = zc.createPushButton({
        normalFile = "house_entityDi_normal.png",
        selectedFile = "house_entityDi_normal.png",
        plist = true,
        pos = cc.p(zc.width - 90 + 50, 85),
        endCallback = _onEliteClick,
    })
    self._eliteBtn = _eliteBtn
    self:addChild(_eliteBtn, 5)
    local _title = zc.getSprite({
    	src = "res/Main/chapterMain/typBtnTitle_elite.png",
    	pos = cc.p(_eliteBtn:getContentSize().width*0.5, _eliteBtn:getContentSize().height*0.5)
    })
    _eliteBtn:addChild(_title, 1)
    _eliteBtn:setVisible(false)
    _mainBtn = zc.createPushButton({
        normalFile = "house_entityDi_normal.png",
        selectedFile = "house_entityDi_normal.png",
        plist = true,
        pos = cc.p(_eliteBtn:getPositionX() - 140 - 100, _eliteBtn:getPositionY()),
        endCallback = _onMainClick
    })
    self:addChild(_mainBtn, 5)
    local _title = zc.getSprite({
    	src = "res/Main/chapterMain/typBtnTitle_normal.png",
    	pos = cc.p(_mainBtn:getContentSize().width*0.5, _mainBtn:getContentSize().height*0.5)
    })
    _mainBtn:addChild(_title, 1)
    self._mainBtn = _mainBtn
    _mainBtn:setVisible(false)
    local _enterBtn = zc.createPushButton({
    	normalFile = "res/Main/chapterMain/enterBtn.png",
    	pos = cc.p(zc.width - 65, zc.height*0.5),
    	endCallback = function()
    		local _idx = self._curSeatId - 1
	    	local _data = self._data[_idx] or {}
    		if _data.isOpen ~= 0 then
    			return
    		end
    		self._curPage = self._curSeatId
            self._isRunaction = false
            self:openChapter(_data.id, _idx)
    	end
    })
    self:addChild(_enterBtn, 2)
    self._enterBtn = _enterBtn

    if self._nationId == 1 then
        _onMainClick()
    else
        _onEliteClick()
    end

    local _file = "res/Main/chapterMain/chapterBg/1.jpg"
    local function _initInfo( node )
        node._bgFile = _file
        node._nameFile = "res/Main/chapterMain/chapterName/1.png"
        local _chapterName = zc.getSprite({
            src = node._nameFile,
            pos = cc.p(zc.width*0.5, zc.height*0.5 - 140)
        })
        node:addChild(_chapterName, 1)
        node._chapterName = _chapterName

        local _chapterNumDi = zc.getSprite({
            src = "res/Main/chapterMain/chapterNumDi.png",
            pos = cc.p(zc.width*0.5 + 160, zc.height*0.5 - 170)
        })
        node:addChild(_chapterNumDi, 1)
        _chapterNumDi:setRotation(-15)
        node._chapterNumDi = _chapterNumDi

        local _chapterNum = zc.createFntLabel({
            fnt = "res/Main/chapterMain/chapterBigNum.fnt",
            text = _idx,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(_chapterNumDi:getContentSize().width*0.5, _chapterNumDi:getContentSize().height*0.5 + 13),
            addwidth = -10,
        })
        _chapterNumDi:addChild(_chapterNum, 1)
        node._chapterNum = _chapterNum
        node:setVisible(false)
    end

    local _bg2 = zc.getSprite({
        src = _file,
        name = "background2",
        pos = cc.p(zc.width*0.5, zc.height*0.5),
    })
    self:addChild(_bg2, -1)
    zc.setBgSize(_bg2)
    _bg2:setVisible(false)
    local bgImg = zc.getSprite({
        src = _file,
        name = "background1",
        pos = cc.p(zc.width*0.5, zc.height*0.5),
    })
    self:addChild(bgImg, -1)
    zc.setBgSize(bgImg)

    self._infoNode = cc.Node:create()
    self:addChild(self._infoNode)
    _initInfo(self._infoNode)
    self._infoNode:setVisible(true)
    self._infoNode._chapterName:setPositionX(self._infoNode._chapterName:getPositionX() - 100)
    self._infoNode._chapterName:setPositionY(self._infoNode._chapterName:getPositionY() - 100)
    self._infoNode._chapterNumDi:setPositionX(self._infoNode._chapterNumDi:getPositionX() + 100)
    self._infoNode._chapterNumDi:setPositionY(self._infoNode._chapterNumDi:getPositionY() + 100)
    self._infoNode._bg = bgImg
    self._infoNode2 = cc.Node:create()
    self:addChild(self._infoNode2)
    _initInfo(self._infoNode2)
    self._infoNode2._bg = _bg2

    self:initPubLayer()
end

function ChapterMainLayer:onEnter()
    if not self:isVisible() then
        return
    end
    musicManager.playMusic(zc.bgm.mainChapter, true)

    if not self._mainBtn:isVisible() and not self._eliteBtn:isVisible() then
        local _flag = zc.getFunctionStatus(15, false)
        if _flag then
            self._mainBtn:setVisible(true)
            self._eliteBtn:setVisible(true)
        end
    end
    if self._guideHand then
        self._guideHand:setVisible(false)
    end
    getGuideManager():addMaskLayer()

    self:freshData(true)
    if self._haveInit then 
        if self._challengeBg and self._challengeBg._updateTimeFunc then
            self._challengeBg._updateTimeFunc()
        end
        local _idx = self._curSeatId - 1
        local _cdata = self._data[_idx]
        if _cdata and _cdata.id then
            self:updateStarTreasure(_cdata.id)
        end
    end

    --功能引导
    performWithDelay(self, function ()
        getGuideManager():removeMaskLayer()
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_11502 then
            getGuideManager():setObjTarget(self._eliteBtn)
            getGuideManager():startGuide()
        elseif _currentGID == GuideKey.KEY_13000 then
            local mainCity = zc.getScene("mainCity")
            if mainCity then
                mainCity:updateTaskLeadTips(true)
            end
            getGuideManager():setCurrentGID(GuideKey.KEY_13001, true)
            local function _callBack()
                getGuideManager():setObjTarget(self._closeBtn)
                getGuideManager():startGuide()
            end
            getGuideManager():setHeroFuncCallBack(_callBack)
            getGuideManager():startGuide()
        end
    end,0.5)  

    performWithDelay(self, function()
        if not self._haveInit then
            self._pubLayer:reloadData()
            self._pubLayer:scrollToCell(self._curSeatId - 2 - 1, false)
            self._haveInit = true
        else
            if self._backIdx == true then 
                self:freshChapterInfo(true) 
            else
                for i = 2, self._seatNum - 3 do
                    if i == self._backIdx then
                        self._pubLayer:updateCellAtIndex(self._backIdx)
                    end
                end
                self:tablePageAfterSlidingFresh()
                self:freshGuide()
            end
            self._backIdx = nil
        end
    end, 0.01)
end

function ChapterMainLayer:onCleanup()
    self:removeAllChildren()
    helper.collectMemory(true)
end

function ChapterMainLayer:scorllviewScriptScroll( table, isForce ) --这里只对卷轴相对中心位置调整scale
    local currentPage = table:getCurrentPage() + 2
    local _offSet = table:getContentOffset().y
   	if not isForce and self._lastOffSet == _offSet then
   		return
   	end
   	self._lastOffSet = _offSet
    for i = currentPage - 2, currentPage + 3 do
        local _cell = table:cellAtIndex(i)
        if _cell then
            local _posY = _cell:getPositionY() + _offSet + self._pubSize.height*0.2*0.5
            local _part = math.abs(self._pubSize.height*0.5 - _posY)/(self._pubSize.height*0.5)
            local _scale = 1 - _part*self._minScale
            _scale = _scale < self._minScale and self._minScale or _scale
            local _opacity = (1 - _part*0.5)*255
            _cell:setScale(_scale)
            zc.doFuncForAllChild(_cell, function( child )
        		child:setOpacity(_opacity)
        	end)
        	if _scale <= 0.7 then
                _cell:setLocalZOrder(1)
    		elseif _scale < 0.85 then
                _cell:setLocalZOrder(2)
    		else
                _cell:setLocalZOrder(3)
    		end
        end
    end
	local _cell = table:cellAtIndex(currentPage - 3)
    if _cell then
        _cell:setScale(self._minScale)
    end
	local _cell = table:cellAtIndex(currentPage + 4)
    if _cell then
        _cell:setScale(self._minScale)
    end

end

function ChapterMainLayer:freshNowChaperUI()
    local _per, _next
    if not self._haveInit then
        _per = nil
        _next = self._infoNode
        self._nowInfoIdx = 2
    elseif self._nowInfoIdx == 1 then
        _per = self._infoNode
        _next = self._infoNode2
        self._nowInfoIdx = 2
    else
        _per = self._infoNode2
        _next = self._infoNode
        self._nowInfoIdx = 1
    end
    self:reorderChild(_next, _next:getLocalZOrder())
	local _idx = self._curSeatId - 1
    local _cdata = self._data[_idx]
    self:updateStarTreasure(_cdata.id)

    _next._bgIdx = _cdata.bgImg
    _next._mapIdx = _cdata.map
    _next._bgFile = "res/Main/chapterMain/chapterBg/" .. tostring(_cdata.map) ..".jpg"
    if not zc.checkFileExist(_next._bgFile) then
        _next._mapIdx = 1
        self._bgFile = "res/Main/chapterMain/chapterBg/1.jpg"
    end
    local _nameId = _cdata.nameId or _idx
    _next._nameFile = "res/Main/chapterMain/chapterName/" .. tostring(_nameId) .. ".png"
    if not zc.checkFileExist(_next._nameFile) then
        self._nameFile = "res/Main/chapterMain/chapterName/1.png"
    end 
    _next._bg:setTexture(_next._bgFile)
    _next._chapterName:setTexture(_next._nameFile)
	_next._chapterNum:setString(_idx)

    if _next._spine then
        _next._spine:removeFromParent()
        _next._spine = nil
    end
    if _next._effSpine then
        _next._effSpine:removeFromParent()
        _next._effSpine = nil
    end

    if self._bgSpineIndex[_next._mapIdx]then
        local _name = tostring(self._bgSpineIndex[_next._mapIdx].name)
        _next._effSpine = zc.createSpine({
            fileName = _name,
            path = "res/Main/chapterMain/chapterBg/" .. _name .. "/",
            actName = "animation",
        })
        _next._effSpine:setPosition(_next._bg:getContentSize().width*0.5, _next._bg:getContentSize().height*0.5)
        _next._bg:addChild(_next._effSpine)
    end
    if self._heroSpineIndex[_next._bgIdx]then
        local _name = tostring(self._heroSpineIndex[_next._bgIdx].name)
        _next._spine = zc.createSpine({
            fileName = _name,
            path = "res/Main/chapterMain/bodys/" .. _next._bgIdx .. "/",
            actName = "animation",
        })
        _next._spine:setPosition(zc.width, 0)
        if self._heroSpineIndex[_next._bgIdx].pos then
            _next._spine:setPosition(self._heroSpineIndex[_next._bgIdx].pos)
        end
        if self._heroSpineIndex[_next._bgIdx].scale then
            _next._spine:setScale(self._heroSpineIndex[_next._bgIdx].scale)
        end
        _next:addChild(_next._spine)
    else
        _next._spine = zc.createSprite("res/Main/chapterMain/bodys/" .. _next._bgIdx .. ".png")
        _next._spine:setAnchorPoint(1, 0)
        _next._spine:setPosition(zc.width, 0)
        _next:addChild(_next._spine)
    end

    local function _doFadeFunc( node, isIn, callback)
        if tolua.isnull(node) then
            return
        end
        local _array = {}
        node:stopActionByTag(1024)
        node:setVisible(true)
        if isIn then
            node:setOpacity(0)
            local _action = cc.FadeIn:create(0.3)
            _array[#_array + 1] = _action
            if callback then
                local _action = cc.CallFunc:create(function()
                    if callback then
                        callback(node)
                    end
                end)
                _array[#_array + 1] = _action
            end
        else
            node:setOpacity(255)
            local _action = cc.FadeOut:create(0.3)
            _array[#_array + 1] = _action
            local _action = cc.CallFunc:create(function()
                node:setVisible(false)
                if callback then
                    callback(node)
                end
            end)
            _array[#_array + 1] = _action
        end
        local _action = cc.Sequence:create(_array)
        _action:setTag(1024)
        node:runAction(_action)
    end

    if _per then
        zc.doFuncForAllChild(_per, function(child)
            _doFadeFunc(child, false)
        end)
        _doFadeFunc(_per._bg, false, function(node)
            if node == _per._bg then
                if _per._bgFile and _per._bgFile ~= _next._bgFile then
                    cc.Director:getInstance():getTextureCache():removeTextureForKey(_per._bgFile)
                end
                if _per._nameFile and _per._nameFile ~= _next._nameFile then
                    cc.Director:getInstance():getTextureCache():removeTextureForKey(_per._nameFile)
                end
            end
        end)
        _doFadeFunc(_per._effSpine, false, function(node)
            if node == _per._effSpine then
                _per._effSpine:removeFromParent()
                _per._effSpine = nil
                if self._bgSpineIndex[_per._bgIdx] and _per._mapIdx ~= _next._mapIdx then
                    local _pics = self._bgSpineIndex[_per._mapIdx].pics
                    local _name = self._bgSpineIndex[_per._mapIdx].name
                    for k,v in pairs(_pics) do
                        cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/chapterMain/chapterBg/" .. _name .. "/".. tostring(v) .. ".png")
                    end
                end
            end
        end)
        _doFadeFunc(_per._spine, false, function(node)
            if node == _per._spine then
                _per._spine:removeFromParent()
                _per._spine = nil
                if _per._bgIdx ~= _next._bgIdx then
                    if self._heroSpineIndex[_per._bgIdx] then
                        local _pics = self._heroSpineIndex[_per._bgIdx].pics
                        local _name = tostring(self._heroSpineIndex[_per._bgIdx].name)
                        for k,v in pairs(_pics) do
                            cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/chapterMain/bodys/" .. _per._bgIdx .. "/" .. tostring(v) .. ".png")
                        end
                    else
                        cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/chapterMain/bodys/" .. _per._bgIdx .. ".png")
                    end
                end
            end
        end)
        zc.doFuncForAllChild(_next, function(child)
            _doFadeFunc(child, true)
        end)
        _doFadeFunc(_next._bg, true)
        _doFadeFunc(_next._effSpine, true)
        _doFadeFunc(_next._spine, true)
    else
        self._mainBtn:runAction(cc.Sequence:create(
            cc.MoveBy:create(0.2, cc.p(60, 0)),
            cc.MoveBy:create(0.05, cc.p(-10, 0))
        ))
        self._eliteBtn:runAction(cc.Sequence:create(
            cc.MoveBy:create(0.2, cc.p(-60, 0)),
            cc.MoveBy:create(0.05, cc.p(10, 0))
        ))
        if self._starBoxBtn then
            self._starBoxBtn:runAction(cc.Sequence:create(
                cc.MoveBy:create(0.2, cc.p(0, 135)),
                cc.MoveBy:create(0.05, cc.p(0, -15))
            ))
        end
        _next._chapterName:runAction(cc.Sequence:create(
            cc.MoveBy:create(0.15, cc.p(125, 125)),
            cc.MoveBy:create(0.05, cc.p(-25, -25))
        ))
        _next._chapterNumDi:runAction(cc.Sequence:create(
            cc.MoveBy:create(0.15, cc.p(-125, -125)),
            cc.MoveBy:create(0.05, cc.p(25, 25))
        ))

        local function _doCellAct( cellIdx, delayTime )
            local _cell = self._pubLayer:cellAtIndex(cellIdx)
            if not _cell then
                return
            end
            _cell:setPositionX(_cell:getPositionX() - 300)
            local _array = {} 
            if delayTime then
                local _action = cc.DelayTime:create(delayTime)
                _array[#_array + 1] = _action
            end
            local _action = cc.MoveBy:create(0.2, cc.p(325, 0))
            _array[#_array + 1] = _action
            local _action = cc.MoveBy:create(0.05, cc.p(-25, 0))
            _array[#_array + 1] = _action
            local _action = cc.Sequence:create(_array)
            _action:setTag(1024)
            _cell:runAction(_action)
        end
        _doCellAct(self._curSeatId) 
        _doCellAct(self._curSeatId + 1, 0.02) 
        _doCellAct(self._curSeatId - 1, 0.02) 
        _doCellAct(self._curSeatId + 2, 0.04) 
        _doCellAct(self._curSeatId - 2, 0.04)  
        
        performWithDelay(_next._bg, function()
            self:freshGuide()
        end, 0.3)
    end

end

function ChapterMainLayer:tablePageAfterSlidingFresh( table )
    local table = self._pubLayer
    local currentPage = table:getCurrentPage() + 2
    if currentPage > self._seatNum - 2 then
        currentPage = self._seatNum - 3
    end

    self:scorllviewScriptScroll(table, true)
    local _tmpPage = currentPage - 1
    local _data = self._data[_tmpPage] or {}
    if _data.isOpen ~= 0 then
    	while( _data.isOpen ~= 0 ) do
    		_tmpPage = _tmpPage - 1
    		_data = self._data[_tmpPage] or {}
    	end
    	table:scrollToCell(_tmpPage - 1, true)
        if self._curSeatId ~= _tmpPage + 1 then
            self._curSeatId = _tmpPage + 1
            self:freshNowChaperUI()
        end
    	return
    end

    local _last_curSeatId = self._curSeatId
    self._curSeatId = currentPage
    for i = currentPage - 2, currentPage + 3 do
        local _index = i-1
        local _data = self._data[_index] or {}
        -- local actionId = _data["icon"] 
        local _tmpCell = table:cellAtIndex(i)  
        if _tmpCell then-- and actionId then
            if i ~= currentPage then
                _tmpCell._touchBtn:setSelected(false)
                local _opacity = 255*0.5
                local _zorder = 1
                if i == currentPage - 1 or i == currentPage + 1 then
                	_opacity = 255*0.8
                	_zorder = 2
                end
                zc.doFuncForAllChild(_tmpCell, function( child )
            		child:setOpacity(_opacity)
            	end)
                _tmpCell:setLocalZOrder(_zorder)
            else
                _tmpCell._touchBtn:setSelected(true)
                zc.doFuncForAllChild(_tmpCell, function( child )
            		child:setOpacity(255)
            	end)
                _tmpCell:setLocalZOrder(3)
                if _last_curSeatId ~= self._curSeatId then
                    self:freshNowChaperUI()
                end
            end
        end
    end

	local _cell = table:cellAtIndex(currentPage - 3)
    if _cell and _cell._touchBtn then
        zc.doFuncForAllChild(_cell, function( child )
    		child:setOpacity(255*0.5)
    	end)
        _cell:setLocalZOrder(0)
        _cell:setScale(self._minScale)
    end
	local _cell = table:cellAtIndex(currentPage + 4)
    if _cell and _cell._touchBtn then
        zc.doFuncForAllChild(_cell, function( child )
    		child:setOpacity(255*0.5)
    	end)
        _cell:setLocalZOrder(0)
        _cell:setScale(self._minScale)
    end
end

function ChapterMainLayer:initPubLayer()
    local _tableSize = cc.size(300, 540)
    self._pubSize = _tableSize
    self._minScale = 0.65
    local tableView = zc.ZCTableView:create(_tableSize)
    tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    tableView:setBounceable(true)
    tableView:setInertia(false)
    tableView:setAutoAlign(true)
    tableView:setDelegate()
    tableView:setPosition(0, (zc.height - _tableSize.height)*0.5)
    self:addChild(tableView, 1)

    local _cellSize = cc.size(_tableSize.width, _tableSize.height*0.2)

    local function scorllviewScriptScroll( table ) --这里只对卷轴相对中心位置调整scale
        self:scorllviewScriptScroll(table)
    end
    local function numberOfCellsInTableView( table )
        return self._seatNum
    end
    local function cellSizeForTable( table, idx )
        return _cellSize.height, _cellSize.width  
    end
    
    local function tablePageAfterSliding( table, cell )
        self:tablePageAfterSlidingFresh()
    end

    local function tableCellAtIndex( table, idx )
        local _cell = table:dequeueCell()
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
            _cell:setContentSize(cc.size(_cellSize.width, _cellSize.height))
            self:createCell(_cell)
        end
        zc.doFuncForAllChild(_cell, function( child )
    		child:setOpacity(255*0.5)
    	end)
        _cell:setScale(self._minScale)
        _cell:setLocalZOrder(0)
        if idx < 2 or idx > self._seatNum - 3 then
            _cell._sprite:setVisible(false)
            _cell._touchBtn:setVisible(false)
            return _cell
        else
            _cell._sprite:setVisible(true)
            _cell._touchBtn:setVisible(true)
        end
        local _index = idx - 1
        self:updateCell(_cell, _index)

        return _cell
    end
    local function tableCellTouched( table, cell )
        local _index = cell:getIdx() - 1
        local _data = self._data[_index] or {}
        if _data.isOpen ~= 0 then
            return
        end
        _index = _index - 1
        local currentPage = table:getCurrentPage()
        if currentPage == _index then
            self._curPage = self._curSeatId
            self._isRunaction = false
            print("self._curPage ----------------------------> ",self._curPage)
            self:openChapter(_data.id, index)
            return
        end
        table:stopAllActions()
        table:scrollToCell(_index, true)
    end
    tableView:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    tableView:registerScriptHandler(numberOfCellsInTableView,zctech.NUMBER_OF_CELLS_IN_TABLEVIEW)  
    tableView:registerScriptHandler(cellSizeForTable,zctech.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex,zctech.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(scorllviewScriptScroll,zctech.SCROLLVIEW_SCRIPT_SCROLL)
    tableView:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)

    self._pubLayer = tableView

end

function ChapterMainLayer:createCell( cell )
    local cellSize = cell:getContentSize()
    local spriteSize = cc.size(cellSize.width-10, cellSize.height)

    local cellSprite = zc.getSprite({
    	src = "res/Main/chapterMain/chapterBtnImg/0.png",
    	ap = cc.p(0, 0.5),
        pos = cc.p(0, cellSize.height/2),
    })
    cell:addChild(cellSprite)
    cell._sprite = cellSprite

    local name = zc.createFntLabel({
        fnt = "res/Main/chapterMain/chapterCellNum.fnt",
        text = 0,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(241, 85),
        addwidth = -3,
    })
    cell._sprite:addChild(name)
    cell._name = name

    local touchBtn = zc.createPushButton({
    	normalFile = "res/Main/chapterMain/chapter_kuang_up.png",
    	selectedFile = "res/Main/chapterMain/chapter_kuang_down.png",
        needSwallow = false,
        anchor = cc.p(0, 0.5),
        noScaleAction = true,
        pos = cc.p(0, cellSize.height/2),
        -- endCallback = function() print("wm----test222 ") end,
    })
    touchBtn:setEnable(false)
    cell:addChild(touchBtn)
    cell._touchBtn = touchBtn
end

--创建cell
function ChapterMainLayer:updateCell( cell, index)
    local _data = self._data[index]
    if not _data then
        return
    end
    cell._name:setString(index)
    local _file = "res/Main/chapterMain/chapterBtnImg/" .. tostring(_data.bgImg) ..".png"
    if not zc.checkFileExist(_file) then
        _file = "res/Main/chapterMain/chapterBtnImg/0.png"
    end
    cell._sprite:setTexture(_file)
    if _data.isOpen ~= 0 then
       	zc.setGray(cell._sprite, true)
    else
       	zc.setGray(cell._sprite, false)  
    end

    --新手引导
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.BTN_ZHANGJIE) and index == 1 then
        -- self._touchBtn_1 = cell._touchBtn
        self._touchBtn_1 = self._enterBtn
        -- self._pubLayer:setTouchEnabled(false)
        -- self._touchBtn_1:setEnable(true)
        -- self._touchBtn_1:setSwallowTouches(true)
        --     print("wm----test111 ")
        -- self._touchBtn_1:setTouchEndedCallback(function()
        --     print("wm----test222 ")
        --     if self._curSeatId ~= index + 1 then
        --         self._pubLayer:stopAllActions()
        --         self._pubLayer:scrollToCell(index - 1, true)
        --         return
        --     end
        --     if _data.isOpen == 0 then
        --         self._curPage = self._curSeatId
        --         self._isRunaction = false
        --         print("self._curPage ----------------------------> ",self._curPage)
        --         self:openChapter(_data.id, index)
        --     else
        --         zc.tipInfo("未开启")
        --     end
        -- end)
    elseif index == 2 then
        self._touchBtn_2 = cell._touchBtn
    end 
end

--获取章节具体数据信息
function ChapterMainLayer:getCurChapterSucessNum( dataInfo )
    local _getTb = {get = -1, all = 0}
    _getTb = {get = 0, all = 0}
    local _chapterid = tonumber(dataInfo.id)
    local chapterInfo = PlayerData:getCopyInfoByChapterId(_chapterid) or {}
    local data = chapterInfo.tollgates
    if data == nil then
        return _getTb
    end
    --以下在关卡数据中增加两个字段，totalStar、getTotalStar
    if not chapterInfo["totalStar"] then --记录关卡总星数
        local _allDatas = gameData.getDataFromCache("tollgate", {chapterId = _chapterid})
        chapterInfo["totalStar"] = (#_allDatas)*3
    end
    local chapterStatusNum = 0
    if not chapterInfo["getTotalStar"] then --是否获得全部星星数
        for i = 1,table.nums(data) do
            if data[i] and data[i]["star"] then
                chapterStatusNum = chapterStatusNum + tonumber(data[i].star)
            end
        end
        if chapterStatusNum >= chapterInfo["totalStar"] then
            chapterInfo["getTotalStar"] = true
        end
    else
        chapterStatusNum = chapterInfo["totalStar"]
    end
    return {get = chapterStatusNum, all = chapterInfo["totalStar"]}
end


function ChapterMainLayer:openChapter(id, idx)
    --新手引导
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.BTN_ZHANGJIE) then
        if _currentGID == GuideKey.KEY_5027 then
            zc.setGuideFuncNextStep(_currentGID)
        else
            getGuideManager():setNextGID(_currentGID)
        end
    end

    local function gotoTollgateLayer(_extraData)
    	--处理副本
        local id = tonumber(id)
        local function refreshTable()
            self._backIdx = true
        end
        zc.createTollgateLayer({
            tollgateId = id, 
            nationId = self._nationId, 
            callback = refreshTable,
            extraData = _extraData, --额外参数(未领取的饰品)
        })
    end
    if self._nationId == 1 then
        gotoTollgateLayer()
    elseif self._nationId == 2 then
        zc.sendHttp({
            apiName = "Tollgate_otherTrinketList",
            successCallback = function (net_data)
                gotoTollgateLayer(net_data)
            end
        })
    end

end

function ChapterMainLayer:getCopyList( nationId ) --nationId 1为普通副本 2为精英副本
    local _nationId = nationId == nil and self._nationId or nationId
    local _allData = gameData.getDataFromCache("chapter", {nationId = _nationId})
    local _tb = {}
    local _data, _activeId, _flag, _statusData
    local addNum = 0 --追加的章节
    for i=1, #_allData do
        local _data = _allData[i]
        _activeIds = string.split(_data.activateId, ",")
        _flag = true
        if _activeIds and #_activeIds > 0 then
            for k,v in pairs(_activeIds) do
                if tonumber(v) ~= 0 then
                    _statusData = PlayerData:getCopyInfoByChapterId(v)
                    if not _statusData then 
                        _flag = false
                        break
                    else
                        local _datas = gameData.getDataFromCache("tollgate", {chapterId = _statusData.chapterId})
                        if #_datas > #_statusData.tollgates then
                            _flag = false
                            break
                        end
                        if _statusData.tollgates[#_statusData.tollgates].status ~= 2 then
                            _flag = false
                            break
                        end  
                    end
                end
            end
        end
        if _flag == false then --如果没有通过上一关
            --这里多显示3个章节(2个章节加一个封, isOpen 0表示可开启 1表示只显示 2表示封)
            if _data then
                _data.isOpen = 1
                _tb[#_tb + 1] = _data
                addNum = addNum + 1
            end
            if _allData[i+1] then
                _allData[i+1].isOpen = 1
                _tb[#_tb + 1] = _allData[i+1]
                addNum = addNum + 1
            end
            if _allData[i+2] then
                _allData[i+2].isOpen = 1
                _tb[#_tb + 1] = _allData[i+2]
                addNum = addNum + 1
            end
            _tb[#_tb].isOpen = 2

            break
        else
            _data.isOpen = 0
            _tb[#_tb + 1] = _data
        end
    end
    return _tb,addNum 
end

function ChapterMainLayer:freshData(isOnEnter)
    self._data = {}
    local addNum = 0
    if self._nationId == 2 then
        self._data, addNum = self:getCopyList(2)
    else
        self._data, addNum = self:getCopyList()
    end
    self._seatNum = #self._data + 4
    local _curSeatId = self._seatNum - 2 - addNum
    if not isOnEnter or self._max ~= _curSeatId then
        self._max = _curSeatId
        self._curSeatId = _curSeatId
    end
    self._addNum = addNum
    -- print( "addNum     ---> ", addNum )
    -- print( "_curSeatId ---> ", self._curSeatId )
    -- print( "isFreshView  ---> ", isFreshView )
end

function ChapterMainLayer:freshChapterInfo( isFreshView )
    if self._pubLayer then
        self._pubLayer:reloadData()
        if isFreshView then
            -- if self._addNum == 0 then
                -- self._pubLayer:scrollToCell(self._curSeatId - 2 - 2, false)
                -- self._pubLayer:scrollToCell(self._curSeatId - 1, false)
            -- else 
                self._pubLayer:scrollToCell(self._curSeatId - 2 - 1, false)
            -- end
        end
        performWithDelay(self, function()
            self._isRunaction = true
        end,0.5, 1999)
    end

    self:freshGuide()

    if self._nationId == 1 then
        if self._challengeBg then
            self._challengeBg:setVisible(false)
        end
        return
    end
    if self._challengeBg then
        self._challengeBg:setVisible(true)
        return
    end
    self._challengeBg = zc.createChapterTimeBar()
    self:addChild(self._challengeBg, 4)
end

--创建星级宝箱
function ChapterMainLayer:createStarTreasure()
    -- local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", cc.size(100, 100))
    local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(100, 100))
    local boxBtn = zc.createPushButton({
        touchSize = cc.size(100, 100),
        normalNode = myScale9,
        needSwallow = true,
        needEnableWhenOut = true,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(80, 50 - 120),
        endCallback = function() end,
    })
    self:addChild(boxBtn, 4)
    boxBtn:setCascadeOpacityEnabled( true )

    local armature = zc.getSpine("missionbox")
    armature:setPosition(80,50)
    armature:setPosition(boxBtn:getContentSize().width/2, boxBtn:getContentSize().height/2)
    boxBtn:addChild(armature)
    armature:playAction("box4_lock", true)

    local star = cc.Sprite:create("res/Main/common/common_hero_star_1.png")
    star:setAnchorPoint(0, 0.5)
    star:setPosition(2, 32)
    boxBtn:addChild(star)
    local starNumLab = zc.createLabel({
        text = "0/0",
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(star:getPositionX()+star:getContentSize().width, star:getPositionY()),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    boxBtn:addChild(starNumLab)

    armature:setVisible(false)
    boxBtn:setVisible(false)
    starNumLab:setVisible(false)
    self._starArmature = armature
    self._starBoxBtn = boxBtn
    self._starNumLab = starNumLab
    -- boxBtn:setOpacity(0)
    -- boxBtn:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.FadeIn:create(0.2)))
end

function ChapterMainLayer:updateStarTreasure(_chapterid)
    if not self._starArmature then
        return
    end
    local chapterInfo = PlayerData:getCopyInfoByChapterId(_chapterid) or {}
    if chapterInfo and chapterInfo.gift then
        local treasureInfo = gameData.getDataFromCache("starTreasure", {["chapterId"]=_chapterid or 1} )

        if not treasureInfo or not next(treasureInfo) then
            return 
        end
        self._starArmature:setVisible(true)
        self._starBoxBtn:setVisible(true)
        self._starNumLab:setVisible(true)

        local treasureNum = #treasureInfo
        if not chapterInfo.gift then
            chapterInfo.gift = {}
            for i = 1, treasureNum do
                chapterInfo.gift[tostring(i)] = 0
            end
        end
        local gift = chapterInfo.gift
        local totalStar = 0
        for i = 1, #chapterInfo["tollgates"] do
            local v = chapterInfo["tollgates"][i]
            totalStar = totalStar + (tonumber(v.star) or 0)
        end
        --设置奖励状态
        for i = 1, treasureNum do
            if treasureInfo[i] then
                local _num = tonumber(treasureInfo[i]["starNumber"]) or 0
                if totalStar >= _num then
                    if tonumber(chapterInfo["gift"][tostring(i)]) == 0 then
                        chapterInfo["gift"][tostring(i)] = 1
                    end
                end
            end
        end

        local nowId = 1
        local canGet = false
        local overGet = false
        local giftNums = table.nums(gift)
        for i = 1, giftNums do
            if tonumber(gift[tostring(i)]) ~= 2 then
                nowId = i
                if tonumber(gift[tostring(i)]) == 1 then
                    canGet = true
                end
                break
            else
                if i == giftNums then
                    overGet = true
                end
            end
        end
        if overGet then
            nowId = treasureNum
        end
        local _max = treasureInfo[nowId] and treasureInfo[nowId]["starNumber"] or 1
        self._starNumLab:setText(tostring(totalStar) .. "/" .. tostring(_max))
        if overGet then
            self._starArmature:playAction("box4_open", true)
        else
            if canGet then
                self._starArmature:playAction("box4_closer", true)
            else
                self._starArmature:playAction("box4_lock", true)
            end
        end
        self._starBoxBtn:setTouchEndedCall(function()
            local function refresh()
                if tolua.isnull(self) then
                    return
                end
                self:updateStarTreasure(_chapterid)
            end
            local _params = {
                chapterId = _chapterid,
                callback = refresh,
            }
            zc.createSourcePop("StarBox", "src/layer/chapter/StarBoxPop.lua", _params)
        end)

    else
        self._starArmature:setVisible(false)
        self._starBoxBtn:setVisible(false)
        self._starNumLab:setVisible(false)
    end
end

function ChapterMainLayer:freshGuide()
    --新手引导
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.BTN_ZHANGJIE) then
        performWithDelay(self, function()
            getGuideManager():setObjTarget(self._touchBtn_1)
            getGuideManager():startGuide()
        end, 0.3)
    end
    if self._touchBtn_2 then
        self:checkShowFuben()
    end 
end

function ChapterMainLayer:checkShowFuben()
    if not getGuideManager():guideIsOver() then
        if self._guideHand then
            self._guideHand:removeFromParent()
            self._guideHand = nil
        end
        return
    end
    local _data = PlayerData:getCopyInfoByChapterId(2) or {}
    local _inlog = tonumber(_data.inlog) or 0
    if _inlog ~= 0 then 
        if self._guideHand then
            self._guideHand:removeFromParent()
            self._guideHand = nil
        end
        return
    end
    if self._guideHand then
        self._guideHand:setVisible(true)
        return
    end
    self._guideHand = zc.createSpine({
        fileName = "shou",
        actName = "shou",
        scale = 0.8
    })
    -- self._guideHand:setScaleX(-1)
    local _btn = self._touchBtn_2
    self._guideHand:setPosition(cc.pMul(cc.pFromSize(_btn:getContentSize()), 0.5))
    _btn:addChild(self._guideHand, 10)
end

return ChapterMainLayer