--[[
FileName        DropIntroducePop.lua
ProjectName     HJ2
Created by wangming on 16-11-01
]]
local DropIntroducePop = class("DropIntroducePop",function ()
    return ZCPopLayer:create({opacityValue=180})
end)

function DropIntroducePop:create(data)
    return DropIntroducePop.new(data)
end

function DropIntroducePop:ctor(params)
    self._containerLayer:setTouchEndedCallback(function() end)
	self._params = params or {}
    self._dropData = self._params.drop --从后端获取的掉落数据
    local _tollgateId = self._params.enemys.tollgateId
    local _curTollgateData = PlayerData:getCurTollGateData(_tollgateId) or {}
    _curTollgateData.haveIntroduce = true
    self:initData()
	self:initUI(_tollgateId)
    self:show(false)
end
function DropIntroducePop:initData()
    local _dropItemArray = {}--掉落装备
    local rewardMap = {}
    for i = 1, #self._dropData do
        local _data = self._dropData[i]
        local _itemType = tonumber(_data.type)
        local _itemId = tonumber(_data.id)
        if _itemType == zc.mainTypeSoldierExp then 
        else
            if not rewardMap[_itemType] then
                rewardMap[_itemType] = {}
            end
            local typeMap = rewardMap[_itemType]
            if typeMap[_itemId] then
            else
                local _hasGeneral = false
                if _itemType == 2 then --检查是否有武将
                    _hasGeneral = PlayerData:hasSameGeneral(_itemId)
                end
                if not _hasGeneral then
                    local idx = #_dropItemArray+1
                    _dropItemArray[idx] = {}
                    _dropItemArray[idx].itemId = _data.id
                    _dropItemArray[idx].itemNum = _data.num
                    _dropItemArray[idx].rate = _data.rate
                    _dropItemArray[idx].itemType = _data.type
                    _dropItemArray[idx].weiget = 0
                    if tonumber(_data.type) == 1 then
                        _dropItemArray[idx].weiget = 10-tonumber(_data.id)
                    elseif tonumber(_data.type) == 2 then
                        _dropItemArray[idx].weiget = 1000000000
                    elseif tonumber(_data.type) == 3 then
                        _dropItemArray[idx].weiget = 1000000+tonumber(_data.id)
                    elseif tonumber(_data.type) == 4 then
                        _dropItemArray[idx].weiget = 1000+tonumber(_data.id)
                    elseif tonumber(_data.type) == 6 then
                        _dropItemArray[idx].weiget = 10+tonumber(_data.id)
                    end
                    typeMap[_itemId] = idx
                end
            end
        end
    end
    self._dropItemArray = _dropItemArray
end
function DropIntroducePop:onCleanup()
	local _params = self._params
	local _par = _params.par
	if _par then
		_params.par = nil
		performWithDelay(_par, function()
			zc.createEnemyInfoPop(_params)
		end, 0.01)
	end
end

--status 2通关 1手杀 0未开启
function DropIntroducePop:initUI( tollgateId )
    local _spine = zc.getSpine( "xingongnengyindao" )
    _spine:setPosition( cc.p(zc.width/2,zc.height/2) )
    _spine:playAction( "hit", false )
    self:addChild(_spine,2)
    _spine:registerSpineEventHandler( function ( event )
        if event.animation == "hit" then
            _spine:playAction( "idle", true)
        end
    end, sp.EventType.ANIMATION_COMPLETE)
    self._spine = _spine

    local bgSp = zc.createSprite()
    bgSp:setContentSize(cc.size(zc.width,zc.height))
    bgSp:setPosition(zc.width/2,zc.height/2)
    self:addChild(bgSp,10)
    bgSp:setCascadeOpacityEnabled(true)

    bgSp:setOpacity(0)

    --
    local _src
    local _scale = 1
    local _tipStr
    local _name = ""

    if tollgateId == GuideIntroduceFB[1] then --掉落武器
        _name = zc.lang("weapon")
        _src = "res/Main/chapterMain/type3.png"
        _tipStr = "[size=20][color=ffe1cead]" .. zc.lang("type_tollaget_drop") .. "[/size][/color][size=22][color=ffff0000]" .. zc.lang("weapon") .. "[/size][/color]"
        _scale = 1.2
        local _tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", tollgateId) 
        --重新设置奖励
        local commonDrop = string.split(_tollDb["commonDrop"], ",")
        self._dropData = {}
        for i = 1, #commonDrop do
            local dropId = commonDrop[i]
            if dropId and tonumber(dropId) > 0 then
                local dropInfo = gameData.getDataFromCacheWithPrimaryKey("drop_award", dropId) 
                self._dropData[#self._dropData+1] = {
                    id = dropInfo.itemId,
                    type = dropInfo.itemType,
                    num = dropInfo.itemNum,
                    rate = dropInfo.rate,
                }
            end
        end
        self:initData()
    elseif tollgateId == GuideIntroduceFB[2] then --掉落神兵进阶卷轴
        _src = "res/Main/chapterMain/type4.png"
        _scale = 1.0
        _tipStr = "[size=20][color=ffe1cead]" .. zc.lang("type_tollaget_drop") .. "[/size][/color][size=22][color=ffff0000]" .. zc.lang("godweapon_advance_scroll") .. "[/size][/color]"
        _name = zc.lang("scroll")
    elseif tollgateId == GuideIntroduceFB[3] then --掉落武将
        _name = zc.lang("general")
        _tipStr = "[size=20][color=ffe1cead]" .. zc.lang("type_tollaget_drop") .. "[/size][/color][size=22][color=ffff0000]" .. zc.lang("general") .. "[/size][/color]"
        local _tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", tollgateId) 
        local _chapterDb = gameData.getDataFromCacheWithPrimaryKey("chapter", _tollDb["chapterId"])
        self._lineColor = _chapterDb["lineColor"] or 3
        local _colorStr = self._lineColor == 1 and "cold" or "warm"
        local _bgImg = "res/Main/chapterMain/bigDi_" .. _colorStr .. ".png"
        local _baseIcon = self:getCircleHead({
            bgImg = _bgImg,
            iconType = _tollDb.iconType,
            iconId = _tollDb.headIcon,
        })
        _baseIcon:setPosition(cc.p(zc.width/2,zc.height/2+60))
        bgSp:addChild(_baseIcon)
    end

    local _normal = zc.createSprite(_src)
    _normal:setPosition(cc.p(zc.width/2,zc.height/2+60))
    bgSp:addChild(_normal)
    _normal:setScale(_scale)
    local content = zc.createLabel({
        text = zc.lang("drop") .. _name,
        fontSize = 26,
        ap = cc.p(0, 0.5),
        pos = cc.p(zc.width/2-276, zc.height/2+110),
    })
    bgSp:addChild(content)

    --文字描述 cc.c3b( 225 206 173 )
    local openLevel = zc.createRichLabel({
        text = _tipStr,
        pos = cc.p(zc.width/2+110, zc.height/2-40),
        anchor = cc.p(0,1),
    })
    openLevel:setDimensions(cc.size(150,0))
    bgSp:addChild(openLevel)

    local intro = zc.createLabel({
        text = zc.lang("tollgate_introduce"),
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(zc.width/2+110, zc.height/2-15),
        color = display.COLOR_YELLOW,
    })
    bgSp:addChild(intro)

    table.sort(self._dropItemArray, function(a,b)
        if not a or not b then
            return false
        end
        return a.weiget > b.weiget
    end)
    local itemList = {}
    for i=1,#self._dropItemArray do 
        local v = self._dropItemArray[i]
        if v and v.itemType then
            local itemType = tonumber(v.itemType)
            local itemId = tonumber(v.itemId)
            if itemType == 2 or itemType == 3 or (itemType == 4 and inArray(itemId,{450,451,452,453}) ) then
                local iconcolor = 1
                local goodname = ""
                local itemType = tonumber(v.itemType)
                if itemType == zc.mainTypeSoldierExp then 
                    --武将经验
                    goodname = LANGUAGE_TOLLGATEHERO.general_exp
                elseif itemType == zc.mainTypeProp then 
                    --背包的道具
                    local itemDb = PlayerData:getBagDBInfoByID(v["itemId"])
                    if itemDb then
                        iconcolor = tonumber(itemDb.color)
                        goodname = itemDb.name
                    end
                end
                local _showItem = true
                local _showHero = nil
                if tonumber(itemType) == zc.mainTypeSoldier then
                    _showItem = false
                    _showHero = function() zc.createHeroInfoPop({heroId = v["itemId"], showHero = true}) end
                end
                local item = zc.createIconByData({
                    data = {
                        mainType = v["itemType"],
                        type = v["itemId"], 
                        id = v["itemId"],
                        num = v.itemNum,
                    }, 
                    showDetailPop = _showItem,
                    listener = _showHero,
                    swallowTouched = true,
                    pos = cc.p(zc.width/2-276+(i-1)*99, zc.height/2+40),
                })
                item:setScale(0.68)
                bgSp:addChild(item)

                item:setCascadeOpacityEnabled(true)

                item:setOpacity(0)
                item:runAction(cc.Sequence:create(cc.FadeIn:create(0.5)))
                itemList[#itemList+1] = item

                if itemType == 2 then --如果是武将
                    local renwu_logo = zc.createSpine({
                        fileName = "renwu_logo",
                        actName = "animation",
                        loop = true,
                    })
                    renwu_logo:setPosition( cc.p(item:getContentSize().width/2, item:getContentSize().height/2) )
                    item:addChild(renwu_logo)
                    renwu_logo:setScale(1.5)
                end
            end
        end
    end

    if table.nums(itemList) == 1 then
        if itemList[1] then
            itemList[1]:setPositionX(zc.width/2-276+55)
        end
    end

    --
    local closeLab = zc.createLabel({
        text = zc.lang("tips_click_empty_continue"),
        stroke = false,
        fontSize = 18,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(zc.width/2, zc.height/2-250),
        color = cc.c3b(83,83,83),
    })
    bgSp:addChild(closeLab, 11)
    local f_right = zc.createSprite("res/Main/chapterMain/lace.png")
    f_right:setAnchorPoint(0, 0.5)
    f_right:setPosition(closeLab:getPositionX()+closeLab:getContentSize().width/2+5,closeLab:getPositionY() )
    bgSp:addChild(f_right)
    local f_left = zc.createSprite("res/Main/chapterMain/lace.png")
    f_left:setAnchorPoint(1, 0.5)
    f_left:setPosition(closeLab:getPositionX()-closeLab:getContentSize().width/2-5, closeLab:getPositionY())
    bgSp:addChild(f_left)
    f_left:setFlipX(true)


    bgSp:runAction(cc.Sequence:create(cc.FadeIn:create(0.5)))

    performWithDelay(self,function()
        self._containerLayer:setTouchEndedCallback(function()
            self._containerLayer:setVisible(false)
            self._spine:playAction( "over", false)
            bgSp:runAction(cc.Sequence:create(cc.FadeOut:create(0.5)))
            for i = 1, #itemList do
                if itemList[i] then
                    itemList[i]:runAction(cc.Sequence:create(cc.FadeOut:create(0.5)))
                end
            end
            self._spine:registerSpineEventHandler( function ( event )
                    if event.animation == "over" then
                        performWithDelay(self._spine, function()
                            LayerManager.removeLayout(true)
                        end,0.1)
                    end
            end, sp.EventType.ANIMATION_COMPLETE)
        end)
    end,0.6)
end
--圆形头像处理
function DropIntroducePop:getCircleHead(params)
    local _params = params or {}
    local _iconType = tonumber(_params.iconType) or 3
    local _bg
    local _isBig = _iconType == 2 or _iconType == 4
    if _isBig then
        _bg = cc.Node:create()
        _bg:setContentSize(141, 146)
        _bg:setAnchorPoint(0.5, 0.5)
        local _actName = self._lineColor == 1 and "animation" or "animation2"
        local _spine = zc.createSpine({
            fileName = "lengseguanka",
            actName = _actName,
        })
        _spine:setPosition(_bg:getContentSize().width*0.5, _bg:getContentSize().height*0.5)
        _bg:addChild(_spine)
    else
        _bg = zc.createSprite(_params.bgImg)
    end

    local _pic
    if _iconType == 3 or _iconType == 4 then
        _pic = zc.createSprite("res/Main/chapterMain/type" .. _iconType .. ".png")--底板
    else
        _pic = cc.ClippingNode:create()
        _pic:setInverted(false)
        _pic:setAlphaThreshold(0.9)
        -- local template = zc.createSprite(_params.templateImg or _params.bgImg)--模板
        local template = zc.createSprite("res/Main/chapterMain/clippingDi.png")--模板
        template:setScale(1.25)

        local _iconStr = "res/Main/hero/head/hero_head_" .. tostring(_params.iconId) .. ".png"
        if not zc.checkFileExist(_iconStr) then
            _iconStr = "res/Main/hero/head/hero_head_5.png"
        end
        local content = zc.createSprite(_iconStr)--底板
        if _isBig then
            _pic:setScale(1.2)
        else
            _pic:setScale(0.80)
        end
        _pic:setStencil(template)
        _pic:addChild(content)

        local _up = zc.createSprite("res/Main/chapterMain/clippingUp.png")
        _up:setPosition(_bg:getContentSize().width*0.5, _bg:getContentSize().height*0.5)
        _bg:addChild(_up, 1)
        if _isBig then
            _up:setScale(1.44)
            _up:setPosition(_up:getPositionX() - 2.5, _up:getPositionY() + 0.5)
            _pic:setPosition(_pic:getPositionX() - 2.5, _pic:getPositionY() + 0.5)
        end
    end
    _pic:setPosition(_bg:getContentSize().width*0.5, _bg:getContentSize().height*0.5)
    _bg:addChild(_pic)
    _bg._pic = _pic
    _bg._headIcon = content

    return _bg
end
return DropIntroducePop