--[[
    FileName: GetOtherTrinketsPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local GetOtherTrinketsPop = class( "GetOtherTrinketsPop", function ()
    return ZCPopLayer:create()
end)
function GetOtherTrinketsPop:create(params)
    return GetOtherTrinketsPop.new(params)
end
function GetOtherTrinketsPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show()
end
function GetOtherTrinketsPop:initData(params)
    local params = params or {}
    self:resetData(params.trinketsBag)
end
function GetOtherTrinketsPop:resetData(_list)
    self._trinketList = {}
    local _list = _list or {}
    for k,v in pairs(_list) do
        if v and v.id then
            self._trinketList[#self._trinketList+1] = v
        end
    end
    self._trinketListNum = table.nums(self._trinketList) or 0
end
function GetOtherTrinketsPop:initUI()

    local popBg = zc.createNormalPop({
        tag = 1,
        titleSrc = "res/Main/common/tipTitle/lingqu.png",
        showSide = false,
        height = 503+31,
        width = 432,
        bianZOrder = 1
    })
    popBg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(popBg)
    local popSize = cc.size(432, 503)
    self._popSize = popSize
    --关闭按钮
    local close = zc.createBackButton({
        pos = cc.p( popSize.width-10  , popSize.height), 
        listener = function()
            self:hide()
        end,
    })
    popBg:addChild( close , 10)

    local _middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = 407,
        height = 291,
    })
    _middleBg:setAnchorPoint(cc.p(0.5, 1))
    _middleBg:setPosition(cc.p(popSize.width/2, popSize.height - 56))
    popBg:addChild(_middleBg)
    self._middleBg = _middleBg

    local infoBg = zc.createGeneralPopScale({
        tag = 2,
        width = _middleBg:getContentSize().width-22,
        height = 268,
    })
    infoBg:setAnchorPoint(cc.p(0.5, 0.5))
    infoBg:setPosition(cc.p(_middleBg:getContentSize().width/2, _middleBg:getContentSize().height/2))
    _middleBg:addChild(infoBg)
    self._infoBg = infoBg

    --下方信息
    local attr_bg = ccui.Scale9Sprite:create( cc.rect( 589/2-213, 0, 426, 71 ), "res/Main/role/trinket/sellDi.png")
    attr_bg:setContentSize(cc.size(426, 139))
    attr_bg:setAnchorPoint(0.5, 0)
    attr_bg:setPosition(popSize.width/2 , 6)
    popBg:addChild(attr_bg)
    self._attr_bg = attr_bg

    self:createRewardList()
    self:createGetButton()
end
function GetOtherTrinketsPop:createGetButton()

    local attr_bg = self._attr_bg
    local attr_bgSize = attr_bg:getContentSize()
    local starbg = zc.getScaleNode("res/Main/role/common/shadow_bg.png", cc.size(122, 33))
    starbg:setAnchorPoint(cc.p(0, 0.5))
    starbg:setPosition(cc.p(21, 105))
    attr_bg:addChild(starbg)

    local tipLab = zc.createLabel({
        text = zc.lang("auto_sell") .. "：",
        fontSize = 22,
        pos = cc.p(starbg:getContentSize().width/2, starbg:getContentSize().height/2),
    })
    starbg:addChild(tipLab)
    
    local _text = {
        {str=LANGUAGE_getTipColorNameByType(1),color=display.COLOR_WHITE},
        {str=LANGUAGE_getTipColorNameByType(2),color=display.COLOR_GREEN},
    }
    self._buttonList = {}
    for i = 1, 2 do

        local _normalNode = ccui.Scale9Sprite:create( cc.rect( 60, 0, 328-80, 0 ), "res/Main/common/checkBar_u.png")
        _normalNode:setContentSize(cc.size(114,48))
        local _selectedNode = ccui.Scale9Sprite:create( cc.rect( 60, 0, 328-80, 0  ), "res/Main/common/checkBar_d.png")
        _selectedNode:setContentSize(cc.size(114,48))

        local checkBox
        checkBox = zc.createPushButton({
            normalNode = _normalNode,
            selectedNode = _selectedNode,
            text = _text[i].str,
            fontColor = _text[i].color,
            text_pos = cc.p(71,48/2),
            fontSize = 22,
            pos = cc.p(attr_bgSize.width/2 + (i-1)*130, 105),
            endCallback = function()
                if checkBox._sale then
                    checkBox._sale = false
                    checkBox._check:setVisible(false)
                else
                    checkBox._sale = true
                    checkBox._check:setVisible(true)
                end
            end
        })
        attr_bg:addChild( checkBox )
        checkBox:setTag(i)
        checkBox._sale = false

        local check = zc.createSprite("res/Main/common/check.png")
        check:setAnchorPoint(0.5, 0.5)
        check:setPosition(26, 48/2)
        checkBox:addChild(check)
        check:setVisible(false)
        check:setScale(0.9)
        checkBox._check = check

        self._buttonList[#self._buttonList+1] = checkBox
    end

    local getBtn = zc.createCommomBtn({
        tag =1,
        btnText = zc.lang("fetch"),
        needSwallow = false,
        endCallback = function()
            local function gotoGet()
                local sellType = {}
                for i = 1, #self._buttonList do
                    if self._buttonList[i]._sale then
                        local tag = self._buttonList[i]:getTag()
                        sellType[tonumber(tag)] = 1
                    end
                end
                --先出售
                local _sellStr = ""
                if next(sellType) then
                    local recordId = {}
                    for i = 1, #self._trinketList do
                        local v = self._trinketList[i]
                        if v and v.id then
                            local static = gameData.getDataFromCacheWithPrimaryKey("trinket", v.id)
                            local color = tonumber(static["color"])
                            if color and sellType[color] and not recordId[tonumber(v.id)] then
                                if _sellStr == "" then
                                    _sellStr = v.id
                                else
                                    _sellStr = _sellStr .. "|" ..v.id
                                end
                                recordId[tonumber(v.id)] = 1
                            end
                        end
                    end
                end
                --再领取
                zc.sendHttp({
                    apiName = "Tollgate_getOtherTrinket",
                    params = {ids=_sellStr},
                    successCallback = function (net_data)
                        PlayerData:updataData( net_data )
                        if _sellStr == "" then
                            zc.tipInfo(zc.lang("get_success") .. "!")
                        end
                        if net_data.trinketsBag and next(net_data.trinketsBag) then
                            self:resetData(net_data.trinketsBag)
                            self._myTable:reloadData()
                        else
                            --领取完了
                            self:hide()
                        end
                    end,
                    errorCallback = function(_errorCode,_msg)
                        zc.tipInfo(_msg)
                    end,
                })
            end  
            local _trinketsInfo = PlayerData:getTrinketsInfo() or {}
            local ownTrinketsNum = 0
            for i, v in ipairs(_trinketsInfo) do
                if tonumber( v.status or 0 ) == 5 then
                    -- 已穿戴
                elseif tonumber( v.status or 0 ) == 0 then
                    -- 未穿戴
                    ownTrinketsNum = ownTrinketsNum + 1
                end
            end
            if ownTrinketsNum >= 200 then
                local comfirm = ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    msg = zc.lang("tips_trinkets_full"),
                    showDi = true,
                    rightText = zc.lang("qianwang_2"),
                    rightCallback = function()
                        zc.createRoleTrinket()
                    end,
                })
                self:addChild(comfirm, 11)
            else
                gotoGet()
            end


        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(attr_bgSize.width/2, 43)
    })
    attr_bg:addChild(getBtn)

end
    
function GetOtherTrinketsPop:createRewardList()

    local myTableBg = self._infoBg
    local tableSize = cc.size(myTableBg:getContentSize().width-4, myTableBg:getContentSize().height-4)
    
    local myTable = zc.ZCTableView:create(tableSize)
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)
    
    local function cellSizeForTable(table,idx)
        return 90, tableSize.width
    end
    local function numberOfCellsInTableView(table)
        return math.floor((self._trinketListNum-1)/5) + 1
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width, 90))
            self:buildCell(cell, nowIdx)
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    
    myTable:reloadData()
    self._myTable = myTable
    
end
function GetOtherTrinketsPop:buildCell(cell, nowIdx)
    local cellSize = cell:getContentSize()
    for i = 1, 5 do
        local item, info = zc.createIconByData({
            data = {
                mainType = 1,
                type = 1, 
                id = 1,
                num = 2,
            }, 
            showDetailPop = true,
            pos = cc.p(45+72*(i-1), cellSize.height/2), 
        })
        item:setScale(62/120)
        cell:addChild(item)
        cell["item"..i] = item
    end
end
function GetOtherTrinketsPop:updateCell(cell, nowIdx)
    for i = 1, 5 do
        local _index = (nowIdx - 1)*5 + i
        local _data = self._trinketList[_index]
        local item = cell["item"..i]
        if _data and _data.id then
            item:setVisible(true)
            local params = {
                data = {
                    mainType = _data.type,
                    type = _data.id or 0,
                    id = _data.id,
                    num = _data.num,
                },
                showDetailPop = true,
            }
            local _info = zc.updateIconByData(item, params)
        else
            item:setVisible(false)
        end
    end
end

return GetOtherTrinketsPop