-- FileName: TollgateMainLayer.lua
-- Author: wangming
-- Date: 2016-09-27
-- Purpose: 新主线章节内关卡界面
--[[TODO List]]

local TollgateMainLayer = class("TollgateMainLayer", function ()
    return zc.createNormalDialog({
        src = "",
        showFlower = false,
        closeCallBack = function()
            local _currentGID = getGuideManager():getCurrentGID()
            if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then
                zc.setGuideFuncNextStep(_currentGID)
                LayerManager.backToMainCity()
                return
            elseif _currentGID == GuideKey.KEY_11501 then
                zc.setGuideFuncNextStep(_currentGID)
            end
            LayerManager.removeLayout()
        end
    })
end);

function TollgateMainLayer:create(params)
    return TollgateMainLayer.new(params)
end

function TollgateMainLayer:ctor(params)
    self._bgSpineIndex = {
        [1] = {
            name = "bule_liuxing",
            haveYun = 1,
            pics = {
                "bule_liuxing",
            }
        },
        [2] = {
            haveYun = 2,
            particle = {
                {
                    name = "flower",
                    x = 105,
                    y = 714,
                    rotation = -20,
                },
                {
                    name = "flower",
                    x = 642,
                    y = 748,
                    rotation = -20,
                },
                {
                    name = "flower",
                    x = 1271,
                    y = 713,
                    rotation = 20,
                },
            },
        },
        [3] = {
            name = "huohai",
            haveYun = 3,
            particle = {                
                {
                    name = "huoyan",
                    rotation = 27.29,
                    x = 202,
                    y = -219,
                    scale = 1.5,
                },
            },
            pics = {
                "huohai",
            }
        },
        [4] = {
            haveYun = 4,
            particle = {
                {
                    name = "rain",
                    x = 365,
                    y = 785,
                    rotation = 15,
                    scaleX = 0.5,
                    scaleY = 1.5,
                },
                {
                    name = "rain",
                    x = 629,
                    y = 786,
                    rotation = 15,
                    scaleX = 0.5,
                    scaleY = 1.5,
                },
                {
                    name = "rain",
                    x = 881,
                    y = 797,
                    rotation = 15,
                    scaleX = 0.5,
                    scaleY = 1.5,
                },
                {
                    name = "rain",
                    x = 1155,
                    y = 788,
                    rotation = 15,
                    scaleX = 0.5,
                    scaleY = 1.5,
                },
                {
                    name = "rain",
                    x = 1411,
                    y = 754,
                    rotation = 15,
                    scaleX = 0.5,
                    scaleY = 1.5,
                },
            },
        },
        [5] = {
            name = "huohai",
            haveYun = 5,
            particle = {                
                {
                    name = "huoyan",
                    rotation = 27.29,
                    x = 202,
                    y = -219,
                    scale = 1.5,
                },
            },
            pics = {
                "huohai",
            }
        },
        [6] = {
            haveYun = 6,
            name = "huohai",
            particle = {                
                {
                    name = "huoyan",
                    rotation = 27.29,
                    x = 202,
                    y = -219,
                    scale = 1.5,
                },
            },
            pics = {
                "huohai",
            }
        },
        [7] = {
            haveYun = 7,
            particle = {                
                {
                    name = "snow",
                    x = 568,
                    y = 750,
                },
            },
        },
        [8] = {
            haveYun = 8,
            particle = {
                {
                    name = "flower",
                    x = 105,
                    y = 714,
                    rotation = -20,
                },
                {
                    name = "flower",
                    x = 642,
                    y = 748,
                    rotation = -20,
                },
                {
                    name = "flower",
                    x = 1271,
                    y = 713,
                    rotation = 20,
                },
            },
        },
        [9] = {
            haveYun = 9,
            name = "huohai",
            particle = {                
                {
                    name = "huoyan",
                    rotation = 27.29,
                    x = 202,
                    y = -219,
                    scale = 1.5,
                },
            },
            pics = {
                "huohai",
            }
        },
        [10] = {
            haveYun = 10,
        },
        [11] = {
            haveYun = 11,
        },
        [12] = {
            haveYun = 12,
        },
        [13] = {
            haveYun = 13,
        },
    }
    local _params = params or {}
    self._tollgateId = tonumber(_params.tollgateId) or 1--第几个副本
    self._nationId = _params.nationId or 1--势力id
    self._sceneFrom = _params.sceneFrom or nil
    self._enemyid = _params.enemyid  --是否直接打开关卡信息
    self._isOpenEnemy = _params.isOpenEnemy == nil and false or params.isOpenEnemy  --确定打开关卡
    self._dropInfo = _params.dropInfo --掉落信息(扫荡信息)
    self._backInitParams = _params.backInitParams
    self._callback = _params.callback
    self._isAnimationEnterShow = _params.isAnimationEnterShow
    self._extraData = _params.extraData

    self._spTargetId = self._enemyid
    if self._enemyid then
        self._isGotoTollgate = true --如果是过来扫荡就不创建底部按钮，防止重复跳转
    end
    self:freshData(false)
    --创建宝箱
    self:initUI()

    self:initButton()
    self:createTollgateInfo(false)

    zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_REFRESH_ELITE_TIME ,
        callback = function()
            if self._challangeBar and self._challangeBar._updateTimeFunc then
                self._challangeBar._updateTimeFunc()
            end
        end,
    })

    if self._isAnimationEnterShow then
        for i=1,#self._lineList do
            local _tb = self._lineList[i]
            for j=1,#_tb do
                _tb[j]:setVisible(false)
            end
        end
        local _imgNode = self._imgNode
        local _tollDatas = gameData.getDataFromCache("tollgate", {chapterId = self._tollgateId}) 
        for i=1, #_tollDatas do
            local _node = _imgNode:getChildByName("tollgateSp" .. i)
            _node:setVisible(false)
        end
        self:goCurTollgate(self._pos[1])
    end
end

function TollgateMainLayer:onCleanup()
    zc.removeEventListener(CUSTOM_EVENT.EVENT_REFRESH_ELITE_TIME)
    if self._mapEffPath then
        cc.Director:getInstance():getTextureCache():removeTextureForKey(self._mapEffPath)
    end
end

function TollgateMainLayer:onExit()
    if not tolua.isnull(self._mapImg) then
        self._mapImg:setTexture(nil)
    end
    cc.Director:getInstance():getTextureCache():removeTextureForKey(self._mapPath)
end

function TollgateMainLayer:onEnter()
    if not self:isVisible() then
        return
    end
    musicManager.playMusic(zc.bgm.mainChapter, true)
    if self._bottomButtonLay then
        self._bottomButtonLay:checkOpen()
        self._bottomButtonLay:checkRedAndBubble()
    end
    if self._isInit then
        if self._challangeBar and self._challangeBar._updateTimeFunc then
            self._challangeBar._updateTimeFunc()
        end
        if self._mapImg then
            self._mapImg:setTexture(self._mapPath)
        end
        self:freshData()
        self:createTollgateInfo()
        return
    end


    self:setFuncGuideTrigger()
    self._isInit = true

    if self._isAnimationEnterShow then
        self._isAnimationEnterShow = nil
        getGuideManager():addMaskLayer()

        local _imgNode = self._imgNode
        local _copyEnemy = _imgNode:getChildByName("tollgateSp1")
        _copyEnemy:setVisible(true)
        for i=1, #self._lineList do
            local _tb = self._lineList[i]
            local _idx = 1
            for j=1, #_tb do
                local _spine = _tb[j]
                _spine:runAction(cc.Sequence:create(
                    cc.DelayTime:create(0.25*(j-1)),
                    cc.CallFunc:create(function()
                        _spine:setVisible(true)
                        _spine:setTimeScale(2.0)
                        _spine:playAction(self._lineColor == 1 and "stop" or "stop2", false)
                        _spine:registerSpineEventHandler( function ( event )
                            if event.animation ~= "stop" and event.animation ~= "stop2" then
                                return
                            end
                            -- _spine:unregisterSpineEventHandler(sp.EventType.ANIMATION_COMPLETE)
                            _spine:playAction(self._lineColor == 1 and "stop_idle" or "stop_idle2", true)
                            _spine:setTimeScale(1.0)
                            if i == 1 then
                                if j ~=#_tb or not self._lineList[2] then
                                    _copyEnemy = _imgNode:getChildByName("tollgateSp" .. (j + 1))
                                end
                            else
                                _copyEnemy = _imgNode:getChildByName("tollgateSp" .. (j + 8))
                            end
                            if _copyEnemy then
                                _copyEnemy:setVisible(true)
                                _copyEnemy:setOpacity(0)
                                _copyEnemy:runAction(cc.FadeIn:create(0.1))
                            end
                            if i == 1 and j == #_tb then
                                getGuideManager():removeMaskLayer()
                                local _talkId = tonumber(self._chapterDb.talk)
                                if _talkId then
                                    local guideScriptLayer = GuideScriptLayer:createWithParams({
                                        storyId = _talkId,
                                        callback = function() end,
                                    })
                                    local scene = cc.Director:getInstance():getRunningScene()
                                    scene:addChild(guideScriptLayer)
                                end
                            end
                        end, sp.EventType.ANIMATION_COMPLETE)
                    end)
                ))
            end
        end
    end

    --是否打开关卡信息
    self._enemyid = tonumber(self._enemyid) or 0
    if self._enemyid and self._enemyid ~= 0 and not self._isOpenEnemy then 
        self._isOpenEnemy = true
        local _targetId = self._enemyid
        self._enemyid = nil

        local _tollData = PlayerData:getCurTollGateData(_targetId)
        if not _tollData then 
            zc.tipInfo(zc.lang("tips_checkpoint_not_open") .. "！")
            return 
        end

        local _db = gameData.getDataFromCacheWithPrimaryKey("tollgate", _tollData.tollgateId)
        local _showCheck = self:checkLineOpen(_db, _tollData)
        if _showCheck then
            local _status = tonumber(_tollData.status)
            if _status == 1 or _status == 2 then
                if self._tollgateId ~= 1 and self._nationId ~= 2 then  
                    local _tollgates = self._chapterData.tollgates or {}
                    local _routeId = tonumber(_tollgates.routeId) or 0
                    if #_tollgates <= 3 and _routeId == 0 then
                        -- zc.tipInfo("请先选择路线!")
                        return
                    end
                end
                self:goBattleEnemy(_tollData)
                return
            end
        end
        if _db.name then
            zc.tipInfo(_db.name .. LANGUAGE_TOLLGATEHERO.not_open)
        else
            zc.tipInfo(zc.lang("tips_checkpoint_not_open") .. "！")
        end
    end
    local _currentGID = getGuideManager():getCurrentGID() 
    print("TollgateMainLayer:".._currentGID)
    if inArray(_currentGID, GuideGroup.BTN_BUZHEN) then
        LayerManager.addShieldLayout(nil, 0.4)
        if self._bottomButtonLay._click == 2 then
            self._bottomButtonLay:playOpenAnimate()
            self._bottomButtonLay._click = 1
        end
        performWithDelay(self,function()
            getGuideManager():setObjTarget(self._bottomButtonLay._buzhenButton)
            getGuideManager():startGuide()
        end, 0.3)
    elseif _currentGID == GuideKey.KEY_4007 then
        getGuideManager():setObjTarget(self._starBoxBtn)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_15102 then
        zc.setGuideFuncNextStep(_currentGID)
        self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
    end
    if self._nationId == 2 then
        --领取多余的饰品
        if self._extraData and next(self._extraData) then
            zc.createGetOtherTrinketsPop(self._extraData)
        end
    end
    
end

function TollgateMainLayer:goBattleEnemy( tollData )
    self._lastTollgateStatus = tollData.status --1未通关
    self._lastEnemyId = self._nextK
    self._lastSelect = tollData.tollgateId
    --从后端获取怪物和掉落物品
    zc.sendHttp({
        apiName = "Tollgate_getTollInfo",
        params = {id=tollData.tollgateId},
        successCallback = function (net_data)
            local _currentGID = getGuideManager():getCurrentGID()
            if inArray(_currentGID, GuideGroup.GUAN_KA) then
                getGuideManager():guideOver()
                getGuideManager():setNextGID(_currentGID)
                self._scrollView:setTouchEnabled(true)
            end
            local enemysData = {
                iconId = net_data.iconId or "15",
                tollgateId = tollData.tollgateId,
                enemys = {}
            }
            local npcData = net_data.npcDataList
            local _tmps_ = {}
            for i = 1, 9 do
                local _data = npcData[tostring(i)]
                enemysData.enemys[i] = {}
                if _data then
                    enemysData.enemys[i] = _data
                    _tmps_[_data.modelId] = _data.modelId
                end
            end
            local _guideData = nil
            local _currentGID = getGuideManager():getCurrentGID()
            -- 第一章假战报

            xpcall(function()
                if self._nationId == 1 and inArray(_currentGID, GuideGroup.BTN_CHU_ZHAN) then
                    local id = (tollData.tollgateId%1000)
                    _guideData = self:initGuidePreload(id)
                else
                    -- 后几章假战报
                    if tollData.status == 1 then
                        local _tollDB = gameData.getDataFromCacheWithPrimaryKey("tollgate", tollData.tollgateId)
                        local _dataIndex = tonumber(_tollDB.battle) or 0
                        if _dataIndex ~= 0 then
                            _guideData = self:initGuidePreload(_dataIndex)
                        end
                    end
                    if not _guideData then
                        for k,v in pairs(_tmps_) do
                            --开始异步加载
                            zc.battle.createHeroArmature({fileName = v , async = true, asyncCallback = function ( ar,fileName )
                                -- print("right yyyyyyyyyy------"..fileName)
                            end})
                        end
                    end
                end
            end, function() end)

            local nowF = PlayerData:getNowFormationsInfo()
            local _params = {
                enemyinfo = tollData, 
                enemys = enemysData,
                drop = net_data.dropInfo,
                tollgateId = self._tollgateId,
                dropInfo = self._dropInfo,
                isFirst = tollData.status,
                guideData = _guideData,
                nationId = self._nationId,
            }

            local _flag = false
            if _params.isFirst == 1 and inArray(enemysData.tollgateId, GuideIntroduceFB) then
                local _curTollgateData = PlayerData:getCurTollGateData(enemysData.tollgateId) or {}
                if not _curTollgateData.haveIntroduce then
                    _flag = true
                end
            end
            if _flag then
                _params.par = self
                zc.createDropIntroducePop(_params)
            else
                if self._nationId == 2 then
                    zc.sendHttp({
                        apiName = "Tollgate_otherTrinketList",
                        successCallback = function (net_data)
                            if net_data.trinketsBag and next(net_data.trinketsBag) then
                                zc.createGetOtherTrinketsPop(net_data) 
                            else
                                zc.createEnemyInfoPop(_params)
                            end
                        end
                    })
                else
                    zc.createEnemyInfoPop(_params)
                end
            end
        end,
    })
end

function TollgateMainLayer:freshData( isGetNew )
    print("====refreshData=====")
    self._chapterData = PlayerData:getCopyInfoByChapterId(self._tollgateId) or {}
    local _chapterDb = gameData.getDataFromCacheWithPrimaryKey("chapter", self._tollgateId)
    self._nationId = _chapterDb.nationId or 1
    self._chapterDb = _chapterDb
    local _nextData, j, k = PlayerData:getNextOpenTollGateData(self._nationId)
    self._nextData = _nextData or {}
    self._nextJ = j
    self._nextK = k
    local _isGetNew = isGetNew == nil and true or isGetNew
    -- print("@@@@@@@@")
    -- dump(self._chapterData)
    -- dump(self._chapterDb)
    -- dump(self._nextData)
    if _isGetNew then
        if j == self._tollgateId and k ~= self._lastEnemyId then
            self._enemyid = self._nextData.tollgateId
        else
            self._enemyid = nil
        end
    end
    if self._nationId == 1 then
        if not self._starArmature then 
            self:createStarTreasure()
        end
        self:updateStarTreasure(self._tollgateId)
    end

    --判断是否开启新的章节
    -- print("--self._tollgateId---",self._tollgateId)
    -- print("--jjjjjjjjj---", j, " , ", k, " , ", self._enemyid)

    local __flag = false
    if GuideTollgateTestKey then
        print("GuideTollgateTestKey" .. GuideTollgateTestKey)
        getGuideManager():setCurrentGID(GuideTollgateTestKey, false)
        GuideTollgateTestKey = nil
        local _currentGID = getGuideManager():getCurrentGID()
        if _currentGID == GuideKey.KEY_11500
          or _currentGID == GuideKey.KEY_12100
          or _currentGID == GuideKey.KEY_12200
          or _currentGID == GuideKey.KEY_12300
          or _currentGID == GuideKey.KEY_12400
          or _currentGID == GuideKey.KEY_12800
          or _currentGID == GuideKey.KEY_13500
          or _currentGID == GuideKey.KEY_13900 
          or _currentGID == GuideKey.KEY_14800  
          or _currentGID == GuideKey.KEY_14900  
          or _currentGID == GuideKey.KEY_15000
          then
            __flag = true
        end
    end

    if __flag or (tonumber(self._tollgateId) ~= j and tonumber(self._lastTollgateStatus) == 1) then
        if self._callback then
            self._callback()
            self._callback = nil
        end
        LayerManager.addShieldLayout(nil, 0.3)
        local _lay = ZCDialog:create(255*0.3)
        self:addChild(_lay, 5)
        --添加动画
        local armature = zc.createAnimationArmature({
            fileName = "zhangjietongguan",
            autoRelease = true
        })
        armature:getAnimation():play("idle")
        armature:setPosition(cc.p(zc.width/2, zc.height/2))
        self:addChild(armature, 10000)
        local _count = 0
        armature:getAnimation():setMovementEventCallFunc(function(armature, movementType, movementID)
            if 1 == tonumber(movementType) then
                if _count == 0 then
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_6005 
                      or _currentGID == GuideKey.KEY_11500
                      or _currentGID == GuideKey.KEY_12100
                      or _currentGID == GuideKey.KEY_12200
                      or _currentGID == GuideKey.KEY_12300
                      or _currentGID == GuideKey.KEY_12400
                      or _currentGID == GuideKey.KEY_12800
                      or _currentGID == GuideKey.KEY_13500
                      or _currentGID == GuideKey.KEY_13900 
                      or _currentGID == GuideKey.KEY_14800 
                      or _currentGID == GuideKey.KEY_14900
                      or _currentGID == GuideKey.KEY_15000 then
                        _lay:removeFromParent()
                        armature:removeFromParent()
                        LayerManager.addShieldLayout(nil, 0.4)
                        if self._bottomButtonLay._click == 2 then
                            self._bottomButtonLay:playOpenAnimate()
                            self._bottomButtonLay._click = 1
                        end
                        performWithDelay(self,function()
                            if _currentGID == GuideKey.KEY_11500 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_11501)
                                getGuideManager():setObjTarget(self._closeBtn)
                                getGuideManager():startGuide()
                            elseif _currentGID == GuideKey.KEY_12100 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_12101)
                                self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                            elseif _currentGID == GuideKey.KEY_12200 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_12201)
                                self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                            elseif _currentGID == GuideKey.KEY_12300 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_12315)
                                getGuideManager():setHeroFuncCallBack(function()
                                    self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                                end)
                                getGuideManager():startGuide()
                            elseif _currentGID == GuideKey.KEY_12400 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_12402)
                                self:doBuzhenGuide(self._bottomButtonLay._countryButton)
                            elseif _currentGID == GuideKey.KEY_12800 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_12801)
                                getGuideManager():setHeroFuncCallBack(function()
                                    self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                                end)
                                getGuideManager():startGuide()
                            elseif _currentGID == GuideKey.KEY_13500 then
                                 getGuideManager():setCurrentGID(GuideKey.KEY_13505)
                                self:doBuzhenGuide(self._bottomButtonLay._smithyButton)
                            elseif _currentGID == GuideKey.KEY_13900 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_13901)
                                self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                            elseif _currentGID == GuideKey.KEY_14800 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_14801)
                                self:doBuzhenGuide(self._bottomButtonLay._roleButton)
                            elseif _currentGID == GuideKey.KEY_14900 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_14901)
                                local function _callBack()
                                    self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                                end
                                getGuideManager():setHeroFuncCallBack(_callBack)
                                getGuideManager():startGuide()
                            elseif _currentGID == GuideKey.KEY_15000 then
                                getGuideManager():setCurrentGID(GuideKey.KEY_15001)
                                local function _callBack()
                                    self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                                end
                                getGuideManager():setHeroFuncCallBack(_callBack)
                                getGuideManager():startGuide()
                            else
                                getGuideManager():setObjTarget(self._bottomButtonLay._fubenButton)
                                getGuideManager():startGuide()
                            end
                        end, 0.3)
                    else
                        local _callBack = self._callback
                        local _nationId = self._nationId or 1
                        local _chapterNew = zc.getScene("ChapterNew") 
                        if _chapterNew then
                            if _callBack then
                                _callBack()
                            end
                        end 
                        LayerManager.removeLayout()
                        if not _chapterNew then
                            zc.createChapter({
                                nationId = _nationId
                            })
                        end
                    end
                end
                _count = _count + 1
            end
        end)
    end

    --没走之前的引导套路，没注释，看的太恶心，
    if self._isInit then
        if zc.getFunctionStatus(48) then
            local currentGID = getGuideManager():getCurrentGID()
            if not PlayerData:getFuncGuideInfo(386) or currentGID == GuideKey.KEY_14801 then
                if not PlayerData:getFuncGuideInfo(386) then
                    getGuideManager():sendFuncGuideTrigger(386)
                end
                local _currentGID = 14801
                getGuideManager():setCurrentGID(GuideKey.KEY_14801)
                self:doBuzhenGuide(self._bottomButtonLay._roleButton)
                getGuideManager():startGuide()
            end
        end
        if zc.getFunctionStatus(50) then
            local currentGID = getGuideManager():getCurrentGID()
            if not PlayerData:getFuncGuideInfo(400) or currentGID == GuideKey.KEY_15001 then
                performWithDelay(self,function()
                    if not PlayerData:getFuncGuideInfo(400) then
                        getGuideManager():sendFuncGuideTrigger(400)
                    end
                    getGuideManager():setCurrentGID(GuideKey.KEY_15001)
                    local function _callBack()
                        performWithDelay(self, function()
                           self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                        end, 0.3)
                    end
                    getGuideManager():setHeroFuncCallBack(_callBack)
                    getGuideManager():startGuide()
                end,0.3)
            end
        end
        if zc.getFunctionStatus(49) then
            local currentGID = getGuideManager():getCurrentGID()
            if not PlayerData:getFuncGuideInfo(391) or currentGID == GuideKey.KEY_14901 then
                performWithDelay(self,function()
                    if not PlayerData:getFuncGuideInfo(391) then
                        getGuideManager():sendFuncGuideTrigger(391)
                    end
                    getGuideManager():setCurrentGID(GuideKey.KEY_14901)
                    local function _callBack()
                        self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                    end
                    getGuideManager():setHeroFuncCallBack(_callBack)
                    getGuideManager():startGuide()
                end,0.3)
            end
        end
        -- 神兵解锁
        if zc.getFunctionStatus(51) then
            local currentGID = getGuideManager():getCurrentGID()
            print("enter fuctin   51--")
            dump(PlayerData:getFuncGuideInfo(411))
            if not PlayerData:getFuncGuideInfo(411) or currentGID == GuideKey.KEY_15101 then
                -- print("怎么不进来？--")
                performWithDelay(self,function()
                    if not PlayerData:getFuncGuideInfo(411) then
                        getGuideManager():sendFuncGuideTrigger(411)
                    end
                    getGuideManager():setCurrentGID(GuideKey.KEY_15101)
                    -- print("进引导前:"..getGuideManager():getCurrentGID())
                    local function _callBack()
                        -- print("进引导:"..getGuideManager():getCurrentGID())
                        self._bottomButtonLay:playOpenAnimate()
                        self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
                    end
                    getGuideManager():setHeroFuncCallBack(_callBack)
                    getGuideManager():startGuide()
                end,0.3)
            end
            
        end
    end

    self._Over = true
end

--功能引导。方磊的处理方法，没走以前的
function TollgateMainLayer:setFuncGuideTrigger()
    print("jin ru setFuncGuideTrigger！")
    local tb = {
        {funcId = 48, guideTrigger = 386},
        {funcId = 50, guideTrigger = 400},
        {funcId = 49, guideTrigger = 391},
        {funcId = 51, guideTrigger = 411},
    }
    for i,v in ipairs(tb) do
        if zc.getFunctionStatus(v.funcId) then
            if not PlayerData:getFuncGuideInfo(v.guideTrigger) then
                getGuideManager():sendFuncGuideTrigger(v.guideTrigger)
            end
        end
    end
end

function TollgateMainLayer:getPos( lineType )
    local _lineType = tonumber(lineType) or 1

    local _lineDatas = {
        [1] = {
            innerWidth = 1250,
            pos = {
                {96, 640 - 344}, 
                {293, 640 - 236}, 
                {429, 640 - 406}, 
                {614, 640 - 258}, 
                {843, 640 - 251}, 
                {1026, 640 - 366},
            },
        },
        [11] = {
            innerWidth = 1250,
            pos = {
                {96, 640 - 344},
                {296, 640 - 421},
                {358, 640 - 215},
                {520, 640 - 364},
                {678, 640 - 202},
                {751, 640 - 394},
                {904, 640 - 248},
                {1064, 640 - 379},
            }
        },
        [21] = {
            innerWidth = 1800,
            pos = {
                {96, 640 - 344},
                {292, 640 - 236},
                {473, 640 - 333},
                {676, 640 - 413},
                {841, 640 - 291},
                {1015, 640 - 426},
                {1133, 640 - 271},
                {1343, 640 - 351},
                {1571, 640 - 354},
            }
        },
        [31] = {
            innerWidth = 1800,
            pos = {
                {96, 640 - 344}, 
                {312, 640 - 457}, 
                {504, 640 - 457}, 
                {673, 640 - 513}, 
                {865, 640 - 513}, 
                {1061, 640 - 473},
                {1245, 640 - 455}, 
                {1436, 640 - 489},  
                {297, 640 - 279}, 
                {473, 640 - 185}, 
                {690, 640 - 209}, 
                {856, 640 - 321}, 
                {1064, 640 - 281}, 
                {1250, 640 - 224}, 
                {1437, 640 - 261},
                {1645, 640 - 375}, 
            }
        },
        [12] = {
            innerWidth = 1250,
            pos = {
                {96, 640 - 374 + 60},
                {291, 640 - 250 + 60},
                {346, 640 - 448 + 60},
                {496, 640 - 305 + 60},
                {587, 640 - 483 + 60},
                {795, 640 - 436 + 60},
                {882, 640 - 261 + 60},
                {1057, 640 - 400 + 60},
            }
        },
        [22] = {
            innerWidth = 1800,
            pos = {
                {108, 640 - 338 + 60},
                {221, 640 - 500 + 60},
                {330, 640 - 327 + 60},
                {504, 640 - 185 + 60},
                {542, 640 - 402 + 60},
                {698, 640 - 515 + 60},
                {773, 640 - 318 + 60},
                {960, 640 - 232 + 60},
                {1047, 640 - 443 + 60},
            }
        },
        [32] = {
            innerWidth = 1800,
            pos = {
                {113, 640 - 388 + 60}, 
                {275, 640 - 520 + 60}, 
                {487, 640 - 515 + 60}, 
                {670, 640 - 442 + 60}, 
                {846, 640 - 529 + 60}, 
                {1039, 640 - 491 + 60},
                {1245, 640 - 539 + 60}, 
                {1436, 640 - 508 + 60},  
                {256, 640 - 222 + 60}, 
                {417, 640 - 323 + 60}, 
                {606, 640 - 257 + 60}, 
                {829, 640 - 241 + 60}, 
                {1008, 640 - 348 + 60}, 
                {1172, 640 - 254 + 60}, 
                {1350, 640 - 346 + 60},
                {1584, 640 - 350 + 60}, 
            }
        },
    }
    local _data = _lineDatas[_lineType]
    local _tollDatas = gameData.getDataFromCache("tollgate", {chapterId = self._tollgateId}) 
    local _nums = table.nums(_tollDatas)
    local _haveLine2 = false
    
    if not _data or table.nums(_data.pos) ~= _nums then
        for k,v in pairs(_lineDatas) do
            if table.nums(v.pos) == _nums then
                _data = v
                break
            end
        end
    end

    local _innerWidth = _data.innerWidth
    _innerWidth = _innerWidth < zc.width and zc.width or _innerWidth
    self._pos = _data.pos
    if table.nums(_data.pos) > 10 then
        _haveLine2 = true
    end 

    local _lineList = {}
    local _imgNode = self._imgNode

    local function _getLine( i1, i2, group )
        _lineList[group] = _lineList[group] or {}
        local _link = zc.createSpine({--"res/Main/chapterMain/jblx1.png")--zc.getSpine("guangzhu")
            fileName = "gz_1",
            actName = self._lineColor == 1 and "stop_idle" or "stop_idle2",
        })
        _imgNode:addChild(_link, -1)
        _lineList[group][#_lineList[group] + 1] = _link

        local p1 = cc.p(self._pos[i1][1], self._pos[i1][2])
        local p2 = cc.p(self._pos[i2][1], self._pos[i2][2])
        
        local _pos = cc.pMidpoint(p1, p2)
        _link:setPosition(_pos)
        --缩放倍数
        local _dis = cc.pGetDistance(p1, p2)
        _bei = _dis/300
        _bei = _bei*0.9
        -- _bei = _bei < 1 and 1 or _bei
        --角度
        local deltaY = p2.y - p1.y;
        local deltaX = p2.x - p1.x;
        local _angle = deltaX > 0 and 180 or -180
        local K = deltaY/deltaX
        local _tmp = CC_RADIANS_TO_DEGREES(math.atan(K))
        _angle = _angle - _tmp

        _link:setScaleX(_bei)
        _link:setRotation(_angle + 180)
    end

    if _haveLine2 then
        _getLine(1, 9, 2)
        for i = 10, 16 do
            _getLine(i, i-1, 2)
        end 
        for i = 2, 8 do
            _getLine(i, i-1, 1)
        end 
        _getLine(8, 16, 1)
    else
        for i = 2, #self._pos do
            _getLine(i, i-1, 1)
        end
    end
    self._lineList = _lineList
    return _innerWidth
end

--创建星级宝箱
function TollgateMainLayer:createStarTreasure()
    -- local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", cc.size(100, 100))
    local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(100, 100))
    local boxBtn = zc.createPushButton({
        touchSize = cc.size(100, 100),
        normalNode = myScale9,
        needSwallow = true,
        needEnableWhenOut = false,
        anchor = cc.p(0.5, 0.5),
        -- pos =cc.p(armature:getPositionX(), armature:getPositionY()),
        pos =cc.p(80,50),
        endCallback = function() end,
    })
    self:addChild(boxBtn, 5)

    local armature = zc.getSpine("missionbox")
    armature:setPosition(80,50)
    armature:setPosition(boxBtn:getContentSize().width/2, boxBtn:getContentSize().height/2)
    boxBtn:addChild(armature)
    armature:playAction("box4_lock", true)

    local star = zc.createSprite("res/Main/common/common_hero_star_1.png")
    star:setAnchorPoint(0, 0.5)
    star:setPosition(2, 32)
    boxBtn:addChild(star)
    local starNumLab = zc.createLabel({
        text = "0/0",
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(star:getPositionX()+star:getContentSize().width, star:getPositionY()),
    })
    boxBtn:addChild(starNumLab)

    armature:setVisible(false)
    boxBtn:setVisible(false)
    starNumLab:setVisible(false)
    self._starArmature = armature
    self._starBoxBtn = boxBtn
    self._starNumLab = starNumLab
end

function TollgateMainLayer:updateStarTreasure(_chapterid)
    if not self._starArmature then
        return
    end
    local chapterInfo = PlayerData:getCopyInfoByChapterId(_chapterid) or {}
    if chapterInfo and chapterInfo.tollgates then
        local treasureInfo = gameData.getDataFromCache("starTreasure", {["chapterId"]=_chapterid or 1} )
        if not treasureInfo or not next(treasureInfo) then
            return 
        end
        self._starArmature:setVisible(true)
        self._starBoxBtn:setVisible(true)
        self._starNumLab:setVisible(true)
        local treasureNum = #treasureInfo
        if not chapterInfo.gift then
            chapterInfo.gift = {}
            for i = 1, treasureNum do
                chapterInfo.gift[tostring(i)] = 0
            end
        end
        local gift = chapterInfo.gift
        local totalStar = 0
        for i = 1, #chapterInfo["tollgates"] do
            local v = chapterInfo["tollgates"][i]
            totalStar = totalStar + (tonumber(v.star) or 0)
        end
        --设置奖励状态
        for i = 1, treasureNum do
            if treasureInfo[i] then
                local _num = tonumber(treasureInfo[i]["starNumber"]) or 0
                if totalStar >= _num then
                    if tonumber(chapterInfo["gift"][tostring(i)]) == 0 then
                        chapterInfo["gift"][tostring(i)] = 1
                    end
                end
            end
        end
        local nowId = 1
        local canGet = false
        local overGet = false
        local giftNums = table.nums(gift)
        for i = 1, giftNums do
            if tonumber(gift[tostring(i)]) ~= 2 then
                nowId = i
                if tonumber(gift[tostring(i)]) == 1 then
                    canGet = true
                end
                break
            else
                if i == giftNums then
                    overGet = true
                end
            end
        end
        if overGet then
            nowId = treasureNum
        end
        local _max = treasureInfo[nowId] and treasureInfo[nowId]["starNumber"] or 1
        self._starNumLab:setText(tostring(totalStar) .. "/" .. tostring(_max))
        if overGet then
            self._starArmature:playAction("box4_open", true)
        else
            if canGet then
                self._starArmature:playAction("box4_closer", true)
            else
                self._starArmature:playAction("box4_lock", true)
            end
        end
        self._starBoxBtn:setTouchEndedCall(function()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_4007 then
                zc.setGuideFuncNextStep(_currentGID)
            end
            local function refresh()
                if tolua.isnull(self) then
                    return
                end
                self:updateStarTreasure(_chapterid)
            end
            local _params = {
                chapterId = _chapterid,
                callback = refresh,
                hideCall = function()
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_4009 then
                        zc.setGuideFuncNextStep(_currentGID)
                        self:addGuide(self._icons)
                    end
                end
            }
            zc.createSourcePop("StarBox", "src/layer/chapter/StarBoxPop.lua", _params)
        end)
    else
        self._starArmature:setVisible(false)
        self._starBoxBtn:setVisible(false) 
        self._starNumLab:setVisible(false) 
    end
end

function TollgateMainLayer:initButton()
    self._bottomButtonLay = requires("src/layer/mainCity/MainBottomBtnsLayer.lua"):create({
        isBack = true,
        needToDefault = self._isGotoTollgate
    })
    self:addChild(self._bottomButtonLay, 4)
end  


function TollgateMainLayer:initUI()
    self:initTouchLayer()--初始化触摸层
    --攻打的线有两条  按照打得远的那条继续打
    
    local _data = gameData.getDataFromCacheWithPrimaryKey("chapter", self._tollgateId)
    self._lineColor = _data.lineColor
    --title
    local _titleBg = zc.getSprite({
        src = "res/Main/chapterMain/infoTitle.png",
        ap = cc.p(0.5, 1),
        pos = cc.p(zc.width*0.25, zc.height),
    })
    self:addChild(_titleBg, 4)

    local _chapterId = tonumber(self._tollgateId) or 1
    _chapterId = _chapterId > 1000 and _chapterId%1000 or _chapterId  
    local _str = zc.lang("num_di") .. _chapterId .. zc.lang("num_zhang") .. " " .. _data.name
    local _titleLab = zc.createLabel({
        text = _str,
        fontSize = 20,
        outLine = true,
        pos = cc.p(_titleBg:getContentSize().width*0.5, _titleBg:getContentSize().height*0.5 + 5),
    })
    _titleBg:addChild(_titleLab)

    --返回按钮
    self.closeCallBack = function () 
        --新手引导
        local _currentGID = getGuideManager():getCurrentGID()
        if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then
            getGuideManager():guideOver()
            getGuideManager():setNextGID(_currentGID)
        end
        LayerManager.removeLayout()     
    end

    if self._nationId == 1 then
        return
    end
    self._challangeBar = zc.createChapterTimeBar()
    self:addChild(self._challangeBar, 4)
end

function TollgateMainLayer:playOutAni( enemySp, idx )
    local i = enemySp.index
    local _tollDb = enemySp._tollDb
    local _spine, _spine2
    if self._lineList[2] then
        if _tollDb.line == 1 then
            _spine = self._lineList[1][i-1]
        elseif _tollDb.line == 2 then
            _spine = self._lineList[2][i-8]
        elseif _tollDb.line == 3 then
            _spine = self._lineList[1][8]
            _spine2 = self._lineList[2][8]
        end
    else
        if i ~= 1 then
            _spine = self._lineList[1][i-1]
        end
    end
    if _spine then
        local _normalNode = enemySp:getStateNormal()
        if _normalNode and _normalNode._baseIcon then
            zc.setGray(_normalNode._baseIcon._headIcon, true)
        end
        _spine:playAction(self._lineColor == 1 and "stop_idle" or "stop_idle2", true)
        performWithDelay(enemySp, function()
            _spine:playAction(self._lineColor == 1 and "start" or "start2", false)
            _spine:setTimeScale(2.0)
            _spine:registerSpineEventHandler( function ( event )
                if event.animation ~= "start" and event.animation ~= "start2" then
                    return
                end
                -- _spine:unregisterSpineEventHandler(sp.EventType.ANIMATION_COMPLETE)
                _spine:playAction(self._lineColor == 1 and "idle" or "idle2", true)
                _spine:setTimeScale(1.0)
                local _normalNode = enemySp:getStateNormal()
                if _normalNode and _normalNode._baseIcon then
                    zc.setGray(_normalNode._baseIcon._headIcon, false)
                    local _effSpine = zc.createSpine({--"res/Main/chapterMain/jblx1.png")--zc.getSpine("guangzhu")
                        fileName = "gz_1",
                        loop = false,
                        autoRemove = true,
                        actName = self._lineColor == 1 and "guanka_open" or "guanka_open2",
                    })
                    _effSpine:setPosition(cc.pMul(cc.pFromSize(_normalNode:getContentSize()), 0.5))
                    _normalNode:addChild(_effSpine)
                end
            end, sp.EventType.ANIMATION_COMPLETE)
        end, 0.5*(idx-1))

        if _spine2 then
            _spine2:playAction(self._lineColor == 1 and "stop_idle" or "stop_idle2", true)
            _spine2:setTimeScale(2.0)
            performWithDelay(enemySp, function()
                _spine2:playAction(self._lineColor == 1 and "start" or "start2", false)
                _spine2:registerSpineEventHandler( function ( event )
                    if event.animation ~= "start" and event.animation ~= "start2" then
                        return
                    end
                    -- _spine2:unregisterSpineEventHandler(sp.EventType.ANIMATION_COMPLETE)
                    _spine2:playAction(self._lineColor == 1 and "idle" or "idle2", true)
                    _spine2:setTimeScale(1.0)
                end, sp.EventType.ANIMATION_COMPLETE)
            end, 0.5*(idx-1))
        end
    end
end

function TollgateMainLayer:checkLineOpen( tollDb, tollData )
    local _lineNum = tonumber(tollDb.line)
    if _lineNum == 0 --起始关卡
      or tollData.status == 2 --已经通关的关卡
      or tonumber(tollDb.activateId) == 0--前置解锁为0的关卡
      then
        return true
    end
    if self._nationId == 2 then
        if tollData.status == 1 then
            return true
        end
        return false
    end
    ------精英副本后续可以不用判断，按照关卡开启进度做显示就行

    if _lineNum == 3 then--boss关卡有一个前置条件达成就显示
        local array = string.split(tollDb.activateId,",")
        for k,v in pairs (array) do 
            if PlayerData:getCurTollGateStatus(v) ~= 2 then 
                return false
            end
        end
        return true
    end
    if tollData.status == 1 --可攻打未通关
      and (_lineNum == 1 or _lineNum == 2) --属于两条线路中的关卡
      and self._chapterData.routeId ~= 0 then --已选择线路
        local _lineTollData = gameData.getDataFromCacheWithPrimaryKey("tollgate", self._chapterData.routeId) 
        if next(_lineTollData) ~= nil then
            if _lineNum == tonumber(_lineTollData.line) then
                return true
            end
            local _bossData = gameData.getDataFromCache("tollgate", {line = 3, chapterId = self._tollgateId}) 
            
            if next(_bossData) ~= nil then
                if PlayerData:getCurTollGateStatus(_bossData.id) == 2 then 
                    return true
                end 
                local array = string.split(_bossData.activateId,",")
                for k,v in pairs (array) do 
                    local _dtat = gameData.getDataFromCacheWithPrimaryKey("tollgate", v) 
                    if tonumber(_dtat.line) ~= _lineNum then
                        if PlayerData:getCurTollGateStatus(v) == 2 then 
                            return true
                        end
                    end
                end
            end
        end
    end
    return false
end

function TollgateMainLayer:freshStar( _tollDb, _tollData, copyEnemy, _newCh, i)
    local _showCheck = self:checkLineOpen(_tollDb, _tollData)
    local _flag = _showCheck and _tollData.status ~= 0
    if _tollData.status == 2 then
        copyEnemy._starDi:setVisible(true)
    else
        copyEnemy._starDi:setVisible(false)
    end
    if not copyEnemy.starNum or copyEnemy.starNum ~= _tollData.star then
        copyEnemy._tollData = _tollData
        local enemyStar = tonumber(_tollData.star) or 0
        copyEnemy.starNum = enemyStar
        for startNum=1, 3 do
            local _star = copyEnemy["star" .. startNum]
            if _star then
                if startNum <= enemyStar then
                    _star:setVisible(true)
                else
                    _star:setVisible(false)
                end
            end
        end 
    end

    local _startNum = tonumber(_tollData.star) or 0
    if _startNum == 0 and _tollDb.bubble and _tollDb.bubble ~= "" then
        local _bubbleImg = zc.createSprite("res/Main/chapterMain/tipBubble.png")
        _bubbleImg:setPosition(copyEnemy:getContentSize().width*0.5, copyEnemy:getContentSize().height*1.5)
        copyEnemy:addChild(_bubbleImg)
        copyEnemy["bubbleImg"] = _bubbleImg

        local _tipLab = zc.createLabel({
            text = tostring(_tollDb.bubble),
            fontSize = 20,
            color = cc.c3b(81, 48, 26),
            pos = cc.p(_bubbleImg:getContentSize().width*0.5, _bubbleImg:getContentSize().height*0.5 + 6)
            
        })
        _bubbleImg:addChild(_tipLab)

        _bubbleImg:runAction(cc.RepeatForever:create(cc.Sequence:create(
            cc.FadeTo:create(1.2, 0.6*255),
            cc.FadeTo:create(1.2, 255)
        )))
    elseif copyEnemy["bubbleImg"] then
        copyEnemy["bubbleImg"]:removeFromParent()
        copyEnemy["bubbleImg"] = nil
    end

    local _normalNode = copyEnemy:getStateNormal()
    if _normalNode and _normalNode._baseIcon then
        zc.setGray(_normalNode._baseIcon._headIcon, not _flag)
        local _colorStr = self._lineColor == 1 and "cold" or "warm"
        local _iconType = _tollDb.iconType
        if _iconType == 6 then
            local _bgImg = "res/Main/chapterMain/openDi6_" .. _colorStr .. ".png"
            if not _flag then
                _bgImg = "res/Main/chapterMain/unOpenDi6_" .. _colorStr .. ".png"
            end
            _normalNode._baseIcon:setTexture(_bgImg)
        elseif _iconType ~= 2 and _iconType ~= 4 and _iconType ~= 5 then
            local _bgImg = "res/Main/chapterMain/openDi_" .. _colorStr .. ".png"
            if not _flag then
                _bgImg = "res/Main/chapterMain/unOpenDi_" .. _colorStr .. ".png"
            end
            _normalNode._baseIcon:setTexture(_bgImg)
        end
    end

    copyEnemy:setTouchEndedCall(function()
        if zc.getPop("EnemyInfo") then
            return
        end
        -- local _lineNum = tonumber(_tollDb.line)
        if not _flag then--boss关卡有一个前置条件达成就显示,但不能挑战
            zc.tipInfo(zc.lang("tips_checkpoint_not_open"))
            return
        end
        self:goBattleEnemy(_tollData)
    end)

    local _actName
    if _flag then
        _actName = self._lineColor == 1 and "idle" or "idle2"
    else
        _actName = self._lineColor == 1 and "stop_idle" or "stop_idle2"
    end
    if self._lineList[2] then
        if tonumber(_tollDb.line) == 1 then
            self._lineList[1][i-1]:playAction(_actName, true)
        elseif tonumber(_tollDb.line) == 2 then
            self._lineList[2][i-8]:playAction(_actName, true)
        elseif tonumber(_tollDb.line) == 3 then
            self._lineList[1][8]:playAction(_actName, true)
            self._lineList[2][8]:playAction(_actName, true)
        end
    else
        if i ~= 1 then
            self._lineList[1][i-1]:playAction(_actName, true)
        end
    end
    if _showCheck and _tollData.status == 1 then
        print("is _showCheck")
        if self._arrow then
            if self._arrow._tollId == _tollDb.id then
                return
            end
            self._arrow:removeFromParent()
            self._arrow = nil
        end
        local arrow = zc.createSpine({--"res/Main/chapterMain/jblx1.png")--zc.getSpine("guangzhu")
            fileName = "gz_1",
            actName = self._lineColor == 1 and "blue" or "red",
        })
        arrow:setPosition(copyEnemy:getPosition())
        local _iconType = _tollDb.iconType
        if _iconType == 6 then
            arrow:setPositionX(arrow:getPositionX() - 4)
        end
        self._imgNode:addChild(arrow, -1)
        self._arrow = arrow

        if self._secondIn and _newCh then --如果是开启新的关卡，做淡入动画
            arrow:setOpacity(0)
            arrow:runAction(cc.Sequence:create(cc.FadeIn:create(1.5)))
        end
        self._secondIn = true
    end
end

function TollgateMainLayer:createOneCopyEnemy( _tollDb, _tollData, i )
    local iconId = _tollDb.icon
    local _showCheck = self:checkLineOpen(_tollDb, _tollData)
    local _colorStr = self._lineColor == 1 and "cold" or "warm"
    local _bgImg = "res/Main/chapterMain/bigDi_" .. _colorStr .. ".png"
    if _tollDb.iconType == 5 then
        _bgImg = "res/Main/chapterMain/eliteDi.png"
    elseif _tollDb.iconType == 6 then
        if not _showCheck or _tollData.status == 0 then
            _bgImg = "res/Main/chapterMain/unOpenDi6_" .. _colorStr .. ".png"
        else
            _bgImg = "res/Main/chapterMain/openDi6_" .. _colorStr .. ".png"
        end
    elseif _tollDb.iconType ~= 2 and _tollDb.iconType ~= 4 then
        if not _showCheck or _tollData.status == 0 then
            _bgImg = "res/Main/chapterMain/unOpenDi_" .. _colorStr .. ".png"
        else
            _bgImg = "res/Main/chapterMain/openDi_" .. _colorStr .. ".png"
        end
    end
    local _baseIcon = self:getCircleHead({
        bgImg = _bgImg,
        iconType = _tollDb.iconType,
        iconId = _tollDb.headIcon,
    })
    if _tollData.status == 0 then
        zc.setGray(_baseIcon._headIcon, true)
    end
    local _nodeSize = _baseIcon:getContentSize()
    local _normalNode = zc.createImageView({
        src = "res/Main/common/img_empty.png",
        scale9 = true,
        size = _nodeSize,
    })
    _normalNode:addChild(_baseIcon)
    _normalNode._baseIcon = _baseIcon
    _baseIcon:setPosition(_nodeSize.width*0.5, _nodeSize.height*0.5)
   
    local _animationNode = nil
    -- if tonumber(iconId) == 8 then
    --     _animationNode = zc.getSpine("drfb")
    --     _animationNode:playAction("idle", true)
    --     _animationNode:setPosition(cc.pMul(cc.pFromSize(_nodeSize), 0.5))
    --     _normalNode:addChild(_animationNode)
    --     _baseIcon:removeFromParent()
    --     _baseIcon = nil
    --     _normalNode._baseIcon = nil
    -- end
    local function deleAnimaNode()
        if _baseIcon then
            _baseIcon:removeFromParent()
            _baseIcon = nil
            _normalNode._baseIcon = nil
        end
        if _animationNode then _animationNode:removeFromParent() end
    end

    local _tollgateId = tonumber(_tollData["tollgateId"])
    if _tollgateId == 1001002 then
        deleAnimaNode()
        local jiaxu, _files = zc.battle.createHeroArmatureWithResId("jiaxu")
        jiaxu:getAnimation():play("tielong_2")
        jiaxu:setPosition( _nodeSize.width/2 - 5, _nodeSize.height/2-20 )
        _normalNode:addChild(jiaxu)
        jiaxu:setScale(0.65)
    -- elseif _tollgateId == 1002005 then
    --     deleAnimaNode()
    --     local zhujian = zc.createSprite("res/Main/copy/9.png")
    --     zhujian:setPosition(cc.p(_nodeSize.width/2 - 15, _nodeSize.height/2))
    --     _normalNode:addChild(zhujian)
    --     zhujian:setScale(0.8)
    elseif _tollgateId == 1004004 then
        if not APP_REVIEW then
            deleAnimaNode()
            local diaochan, _files = zc.battle.createHeroArmatureWithResId("diaochan")
            diaochan:getAnimation():play("tielong")
            diaochan:setPosition(cc.p(_nodeSize.width/2 + 15, _nodeSize.height/2-20))
            _normalNode:addChild(diaochan)
        end
    elseif _tollgateId == 1004005 then
        deleAnimaNode()
        local zhujian = zc.getSpine("huoshaoluoyang")
        zhujian:playAction("zhujian", true)
        zhujian:setPosition(cc.p(_nodeSize.width/2, _nodeSize.height/2+10))
        _normalNode:addChild(zhujian)
        zhujian:setScale(0.5)
    -- elseif _tollgateId == 1003016 then
    --     deleAnimaNode()
    --     local huoshaoluoyang = zc.getSpine("huoshaoluoyang")
    --     huoshaoluoyang:playAction("huoshaoluoyang", true)
    --     huoshaoluoyang:setPosition(cc.p(_nodeSize.width/2 - 5, _nodeSize.height/2))
    --     _normalNode:addChild(huoshaoluoyang)
    --     huoshaoluoyang:setScale(0.9)
    elseif _tollgateId == 1010008 then
        if not APP_REVIEW then
            deleAnimaNode()
            local tingzi = zc.createAnimationArmature({
                fileName = "tingzi",
                autoRelease = true
            })
            tingzi:getAnimation():playWithIndex(0)
            tingzi:setPosition(cc.p(_nodeSize.width/2 + 25, _nodeSize.height/2 - 35))
            _normalNode:addChild(tingzi)
            tingzi:setScale(0.5)
            local lvbu_bone = tingzi:getBone("lvbu")
            local diaochan_bone = tingzi:getBone("diaochan")
            local lvbu, _files1 = zc.battle.createHeroArmatureWithResId("lvbu")
            lvbu:getAnimation():play("tingzi")
            lvbu_bone:addDisplay(lvbu,1)
            lvbu_bone:changeDisplayWithIndex(1, true)
            lvbu_bone:setIgnoreMovementBoneData(true)
            local diaochan, _files = zc.battle.createHeroArmatureWithResId("diaochan")
            diaochan:getAnimation():play("tingzi")
            diaochan_bone:addDisplay(diaochan,1) 
            diaochan_bone:changeDisplayWithIndex(1, true)
            diaochan_bone:setIgnoreMovementBoneData(true)
        end
    end

    local _pos = cc.p(self._pos[i][1], self._pos[i][2])
    local copyEnemy = zc.createPushButton({
        normalNode = _normalNode,
        needSwallow = false,
        needEnableWhenMoving = true,
        pos = _pos,
        endCallback = function() end
    })
    copyEnemy:setCascadeOpacityEnabled(true)
    copyEnemy._animationNode = _animationNode

    local starpos, titlepos = self:getStarTitlePostion(iconId, copyEnemy)--星星及标题的位置
    local _starDi = zc.getSprite({
        src = "res/Main/chapterMain/starBg.png",
        pos = starpos,
    })
    copyEnemy._starDi = _starDi
    copyEnemy:addChild(_starDi)
    for starnum = 1, 3 do 
        local starB = zc.getSprite({
            src = "res/Main/common/common_hero_star_2.png",
            pos = cc.p(_starDi:getContentSize().width/4*starnum, _starDi:getContentSize().height*0.5)
        })
        _starDi:addChild(starB)
        local star = zc.getSprite({
            src = "res/Main/common/common_hero_star_1.png",
            pos = cc.p(_starDi:getContentSize().width/4*starnum, _starDi:getContentSize().height*0.5)
        })
        _starDi:addChild(star)
        copyEnemy["star" .. starnum] = star
    end

    self:freshStar(_tollDb, _tollData, copyEnemy, true, i)
  
    local statusLabel = zc.createLabel({
        text = _tollDb.name,
        fontSize = 20,
        outLine = true,
        pos = titlepos,
    })
    copyEnemy["nameLabel"] = statusLabel
    copyEnemy:addChild(statusLabel)
    --名字背景位置调整
    if _tollgateId == 1002016 then
        statusLabel:setPositionX(statusLabel:getPositionX()+50)
    end

    return copyEnemy
end

function TollgateMainLayer:getTollData( tollDb )
    -- dump(tollDb, "tollDb ======================= ")
    local _tollId = tonumber(tollDb.id)
    local _tollData
    local _tollgates = self._chapterData.tollgates or {}
    if #_tollgates > 0 then
        for k,v in pairs(_tollgates) do

            -- dump(v, "v ==================")
            if v.tollgateId == _tollId then
                _tollData = v
                break
            end
        end
    end
    -- dump(_tollData, "_tollData ==========1111")
    if not _tollData then
        _tollData = {
            buyNum = 0,
            num = 0,
            status = 0,
            star = 0,
            tollgateId = _tollId
        }
        if tonumber(tollDb.activateId) == 0 then
            _tollData.status = 1
        end
    end
    -- dump(_tollData, "_tollData ==========222222")

    return _tollData
end

function TollgateMainLayer:getNowShowGroup( nowIndex )
    do 
        local _idx = tonumber(nowIndex) or 1
        return {_idx}
    end
    if self._nationId == 1 then
        if nowIndex == 1 then
            return {1}
        elseif nowIndex <= 4 then
            return {2, 3, 4}
        elseif nowIndex <= 7 then
            return {5, 6, 7}
        -- elseif nowIndex <= 8 then
        --     return {8}
        elseif nowIndex > 8 and nowIndex <= 11 then
            return {9, 10, 11}
        elseif nowIndex > 11 and nowIndex <= 14 then
            return {12, 13, 14}
        -- elseif nowIndex <= 15 then
        --     return {15}
        elseif nowIndex == 16 then
            return {16}
        else 
            return {}
        end
    else
        if nowIndex <= 3 then
            return {1, 2, 3}
        elseif nowIndex <= 6 then
            return {4, 5, 6}
        else
            return {7, 8, 9}
        end
    end
end

function TollgateMainLayer:checkStartShow( idx )
    if self._nationId == 1 then
        if idx == 1 
          or idx == 8 
          or idx == 15 then
            return true
        end
    end 
    return false
end

function TollgateMainLayer:createTollgateInfo( doAnimation )
    local _imgNode = self._imgNode
    local _doAnimation = doAnimation == nil and true or doAnimation
    -- _imgNode:removeAllChildren()

    local fightLine = {}
    self._chapterData.tollgates = self._chapterData.tollgates or {}
    
    local _tollDatas = gameData.getDataFromCache("tollgate", {chapterId = self._tollgateId}) 
    -- dump(_tollDatas, "_tollDatas:")
    local function _checkActionShow( idx, nowIndex)
        if not nowIndex then
            return false
        end
        local _group = self:getNowShowGroup(nowIndex)
        if inArray(idx, _group) then
            return true
        end
        return false
    end
    local _icons = {}
    local _openIcons = {}
    local _actionTb = {}
    local _enemyIndex, _lastSelectIndex, _nowIndex
    local _isAction = false
    local _currentGID = getGuideManager():getCurrentGID()
    local _isGuide = (_currentGID ~= GuideKey.KEY_OVER) and (_currentGID ~= 1) and (_currentGID ~= -1)
    local _isGuideChapter = _isGuide and (self._nationId == 1) and (self._tollgateId == 1)
    for i=1,#_tollDatas do
        local _tollDb = _tollDatas[i]
        local _tollData = self:getTollData(_tollDb)
        if _tollData.tollgateId == self._lastSelect then
            _lastSelectIndex = i
        end
        if _tollData.tollgateId == self._nextData.tollgateId then
            _nowIndex = i
        end
        local _showCheck = self:checkLineOpen(_tollDb, _tollData)
        local _show2 = false
        if not _showCheck then
            _show2 = _checkActionShow(i, _nowIndex)
            _showCheck = self:checkStartShow(i)
        end

        if (_tollData.tollgateId == self._enemyid) or
           (_isGuideChapter and _tollData.status == 1) then
            _enemyIndex = i
        end
        local copyEnemy = _imgNode:getChildByName("tollgateSp" .. i)
        if copyEnemy then
            self:freshStar(_tollDb, _tollData, copyEnemy, nil, i)
            if copyEnemy.spTargetSpine and copyEnemy.starNum == 3 then
                copyEnemy.spTargetSpine:removeFromParent()
                copyEnemy.spTargetSpine = nil
            end
        else
            copyEnemy = self:createOneCopyEnemy(_tollDb, _tollData, i)
            copyEnemy:setName("tollgateSp" .. i)
            _imgNode:addChild(copyEnemy)
            if _tollDb.id == self._spTargetId and 
             _tollData.status == 2 then
                self._spTargetId = nil
                local _spine = zc.getSpine("shou")
                _spine:setPosition(cc.pMul(cc.pFromSize(copyEnemy:getContentSize()), 0.5))
                copyEnemy:addChild(_spine, 100)
                copyEnemy.spTargetSpine = _spine
                _spine:playAction("shou", true)
            end
            copyEnemy.index = i
        end
        copyEnemy._tollDb = _tollDb
        if (_isGuideChapter and _tollData.status == 1)
          or _tollData.tollgateId == self._nextData.tollgateId 
          or _show2 
          then
            _actionTb[#_actionTb + 1] = copyEnemy
        end
        _icons[#_icons + 1] = copyEnemy

        if _showCheck or _show2 or (_isGuideChapter and _tollData.status == 1) then
            _openIcons[#_openIcons + 1] = copyEnemy
        end
        if _tollData.status == 1 then 
            fightLine[#fightLine+1] = i
        end
    end

    table.sort(_icons, function( a, b )
        if not a or not b then
            return false
        end
        return a:getPositionY() > b:getPositionY()
    end)
    for i=1,#_icons do
        _imgNode:reorderChild(_icons[i], 0)
    end

    --调到某一条线 --移动到新开启的关卡
    if _enemyIndex then 
        self:goCurTollgate(self._pos[_enemyIndex], _doAnimation)
        if _doAnimation then
            for i=1,#_actionTb do
                if not _isAction then
                    _isAction = true
                end
                -- _actionTb[i]:setVisible(false)
                -- performWithDelay(_actionTb[i], function()
                    self:playOutAni(_actionTb[i], i)
                -- end, i*0.5)
            end
        end
    elseif _lastSelectIndex then
        -- self:goCurTollgate(self._pos[_lastSelectIndex], _doAnimation)
    elseif self._nextJ ~= self._tollgateId then
        self:goCurTollgate(self._pos[#self._pos])
    elseif _nowIndex then
        self:goCurTollgate(self._pos[_nowIndex], _doAnimation)
    else
        local curFightPlace = 1
        for k=1,#fightLine do 
            local fightJuli = 0
            if fightLine[k] <= 9 then 
                --第一条线
                fightJuli = fightLine[k]
            elseif  fightLine[k] >= 10 then 
                --第二条线
                fightJuli = fightLine[k] - 9
            end
            if curFightPlace <= fightJuli then 
                curFightPlace = fightLine[k]
            end
        end
        self:goCurTollgate(self._pos[curFightPlace])
    end
    
    if self._nationId == 1
      and self._chapterData.routeId == 0 
      and #fightLine == 2
      -- and self._tollgateId ~= 1 then
      -- #self._chapterData.tollgates > 0
      then
        if (tonumber(_tollDatas[fightLine[1]].line) == 1) then
            self._line1 = _tollDatas[fightLine[2]].id
            self._line2 = _tollDatas[fightLine[1]].id
        else
            self._line1 = _tollDatas[fightLine[1]].id
            self._line2 = _tollDatas[fightLine[2]].id
        end
        self:showChooseLine()
    end

    --新手引导
    getGuideManager():guideOver()


    local _time = _isAction and 1.5 or 0.3
    local _mask = getGuideManager():getMaskLayer()
    self:addChild(_mask, 100)
    performWithDelay(self, function()
        _mask:removeFromParent()
        self:addGuide(_openIcons)
    end, _time)
    self._icons = _openIcons
end
--[[
获取星星  及 标题 的 位置
]]
function TollgateMainLayer:getStarTitlePostion(icon, copyEnemy)
    do 
        local _size = copyEnemy:getContentSize()
        local starpos = cc.p(_size.width*0.5, 0)
        local titlepos = cc.p(_size.width*0.5, _size.height + 10)
        return starpos, titlepos
    end
    icon = tonumber(icon)
    --一共十个建筑位置
    local starInBuilding = {
        {0.5, 0.13}, {0.5, 0.24}, {0.6, 0.15}, 
        {0.6, 0.15}, {0.58, 0.23}, {0.5, 0.28}, 
        {0.5, 0.15}, {0.4, 0.12}, {0.5, 0.12}, 
        {0.5, 0.07}
    }
    local titlInBuilding = {
        {0.95, 0.6}, {0.95, 0.6}, {0.95, 0.6}, 
        {0.95, 0.6}, {0.95, 0.6}, {0.95, 0.6}, 
        {0.95, 0.6}, {0.95, 0.6}, {0.95, 0.7}, 
        {1, 0.68}
    }
    local starPos = {0.5, 0}
    if starInBuilding[icon] then 
        starPos = starInBuilding[icon]
    end
    local titlePos = {0.9, 0.6}
    if titlInBuilding[icon] then 
        titlePos = titlInBuilding[icon]
    end
    local starpos = cc.p(copyEnemy:getContentSize().width*starPos[1], copyEnemy:getContentSize().width*starPos[2])
    local titlepos = cc.p(copyEnemy:getContentSize().width*titlePos[1], copyEnemy:getContentSize().height*titlePos[2])

    return starpos, titlepos
end
--到当前关卡
function TollgateMainLayer:goCurTollgate(pos, haveAnimation)
    local _worldPos = self._imgNode:convertToWorldSpace(cc.p(pos[1], pos[2]))
    local _nowPosX = self._bgImg:getPositionX()
    local _max = 0
    local _minX = zc.width - self._bgImg:getContentSize().width
    
    local _pos = cc.pSub(cc.p(zc.width*0.5, zc.height*0.5), _worldPos)
    local _pX = _nowPosX + _pos.x

    if _pX > _max then
        _pX = _max
    elseif _pX < _minX then
        _pX = _minX
    end

    local _time = haveAnimation and 0.3 or 0
    self._scrollView:setAutoMove(_time, _pX - _nowPosX, nil , false)
end

function TollgateMainLayer:initTouchLayer()
    local _data = gameData.getDataFromCacheWithPrimaryKey("chapter", self._tollgateId)
    self._mapIdx = tonumber(_data.map) or 1
    self._mapPath = "res/Main/chapterMain/chapterBg/" .. tostring(self._mapIdx) .. ".jpg"
    if not zc.checkFileExist(self._mapPath) then
        self._mapIdx = 1
        self._mapPath = "res/Main/chapterMain/chapterBg/1.jpg"
    end
    local mapImg = zc.getSprite({
        src = self._mapPath,
        ap = cc.p(0, 0.5),
        pos = cc.p(0, zc.height*0.5),
    })
    if zc.height > 700 then
        local _scale = zc.height/mapImg:getContentSize().height
        mapImg:setScale(_scale)
    end
    self._mapImg = mapImg
    if self._bgSpineIndex[self._mapIdx]then
        local _particleData = self._bgSpineIndex[self._mapIdx].particle
        if _particleData then 
            for i=1, #_particleData do
                local _file = "res/Main/chapterMain/chapterBg/" .. _particleData[i].name .. "/" .. _particleData[i].name .. ".plist"
                local particle = cc.ParticleSystemQuad:create(_file)
                local _pY = _particleData[i].y*mapImg:getScale()
                particle:setPosition(_particleData[i].x, _pY)
                mapImg:addChild(particle)
                if _particleData[i].rotation then
                    particle:setRotation(_particleData[i].rotation)
                end
                if _particleData[i].scale then
                    particle:setScale(_particleData[i].scale)
                end
                if _particleData[i].scaleX then
                    particle:setScaleX(_particleData[i].scaleX)
                end
                if _particleData[i].scaleY then
                    particle:setScaleY(_particleData[i].scaleY)
                end
            end
        end
        if self._bgSpineIndex[self._mapIdx].name then
            local _name = tostring(self._bgSpineIndex[self._mapIdx].name)
            mapImg._effSpine = zc.createSpine({
                fileName = _name,
                path = "res/Main/chapterMain/chapterBg/" .. _name .. "/",
                actName = "animation",
            })
            mapImg._effSpine:setPosition(mapImg:getContentSize().width*0.5, mapImg:getContentSize().height*0.5)
            mapImg:addChild(mapImg._effSpine)
        end
        local _haveYun = tonumber(self._bgSpineIndex[self._mapIdx].haveYun) or 0
        if _haveYun ~= 0 then
            self._mapEffPath = "res/Main/chapterMain/chapterBg/" .. _haveYun .. "/" .. _haveYun .. ".png"
            local _upYun = zc.createSpine({
                fileName = self._mapIdx,
                path = "res/Main/chapterMain/chapterBg/" .. _haveYun .. "/",
                actName = "top",
            })
            _upYun:setPosition(zc.width*0.5, zc.height)
            self:addChild(_upYun, 4)
            _downYun = zc.createSpine({
                fileName = self._mapIdx,
                path = "res/Main/chapterMain/chapterBg/" .. _haveYun .. "/",
                actName = "down",
            })
            _downYun:setPosition(zc.width*0.5, 0)
            self:addChild(_downYun, 4)

            local widthScale  = zc.width/1136
            if widthScale > 1 then 
                _upYun:setScale(widthScale)
                _downYun:setScale(widthScale)
            end
        end
    end

    local _node = cc.Node:create()
    _node:setAnchorPoint(0, 0.5)
    _node:setPosition(0, zc.height*0.5)
    self._imgNode = _node
    local _innerWidth = self:getPos(_data.lineType)
    _node:setContentSize(cc.size(_innerWidth, 640))

    local scrollView = requires("src/layer/mainCity/MyFullScrollLayer.lua"):createOne()
    scrollView:setDefaultType(2)
    scrollView:setScrollAutoScale(3)
    scrollView:addBackLay(_node, 1)
    scrollView:addBackLay(mapImg, 2)
    self._bgImg = self._imgNode

    self:addChild(scrollView)
    self._scrollView = scrollView
end

function TollgateMainLayer:showChooseLine()
    self._showChoosLineStatus = true
    
    if self._selectDi then
        self._selectDi:removeFromParent()
    end
    LayerManager.addShieldLayout(nil, 0.01)
    performWithDelay(self, function()
        local topInfo = LayerManager.getTopInfoLayer()
        if topInfo then
            topInfo:setVisible(false)
        end
        self._selectDi = requires("src/layer/chapter/LineChooseLayer.lua"):create({
            id = self._tollgateId,
            nationId = self._nationId,
            callBack = function( chooseId )
                if chooseId == 1 then
                    self:doChooseLine(self._line1)
                elseif chooseId == 2 then
                    self:doChooseLine(self._line2)
                end
            end
        })
        self:addChild(self._selectDi, 100)
    end, 0.01)
end

function TollgateMainLayer:doChooseLine( routeId )
    zc.sendHttp({
        apiName = "Tollgate_tollgateChoose",
        params = {chapterId = self._tollgateId, routeId = routeId},
        successCallback = function (data)
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_10002 or _currentGID == GuideKey.KEY_10011 then
                getGuideManager():setFuncGuideOver()
            end
            local topInfo = LayerManager.getTopInfoLayer()
            if topInfo then
                topInfo:setVisible(true)
            end
            self._showChoosLineStatus = false
            if self._selectDi then
                self._selectDi:removeFromParent()
                self._selectDi = nil
            end
            PlayerData:setRouteId(self._tollgateId, routeId)
            self:freshData()
            self:createTollgateInfo()
        end,
    })
end


--圆形头像处理
function TollgateMainLayer:getCircleHead(params)
    local _params = params or {}
    local _iconType = tonumber(_params.iconType) or 3
    local _bg
    local _isBig = _iconType == 2 or _iconType == 4
    if _isBig or _iconType == 5 then
        _bg = cc.Node:create()
        _bg:setContentSize(141, 146)
        _bg:setAnchorPoint(0.5, 0.5)
        if _isBig then
            local _actName = self._lineColor == 1 and "animation" or "animation2"
            local _spine = zc.createSpine({
                fileName = "lengseguanka",
                actName = _actName,
            })
            _spine:setPosition(_bg:getContentSize().width*0.5, _bg:getContentSize().height*0.5)
            _bg:addChild(_spine)
        else
            local _spine = zc.createSprite(_params.bgImg)
            _spine:setPosition(_bg:getContentSize().width*0.5, _bg:getContentSize().height*0.5)
            _bg:addChild(_spine)
            _spine:runAction(cc.RepeatForever:create(cc.RotateBy:create(3.5, 360)))
        end
    else
        _bg = zc.createSprite(_params.bgImg)
    end

    local _pic
    if _iconType == 3 or _iconType == 4 then
        _pic = zc.createSprite("res/Main/chapterMain/type" .. _iconType .. ".png")--底板
    else
        _pic = cc.ClippingNode:create()
        _pic:setInverted(false)
        _pic:setAlphaThreshold(0.9)
        -- local template = zc.createSprite(_params.templateImg or _params.bgImg)--模板
        local template = zc.createSprite("res/Main/chapterMain/clippingDi.png")--模板
        template:setScale(1.25)

        local _iconStr = "res/Main/hero/head/hero_head_" .. tostring(_params.iconId) .. ".png"
        if not zc.checkFileExist(_iconStr) then
            _iconStr = "res/Main/hero/head/hero_head_5.png"
        end
        local content = zc.createSprite(_iconStr)--底板
        if _isBig or _iconType == 5 then
            _pic:setScale(1.2)
        else
            _pic:setScale(0.80)
        end
        _pic:setStencil(template)
        _pic:addChild(content)

        local _up = zc.createSprite("res/Main/chapterMain/clippingUp.png")
        _up:setPosition(_bg:getContentSize().width*0.5, _bg:getContentSize().height*0.5)
        _bg:addChild(_up, 1)
        if _isBig or _iconType == 5 then
            _up:setScale(1.44)
            _up:setPosition(_up:getPositionX() - 2.5, _up:getPositionY() + 0.5)
            _pic:setPosition(_pic:getPositionX() - 2.5, _pic:getPositionY() + 0.5)
        end
    end
    _pic:setPosition(_bg:getContentSize().width*0.5, _bg:getContentSize().height*0.5)
    _bg:addChild(_pic)
    _bg._pic = _pic
    _bg._headIcon = content

    return _bg
end

function TollgateMainLayer:initGuidePreload( id )
    local _fileName = zc.getFightDatasFilePath() .. "battle" .. id .. ".data"
    if zc.checkFileExist(_fileName) then
        local __data = cc.FileUtils:getInstance():getStringFromFile(_fileName)
        --替换初始
        local _weapon = PlayerData:getRoleUserWeapons()
        local sex = PlayerData:getBaseInfoByTag("seigniorId")
        local zhujue = sex == 1 and "\"nanzhu\"\," or "\"nvzhujue\"\,"
        local _weaponId = math.modf(_weapon.weaponId/1000)
        if id <= 6 then
            local _subText = "\"nanzhu\"\,1002"
            if id == 6 then
                _weaponId = _weaponId == 1 and 1004 or 2004
            elseif id == 5 then
                _weaponId = _weapon.weaponId
            else
                _weaponId = _weaponId == 1 and 9 or 42
            end
            local _gText = zhujue .. _weaponId
            __data = string.gsub(__data, _subText, _gText)
        end
        local _subText = "\"nanzhu\"\,1001"
        local _gText = zhujue .. _weapon.weaponId
        __data = string.gsub(__data, _subText, _gText)
        --替换结束
        
        --替换主角名字
        _subText = zc.lang("leading_actor")
        _gText = PlayerData:getBaseInfoByTag("userName")
        __data = string.gsub(__data, _subText, _gText)
        __data = json.decode(__data)
        local _heroDatas = __data.data.warModel[6][2]
        local _count = 0
        for k,v in pairs(_heroDatas) do
            local _flag = true
            if v[2] ~= 0 then
                _count = _count + 1
                if _count > 2 then
                    _flag = false
                end
            end
            if _flag then
                zc.battle.createHeroArmature({fileName = v[12], async = true, asyncCallback = function( ar, fileName )
                    -- print("right yyyyyyyyyy------" .. fileName)
                end})
            end
        end
        print("wm----have file : ", _fileName)
        return __data.data.warModel
    else
        print("wm----not have file : ", _fileName)
    end
    return nil
end

function TollgateMainLayer:doBuzhenGuide( btn )
    dump(btn)

    LayerManager.addShieldLayout(nil, 0.4)
    if self._bottomButtonLay._click == 2 then
        self._bottomButtonLay:playOpenAnimate()
        self._bottomButtonLay._click = 1
    end
    local __btn = btn or self._bottomButtonLay._buzhenButton
    performWithDelay(self,function()
        getGuideManager():setObjTarget(__btn, 0.8)
        getGuideManager():startGuide()
    end, 0.3)
end

--新手引导处理关卡
function TollgateMainLayer:addGuide(list)
    local function _doGuide( _currentGID )
        self._scrollView:setTouchEnabled(false)
        if _currentGID == GuideKey.KEY_11505 then
            getGuideManager():setObjTarget(list[1], 0.8*1.3)
            getGuideManager():startGuide()
            return
        end
        local _idx = 1
        for i,v in ipairs(GuideGroup.GUAN_KA) do
            if tonumber(v) == _currentGID then
                _idx = i 
                break
            end
        end

        local __currentGID = getGuideManager():getCurrentGID()
        if #list ~= _idx and __currentGID and __currentGID ~= 1 then
            getGuideManager():setCurrentGID(GuideGroup.GUAN_KA[#list], true)
            _idx = #list
        end
        if _idx == 1 then
            getGuideManager():setObjTarget(list[1],0.8*1.3)
        else
            self:goCurTollgate(self._pos[_idx], false)
            getGuideManager():setObjTarget(list[_idx],0.8*0.6) 
        end
        getGuideManager():startGuide()
    end

    local function _doBuzhenGuide( _btn )
        self:doBuzhenGuide( _btn )
    end

    local function _guideGuanKa()
        local _currentGID = getGuideManager():getCurrentGID()
        if not inArray(_currentGID, GuideGroup.GUAN_KA) then
            return
        end
        if self._nationId == 1 and _currentGID < 10000 then
            if self._tollgateId ~= 1 then
                getGuideManager():setCurrentGID(GuideKey.KEY_OVER, true)
                return
            end
            if #list > 2 then
                local _formation = PlayerData:getNowFormationsInfo()
                if _formation.level == 1 then
                    getGuideManager():setCurrentGID(GuideKey.KEY_2009, true)
                    _doBuzhenGuide()
                    return
                else
                    local _num = 0
                    for i=1, 9 do
                        if _formation["location" .. i] ~= nil and _formation["location" .. i] ~= 0 then
                            _num = _num + 1
                        end
                    end
                    if _num < 3 then
                        getGuideManager():setCurrentGID(GuideKey.KEY_2015, true)
                        _doBuzhenGuide()
                        return
                    end 
                end
            end
        end
        _doGuide(_currentGID)
    end

    local _currentGID = getGuideManager():getCurrentGID()

    if inArray(_currentGID, GuideGroup.DUI_HUA) then
        getGuideManager():guideOver()
        if _currentGID == GuideKey.KEY_1001 then
            getGuideManager():setHeroFuncCallBack(function()
                getGuideManager():setCurrentGID(GuideKey.KEY_1004)
                _guideGuanKa()
            end)
        elseif _currentGID == GuideKey.KEY_5007 then
            getGuideManager():setHeroFuncCallBack(function()
                _doBuzhenGuide(self._bottomButtonLay._soliderButton)
            end)
        elseif _currentGID == GuideKey.KEY_11508 then
            getGuideManager():setHeroFuncCallBack(function()
                _doBuzhenGuide(self._bottomButtonLay._roleButton)
            end)
        else
            getGuideManager():setHeroFuncCallBack(_guideGuanKa)
        end
        getGuideManager():startGuide()
    elseif inArray(_currentGID, GuideGroup.BTN_BUZHEN) then
        _doBuzhenGuide()
    elseif _currentGID == GuideKey.KEY_6005 then
    elseif inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then  -- 返回主城
        if inArray(_currentGID, GuideGroup.FB_BACK_MAINCITY) then
            --进入后打开按钮
            _doBuzhenGuide(self._bottomButtonLay._fubenButton) 
        else
            zc.addGuideBtn(self._closeBtn)   
        end
    elseif _currentGID == GuideKey.KEY_4007 then
        getGuideManager():setObjTarget(self._starBoxBtn)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12900 then
        getGuideManager():setCurrentGID(GuideKey.KEY_12901)
        getGuideManager():setHeroFuncCallBack(function()
            _doBuzhenGuide(self._bottomButtonLay._smithyButton)
        end)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_11400 then
         getGuideManager():setCurrentGID(GuideKey.KEY_11401)
        _doBuzhenGuide(self._bottomButtonLay._soliderButton)
    elseif _currentGID == GuideKey.KEY_11600 then
         getGuideManager():setCurrentGID(GuideKey.KEY_11601)
        _doBuzhenGuide(self._bottomButtonLay._fubenButton)
    elseif _currentGID == GuideKey.KEY_14200 then
        getGuideManager():setCurrentGID(GuideKey.KEY_14201)
        getGuideManager():setHeroFuncCallBack(function()
            _doBuzhenGuide(self._bottomButtonLay._smithyButton)
        end)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14300 then
        getGuideManager():setCurrentGID(GuideKey.KEY_14301)
        getGuideManager():setHeroFuncCallBack(function()
            _doBuzhenGuide(self._bottomButtonLay._soliderButton)
        end)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12700 then
        getGuideManager():setCurrentGID(GuideKey.KEY_12701)
        _doBuzhenGuide(self._bottomButtonLay._fubenButton)
    elseif _currentGID == GuideKey.KEY_13200 then
        getGuideManager():setCurrentGID(GuideKey.KEY_13201)
        _doBuzhenGuide(self._bottomButtonLay._fubenButton)
    elseif _currentGID == GuideKey.KEY_12000 then
        getGuideManager():setCurrentGID(GuideKey.KEY_12001)
        self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
    elseif _currentGID == GuideKey.KEY_12500 then
        getGuideManager():setCurrentGID(GuideKey.KEY_12501)
        self:doBuzhenGuide(self._bottomButtonLay._fubenButton)
    elseif _currentGID == GuideKey.KEY_14500 then
        getGuideManager():setCurrentGID(GuideKey.KEY_14501)
        _doBuzhenGuide(self._bottomButtonLay._fubenButton)
    elseif _currentGID == GuideKey.KEY_14600 then
        getGuideManager():setCurrentGID(GuideKey.KEY_14601)
        _doBuzhenGuide(self._bottomButtonLay._fubenButton)
    elseif _currentGID == GuideKey.KEY_14700 then
        getGuideManager():setCurrentGID(GuideKey.KEY_14701)
        _doBuzhenGuide(self._bottomButtonLay._fubenButton)
    else
        _guideGuanKa()
    end
end

return TollgateMainLayer