--[[
-- 国家仓库
-- @author lph
-- Creation  2016-4-13
]]
local CountryWarehouseDetailPop = class("CountryWarehouseDetailPop", function ()
    return ZCPopLayer:create() 
end);

function CountryWarehouseDetailPop:create(params)
	local _CountryWarehouseDetail = CountryWarehouseDetailPop.new(params)
	return _CountryWarehouseDetail
end

function CountryWarehouseDetailPop:ctor(params)
    self:initData(params)
	self:initUI()
    self:initCitysList()
end

function CountryWarehouseDetailPop:initData(params)
	self._salary_data = params.salaryData
end

function CountryWarehouseDetailPop:initUI()
	local _bg = zc.createImageView({
        src = "res/Main/country/warehouse/warehouse_pop_bg.png",
        ap = cc.p(0.5,0.5),
        pos = cc.p(zc.width/2, zc.height/2) 
    })
    self:addContent(_bg)
    self._bg = _bg
    --建筑图标
    local _houseImg = zc.createImageView({
        src = "res/Main/copy/2.png",
        ap = cc.p(0.5,0.5),
        pos = cc.p(50, 300),
        scale = 0.5,
    })
    _bg:addChild(_houseImg)
    --标题
    local _title_label = zc.createLabel({
        text = zc.lang("country_warehouse"),
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(100, 320),
        stroke = true,
    })
    _bg:addChild(_title_label)
    --资源保护 
    local _protect_label = zc.createLabel({
        text = zc.lang("country_res_protect") .. ":",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(100, 290),
        stroke = true,
        color = display.COLOR_GREEN,
    })
    _bg:addChild(_protect_label)
    local _src = zc.getImgByType(self._salary_data.type)
    local _resImg = zc.createImageView({
        src = _src,
        ap = cc.p(0,0.5),
        pos = cc.p(100+_protect_label:getContentSize().width, 290),
        scale = 0.7,
    })
    _bg:addChild(_resImg)
    local _text = zc.getWan( self._salary_data.numLimit, 1 )
    local _protect_num_label = zc.createLabel({
        text = _text,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(130+_protect_label:getContentSize().width, 290),
        stroke = true,
        color = display.COLOR_GREEN,
    })
    _bg:addChild(_protect_num_label)
end

function CountryWarehouseDetailPop:initCitysList()
    local _tableSize = cc.size(300, 245)
    local _tableView = zc.ZCTableView:create(_tableSize)
    _tableView:setPosition(5, 15)
    _tableView:setInertia(true)
    _tableView:setBounceable(true)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    self._bg:addChild(_tableView)
    self._citysTable = _tableView

    local _cellSize = cc.size(300, 85)

    local function numberOfCellsInTableView( table )
        return 3 --#self._citysData
    end
    local function cellSizeForTable( table, index )
        return _cellSize.height , _cellSize.width
    end
    local function tableCellAtIndex( table, index )
        local cell = table:dequeueCell()
        if cell then
            cell:removeAllChildren()
        else
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        end

        local _di = zc.createImageView({
            src = "res/Main/country/warehouse/warehouse_pop_item_bg.png",
            ap = cc.p(0,0.5),
            pos = cc.p(7, 47),
        })

        cell:addChild(_di)
        self:createOneCell(_di, index)
        return cell
    end
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableView:reloadData()
end

function CountryWarehouseDetailPop:createOneCell( cell, index )
    -- local _cityData = self._citysData[index+1]
    -- if _cityData then
    -- end
    --建筑图标
    local _bg_s = zc.createScale9Sprite({
        size = cc.size(65, 65),
        file = "res/Main/country/warehouse/warehouse_pop_bg_s.png",
        pos = cc.p(40, 40),
    })
    cell:addChild(_bg_s)
    local _houseImg = zc.createImageView({
        src = "res/Main/copy/2.png",
        ap = cc.p(0.5,0.5),
        pos = cc.p(30, 25),
        scale = 0.4,
    })
    _bg_s:addChild(_houseImg)
    local _city_name_label = zc.createLabel({
        text = zc.lang("luoyang"),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(75, 55),
        stroke = true,
    })
    cell:addChild(_city_name_label)
    local _src = zc.getImgByType(self._salary_data.type)
    local _resImg = zc.createImageView({
        src = _src,
        ap = cc.p(0,0.5),
        pos = cc.p(75, 25),
        scale = 0.7,
    })
    cell:addChild(_resImg)
    local _res_num_label = zc.createLabel({
        text = "1000000",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(105, 25),
        stroke = true,
    })
    cell:addChild(_res_num_label)
end


return CountryWarehouseDetailPop