--[[
	猎魂系统
	wangming
	2017.4.12
]]
local HeroSoulRandLayer = class("HeroSoulRandLayer", function()
    return zc.createNormalDialog({
        src = "",
        showFlower = false
    })
end)

function HeroSoulRandLayer:create( params )
	return HeroSoulRandLayer.new( params )
end

function HeroSoulRandLayer:ctor( params )
	self._randSoul = {}
	self._nowPlace = 1
	self._fullFlag = false
	self._soulGroup = {}
	self._times = tonumber(params.times) or 0

	local _bg = zc.createSprite("res/Main/heroSoul/bg2.jpg")
	_bg:setPosition(zc.width*0.5, zc.height*0.5)
	self:addChild(_bg, -1)
	local _x, _y

	local _soulNode = cc.Node:create()
	self:addChild(_soulNode)
	local _scales = {0.95, 0.78, 0.65, 0.57}
	local _poss = {
		cc.p(55, 135),
		cc.p(155, 125),
		cc.p(240, 110),
		cc.p(320, 100),
		cc.p(55, -100),
		cc.p(155, -75),
		cc.p(240, -60),
		cc.p(320, -45),
	}
	local _cellSize = cc.size(108, 192)
	for i=1, 16 do
		local _idx = i <= 8 and i or i - 8
		local __idx = _idx <= 4 and _idx or _idx - 4
		local _leftFlag = i <= 8 and 1 or -1
		_x = i <= 8 and 0 or zc.width

		local _node = cc.Node:create()
		_node:setPosition(_x + _leftFlag*_poss[_idx].x, zc.height*0.5 + _poss[_idx].y + _cellSize.height)
		_soulNode:addChild(_node, 4 - __idx)
		_node:setVisible(false)

		local _sp = zc.createSprite()
		_sp:setContentSize(_cellSize)
		local _di = zc.createPushButton({
			normalNode = _sp,
			pos = cc.p(0, -_cellSize.height),
			scale = _scales[__idx],
			endCallback = function()
				local _db = gameData.getDataFromCacheWithPrimaryKey("heroSoul", self._randSoul[tostring(i)])
				local _sellDb = gameData.getDataFromCacheWithPrimaryKey("heroSoul_Sell", _db.quality)
				if next(_sellDb) == nil then
					self:doGet(i)
				else
					self:doSell(i)
				end
			end,
		})
		_node:addChild(_di, 4 - __idx)
		_node.btn = _di
		self._soulGroup[i] = _node
	end

	local _btnSpine = zc.getSpine("hunji_shangdian")
	_btnSpine:playAction("idle", true)
	_btnSpine:setPosition(zc.width*0.5, 0)
	self:addChild(_btnSpine)

	local _h = 180
	self._lrBtns = {}
	for i=1, 2 do
		local _node = zc.createSprite()
		_node:setContentSize(120, _h)
		local _btn = zc.createPushButton({
	    	normalNode = _node,
	    	noScaleAction = true,
	       	pos = cc.p(zc.width*0.5 - 260 + 550*(i - 1), _h*0.5),
	    	endCallback = function()
	    		if i == 1 then
		    		zc.createHeroSoulShop()
	    		else	    	
	    			zc.createHeroSoul()
	    		end
    		end,
		})
		self:addChild(_btn)
		self._lrBtns[i] = _btn
	end

    local _leftBtn = zc.createPushButton({
    	normalFile = "res/Main/heroSoul/btnSoulFete.png",
    	pos = cc.p(zc.width*0.5 - 80, 110),
    	scale = 0.9,
    	endCallback = function()
	    	if self._fullFlag then
	    		self:doGet()
	    	else
	    		self:doRand(1)
	    	end
    	end
	})
	self:addChild(_leftBtn)
	self._leftBtn = _leftBtn
    local _leftTipSize = cc.size(140, 34)
    local _leftCostDi = zc.getScaleNode("res/Main/role/common/name_bg.png", _leftTipSize)
    _leftCostDi:setPosition(_leftBtn:getPositionX(), 30)
    self:addChild(_leftCostDi)
    local _leftCostIcon = zc.createSprite(zc.getImgByType(zc.dataTypeMoney))
    _leftCostIcon:setPosition(0, _leftTipSize.height*0.5)
    _leftCostDi:addChild(_leftCostIcon)
    local _leftCostNum = zc.createLabel({
    	fontSize = 20,
    	pos = cc.p(_leftTipSize.width*0.5, _leftTipSize.height*0.5),
	})
    _leftCostDi:addChild(_leftCostNum)
    self._leftCostDi = _leftCostDi
    self._leftCostIcon = _leftCostIcon
    self._leftCostNum = _leftCostNum

    local _rightBtn = zc.createPushButton({
    	normalFile = "res/Main/heroSoul/btnOneKeySoulFete.png",
    	pos = cc.p(zc.width*0.5 + 80, 110),
    	scale = 0.9,
    	endCallback = function()
	    	if self._fullFlag then
	    		self:doSell()
	    	else
	    		self:doRand(2)
	    	end
    	end
	})
	self:addChild(_rightBtn)
	self._rightBtn = _rightBtn

	local _middleEffNode = cc.Node:create()
	self:addChild(_middleEffNode)
	self._middleEffNode = _middleEffNode

	zc.getSpine("hunjitexiao")

	self._startRandSoul = params.randSoul
	self._startNowPlace = params.nowPlace
end

function HeroSoulRandLayer:onEnter()
	if not self.haveInit then
		self:freshRandInfo({
			randSoul = self._startRandSoul, 
			nowPlace = self._startNowPlace,
			typeFlag = 0,
			isInit = true
		})
	end
	self.haveInit = true
	self:addGuide()
end

function HeroSoulRandLayer:freshRandInfo( params )
	local _typeFlag = tonumber(params.typeFlag) or 0
	local _randSoul = params.randSoul or {}
	local _tmpF_flag = true
	local _tmpE_flag = true
	local _effIdx = 0
	local _waitTime = 0

	for i = 1, 16 do
		local _soulId = tonumber(_randSoul[tostring(i)]) or 0
		local _oldSoulId = tonumber(self._randSoul[tostring(i)]) or 0
		local _di = self._soulGroup[i].btn

		local _spine = self._soulGroup[i].spine
		self._soulGroup[i]:stopAllActions()
		if _soulId == 0 then
			self._soulGroup[i]:setVisible(false)
			_tmpF_flag = false
			if _spine then
				_spine:removeFromParent()
				self._soulGroup[i].spine = nil
			end
		else
			_tmpE_flag = false
			local _data = gameData.getDataFromCacheWithPrimaryKey("heroSoul", _soulId)
			local _quality = zc.getQualityByQualifications(_data.quality)
			_spine = zc.createHeroSoulSpine({
				par = _di,
				spine = _spine,
				iconId = _data.pictureId,
				pos = cc.p(_di:getContentSize().width*0.5, _di:getContentSize().height*0.5)
			})
			self._soulGroup[i].spine = _spine
			if not params.isInit and _oldSoulId ~= _soulId then
				self._soulGroup[i]:setVisible(false)
				performWithDelay(self._soulGroup[i], function()
					self._soulGroup[i]:setVisible(true)
					local _actName = _quality .. "-1"
		            _spine:playAction(_actName)
		            _spine:registerSpineEventHandler( function ( event )
		                if event.animation == _actName then
		                    _spine:playAction(_quality .. "-2", true)
		                end
		            end, sp.EventType.ANIMATION_COMPLETE)
					local _eff = zc.createSpine({
						fileName = "hundenglong",
						actName = "blood",
						loop = false,
						autoRemove = true,
					})
					_eff:setPosition(_spine:getPosition())
					self._soulGroup[i].btn:addChild(_eff)
					
					if _spine.quality ~= _quality then
						local _iconId = tonumber(_data.pictureId) or 1
						if _iconId ~= -1 then
					        local _slotName = ""
					        for i=1, 11 do
					            _slotName = "zitipifu/zi_" .. i
					            if i == _iconId then
					                _spine:setAttachment(_slotName, _slotName)
					            else
					                _spine:setAttachment(_slotName, "")
					            end
					        end
						end
					end
					_spine.quality = _quality
				end, _effIdx*0.3)
				_effIdx = _effIdx + 1
			else
				if not self._soulGroup[i]:isVisible() then
		            _spine:playAction(_quality .. "-2", true)
		        end
				self._soulGroup[i]:setVisible(true)
				_spine.quality = _quality
			end
		end
	end
	self._randSoul = _randSoul
	_waitTime = _effIdx*0.3

	if not self._fullFlag then
		self._fullFlag = _tmpF_flag
	end
	if _tmpE_flag then
		self._fullFlag = false
	end

	local _oldPlace = self._nowPlace
	local function _doLine( i, flag )
		if i < 5 then
			local _effL = zc.createSpine({
		        fileName = "hunjitexiao",
		        needInit = false,
		        actName = "L" .. i,
		        autoRemove = true,
		        loop = false,
		    })
		    _effL:setPosition(zc.width*0.5, zc.height*0.5)
			self._middleEffNode:addChild(_effL)
			performWithDelay(_effL, flag, 0.08)
		end
	end
	local function _createOne( i )
		if i > 5 then
			return
		end
		local _effL = zc.createSpine({
	        fileName = "hunjitexiao",
	        needInit = false,
	        actName = "D" .. i,
	        loop = true,
	    })
	    _effL:setPosition(zc.width*0.5, zc.height*0.5)
		self._middleEffNode:addChild(_effL)
	end
	local function _normalFresh(idx)
		local _idx = idx or self._nowPlace
		for i=1, _idx do
			_createOne(i)
		end
	end

	local _posBo = {
		{zc.width*0.5 - 132, zc.height*0.5 + 18, 1}, 
		{zc.width*0.5 - 50, zc.height*0.5 - 33, 1}, 
		{zc.width*0.5 + 46, zc.height*0.5 - 5, 1.5}, 
		{zc.width*0.5 + 79, zc.height*0.5 + 107, 2},
		{zc.width*0.5 - 50, zc.height*0.5 + 96, 3},
	}
	local function _playBao( i, callback )
		local _eff = zc.createSpine({
	        fileName = "hunjitexiao",
	        needInit = false,
	        loop = false,
	        autoRemove = true,
	        actName = "FWblood",
	    })
	    _eff:setPosition(_posBo[i][1], _posBo[i][2])
	    _eff:setScale(_posBo[i][3])
		self._middleEffNode:addChild(_eff)
		performWithDelay(_eff, function()
			if callback then
				callback()
			end
		end, 0.25)
	end

	local function _doHeroSoulFly( idx )
		if params.heroSoulFlag then
			local _pos = _posBo[idx] and cc.p(_posBo[idx][1], _posBo[idx][2]) or cc.p(zc.width*0.5, zc.height*0.5)
			local _particle = cc.ParticleSystemQuad:create("res/Main/role/equip/jinjie/jinjie.plist")
			_particle:setPosition(_pos)
			local _topLay = LayerManager.getTopInfoLayer()
			_topLay:addChild(_particle, 1)
		    local _endPos = _topLay:getItemPos(zc.mainTypeResource, zc.dataLightSoul)
			_particle:runAction(cc.Sequence:create(
				cc.MoveTo:create(0.5, _endPos), 
				cc.CallFunc:create(function()
					local __spine = zc.createSpine({
                        fileName = "eff_deng",
                        actName = "deng1",
                        loop = false,
                        needInit = false,
                        autoRemove = true,
                    })
                    __spine:setPosition( _endPos )
                    _topLay:addChild( __spine, 1 )
				end),
				cc.RemoveSelf:create(true)))
		end
	end

	local _onePartTime = 0.6
	if params.nowPlace then
		self._middleEffNode:removeAllChildren()
		local _tmpTime = 0
		self._nowPlace = tonumber(params.nowPlace) or 1
		if _typeFlag == 0 then
			_normalFresh()
		elseif _typeFlag == 1 then
			_doHeroSoulFly(_oldPlace)
			if _oldPlace < self._nowPlace then
				_normalFresh(self._nowPlace - 1)
				_doLine(self._nowPlace - 1, function()
					_playBao(self._nowPlace, function()
						_createOne(self._nowPlace)
					end)
				end)
			else
				_normalFresh()
				_playBao(self._nowPlace)
			end
			_tmpTime = _onePartTime
		elseif _typeFlag == 2 then
			_doHeroSoulFly(0)
			local _doOneByOne
			_doOneByOne = function( i )
				_doLine(i, function()
					_playBao(i + 1, function()
						_createOne(i + 1)
						i = i + 1
						if i == 5 then
							performWithDelay(self, function()
								self._middleEffNode:removeAllChildren()
								_normalFresh()
								_playBao(self._nowPlace)
							end, 0.5)
						else
							_doOneByOne(i)
						end
					end)
				end)
			end
			_playBao(1, function()
				_createOne(1)
				_doOneByOne(1)
			end)
			_tmpTime = _onePartTime*5
		end
		_waitTime = _waitTime < _tmpTime and _tmpTime or _waitTime
	end

	if _typeFlag == 2 then
		getGuideManager():addMaskLayer()
		performWithDelay(self, function()
			getGuideManager():removeMaskLayer()
		end, _waitTime)
	end

	

	if self._fullFlag then
		self._leftBtn:getStateNormal():setTexture("res/Main/heroSoul/BtnOneKeyGether.png")
		self._rightBtn:getStateNormal():setTexture("res/Main/heroSoul/BtnOneKeySell.png")
		self._leftCostDi:setVisible(false)
	else
		self._leftBtn:getStateNormal():setTexture("res/Main/heroSoul/btnSoulFete.png")
		self._rightBtn:getStateNormal():setTexture("res/Main/heroSoul/btnOneKeySoulFete.png")
		self._leftCostDi:setVisible(true)
		if self._times == 0 then
			self._leftCostIcon:setVisible(false)
			self._leftCostNum:setString(zc.lang("free"))
		else
			self._leftCostIcon:setVisible(true)
			local _data = gameData.getDataFromCacheWithPrimaryKey("hunji", self._nowPlace)
			self._leftCostNum:setString(_data.needMoney)
		end
	end
end

function HeroSoulRandLayer:doRand( randType )
	local _cost = tonumber(self._leftCostNum:getString()) or 0
	local _myMoney = zc.getNumByTypeId(zc.mainTypeResource, zc.dataTypeMoney)
	if _myMoney < _cost then
		local _currentGID = getGuideManager():getCurrentGID()
		if _currentGID == GuideKey.KEY_14705 or _currentGID == GuideKey.KEY_14706 then
			getGuideManager():setFuncGuideOver()
		end
		zc.tipInfo(zc.lang("tips_money_deficiency"))
		return
	end
	zc.sendHttp({
        apiName = "HeroSoul_randSoul",
        params = {type=randType},
        successCallback = function( backData )
	        self._times = self._times + 1
    		local _flag = false
        	if backData.clientItems then
        		for k,v in pairs(backData.clientItems) do
        			local _num = tonumber(v.num) or 0
        			if _num > 0 and tonumber(v.type) == zc.mainTypeResource 
        			  and tonumber(v.id) == zc.dataLightSoul then
        				_flag = true
        				break
        			end
        		end
        	end
        	backData.noAnimation = true
        	PlayerData:updataData(backData)
        	self:freshRandInfo({
        		randSoul = backData.randSoul, 
        		nowPlace = backData.nowPlace, 
        		typeFlag = randType, 
        		heroSoulFlag = _flag
        	})
        	local _currentGID = getGuideManager():getCurrentGID()
        	if _currentGID == GuideKey.KEY_14705 or _currentGID == GuideKey.KEY_14706 then
        		zc.setGuideFuncNextStep(_currentGID, false)
        		self:addGuide()
        	end
        end
    })
end

function HeroSoulRandLayer:doGet( idx )
    local _nums = table.nums(PlayerData:getHeroSoul())
	local _haveOne = false
    if idx == 1 then
    	_nums = _nums + 1
    else
    	for i = 1, 16 do
			local _soulId = tonumber(self._randSoul[tostring(i)]) or 0
			if _soulId ~= 0 then
				local _db = gameData.getDataFromCacheWithPrimaryKey("heroSoul", _soulId)
				local _db2 = gameData.getDataFromCacheWithPrimaryKey("heroSoul_Sell", _db.quality)
				if next(_db2) == nil then
					_nums = _nums + 1
					_haveOne = true
				end
			end
		end
    end
    if _nums > 200 then
        local comfirm = ZCConfirmDialog:createWithParams({
            title = zc.lang("prompt"),
            msg = zc.lang("tip_soulbag_is_full_to_tidy"),
            rightText = zc.lang("qianwang"),
            rightCallback = function()
                zc.createHeroSoul()
            end
        })
        self:addChild(comfirm, 11)
        return
    end
	local _type = idx == nil and 2 or 1
	local _index = idx
	if _type == 2 then
		if not _haveOne then
			zc.tipInfo(zc.lang("tip_no_soul_to_gather_fornow"))
			return
		end
	end

	zc.sendHttp({
        apiName = "HeroSoul_getHeroSoul",
        params = {type = _type, index = _index},
        successCallback = function( backData )
        	PlayerData:updataData(backData)
        	local _currentGID = getGuideManager():getCurrentGID()
    		if _currentGID == GuideKey.KEY_14709 then
    			getGuideManager():guideOver()
    		end
        	backData.callback = function()
        		if _currentGID == GuideKey.KEY_14709 then
			    	zc.setGuideFuncNextStep(_currentGID, false)
			    	self:addGuide()
	        	end
        	end
        	zc.createShowReward(backData)
        	self:freshRandInfo({randSoul = backData.randSoul})
        	
        end
    })
end

function HeroSoulRandLayer:doSell( idx )
	local _type = idx == nil and 2 or 1
	local _index = idx
	if _type == 2 then
		local _haveOne = false
		for i = 1, 16 do
			local _soulId = tonumber(self._randSoul[tostring(i)]) or 0
			if _soulId ~= 0 then
				local _db = gameData.getDataFromCacheWithPrimaryKey("heroSoul", _soulId)
				local _db2 = gameData.getDataFromCacheWithPrimaryKey("heroSoul_Sell", _db.quality)
				if next(_db2) ~= nil then
					_haveOne = true
					break
				end
			end
		end
		if not _haveOne then
			zc.tipInfo(zc.lang("tip_no_soul_to_sell_fornow"))
			return
		end
	end
	zc.sendHttp({
        apiName = "HeroSoul_sell",
        params = {type = _type, index = _index},
        successCallback = function( backData )
        	PlayerData:updataData(backData)
        	self:freshRandInfo({randSoul = backData.randSoul})
        	local _currentGID = getGuideManager():getCurrentGID()
        	if _currentGID == GuideKey.KEY_14708 then
		    	zc.setGuideFuncNextStep(_currentGID, false)
		    	self:addGuide()
        	end
        end
    })
end

function HeroSoulRandLayer:addGuide()
	local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14703 then
	    getGuideManager():sendFuncGuideTrigger(47)
    	zc.setGuideFuncNextStep(_currentGID, false)
    	self:addGuide()
    elseif _currentGID == GuideKey.KEY_14704 then
    	local function _callBack()
            getGuideManager():setObjTarget(self._leftBtn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14705 or _currentGID == GuideKey.KEY_14706 then
        getGuideManager():setObjTarget(self._leftBtn)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14707 then
    	local function _callBack()
            getGuideManager():setObjTarget(self._soulGroup[1].btn)
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14709 then
        getGuideManager():setObjTarget(self._soulGroup[2].btn)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14710 then
    	local function _callBack()
            getGuideManager():setObjTarget(self._lrBtns[2])
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14715 then
    	zc.setGuideFuncNextStep(_currentGID, false)
    	self:addGuide()
    else
		local _flag = PlayerData:getFuncGuideInfo(47)
	    if _flag then
	        return
	    end
	    getGuideManager():sendFuncGuideTrigger(47)
    	getGuideManager():setCurrentGID(GuideKey.KEY_14704)
    	self:addGuide()
    end
end

return HeroSoulRandLayer