--[[
	重生预览
	2016.10.17
--]]
local InheritanceRewardPop = class("InheritanceRewardPop", function()
	return ZCPopLayer:create()
end)

function InheritanceRewardPop:create( params )
	return InheritanceRewardPop.new( params )
end

function InheritanceRewardPop:ctor( params )
	self:initData( params )
	self:initUI()
end

function InheritanceRewardPop:initData( params )
    -- 1武将2兵器

	local _objType = tonumber( params.objType ) or 1
    self._objType = _objType
 --    -- 1预览2重生3分解
	local _funType = tonumber( params.funType ) or 1
    self._funType = _funType
 --    -- 回调
    self._callback = params.callback
	-- -- 预览

    local allItems = params.data.items or {} --道具
    if params.data.resources then --资源
        for k,v in pairs(params.data.resources) do
            if v and v.num and tonumber(v.num) > 0 then
                allItems[#allItems+1] = v    
            end    
        end
    end

    local totalReward = {}
    local rewardMap = {}
    for i = 1, table.nums(allItems) do
        local v = params.data.items[i]
        local itemType = tonumber(v["type"])
        local itemId = tonumber(v["id"])
        if itemType and itemType > 0 and itemId and itemId > 0 then
            if not rewardMap[itemType] then
                rewardMap[itemType] = {}
            end
            local typeMap = rewardMap[itemType]
            if itemType ~= 1 and 
                itemType ~= 4 and
                itemType ~= 6 and
                itemType ~= 2 then --个数需要累加的：物资、背包物品、武将(本来是不累加的，扫荡的特殊处理)、玩家经验；个数不累加的现在只有武器、饰品
                typeMap = {}
            end
            if typeMap[itemId] then
                local idx = typeMap[itemId]
                if itemType == 2 then
                    totalReward[idx].changeNum = 1
                else
                    totalReward[idx].changeNum = tonumber(totalReward[idx].changeNum) + tonumber(v["num"])
                end
            else
                local idx = #totalReward + 1
                typeMap[itemId] = idx
                totalReward[idx] = {
                    itemType = v.type,
                    itemId = v.id, 
                    itemId = v.id,
                    changeNum = v.num,
                }
            end
        end
    end
    self._iconList = totalReward

    self._iconPerCell = 4

    local _size = self:getContentSize()
    self._width = _size.width
    self._height = _size.height
end

function InheritanceRewardPop:initUI()
	local _bg =  cc.Sprite:create( "res/Main/common/popBg/popup_Bg_blue.png" )
	_bg:setPosition( self._width/2, self._height/2 )
	self:addContent( _bg )
	local _bgSize = _bg:getContentSize()
	local _bgWidth = _bgSize.width
	local _bgHeight = _bgSize.height
    
    -- common_close_btn_d 
    local _close = zc.createBackButton({
        pos = cc.p( _bgWidth - 20, _bgHeight - 20 ), 
        listener = function() 
            self:hide()
        end,
    })
    _bg:addChild( _close )

    local _titleText = ""
    if self._funType == 3 then
        _titleText = "fenjiehuode"
    else
        _titleText = "chongshenghuode"
    end
    local _title =  zc.getTipPopTitle( _titleText )
    _title:setPosition( _bgWidth/2, _bgHeight - 30 )
    _bg:addChild( _title )

    -- 中间背景
    local _middleBgWidth = 460
    local _middleBgHeight = 250
    local _middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(_middleBgWidth, _middleBgHeight))
    _middleBg:setPosition( _bgWidth/2, _bgHeight/2 + 5 )
    _bg:addChild( _middleBg )

    local _tableview = zc.ZCTableView:create(cc.size(_middleBgWidth, _middleBgHeight))
    _tableview:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableview:setPosition(cc.p(0, 0))
    _tableview:setDelegate()
    _tableview:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local _cellWidth = _middleBgWidth
    local _cellHeight = 120
    local function cellSizeForTable(table, idx) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell(cell, cellIndex, _cellWidth, _cellHeight)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        return math.ceil( #self._iconList/self._iconPerCell )
    end
    _tableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _tableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _tableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _middleBg:addChild( _tableview )
    _tableview:reloadData()
    self._tableview = _tableview

    if self._funType == 1 then
        local _tipText = ""
        if self._objType == 1 then
            _tipText = zc.lang("reborn_solider_to_origin")
        else
            _tipText = zc.lang("reborn_weapon_to_origin")
        end
        local _tip = zc.createLabel({
            text = _tipText,
            fontSize = 25,
            ap = cc.p(0, 0.5),
            pos = cc.p(40, 40),
            outLine = true,
            color = display.COLOR_YELLOW
        })
        _bg:addChild( _tip )
    else
    	local _btn = zc.createCommomBtn({
            tag = 1,
    	    pos = cc.p( _bgWidth/2, 50 ), 
    	    text = zc.lang("confirm2"),
    	    listener = function () 
                if self._callback then
                    self._callback()
                end
                self:hide()
    	    end,
    	})
    	_bg:addChild( _btn )
    end
end
function InheritanceRewardPop:buildCell(cell, cellIndex, cellWidth, cellHeight)
    cell._item = {}
    cell._name = {}
    local _side = 0
    local _width = ( cellWidth - _side*2 )/self._iconPerCell
    for i = 1, self._iconPerCell do
        local _posX = _side + ( i - 0.5 )*_width
        local _item = zc.createIconByData({
            data = {
                mainType=zc.mainTypeSoldier,
                type=1, 
                id=1,
                quality=1,
            }, 
            pos = cc.p( _posX, cellHeight/2 + 6 ), 
        })
        _item:setScale(0.75)
        cell:addChild( _item )
        cell._item[i] = _item
        local _name =  zc.createLabel({
            text = "",
            fontSize = 18,
            pos = cc.p( _posX, 10 ),
            color = cc.c3b( 106, 47, 0 ),
        })
        cell:addChild( _name )
        cell._name[i] = _name
    end
end
function InheritanceRewardPop:updateCell(cell, cellIndex)
    for i = 1, self._iconPerCell do
        local _index =  cellIndex*self._iconPerCell + i
        local _data = self._iconList[_index]
        if _data then
            local _info = zc.updateIconByData(cell._item[i], {
                data = {
                    mainType = _data.itemType,
                    type = _data.itemId, 
                    id = _data.itemId,
                    num = _data.changeNum,
                },
                showDetailPop = true,
            })
            cell._item[i]:setVisible(true)
            cell._name[i]:setText( _info.name )
            cell._name[i]:setVisible(true)
        else
            cell._item[i]:setVisible( false )
            cell._name[i]:setVisible( false )
        end
    end
end

return InheritanceRewardPop