--[[
	我要变强
	唐实聪
	2016.8.30
]]
local StrongerLayer = class("StrongerLayer", function()
	return zc.createNormalDialog()
end)

function StrongerLayer:create( params )
	return self.new( params )
end

function StrongerLayer:ctor( params )
	-- dump(params,"params")
	self:initData()
	self:initUI()

	self:refreshStatus( params )
end

function StrongerLayer:initData()
	self._data = {{}}

	local _upHero = PlayerData:getNowFormationFiles()
	local _formationInfo = PlayerData:getFormationsInfo() or {}
    for i, v in pairs( _formationInfo ) do
        if v.status == 1 then
            for j = 1, 9 do
                local _id = tonumber( v["location"..j] ) or 0
                if _id ~= 0 then
                    _upHero[_id] = true
                end
            end
        end
    end

    local _mainHeroId = tonumber( PlayerData.info.heroId ) or 0
	local _mainHeroList = {}
	local _upHeroList = {}
	local _downHeroList = {}
	local _allHeroList = {}
	local _heroList = PlayerData:getGeneralInfo()
	for i, v in ipairs( _heroList ) do
		local _id = tonumber( v.id ) or 0
		if _id == _mainHeroId then
			-- 主角
			_mainHeroList[#_mainHeroList + 1] = v
			_allHeroList[#_allHeroList + 1] = v
		elseif _upHero[_id] then
			-- 武将
			_upHeroList[#_upHeroList + 1] = v
			_allHeroList[#_allHeroList + 1] = v
		else
			-- 未上阵武将
			_downHeroList[#_downHeroList + 1] = v
		end
	end
	self._mainHeroList = _mainHeroList
	self._upHeroList = _upHeroList
	self._allHeroList = _allHeroList

	-- 没有上阵武将，查找未上阵武将，跳转用
	table.sort(_downHeroList, function( a, b )
        local _qlft_a = tonumber( a.qualifications ) or 0
        local _qlft_b = tonumber( b.qualifications ) or 0
        if _qlft_a ~= _qlft_b then
            return _qlft_a > _qlft_b
        else
            return tonumber( a.fighting ) > tonumber( b.fighting )
        end
    end)
    self._downHeroList = _downHeroList

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end

function StrongerLayer:initUI()
	-- 通用背景
    local _commonBg = cc.Sprite:create( "res/Main/common/common_bg.jpg" )
    _commonBg:setPosition( self._width/2, self._height/2 )
    self:addChild( _commonBg )
    zc.setBgSize( _commonBg )

    local _bgSp = zc.createNormalPop({
    	tag = 2,
    	height = 570,
    	src = "res/Main/stronger/bg.jpg",
	})
	_bgSp:setPosition( self._width/2, self._height/2 )
	self:addChild( _bgSp )
    _bgSp:setScaleX( 690/_bgSp:getBoundingBox().width )
	local _bgSize = _bgSp:getBoundingBox()
	local _bgWidth = _bgSize.width
	local _bgHeight = _bgSize.height
	local _bg = cc.Sprite:create()
	_bg:setContentSize( _bgWidth, _bgHeight )
	_bg:setPosition( _bgSp:getPosition() )
	self:addChild( _bg )

	-- tableview
    local _cellWidth = _bgWidth
    local _cellHeight = 158
	local _tableview = zc.ZCTableView:create( cc.size( _cellWidth, _cellHeight*3 ) )
	_tableview:setDelegate()
	_tableview:setBounceable( false )
	_tableview:setInertia( true )
	_tableview:setPosition( 0, 10 )
    _tableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    _tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local function cellSizeForTable(table, index) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, index)
        local _cell = table:dequeueCell()
        -- 创建模板
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
        end
        _cell:removeAllChildren()
        self:buildCell( _cell, index + 1, _cellWidth, _cellHeight )

        return _cell
    end
    local function numberOfCellsInTableView()
    	return #self._data
    end
    _tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
	_bg:addChild( _tableview )
	self._tableview = _tableview

	local _title = cc.Sprite:create( "res/Main/stronger/title.png" )
	_title:setPosition( 120, _bgHeight - 23 )
	_bg:addChild( _title, 6 )
end

function StrongerLayer:buildCell( cell, index, cellWidth, cellHeight )
	local _type = index
    local _cellBg = cc.Sprite:create( "res/Main/stronger/cellBg_".._type..".png" )
    _cellBg:setPosition( cellWidth/2, cellHeight/2 )
    cell:addChild( _cellBg )
    local _cellBgSize = _cellBg:getContentSize()
    local _cellBgWidth = _cellBgSize.width
    local _cellBgHeight = _cellBgSize.height

    local _cellTitle = cc.Sprite:create( "res/Main/stronger/cellTitle_".._type..".png" )
    _cellTitle:setAnchorPoint( 0, 0.5 )
    _cellTitle:setPosition( 0, _cellBgHeight/2 )
    _cellBg:addChild( _cellTitle )

    local _tableview = zc.ZCTableView:create( cc.size( _cellBgWidth - 60, _cellBgHeight ) )
	_tableview:setDelegate()
	_tableview:setBounceable( true )
	_tableview:setInertia( true )
	_tableview:setPosition( 60, 0 )
    _tableview:setDirection( cc.SCROLLVIEW_DIRECTION_HORIZONTAL )
    _tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local _cellWidth = 108
    local _cellHeight = _cellBgHeight
    local function cellSizeForTable(table, index) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, index)
        local _cell = table:dequeueCell()
        -- 创建模板
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
            local _iconBg = cc.Sprite:create( "res/Main/stronger/iconBg.png" )
            _cell._iconBg = _iconBg
            local _iconBgSize = _iconBg:getContentSize()
            local _iconBgWidth = _iconBgSize.width
            local _iconBgHeight = _iconBgSize.height
            local _icon = cc.Sprite:create()
            _icon:setScale( 0.5 )
            _icon:setPosition( _iconBgWidth/2, _iconBgHeight/2 + 10 )
            _iconBg:addChild( _icon )
            _cell._icon = _icon
            local _name = zc.createLabel({
            	fontSize = 20,
            	color = cc.c3b( 230, 224, 163 ),
            	pos = cc.p( _iconBgWidth/2, 22 ),
        	})
        	_iconBg:addChild( _name )
            _cell._name = _name
            local _arrow = cc.Sprite:create( "res/Main/stronger/arrow.png" )
            _arrow:setPosition( _iconBgWidth - 30, 55 )
            _iconBg:addChild( _arrow )
            _cell._arrow = _arrow

            local _btn = zc.createPushButton({
            	normalNode = _iconBg,
            	pos = cc.p( _cellWidth/2, _cellHeight/2 ),
            	needSwallow = false,
            	needEnableWhenMoving = true,
            	endCallback = function()
            		self:clickIcon( _cell._type, _cell._functionId, _cell._params )
            	end
        	})
        	_cell:addChild( _btn )
        end

        local _data = self._data[_type][index + 1]
        if _data then
        	_cell._type = _type
        	_cell._functionId = _data.functionId
        	_cell._params = _data.params
        	_cell._iconBg:setVisible( true )
        	_cell._icon:setTexture( "res/Main/common/common_icon_".._data.icon..".png" )
        	_cell._name:setText( _data.content )
        	if _data.status then
        		_cell._arrow:setVisible( true )
        		_cell._arrow:stopAllActions()
        		_cell._arrow:runAction(
	            	cc.RepeatForever:create(
	            		cc.Sequence:create(
	            			cc.FadeTo:create( 1, 0 ),
	            			cc.FadeTo:create( 1, 255 )
	        			)
	        		)
	        	)
        	else
        		_cell._arrow:setVisible( false )
        	end
        else
        	_cell._iconBg:setVisible( false )
        end

        return _cell
    end
    local function numberOfCellsInTableView()
    	return #self._data[_type]
    end
    _tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
	cell:addChild( _tableview )
	_tableview:reloadData()
end

function StrongerLayer:buildFunction()
	local _data = {}
	local _list = gameData.getDataFromCache("functions")
	for _id, _functionData in pairs( _list ) do
		local _show = tonumber( _functionData.show ) or 0
		if _show == 1 then
			-- 显示
			local _functionId = tonumber( _functionData.functionId ) or 0
			if zc.getFunctionStatus( _functionId, false ) then
				local _types = string.split( tostring( _functionData.type ), "|" )
				for i, _type in ipairs( _types ) do
					_type = tonumber( _type ) or 0
					if _type ~= 0 then
						_data[_type] = _data[_type] or {}
						local _index = #_data[_type] + 1
						local _status, _params = self:buildStatus( _type, _functionId )
						local __data = clone( _functionData )
						__data.status = _status
						__data.params = _params
						_data[_type][_index] = __data
					end
				end
				
			end
		end
	end
	for i, v in ipairs( _data ) do
		table.sort(v, function( a, b )
			return tonumber( a.userLevel ) < tonumber( b.userLevel )
		end)
	end
	self._data = _data
end
function StrongerLayer:buildStatus( _type, _functionId )
	local _status = false
	local _params = nil
	if _functionId == 4 then
		-- 阵法升级
		_status = PlayerData:getFormationRedState()
	elseif _functionId == 7 then
		-- 神兵强化
		_status = PlayerData:getGodWeaponRedDotState()
	elseif _functionId == 10 then
		-- 洗练饰品
		_status = zc.getTrinketRedDotStatus()
	elseif _functionId == 12 then
		-- 兵器谱
		_status = PlayerData:getSmithBookRedDotState()
	elseif _functionId == 13 then
		-- 培养
		local _heroList = { self._mainHeroList, self._upHeroList }
		local _heroId = 0
		local _choice = 0
		_status, _heroId, _choice = zc.getCultureRedDotStatus( _heroList[_type] )
		if _status then
			_params = {id = _heroId, choice = _choice}
		else
			local _heroData = _heroList[_type][1] or self._downHeroList[1] or {}
			_heroId = _heroData.id
			_params = {id = _heroId, choice = 1}
		end
	elseif _functionId == 14 then
		-- 升星
		local _heroId = 0
		_status, _heroId = zc.getStarupRedDotStatus( self._allHeroList )
		if _status then
			_params = {id = _heroId}
		else
			_heroId = self._mainHeroList[1] or {}
			_heroId = _heroId.id
			_params = {id = _heroId}
		end
	elseif _functionId == 18 then
		-- 羁绊
		local _heroId = 0
		_status, _heroId = zc.getFetterRedDotStatus( self._upHeroList )
		if _status then
			_params = {id = _heroId}
		else
			local _heroData = self._upHeroList[1] or self._downHeroList[1] or {}
			_heroId = _heroData.id
			_params = {id = _heroId}
		end
	elseif _functionId == 20 then
		-- 兵书
	elseif _functionId == 21 then
		-- 主角命格
		_status = tonumber(PlayerData:getTalentCanDo(self)) or 0
		_status = _status > 0
	elseif _functionId == 25 then
		-- 群雄
		_status = PlayerData:getResourcesInfo().captainEnergy
		_status = _status > 0
	elseif _functionId == 26 then
		-- 好友度
		local _index = 1
		_status, _index = false
		_params = {index = _index}
	elseif _functionId == 27 then
		-- 校场
		_status = zc.getDrillFieldStrongerStatus( self._upHeroList )
	elseif _functionId == 29 then
		-- 武器洗练
		_status = PlayerData:checkCanClearWeapons()
	elseif _functionId == 34 then
		-- 装备进阶
		local _heroList = { self._mainHeroList, self._upHeroList }
		local _heroId = 0
		local _position = 0
		_status, _heroId, _position = zc.getEquipRedDotStatus( _heroList[_type], 2 )
		if _status then
			_params = {id = _heroId, position = _position}
		else
			local _heroData = _heroList[_type][1] or self._downHeroList[1] or {}
			_heroId = _heroData.id
			_params = {id = _heroId, position = 1}
		end
	elseif _functionId == 35 then
		-- 熟练度
		_status = PlayerData:getSmithPracticeRedDotState()
	elseif _functionId == 36 then
		-- 装备强化
		local _heroList = { self._mainHeroList, self._upHeroList }
		local _heroId = 0
		local _position = 0
		_status, _heroId, _position = zc.getEquipRedDotStatus( _heroList[_type], 1 )
		if _status then
			_params = {id = _heroId, position = _position}
		else
			local _heroData = _heroList[_type][1] or self._downHeroList[1] or {}
			_heroId = _heroData.id
			_params = {id = _heroId, position = 1}
		end
	elseif _functionId == 37 then
		-- 勾玉
		local _heroId = 0
		local _objId = 0
		local _isWeapon = true
		_status, _heroId, _objId, _isWeapon = zc.getGemSetRedDotStatusByHero( self._allHeroList )
		if _status then
			_params = {id = _heroId, objId = _objId, isWeapon = _isWeapon}
		else
			_heroId = self._mainHeroList[1] or {}
			_heroId = _heroId.id
			_params = {id = _heroId, objId = 0, isWeapon = true}
		end
	elseif _functionId == 43 then
		local _heroId = 0
		for k,v in pairs(self._mainHeroList) do
			_status = PlayerData:canBreaktrough(v)
			if _status then
				_heroId = v.id
				break
			end
		end
		if not _status then
			for k,v in pairs(self._upHeroList) do
				_status = PlayerData:canBreaktrough(v)
				if _status then
					_heroId = v.id
					break
				end
			end
		end
		if _heroId ~= 0 then
			_params = {id = _heroId}
		end
	end

	return _status, _params
end
function StrongerLayer:refreshStatus( params )
	self._params = params
	self:buildFunction()

	self._tableview:reloadData()
end
function StrongerLayer:clickIcon( type, functionId, params )
	local _type = tonumber(type) or 0
	local _functionId = tonumber(functionId) or 0
	zc.gotoFunction( _functionId, params, false )
end


return StrongerLayer
