--[[
FileName 		MultiCopyRewardPop.lua
ProjectName		HJ2

Created by wangming on 16-07-13
    -- 
]]

local MultiCopyRewardPop = class( "MultiCopyRewardPop", function ()
    return ZCPopLayer:create()
end)


function MultiCopyRewardPop:create( params )
	local _pop = MultiCopyRewardPop.new(params)
	_pop:show()
	return _pop
end
function MultiCopyRewardPop:onCleanup()
    if self._callback then
        self._callback()
    end
end
function MultiCopyRewardPop:ctor(params)
	local _reward = params.reward or {}
    self._callback = params.callback

    local _tb = {}
    for k,v in pairs(_reward) do
        local reData = gameData.getDataFromCacheWithPrimaryKey("drop_award", v)
        local _flag = true
        for i=1, #_tb do 
            if _tb[i].itemId == reData.itemId and _tb[i].itemType == reData.itemType then
                _flag = false
                break
            end
        end
        if _flag then
            _tb[#_tb + 1] = {
                    itemId = reData.itemId,
                    itemType = reData.itemType,
                }
        end
    end
    _reward = zc.getActivity17AddInfo(4, _tb)
	local popBg = zc.createSprite("res/Main/wushenTower/pop_reward.png")
    popBg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(popBg)

    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    local tableSize = cc.size(435, 245)
    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(popBg:getContentSize().width*0.5, popBg:getContentSize().height*0.5 - 10)
    popBg:addChild(myTableBg)

    tableSize = cc.size(tableSize.width-4, tableSize.height-4)
    local myTable = zc.ZCTableView:create(tableSize)
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    myTableBg:addChild(myTable)
    
    local _hang = 4
    local _countNum,_left = math.modf(#_reward/_hang)
    if _left > 0 then
        _countNum = _countNum + 1
    end
    local _cellSize = cc.size(tableSize.width, 100)
    local function cellSizeForTable(table,idx)
        return _cellSize.height, _cellSize.width
    end
    local function numberOfCellsInTableView(table)
        return _countNum
    end
    local function tableCellAtIndex(table,idx)
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width-4, 92))
        else
            cell:removeAllChildren()
        end

        xpcall(function()
            for i = 1, _hang do
                local _idx = idx*_hang + i
                local item = zc.createIconByData({
                    data = {
                        mainType = _reward[_idx]["itemType"],
                        type = _reward[_idx]["itemId"], 
                        id = _reward[_idx]["itemId"],
                        quality = 1,
                    }, 
                    showDetailPop = true,
                    pos = cc.p(50 + 110*(i-1), _cellSize.height*0.5), 
                })
                item:setScale(0.8)
                cell:addChild(item)
            end
        end, function() end)
    
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:reloadData()

    local _label = zc.createLabel({
        text = zc.lang("possible_to_get_rewards"),
        size = 20,
        color = cc.c3b(43, 26, 6),
        pos = cc.p(popBg:getContentSize().width*0.5, popBg:getContentSize().height - 75),
    })
    popBg:addChild(_label)
end

return MultiCopyRewardPop