--[[
    FileName: NoticePop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local NoticePop = class( "NoticePop", function ()
    return ZCPopLayer:create()
end)
function NoticePop:create(params)
    return NoticePop.new(params)
end
function NoticePop:ctor(params)
    self._callBack = params and params.callBack or nil
    self._containerLayer:setTouchEndedCallback(function() end)

    self:initUI()
    self:show(false)
end

function NoticePop:initUI()
    local popBg = cc.Sprite:create("res/Main/notice/notice.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    local popSize = popBg:getContentSize()
    self._popBg = popBg

    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10-30),
        listener = function () 
            self:removeFromParentAndCleanup(true)
        end,
    })
    popBg:addChild(close, 2)

    local close = zc.createCommomBtn({
        tag =1,
        text = zc.lang("known"),
        needSwallow = false,
        endCallback = function()
            self:removeFromParentAndCleanup(true)
        end,
        pos = cc.p(popSize.width/2, 45),
    })
    popBg:addChild(close)

    self:initTableView()
    
    local _diW, _diH = 580, 360
    local _di = ccui.Scale9Sprite:create(cc.rect(20, 21, 9, 8), "res/Main/notice/diPop.png")
    _di:setAnchorPoint(1, 0)
    _di:setContentSize(_diW, _diH)
    _di:setPosition(popSize.width - 20, 90)
    popBg:addChild(_di)


    if ZC_targetPlatform ~= cc.PLATFORM_OS_MAC then
        local _bianW = 25
        local _bianH = 10
        local view = ccexp.WebView:create()
        view:setContentSize(_diW - _bianW*2, _diH - _bianH*2)
        view:setAnchorPoint(0, 0)
        view:setPosition(_bianW, _bianH)
        view:setScalesPageToFit(false)
        self._view = view
        _di:addChild(view)
    end

    -- self:initInfomation()
end

function NoticePop:initTableView()
    local _viewSize = cc.size(270, 366)
    local tabTableview = zc.ZCTableView:create(_viewSize)
    tabTableview:setBounceable(true)
    tabTableview:setInertia(true)
    tabTableview:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tabTableview:setPosition(cc.p(28, 85))
    tabTableview:setDelegate()
    tabTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN)

    local _cellH = 115
    local function cellSizeForTable(table, index) 
        return _cellH, _viewSize.width
    end
    local function numberOfCellsInTableView()
        return table.nums(self._contentsTable)
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_viewSize.width, _cellH)

            local _btn = zc.createPushButton({
                normalFile = "res/Main/notice/btn_u.png",
                selectedFile = "res/Main/notice/btn_d.png",
                anchor = cc.p(0.5, 0),
                pos = cc.p(_viewSize.width*0.5, 5),
                needEnableWhenMoving = true,
                needSwallow = false,
                endCallback = function() end,
            })
            cell:addChild(_btn)
            cell._btn = _btn

            local _typeSp = zc.createSprite()
            _typeSp:setPosition(45, 55)
            _btn:addChild(_typeSp, 2)
            cell._typeSp = _typeSp

            local _labelTagSp = zc.getSpine("huodong_new")
            _labelTagSp:setPosition(230, 90)
            _btn:addChild(_labelTagSp, 2)
            cell._labelTagSp = _labelTagSp

            local _normalStatus = _btn:getStateNormal()
            local _selectedStatus = _btn:getStateSelected()

            local _normalLab = zc.createLabel({
                fontSize = 30,
                color = cc.c3b(225, 227, 114),
                outLine = true,
                pixel = 2,
                color2 = cc.c3b(4, 4, 4),
                pos = cc.p(165, 52),
            })
            _normalStatus:addChild(_normalLab)
            cell._normalLab = _normalLab
            local _selectedLab = zc.createLabel({
                fontSize = 30,
                color = cc.c3b(63, 31, 16),
                -- outLine = true,
                -- color2 = cc.c3b(216, 181, 181),
                pos = cc.p(165, 52),
            })
            _selectedStatus:addChild(_selectedLab)
            cell._selectedLab = _selectedLab
        end
        local _btn = cell._btn
        _btn:setScale(1.0)
        if self._nowIdx == index then
            _btn:setSelected(true)
            _btn:setEnable(false)
        else
            _btn:setSelected(false)
            _btn:setEnable(true)
        end
        local _typeSp = cell._typeSp
        local _normalLab = cell._normalLab
        local _selectedLab = cell._selectedLab
        local _labelTagSp = cell._labelTagSp

        local _index = index + 1
        local _data = self._contentsTable[_index]
        if _data then
            _normalLab:setVisible(true)
            _selectedLab:setVisible(true)
            _typeSp:setVisible(true)

            _normalLab:setString(_data.title)
            _selectedLab:setString(_data.title)
            local _type = tonumber(_data.type) or 1
            _typeSp:setTexture("res/Main/notice/type" .. _type .. ".png")
            local _tag = tonumber(_data.labelType) or 0
            if _tag == 0 then
                _labelTagSp:setVisible(false)
            else
                _labelTagSp:setVisible(true)
                local _actName = _tag == 1 and "new" or "hot"
                _labelTagSp:playAction(_actName, true)
            end
        else
            _normalLab:setVisible(false)
            _selectedLab:setVisible(false)
            _typeSp:setVisible(false)
            _labelTagSp:setVisible(false)
        end
        _btn:setTouchEndedCall(function()
            self:selectedIndex(index)
        end)

        return cell
    end
    tabTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tabTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    tabTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    self._popBg:addChild(tabTableview, 1)
    self._tabTableview = tabTableview
end

function NoticePop:selectedIndex( idx )
    local _data = self._contentsTable[idx + 1]
    if not _data then
        return
    end
    if self._nowIdx then
        local _cell = self._tabTableview:cellAtIndex(self._nowIdx)
        if _cell then
            _cell._btn:setSelected(false)
            _cell._btn:setEnable(true)
        end
    end
    self._nowIdx = idx
    local _cell = self._tabTableview:cellAtIndex(self._nowIdx)
    if _cell then
        _cell._btn:setSelected(true)
        _cell._btn:setEnable(false)
    end

    if not self._view then
        return
    end
    local wordSize = 1
    if ZC_targetPlatform == cc.PLATFORM_OS_IPAD then
        wordSize = 3
    end
    local contents = _data.content or ""

    local string = "<p><font size="..wordSize..">"..contents.."</font></p>"
    local baseurl = "" -- 本地地址路径，可以不填写
    self._view:loadHTMLString(string, baseurl)--加载页面
end

function NoticePop:onEnter()
    local contents, contentsTable = zc.getAnnouncement()
    if contents == "" then
        return
    end
    self._contentsTable = contentsTable or {}
    self._tabTableview:reloadData()
    
    self:selectedIndex(0)
end

function NoticePop:onCleanup()
    -- print("onCleanup ====")
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/notice/notice.png")
    textureCache:removeTextureForKey("res/Main/notice/btn_u.png")
    textureCache:removeTextureForKey("res/Main/notice/btn_d.png")
    textureCache:removeTextureForKey("res/Main/notice/diPop.png")
    textureCache:removeTextureForKey("res/Main/notice/type1.png")
    textureCache:removeTextureForKey("res/Main/notice/type2.png")
    if self._callBack then
        self._callBack()
    end
end

return NoticePop