--[[
	武将宝石镶嵌弹窗
	唐实聪
	2016.9.29
]]
local RoleGemSetPop = class("RoleGemSetPop", function()
	return ZCPopLayer:create()
end)

function RoleGemSetPop:create( params )
	return RoleGemSetPop.new( params )
end

function RoleGemSetPop:ctor( params )
	self:initData( params )
	self:initUI()
	self:refreshListLayer()
	self:refreshInfoLayer()
	self:show(false)
end

-- 处理数据
function RoleGemSetPop:initData( params )
    self._params = params.data

	self._gemIndex = 1

	self._cellIconNum = 5
	self._gemList = {}

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end
-- 初始化界面
function RoleGemSetPop:initUI()
	self:initInfoLayer()
	self:initListLayer()
end

-- 创建信息弹窗
function RoleGemSetPop:initInfoLayer()
	-- 背景
	local _bgWidth = 384
	local _bgHeight = 569 + 31
    local _bg = zc.createNormalPop({
        tag = 1,
        titleTag = 1,
        height = _bgHeight,
        showSide = false,
    })
	_bg:setPosition( self._width/2 - _bgWidth/2 - 60, self._height/2 )
	self:addContent( _bg )
	self._infoLayer = _bg
	-- 吞噬cellbtn的点击事件层
	local _swallow = zc.createPushButton({
		touchSize = cc.size( _bgWidth, _bgHeight ),
		pos = cc.p( _bgWidth/2, _bgHeight/2 ),
		needSwallow = true,
	})
	_bg:addChild( _swallow )

	-- 顶部
	local _topBgWidth = _bgWidth - 36
	local _topBgHeight = 130 + 15
    local _topBg = zc.createGeneralPopScale({
        width = _topBgWidth,
        height = _topBgHeight,
    })
	_topBg:setPosition( _bgWidth/2 - 8, _bgHeight - 152 )
	_bg:addChild( _topBg, 1 )
    -- 背景
    local _iconBg = cc.Sprite:create( "res/Main/common/popBg/bgFlower.png" )
    _iconBg:setPosition( 70, _topBgHeight*0.5 )
    _iconBg:setScale( 0.7 )
    _topBg:addChild( _iconBg )
	local _gemIcon = zc.createIconByData({
        data = {
            mainType = zc.mainTypeWeapon,
            type = 1,
            id = 1,
            quality = 1,
        },
        ap = cc.p( 0, 0 ),
        pos = cc.p( 53, 53 ), 
    })
	_gemIcon:setPosition( _iconBg:getPosition() )
	_gemIcon:setScale( 0.8 )
	_topBg:addChild( _gemIcon )
	_bg._gemIcon = _gemIcon

	-- 名字背景
    local _nameBg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 163, 8 ), "res/Main/common/popBg/di_properties.png" )
	_nameBg:setPosition( 240, _topBgHeight*0.5 + 20 )
	_topBg:addChild( _nameBg )
    -- 名字
    local _name = zc.createLabel({
        fontSize = 20,
        ttf = zc.getFont( 1 ),
        pos = cc.p( _nameBg:getContentSize().width/2, _nameBg:getContentSize().height/2 ),
        outLine = true,
        pixel = 1.5,
    })
    _nameBg:addChild( _name )
    _bg._name = _name
    -- 需求等级背景
    local _needLevelBg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 163, 8 ), "res/Main/common/popBg/di_properties.png" )
    _needLevelBg:setPosition( 240, _topBgHeight*0.5 - 20 )
    _topBg:addChild( _needLevelBg )
    -- 需求等级
    local _needLevel = zc.createLabel({
        fontSize = 20,
        ttf = zc.getFont( 1 ),
        pos = cc.p( _needLevelBg:getContentSize().width/2, _needLevelBg:getContentSize().height/2 ),
        outLine = true,
        pixel = 1.5,
    })
    _needLevelBg:addChild( _needLevel )
    _bg._needLevel = _needLevel

    -- 底部
	local _bottomBgWidth = _bgWidth - 36
	_bg._bottomBgWidth = _bottomBgWidth
	local _bottomBgHeight = 354
	local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        width = _bottomBgWidth,
        height = _bottomBgHeight,
    })
	_bottomBg:setAnchorPoint( 0.5, 0 )
	_bottomBg:setPosition( _bgWidth/2 - 8, 15 )
	_bg:addChild( _bottomBg )

	-- 属性背景
	local _attrBgWidth = _bottomBgWidth - 18
	local _attrBgHeight = 275
	_bg._attrBgHeight = _attrBgHeight
	local _attrBg = zc.createGeneralPopScale({
        tag = 2,
        width = _attrBgWidth,
        height = _attrBgHeight,
    })
	_attrBg:setAnchorPoint( 0.5, 1 )
	_attrBg:setPosition( _bottomBgWidth/2, _bottomBgHeight - 10 )
	_bottomBg:addChild( _attrBg )

	-- 属性标题
	local _attrScrollview = zc.createScrollview({
	    pos = cc.p( 0, 0 ),
	    size = cc.size( _attrBgWidth, _attrBgHeight ),
	    touchEnable = true,
	    dir = ccui.ScrollViewDir.vertical,
	})
	_attrBg:addChild( _attrScrollview )
	_bg._attrScrollview = _attrScrollview
    local _titlePosY = { 253, 161, 83 }
	for i = 1, 3 do
	    local _attrTitle = cc.Sprite:create( "res/Main/role/gem/title_1_"..i..".png" )
	    _attrTitle:setPosition( _attrBgWidth/2, _titlePosY[i] )
	    _attrScrollview:addChild( _attrTitle )
        local _attrTitleLeft = cc.Sprite:create( "res/Main/common/lace.png" )
        _attrTitleLeft:setAnchorPoint( 1, 0.5 )
        _attrTitleLeft:setPosition( _attrBgWidth/2 - 55, _titlePosY[i] )
        _attrScrollview:addChild( _attrTitleLeft )
        local _attrTitleRight = cc.Sprite:create( "res/Main/common/lace.png" )
        _attrTitleRight:setAnchorPoint( 0, 0.5 )
        _attrTitleRight:setPosition( _attrBgWidth/2 + 55, _titlePosY[i] )
        _attrTitleRight:setFlippedX( true )
        _attrScrollview:addChild( _attrTitleRight )
    end
    -- 进度条
    local _progressBg = ccui.Scale9Sprite:create(cc.rect(9, 0, 1, 26 ), "res/Main/smithy/practice/progressBg.png")
    _progressBg:setContentSize( 280, 30 )
    _progressBg:setPosition( _attrBgWidth/2, 207 )
    _attrScrollview:addChild( _progressBg )
    -- 模板
    local _stencil = ccui.Scale9Sprite:create(cc.rect(9, 0, 1, 26 ), "res/Main/smithy/practice/progressBg.png")
    _stencil:setContentSize( 280, 30 )
    _stencil:setAnchorPoint( 0, 0 )
    -- 
    local _progress = ccui.Scale9Sprite:create(cc.rect(3, 0, 1, 23 ), "res/Main/smithy/practice/progress.png")
    _progress:setContentSize( 280, 30 )
    _progress:setAnchorPoint( 1, 0 )
    _progress:setPosition( 0, -2 )
    -- _clippingNode
    local _clippingNode = cc.ClippingNode:create()
    _clippingNode:setStencil( _stencil )
    _clippingNode:addChild( _progress )
    _clippingNode:setInverted( false )
    _clippingNode:setAlphaThreshold( 0 )
    _progressBg:addChild( _clippingNode )
    _bg._progress = _progress
    -- 经验值
    local _expNum = zc.createLabel({
        fontSize = 18,
        color = zc.COLOR_YELLOW,
        pos = cc.p( _progressBg:getContentSize().width/2, _progressBg:getContentSize().height/2 ),
        outLine = true,
    })
    _progressBg:addChild( _expNum )
    _bg._expNum = _expNum
	_bg._attrLabel = {}
	do
        -- 属性
        local _attrText = zc.createLabel({
            fontSize = 18,
            color = cc.c3b( 203, 183, 123 ),
            ttf = zc.getFont( 1 ),
            pos = cc.p( 25, 127 ),
            outLine = true,
        })
        _attrText:setAnchorPoint( 0, 0.5 )
        _attrBg:addChild( _attrText )
        -- 属性值
        local _attrNum = zc.createLabel({
            fontSize = 18,
            ttf = zc.getFont( 1 ),
            pos = cc.p( 100, 127 ),
            outLine = true,
        })
        _attrNum:setAnchorPoint( 0, 0.5 )
        _attrBg:addChild( _attrNum )

        _bg._attrLabel[1] = {
            _attrText = _attrText,
            _attrNum = _attrNum,
        }
	end
	do
        -- 属性
        local _attrText = zc.createLabel({
            fontSize = 18,
            color = cc.c3b( 203, 183, 123 ),
            ttf = zc.getFont( 1 ),
            pos = cc.p( 25, 44 ),
            outLine = true,
        })
        _attrText:setAnchorPoint( 0, 0.5 )
        _attrBg:addChild( _attrText )
        -- 属性值
        local _attrNum = zc.createLabel({
            fontSize = 18,
            ttf = zc.getFont( 1 ),
            pos = cc.p( 100, 44 ),
            outLine = true,
        })
        _attrNum:setAnchorPoint( 0, 0.5 )
        _attrBg:addChild( _attrNum )
        -- 增加数字
        local _attrAddNum = zc.createLabel({
            fontSize = 18,
            color = zc.COLOR_GREEN,
            ttf = zc.getFont( 1 ),
            pos = cc.p( 220, 44 ),
            outLine = true,
        })
        _attrAddNum:setAnchorPoint( 1, 0.5 )
        _attrBg:addChild( _attrAddNum )
        -- 箭头
        local _arrow = cc.Sprite:create( "res/Main/common/arrow_green.png" )
        _arrow:setPosition( 270, 44 )
        _arrow:setRotation( -90 )
        _attrBg:addChild( _arrow )

        local _max = zc.createLabel({
            text = zc.lang("already_max_level_gem"),
            fontSize = 18,
            color = zc.COLOR_RED,
            ttf = zc.getFont( 1 ),
            pos = cc.p( _attrBgWidth/2, 44 ),
            outLine = true,
        })
        _attrBg:addChild( _max )

        _bg._attrLabel[2] = {
            _attrText = _attrText,
            _attrNum = _attrNum,
            _attrAddNum = _attrAddNum,
            _arrow = _arrow,
            _max = _max,
        }
	end

	-- 镶嵌
    local _btn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p( _bottomBgWidth/2, 34 ),
        text = zc.lang("inlay"),
        endCallback = function()
        	self:clickBtn()
    	end
	})
	_bottomBg:addChild( _btn )
	_bg._btn = _btn
    self._guideBtn = _btn
end
-- 点击按钮响应
function RoleGemSetPop:clickBtn()
    local _gemList = self._gemList[self._gemIndex]
    if not _gemList then
        zc.tipInfo(zc.lang("choose_gem"))
        return
    end
    local _id = _gemList.id[1]
    if not _id then
        zc.tipInfo(zc.lang("choose_gem"))
        return
    end
    self._params.gemId = _id
    zc.sendHttp({
        apiName = "Gem_set",
        params = {
            type=self._params.type,
            id=self._params.id,
            place=self._params.place,
            gemId=self._params.gemId,
        },
        successCallback = function( backData )
            -- dump(backData,"backData Gem_set =============== ")
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12312 then
                zc.setGuideFuncNextStep(_currentGID)
            end
            PlayerData:updataData( backData )
            if self._params.type == 3 then
                PlayerData:updateWeaponsInfoById( backData.info )
            else
                PlayerData:updateEquip( backData.info )
            end

            self._params._objData._place = {
                gemId1 = backData.info.gemId1,
                gemId2 = backData.info.gemId2,
                gemId3 = backData.info.gemId3,
                gemId4 = backData.info.gemId4,
            }

            for i, v in ipairs( backData.gemEtt ) do
                PlayerData:updateGem( v )
            end
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_GEM})
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLELAYER_CHANGE, data = {id = 5}})
            self:hide()
        end
    })
end
-- 刷新信息弹窗
function RoleGemSetPop:refreshInfoLayer()
	local _gemList = self._gemList[self._gemIndex]
	if not _gemList then
		return
	end
	local _gemInfo = _gemList.info
    -- dump(_gemList,"_gemList")

	local _bg = self._infoLayer
	-- 图标
	zc.updateIconByData(_bg._gemIcon, {
        data = {
            mainType=zc.mainTypeGem,
            type=_gemInfo.gemId,
            id=_gemInfo.gemId,
            level = zc.getLevelTipShow().._gemInfo.level,
        },
        showLevel = true,
    })
    -- 名字
    _bg._name:setText( _gemInfo.name )
	_bg._needLevel:setText( zc.lang("have_num") .. ": ".._gemList.num )

	_bg._attrLabel[1]._attrText:setString( LANGUAGE_getGemAttrByType( _gemInfo.type ) )
	_bg._attrLabel[1]._attrNum:setString( _gemInfo.value )

	local _nxtInfo = gameData.getDataFromCacheWithPrimaryKey("gem",_gemInfo.nextGem)
    if next(_nxtInfo) then
        -- 没到满级
    	_bg._attrLabel[2]._attrText:setString( LANGUAGE_getGemAttrByType( _nxtInfo.effectId ) )
    	_bg._attrLabel[2]._attrText:setVisible( true )
        _bg._attrLabel[2]._attrNum:setString( _nxtInfo.value )
        _bg._attrLabel[2]._attrNum:setVisible( true )
    	_bg._attrLabel[2]._attrAddNum:setString( "+"..( tonumber(_nxtInfo.value) - tonumber(_gemInfo.value) ) )
        _bg._attrLabel[2]._attrAddNum:setVisible( true )
        _bg._attrLabel[2]._arrow:setVisible( true )
        _bg._attrLabel[2]._max:setVisible( false )

        local _expNow = tonumber(_gemInfo.exp) or 0
        local _gemExpData = gameData.getDataFromCache("gem_experience",{level=_gemInfo.level})
        local _expMax = tonumber(_gemExpData.levelUpEx) or 0
        local _pct = 1
        if _expMax ~= 0 then
            _pct = _expNow/_expMax
        end
        local _progressWidth = _bg._progress:getContentSize().width
        _bg._progress:stopAllActions()
        _bg._progress:runAction(
            cc.MoveTo:create( 0.2, cc.p( _progressWidth*_pct, -2 ) )
        )
        _bg._expNum:setText( _expNow.."/".._expMax )
    else
        -- 满级
        _bg._attrLabel[2]._attrText:setVisible( false )
        _bg._attrLabel[2]._attrNum:setVisible( false )
        _bg._attrLabel[2]._attrAddNum:setVisible( false )
        _bg._attrLabel[2]._arrow:setVisible( false )
        _bg._attrLabel[2]._max:setVisible( true )
        local _progressWidth = _bg._progress:getContentSize().width
        _bg._progress:stopAllActions()
        _bg._progress:runAction(
            cc.MoveTo:create( 0.2, cc.p( _progressWidth, -2 ) )
        )
        _bg._expNum:setText( "Max" )
    end
end

-- 创建列表弹窗
function RoleGemSetPop:initListLayer()
	-- 背景
	local _bgWidth = 482
	local _bgHeight = 538
	local _bg = cc.Sprite:create()
	_bg:setContentSize( _bgWidth, _bgHeight )
	_bg:setPosition( self._width/2 + _bgWidth/2 - 40 , self._height/2 )
	self:addContent( _bg )
	self._listLayer = _bg
	-- 吞噬cellbtn的点击事件层
	local _swallow = zc.createPushButton({
		touchSize = cc.size( _bgWidth, _bgHeight ),
		pos = cc.p( _bgWidth/2, _bgHeight/2 ),
		needSwallow = true,
	})
	_bg:addChild( _swallow )
	-- 下层背景
	local _bottomBg = zc.createNormalPop({
		width = _bgWidth + 32,
		height = _bgHeight + 60,
		showSide = false,
	})
	_bottomBg:setPosition( _bgWidth/2, _bgHeight/2 )
	_bg:addChild( _bottomBg )
	-- 上层背景
	local _topBg = cc.Sprite:create( "res/Main/common/popBg/di_4.png" )
	_topBg:setScaleX( _bgWidth/_topBg:getContentSize().width )
	_topBg:setScaleY( _bgHeight/_topBg:getContentSize().height )
	_topBg:setPosition( _bgWidth/2, _bgHeight/2 )
	_bg:addChild( _topBg )

	-- tableview
    local _gemTableview = zc.ZCTableView:create( cc.size( _bgWidth, _bgHeight ) )
    _gemTableview:setBounceable( true )
    _gemTableview:setInertia( true )
    _gemTableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    _gemTableview:setPosition( 0, 0 )
    _gemTableview:setDelegate()
    _gemTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = _bgWidth
    local cellHeight = 112
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellWidth, cellHeight )
        end
        self:updateCell( cell, index )

        return cell
    end
    local function numberOfCellsInTableView()
        return math.ceil( #self._gemList/self._cellIconNum )
    end
    _gemTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _gemTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _gemTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _bg:addChild( _gemTableview )
    self._gemTableview = _gemTableview
end
-- 创建cell
function RoleGemSetPop:buildCell( cell, index, cellWidth, cellHeight )
	-- 两边
	local cellSide = 8
	local cellDisX = ( cellWidth - cellSide*2 )/self._cellIconNum
	cell._icon = {}
	for i = 1, self._cellIconNum do
		local _posX = ( i - 0.5 )*cellDisX + cellSide
		-- icon
		local _icon = zc.createIconByData({
	        data = {
	            mainType=zc.mainTypeGem,
	            type=1,
	            id=1,
	        },
	        pos = cc.p( _posX, cellHeight/2 ), 
	    })
	    _icon:setScale( 0.65 )
		cell:addChild( _icon )
		cell._icon[i] = _icon
		-- 选中
	    local _selected = zc.getItemClickEffect( 2 )
	    _selected:setPosition( _icon:getContentSize().width/2, _icon:getContentSize().height/2 )
	    _icon:addChild( _selected )
	    _icon._selected = _selected
	end
end
-- 更新cell
function RoleGemSetPop:updateCell( cell, index )
	cell._index = index
	for i = 1, self._cellIconNum do
		local _gemIndex = index*self._cellIconNum + i
		local _gemList = self._gemList[_gemIndex]
		local _icon = cell._icon[i]
		if _gemList then
            local _gemInfo = _gemList.info
			-- cellBg
			_icon:setVisible( true )
			if self._gemIndex == _gemIndex then
				_icon._selected:setVisible( true )
				self._selectedCell = cell
			else
				_icon._selected:setVisible( false )
			end
			-- icon
			zc.updateIconByData(_icon, {
				data = {
		            mainType=zc.mainTypeGem,
		            type=_gemInfo.gemId,
		            id =_gemInfo.gemId,
		            level = zc.getLevelTipShow().._gemInfo.level,
		            num = _gemList.num,
		        },
		        showLevel = true,
		        listener = function()
		        	if self._gemIndex ~= _gemIndex then
		        		if self._selectedCell then
							self._selectedCell._icon[( self._gemIndex - 1 )%self._cellIconNum + 1]._selected:setVisible( false )
						end
						self._gemIndex = _gemIndex
						_icon._selected:setVisible( true )
						self._selectedCell = cell
						self:refreshInfoLayer()
		        	end
		        end
			})
		else
			_icon:setVisible( false )
		end
	end
end

-- 刷新列表弹窗
function RoleGemSetPop:refreshListLayer()
    self:buildListData()
	self._gemTableview:reloadData()
end
-- 构造列表数据，相同类型相同等级相同经验值的宝石堆叠
function RoleGemSetPop:buildListData()
    local _allGem = PlayerData:getGemInfo()
    local _gemList = {}
    local _index = {}
    for k, _gemData in pairs( _allGem ) do
        local _place = tonumber( _gemData.place ) or 0
        if _place == 0 then
            -- 空闲宝石
            local _gemId = tonumber( _gemData.gemId ) or 0
            local _type = tonumber( _gemData.type ) or 0
            local _level = tonumber( _gemData.level ) or 0
            local _exp = tonumber( _gemData.exp ) or 0
            -- 检查是否已经有这种宝石了
            local __index = 0
            if _index[_gemId] and _index[_gemId][_exp] then
                __index = _index[_gemId][_exp]
            end
            if __index == 0 then
                -- 没有
                local _info = clone( _gemData )
                -- ...
                local ___index = #_gemList + 1
                _gemList[___index] = {
                    info = _info,
                    gemId = _gemId,
                    type=_type,
                    level = _level,
                    exp = _exp,
                    num = 1,
                    id = { _info.id },
                }
                _index[_gemId] = _index[_gemId] or {}
                _index[_gemId][_exp] = ___index
            else
                -- 有了
                _gemList[__index].num = _gemList[__index].num + 1
                local ___index = #_gemList[__index].id + 1
                _gemList[__index][___index] = _gemData.id
            end
        end
    end
    local _typeSort = {
        [30] = 1, [8] = 2, [12] = 3, [4] = 4
    }
    table.sort(_gemList,function(a,b)
        if _typeSort[a.type] ~= _typeSort[b.type] then
            return _typeSort[a.type] < _typeSort[b.type]
        elseif a.level ~= b.level then
            return a.level > b.level
        else
            return a.exp > b.exp
        end
    end)
    -- dump(_gemList,"_gemList")
    self._gemList = _gemList
end

function RoleGemSetPop:onEnter()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12311 then
        zc.setGuideFuncNextStep(_currentGID, false)
        getGuideManager():setObjTarget(self._guideBtn)
        getGuideManager():startGuide()
    end
end

return RoleGemSetPop