--[[
	武将宝石升级弹窗
	唐实聪
	2016.9.29
]]
local RoleGemUpgradePop = class("RoleGemUpgradePop", function()
	return ZCPopLayer:create()
end)

function RoleGemUpgradePop:create( params )
	return RoleGemUpgradePop.new( params )
end

function RoleGemUpgradePop:ctor( params )
	self:initData( params )
	self:initUI()
	self:refreshListLayer()
	self:refreshInfoLayer()
	self:show(false)
end

-- 处理数据
function RoleGemUpgradePop:initData( params )
    self._params = params.data
    self._gemData = PlayerData:getGemInfoById( params.data.gemId )
    -- 是否是顶级宝石
    self._isMax = true
    local _nxtData = gameData.getDataFromCacheWithPrimaryKey("gem",self._gemData.nextGem)
    if next(_nxtData) then
        self._isMax = false
    end


    -- 宝石经验
    local _gemExpData = gameData.getAllDataWithNoClone("gem_experience")
    local _gemExp = {}
    for k,v in pairs( _gemExpData ) do
        _gemExp[tonumber( v.level )] = {
            levelEx = tonumber( v.levelEx ) or 0,
            levelUpEx = tonumber( v.levelUpEx ) or 0,
        }
    end
    -- dump(_gemExp,"_gemExp")
    self._gemExp = _gemExp
    -- 总经验值
    self._totalExp = 0
    -- 选中的列表
    self._selectList = {}
    self._selectIcon = {}
    -- 每行显示宝石数量
	self._cellIconNum = 5
    -- 宝石列表
	self._gemList = {}
    -- 最多可选取宝石数量
    self._selectMax = 20

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end
-- 初始化界面
function RoleGemUpgradePop:initUI()
	self:initInfoLayer()
	self:initListLayer()
end

-- 创建信息弹窗
function RoleGemUpgradePop:initInfoLayer()
	-- 背景
	local _bgWidth = 384
	local _bgHeight = 569 + 31
    local _bg = zc.createNormalPop({
        tag = 1,
        titleTag = 1,
        height = _bgHeight,
        showSide = false,
    })
	_bg:setPosition( self._width/2 - _bgWidth/2 - 60, self._height/2 )
	self:addContent( _bg, 1 )
	self._infoLayer = _bg
	-- 吞噬cellbtn的点击事件层
	local _swallow = zc.createPushButton({
		touchSize = cc.size( _bgWidth, _bgHeight ),
		pos = cc.p( _bgWidth/2, _bgHeight/2 ),
		needSwallow = true,
	})
	_bg:addChild( _swallow )

	-- 顶部
	local _topBgWidth = _bgWidth - 36
	local _topBgHeight = 130 + 15
    local _topBg = zc.createGeneralPopScale({
        width = _topBgWidth,
        height = _topBgHeight,
    })
	_topBg:setPosition( _bgWidth/2 - 8, _bgHeight - 152 )
	_bg:addChild( _topBg, 1 )
    -- 背景
    local _iconBg = cc.Sprite:create( "res/Main/common/popBg/bgFlower.png" )
    _iconBg:setPosition( 70, _topBgHeight*0.5 )
    _iconBg:setScale( 0.7 )
    _topBg:addChild( _iconBg )
	local _gemIcon = zc.createIconByData({
        data = {
            mainType = zc.mainTypeWeapon,
            type = 1,
            id = 1,
            quality = 1,
        },
        ap = cc.p( 0, 0 ),
        pos = cc.p( 53, 53 ), 
    })
	_gemIcon:setPosition( _iconBg:getPosition() )
	_gemIcon:setScale( 0.8 )
	_topBg:addChild( _gemIcon )
	_bg._gemIcon = _gemIcon

	-- 名字背景
    local _nameBg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 163, 8 ), "res/Main/common/popBg/di_properties.png" )
	_nameBg:setPosition( 240, _topBgHeight*0.5 + 20 )
	_topBg:addChild( _nameBg )
    -- 名字
    local _name = zc.createLabel({
        fontSize = 20,
        ttf = zc.getFont( 1 ),
        pos = cc.p( _nameBg:getContentSize().width/2, _nameBg:getContentSize().height/2 ),
        outLine = true,
        pixel = 1.5,
    })
    _nameBg:addChild( _name )
    _bg._name = _name
    -- 需求等级背景
    local _needLevelBg = ccui.Scale9Sprite:create( cc.rect( 15, 12, 163, 8 ), "res/Main/common/popBg/di_properties.png" )
    _needLevelBg:setPosition( 240, _topBgHeight*0.5 - 20 )
    _topBg:addChild( _needLevelBg )
    -- 需求等级
    local _needLevel = zc.createLabel({
        fontSize = 20,
        ttf = zc.getFont( 1 ),
        -- color = zc.COLOR_RED,
        outLine = true,
        pixel = 1.5,
        pos = cc.p( _needLevelBg:getContentSize().width/2, _needLevelBg:getContentSize().height/2 ),
    })
    _needLevelBg:addChild( _needLevel )
    _bg._needLevel = _needLevel

    -- 底部
	local _bottomBgWidth = _bgWidth - 36
	_bg._bottomBgWidth = _bottomBgWidth
	local _bottomBgHeight = 354
	local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        width = _bottomBgWidth,
        height = _bottomBgHeight,
    })
	_bottomBg:setAnchorPoint( 0.5, 0 )
	_bottomBg:setPosition( _bgWidth/2 - 8, 15 )
	_bg:addChild( _bottomBg )

	-- 属性背景
	local _attrBgWidth = _bottomBgWidth - 18
	local _attrBgHeight = 275
    _bg._attrBgWidth = _attrBgWidth
	_bg._attrBgHeight = _attrBgHeight
	local _attrBg = zc.createGeneralPopScale({
        tag = 2,
        width = _attrBgWidth,
        height = _attrBgHeight,
    })
	_attrBg:setAnchorPoint( 0.5, 1 )
	_attrBg:setPosition( _bottomBgWidth/2, _bottomBgHeight - 10 )
	_bottomBg:addChild( _attrBg )
    _bg._attrBg = _attrBg

	-- 属性标题
	local _attrScrollview = zc.createScrollview({
	    pos = cc.p( 0, 0 ),
	    size = cc.size( _attrBgWidth, _attrBgHeight ),
	    touchEnable = true,
	    dir = ccui.ScrollViewDir.vertical,
	})
	_attrBg:addChild( _attrScrollview )
	_bg._attrScrollview = _attrScrollview
    local _titlePosY = { 253, 168, 75 }
	for i = 1, 3 do
	    local _attrTitle = cc.Sprite:create( "res/Main/role/gem/title_2_"..i..".png" )
	    _attrTitle:setPosition( _attrBgWidth/2, _titlePosY[i] )
	    _attrScrollview:addChild( _attrTitle )
        local _attrTitleLeft = cc.Sprite:create( "res/Main/common/lace.png" )
        _attrTitleLeft:setAnchorPoint( 1, 0.5 )
        _attrTitleLeft:setPosition( _attrBgWidth/2 - 55, _titlePosY[i] )
        _attrScrollview:addChild( _attrTitleLeft )
        local _attrTitleRight = cc.Sprite:create( "res/Main/common/lace.png" )
        _attrTitleRight:setAnchorPoint( 0, 0.5 )
        _attrTitleRight:setPosition( _attrBgWidth/2 + 55, _titlePosY[i] )
        _attrTitleRight:setFlippedX( true )
        _attrScrollview:addChild( _attrTitleRight )
    end
    -- 进度条
    local _progressBg = ccui.Scale9Sprite:create(cc.rect(9, 0, 1, 26 ), "res/Main/smithy/practice/progressBg.png")
    _progressBg:setContentSize( 280, 30 )
    _progressBg:setPosition( _attrBgWidth/2, 210 )
    _attrScrollview:addChild( _progressBg )
    -- 模板
    local _stencil = ccui.Scale9Sprite:create(cc.rect(9, 0, 1, 26 ), "res/Main/smithy/practice/progressBg.png")
    _stencil:setContentSize( 280, 30 )
    _stencil:setAnchorPoint( 0, 0 )
    -- 
    local _progress = ccui.Scale9Sprite:create(cc.rect(3, 0, 1, 23 ), "res/Main/smithy/practice/progress.png")
    _progress:setContentSize( 280, 30 )
    _progress:setAnchorPoint( 1, 0 )
    _progress:setPosition( 0, -2 )
    -- _clippingNode
    local _clippingNode = cc.ClippingNode:create()
    _clippingNode:setStencil( _stencil )
    _clippingNode:addChild( _progress )
    _clippingNode:setInverted( false )
    _clippingNode:setAlphaThreshold( 0 )
    _progressBg:addChild( _clippingNode )
    _bg._progress = _progress
    -- 经验值
    local _expNum = zc.createLabel({
        fontSize = 18,
        color = zc.COLOR_YELLOW,
        pos = cc.p( _progressBg:getContentSize().width/2, _progressBg:getContentSize().height/2 ),
        outLine = true,
    })
    _progressBg:addChild( _expNum )
    _bg._expNum = _expNum
	_bg._attrLabel = {}
	do
		_bg._attrLabel[1] = {}
        local _attrPosY = { 142, 112 }
		for j = 1, 2 do
	        -- 属性
            local _attrText = zc.createLabel({
                fontSize = 18,
                color = cc.c3b( 203, 183, 123 ),
                ttf = zc.getFont( 1 ),
                pos = cc.p( 25, _attrPosY[j] ),
                outLine = true,
            })
            _attrText:setAnchorPoint( 0, 0.5 )
            _attrBg:addChild( _attrText )
            -- 属性值
            local _attrNum = zc.createLabel({
                fontSize = 18,
                ttf = zc.getFont( 1 ),
                pos = cc.p( 100, _attrPosY[j] ),
                outLine = true,
            })
            _attrNum:setAnchorPoint( 0, 0.5 )
            _attrBg:addChild( _attrNum )

            _bg._attrLabel[1][j] = {
                _attrText = _attrText,
                _attrNum = _attrNum,
            }
	    end
	end
	do
		_bg._attrLabel[2] = {}
        local _attrPosY = { 47, 17 }
		for j = 1, 2 do
	        -- 属性
            local _attrText = zc.createLabel({
            	text = "1",
                fontSize = 18,
                color = cc.c3b( 203, 183, 123 ),
                ttf = zc.getFont( 1 ),
                pos = cc.p( 25, _attrPosY[j] ),
                outLine = true,
            })
            _attrText:setAnchorPoint( 0, 0.5 )
            _attrBg:addChild( _attrText )
            -- 属性值
            local _attrNum = zc.createLabel({
                fontSize = 18,
                ttf = zc.getFont( 1 ),
                pos = cc.p( 100, _attrPosY[j] ),
                outLine = true,
            })
            _attrNum:setAnchorPoint( 0, 0.5 )
            _attrBg:addChild( _attrNum )
            -- 增加数字
            local _attrAddNum = zc.createLabel({
                fontSize = 18,
                color = zc.COLOR_GREEN,
                ttf = zc.getFont( 1 ),
                pos = cc.p( 185, _attrPosY[j] ),
                outLine = true,
            })
            _attrAddNum:setAnchorPoint( 0, 0.5 )
            _attrBg:addChild( _attrAddNum )
            -- 箭头
            local _arrow = cc.Sprite:create( "res/Main/common/arrow_green.png" )
            _arrow:setPosition( 270, _attrPosY[j] )
            _arrow:setRotation( -90 )
            _attrBg:addChild( _arrow )

            _bg._attrLabel[2][j] = {
                _attrText = _attrText,
                _attrNum = _attrNum,
                _attrAddNum = _attrAddNum,
                _arrow = _arrow,
            }
	    end
        local _max = zc.createLabel({
            text = zc.lang("already_max_level_gem"),
            fontSize = 18,
            color = zc.COLOR_RED,
            ttf = zc.getFont( 1 ),
            pos = cc.p( _attrBgWidth/2, 32 ),
            outLine = true,
        })
        _attrBg:addChild( _max )
        _bg._attrLabel[2]._max = _max
	end

    -- 左按钮，合成
    local _leftBtn = zc.createCommomBtn({
		tag = 2,
		text = zc.lang("compose"),
        pos = cc.p( 85, 34 ),
        endCallback = function()
        	self:clickLeftBtn()
    	end
	})
	_bottomBg:addChild( _leftBtn )
    _leftBtn:setEnable( false )
	_bg._leftBtn = _leftBtn
    -- 添加红点
    local _redPoint_l = cc.Sprite:create( "res/Main/common/common_red_point.png" )
    _redPoint_l:setAnchorPoint( 1, 1 )
    _redPoint_l:setPosition( _leftBtn:getContentSize().width + 5, _leftBtn:getContentSize().height + 5 )
    _redPoint_l:setVisible( false )
    _leftBtn:addChild( _redPoint_l )
    _leftBtn._redPoint = _redPoint_l
	-- 右按钮，卸下
    local _rightBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p( _bottomBgWidth - 85, 34 ),
        text = zc.lang("unload"),
        endCallback = function()
        	self:clickRightBtn()
    	end
	})
	_bottomBg:addChild( _rightBtn )
	_bg._rightBtn = _rightBtn
    -- 添加红点
    local _redPoint_r = cc.Sprite:create( "res/Main/common/common_red_point.png" )
    _redPoint_r:setAnchorPoint( 1, 1 )
    _redPoint_r:setPosition( _leftBtn:getContentSize().width + 5, _leftBtn:getContentSize().height + 5 )
    _redPoint_r:setVisible( false )
    _rightBtn:addChild( _redPoint_r )
    _rightBtn._redPoint = _redPoint_r
end
-- 点击左边按钮响应，合成
function RoleGemUpgradePop:clickLeftBtn()
    local _targetGemId = ""
    for k,v in pairs( self._selectList ) do
        _targetGemId = _targetGemId..k.."|"
    end
    _targetGemId = string.sub(_targetGemId,0,string.len(_targetGemId)-1)
    zc.sendHttp({
        apiName = "Gem_upgradeGem",
        params = {
            gemId=self._params.gemId,
            type=2,
            targetGemId=_targetGemId,
        },
        successCallback = function( backData )
            musicManager.playEffect(zc.effect["gouyuhecheng"])
            -- dump(backData,"backData")
            PlayerData:updataData( backData )
            PlayerData:updateGem( backData.gemInfo )
            self:doAnimation(function()
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_GEM})
                self._gemData = PlayerData:getGemInfoById( self._gemData.id )
                -- 是否是顶级宝石
                self._isMax = true
                local _nxtData = gameData.getDataFromCacheWithPrimaryKey("gem",self._gemData.nextGem)
                if next(_nxtData) then
                    self._isMax = false
                end
                self._totalExp = 0
                self._selectList = {}
                self:refreshListLayer()
                self:refreshInfoLayer()
            end)
        end
    })

end
-- 点击右边按钮响应，卸下
function RoleGemUpgradePop:clickRightBtn()
	zc.sendHttp({
        apiName = "Gem_unload",
        params = {
            type=self._params.type,
            id=self._params.id,
            place=self._params.place,
        },
        successCallback = function( backData )
            -- dump(backData,"backData Gem_unloa==================== ")
            PlayerData:updataData( backData )
            if self._params.type == 3 then
                PlayerData:updateWeaponsInfoById( backData.info )
            else
                PlayerData:updateEquip( backData.info )
            end

            self._params._objData._place = {
                gemId1 = backData.info.gemId1,
                gemId2 = backData.info.gemId2,
                gemId3 = backData.info.gemId3,
                gemId4 = backData.info.gemId4,
            }

            PlayerData:updateGem( backData.gemEtt )
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REFRESH_GEM})
            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLELAYER_CHANGE, data = {id = 5}})
            self:hide()
        end
    })
end
-- 刷新信息弹窗
function RoleGemUpgradePop:refreshInfoLayer()
	local _gemInfo = self._gemData
    -- dump(_gemInfo,"_gemInfo")

	local _bg = self._infoLayer
	-- 图标
	zc.updateIconByData(_bg._gemIcon, {
        data = {
            mainType=zc.mainTypeGem,
            type=_gemInfo.gemId,
            id=_gemInfo.gemId,
            level = zc.getLevelTipShow().._gemInfo.level,
        },
        showLevel = true,
    })
    -- 名字
    _bg._name:setText( _gemInfo.name )
    _bg._needLevel:setText( zc.lang("equiped_by")..self._params.heroName )

    _bg._attrLabel[1][1]._attrText:setString( zc.lang("level") .. ":" )
    _bg._attrLabel[1][1]._attrNum:setString( _gemInfo.level )
    _bg._attrLabel[1][2]._attrText:setString( LANGUAGE_getGemAttrByType( _gemInfo.type ) )
    _bg._attrLabel[1][2]._attrNum:setString( _gemInfo.value )

    self:refreshUpgrade()
end
-- 刷新合成之后的属性数据 
function RoleGemUpgradePop:refreshUpgrade( level, exp )
    local _bg = self._infoLayer

    if self._isMax then
        for i = 1, 2 do
            _bg._attrLabel[2][i]._attrText:setVisible( false )
            _bg._attrLabel[2][i]._attrNum:setVisible( false )
            _bg._attrLabel[2][i]._attrAddNum:setVisible( false )
            _bg._attrLabel[2][i]._arrow:setVisible( false )
        end
        _bg._attrLabel[2]._max:setVisible( true )
        local _progressWidth = _bg._progress:getContentSize().width
        _bg._progress:stopAllActions()
        _bg._progress:runAction(
            cc.MoveTo:create( 0.2, cc.p( _progressWidth, -2 ) )
        )
        _bg._expNum:setText( "Max" )

        self._selectNum:setVisible( false )
    else
        for i = 1, 2 do
            _bg._attrLabel[2][i]._attrText:setVisible( true )
            _bg._attrLabel[2][i]._attrNum:setVisible( true )
            _bg._attrLabel[2][i]._attrAddNum:setVisible( true )
            _bg._attrLabel[2][i]._arrow:setVisible( true )
        end
        _bg._attrLabel[2]._max:setVisible( false )

        local _gemInfo = self._gemData
        local _level_bef = tonumber(_gemInfo.level) or 0
        local _exp_bef = tonumber(_gemInfo.exp) or 0
        local _value_bef = tonumber(_gemInfo.value) or 0

        local _level_aft = level or _level_bef
        local _exp_aft = exp or _exp_bef
        local _data_aft = gameData.getDataFromCache("gem",{level=_level_aft,effectId=_gemInfo.type})
        local _value_aft = tonumber(_data_aft.value) or 0

        local _levelDif = _level_aft - _level_bef
        local _levelFlag = _levelDif > 0
        local _valueDif = _value_aft - _value_bef
        local _valueFlag = _valueDif > 0

        _bg._attrLabel[2][1]._attrText:setString(zc.lang("level") .. ":" )
        _bg._attrLabel[2][1]._attrNum:setString( _level_aft )
        _bg._attrLabel[2][1]._attrAddNum:setString( _levelDif )
        _bg._attrLabel[2][1]._attrAddNum:setVisible( _levelFlag )
        _bg._attrLabel[2][1]._arrow:setVisible( _levelFlag )

        _bg._attrLabel[2][2]._attrText:setString( LANGUAGE_getGemAttrByType( _data_aft.effectId ) )
        _bg._attrLabel[2][2]._attrNum:setString( _value_aft )
        _bg._attrLabel[2][2]._attrAddNum:setString( _valueDif )
        _bg._attrLabel[2][2]._attrAddNum:setVisible( _valueFlag )
        _bg._attrLabel[2][2]._arrow:setVisible( _valueFlag )

        -- 宝石升级而且经验为0，伪造等级和经验
        local _realLevel = _level_aft
        local _fakeLevel = _level_aft
        local _fakeExp = _exp_aft
        if _level_bef ~= _level_aft and _exp_aft == 0 then
            _fakeLevel = _level_aft - 1
            _fakeExp = self._gemExp[_fakeLevel].levelUpEx
        end
        -- 计算进度条
        local _expMax = self._gemExp[_fakeLevel] and self._gemExp[_fakeLevel].levelUpEx or 0
        local _pct = 1
        if _expMax ~= 0 then
            _pct = _fakeExp/_expMax
        end
        if self._upgradeMax then
            _pct = 1
        end
        local _progressWidth = _bg._progress:getContentSize().width
        _bg._progress:stopAllActions()
        local _action = {}
        local _fakeLevelDif = self._fakeLevel and _fakeLevel - self._fakeLevel  or 0
        if _fakeLevelDif > 0 then
            for i = 1, _fakeLevelDif do
                _action[#_action + 1] = cc.MoveTo:create( 0.2, cc.p( _progressWidth, -2 ) )
                _action[#_action + 1] = cc.Place:create( cc.p( 0, -2 ) )
            end
        elseif _fakeLevelDif < 0 then
            for i = 1, -_fakeLevelDif do
                _action[#_action + 1] = cc.MoveTo:create( 0.2, cc.p( 0, -2 ) )
                _action[#_action + 1] = cc.Place:create( cc.p( _progressWidth, -2 ) )
            end
        end
        _action[#_action + 1] = cc.MoveTo:create( 0.2, cc.p( _progressWidth*_pct, -2 ) )
        _bg._progress:runAction( cc.Sequence:create( _action ) )
        
        _bg._expNum:stopAllActions()
        _bg._expNum:runAction(
            cc.Sequence:create(
                cc.ScaleTo:create( 0.2, 1.5 ),
                cc.CallFunc:create(function()
                    if self._upgradeMax then
                        _bg._expNum:setText( "Max" )
                    else
                        _bg._expNum:setText( _fakeExp.."/".._expMax )
                    end
                end),
                cc.ScaleTo:create( 0.2, 1 )
            )
        )
        
        -- 等级变化
        local _realLevelDif = self._realLevel and _realLevel - self._realLevel  or 0
        if _realLevelDif ~= 0 then
            local _animation = zc.createSpine({
                fileName = "chuxiantexiao",
                actName = "idle",
                loop = false,
                autoRemove = true,
            })
            _animation:setPosition( _bg._attrBgWidth/2, 32 )
            _bg._attrBg:addChild( _animation )
        end
        self._fakeLevel = _fakeLevel
        self._realLevel = _realLevel

        self._selectNum:setVisible( true )
        --203,183,123
        -- self._selectNum:setString( "[color=ffcbb77b]已选取:[/color][color=ff00ff66]"..table.nums(self._selectList).."/"..self._selectMax.."[/color]" )
        self._selectNum:setString( table.nums(self._selectList).."/"..self._selectMax )
    end
end

-- 创建列表弹窗
function RoleGemUpgradePop:initListLayer()
	-- 背景
	local _bgWidth = 482
	local _bgHeight = 538
	local _bg = cc.Sprite:create()
	_bg:setContentSize( _bgWidth, _bgHeight )
	_bg:setPosition( self._width/2 + _bgWidth/2 - 40 , self._height/2 )
	self:addContent( _bg )
	self._listLayer = _bg
	-- 吞噬cellbtn的点击事件层
	local _swallow = zc.createPushButton({
		touchSize = cc.size( _bgWidth, _bgHeight ),
		pos = cc.p( _bgWidth/2, _bgHeight/2 ),
		needSwallow = true,
	})
	_bg:addChild( _swallow )
	-- 下层背景
	local _bottomBg = zc.createNormalPop({
		width = _bgWidth + 32,
		height = _bgHeight + 60,
		showSide = false,
	})
	_bottomBg:setPosition( _bgWidth/2, _bgHeight/2 )
	_bg:addChild( _bottomBg )
	-- 上层背景
	local _topBg = cc.Sprite:create( "res/Main/common/popBg/di_4.png" )
	_topBg:setScaleX( _bgWidth/_topBg:getContentSize().width )
	_topBg:setScaleY( ( _bgHeight - 80 )/_topBg:getContentSize().height )
	_topBg:setPosition( _bgWidth/2, _bgHeight/2 + 40 )
	_bg:addChild( _topBg )

	-- tableview
    local _gemTableview = zc.ZCTableView:create( cc.size( _bgWidth, _bgHeight - 80 ) )
    _gemTableview._showHeight = _bgHeight - 80
    _gemTableview:setBounceable( true )
    _gemTableview:setInertia( true )
    _gemTableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    _gemTableview:setPosition( 0, 80 )
    _gemTableview:setDelegate()
    _gemTableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = _bgWidth
    local cellHeight = 112
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, index, cellWidth, cellHeight )
        end
        self:updateCell( cell, index )

        return cell
    end
    local function numberOfCellsInTableView()
        return math.ceil( #self._gemList/self._cellIconNum )
    end
    _gemTableview:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _gemTableview:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _gemTableview:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _bg:addChild( _gemTableview )
    self._gemTableview = _gemTableview

    -- 一键选取
    local _oneKeyBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p( _bgWidth/2, 40 ),
        text = zc.lang("one_key_choose"),
        endCallback = function()
            self:oneKeySelect()
        end
    })
    _bg:addChild( _oneKeyBtn )
    self._oneKeyBtn = _oneKeyBtn

    -- 数量
    local _selectNum = zc.createLabel({
        text = "xx",
        outLine = true,
        fontSize = 23,
        ap = cc.p(0, 0.5),
        pos = cc.p(_bgWidth - 60, 40),
        color = display.COLOR_GREEN,
    })
    _bg:addChild( _selectNum )
    self._selectNum = _selectNum

    local _yixuanzhe = zc.createLabel({
        text = zc.lang("already_choosed"),
        outLine = true,
        fontSize = 23,
        ap = cc.p(1, 0.5),
        pos = cc.p(0, _selectNum:getContentSize().height/2),
        color = cc.c3b(203,183,123),
    })
    _selectNum:addChild(_yixuanzhe)
    
end
-- 创建cell
function RoleGemUpgradePop:buildCell( cell, index, cellWidth, cellHeight )
	-- 两边
	local cellSide = 8
	local cellDisX = ( cellWidth - cellSide*2 )/self._cellIconNum
	cell._icon = {}
	for i = 1, self._cellIconNum do
		local _posX = ( i - 0.5 )*cellDisX + cellSide
		-- icon
		local _icon = zc.createIconByData({
	        data = {
	            mainType=zc.mainTypeGem,
	            type=1,
	            id=1,
	        },
	        pos = cc.p( _posX, cellHeight/2 ), 
	    })
	    _icon:setScale( 0.65 )
		cell:addChild( _icon )
		cell._icon[i] = _icon
		-- 选中
	    local _selected = zc.getSpine("jiban")
        _selected:playAction("unlock", true)
        _selected:setScale( 1.2 )
	    _selected:setPosition( _icon:getContentSize().width/2, _icon:getContentSize().height/2 )
	    _icon:addChild( _selected )
	    _icon._selected = _selected
	end
end
-- 更新cell
function RoleGemUpgradePop:updateCell( cell, index )
	cell._index = index
	for i = 1, self._cellIconNum do
		local _gemIndex = index*self._cellIconNum + i
		local _gemInfo = self._gemList[_gemIndex]
		local _icon = cell._icon[i]
		if _gemInfo then
			-- cellBg
			_icon:setVisible( true )
            local _id = _gemInfo.id
            _icon._id = _id
            local _flag = self._selectList[_id]
            if _flag == nil then
                _flag = false
            end
            _icon._selected:setVisible( _flag )
            self._selectIcon[_id] = _flag and _icon or nil
			-- icon
			zc.updateIconByData(_icon, {
				data = {
		            mainType=zc.mainTypeGem,
		            type=_gemInfo.gemId,
		            id =_gemInfo.gemId,
		            level = zc.getLevelTipShow().._gemInfo.level,
		        },
		        showLevel = true,
		        listener = function()
                    if self._isMax then
                        zc.tipInfo(zc.lang("already_max_level_gem"))
                        return
                    end
                    _flag = not _flag
                    if _flag and table.nums(self._selectList) >= self._selectMax then
                        -- 选中且数量达到上限
                        zc.tipInfo(zc.lang("choose_gem_to_max_num"))
                    else
                        -- 其他
                        self._selectList[_id] = _flag or nil
                        self._selectIcon[_id] = _flag and _icon or nil
                        _icon._selected:setVisible( _flag )
                        self:selectGem( _gemInfo, _flag )
                    end
		        end
			})
		else
			_icon:setVisible( false )
		end
	end
end

-- 构造列表数据
function RoleGemUpgradePop:buildListData()
	local _allGem = PlayerData:getGemInfo()
	local _gemList = {}
    local _type = tonumber(self._gemData.type) or 0
	for k, _gemData in pairs( _allGem ) do
        local __type = tonumber(_gemData.type) or 0
        local _place = tonumber(_gemData.place) or 0
        if _type == __type and _place == 0 then
            local _level = tonumber( _gemData.level ) or 0
            local _levelExp = self._gemExp[_level] or {}
            _levelExp = _levelExp.levelEx or 0
            local _exp = tonumber(_gemData.exp) or 0
            _gemList[#_gemList + 1] = {
                id = tonumber(_gemData.id) or 0,
                gemId = _gemData.gemId,
                level = _level,
                exp = _exp,
                totalExp = _levelExp + _exp,
            }
        end
	end
    table.sort(_gemList,function(a,b)
        if a.level == b.level then
            return a.exp < b.exp
        else
            return a.level < b.level
        end
    end)
	-- dump(_gemList,"_gemList")
	self._gemList = _gemList

    if self._isMax or #_gemList == 0 then
        self._oneKeyBtn:setEnable( false )
    else
        self._oneKeyBtn:setEnable( true )
    end
end
-- 刷新列表弹窗
function RoleGemUpgradePop:refreshListLayer()
	self:buildListData()
	self._gemTableview:reloadData()
end

-- 点击宝石
function RoleGemUpgradePop:selectGem( _gemInfo, _flag )
    if _flag then
        self._totalExp = self._totalExp + _gemInfo.totalExp
    else
        self._totalExp = self._totalExp - _gemInfo.totalExp
    end
    print("~~~~~~~~~self._totalExp=",self._totalExp)
    self:setLeftBtn()
    self:calculateExp()
end
-- 计算经验
function RoleGemUpgradePop:calculateExp()
    local _totalExp = self._totalExp
    local _exp = tonumber(self._gemData.exp) or 0
    _totalExp = _totalExp + _exp

    local _level = tonumber( self._gemData.level ) or 0
    -- 是否满级
    local _max = true
    for _index = _level, #self._gemExp - 1 do
        local _needExp = self._gemExp[_index].levelUpEx
        local _leftExp = _totalExp - _needExp
        print("~~~~~~~_leftExp=",_leftExp,"_index=",_index)
        if _leftExp >= 0 then
            _totalExp = _leftExp
        else
            _level = _index
            _max = false
            break
        end
    end
    if _max then
        -- 合成后满级
        self._upgradeMax = true
        _level = #self._gemExp
        _totalExp = 0
    else
        self._upgradeMax = false
    end
    print("~~~~~~~~~~~~~~~~~~~~~_level=",_level,"_totalExp=",_totalExp)

    self:refreshUpgrade( _level, _totalExp )    
end

-- 一键选取
function RoleGemUpgradePop:oneKeySelect()
    self._totalExp = 0
    self._selectList = {}

    -- 计算当前宝石升级需要的经验值
    local _level = tonumber(self._gemData.level) or 0
    local _exp = tonumber(self._gemData.exp) or 0
    local _levelUpEx = self._gemExp[_level].levelUpEx
    local _needExp = _levelUpEx - _exp

    local _max = self._selectMax
    local _total = #self._gemList
    local _end = _max > _total and _total or _max
    for i = 1, _end do
        local _gemData = self._gemList[i]
        if _needExp > 0 then
            _needExp = _needExp - _gemData.totalExp
            self._totalExp = self._totalExp + _gemData.totalExp
            self._selectList[_gemData.id] = true
        else
            break
        end
    end
    print("~~~~~~~~~self._totalExp=",self._totalExp)
    self._gemTableview:reloadData()
    self:setLeftBtn()
    self:calculateExp()
end
-- 设置合成按钮状态
function RoleGemUpgradePop:setLeftBtn()
    if next(self._selectList) then
        self._infoLayer._leftBtn:setEnable( true )
    else
        self._infoLayer._leftBtn:setEnable( false )
    end
end
-- 合成动画
function RoleGemUpgradePop:doAnimation(_callback)
    getGuideManager():addMaskLayer()
    local _bg = self._infoLayer
    -- 飞
    local _tableviewY = self._gemTableview:getContentOffset().y
    local _tableviewHeight = self._gemTableview._showHeight
    local _cellHeight = 112
    local _beginPoss = {}
    for k, v in pairs( self._selectIcon  ) do
        if not tolua.isnull( v ) and v:isVisible() and v._id == k then
            local _parentY = v:getParent():getPositionY()
            local _posY = _parentY + _tableviewY + _cellHeight/2
            if _posY > 0 and _posY < _tableviewHeight then
                local _pos = v:convertToWorldSpaceAR( cc.p( 0, 0 ) )
                _beginPoss[#_beginPoss + 1] = _bg:convertToNodeSpace( _pos )
            end
        end
    end

    musicManager.playEffect(zc.effect["gouyufei"])
    if #_beginPoss > 0 then
        local _endPos = cc.p( 0, 0 )
        do
            local _pos = _bg._gemIcon:convertToWorldSpaceAR( cc.p( 0, 0 ) )
            _endPos = _bg:convertToNodeSpace( _pos )
        end
        -- 间隔
        local _interval = ( 19 + #_beginPoss )/20*0.1

        for i, _beginPos in ipairs( _beginPoss ) do
            local _particle = cc.ParticleSystemQuad:create("res/Main/role/equip/jinjie/jinjie.plist")
            _particle:setPosition( _beginPos )
            -- _particle:setAutoRemoveOnFinish( true ) -- 这个plist特效是循环的，这里设置自动删除是没有效果的
            _bg:addChild( _particle, 6 )
            
            if i == #_beginPoss then
                -- 最后一个
                _particle:runAction(
                    cc.Sequence:create(
                        cc.DelayTime:create( i*_interval ),
                        cc.MoveTo:create( 1, _endPos ),
                        cc.CallFunc:create(
                            function()
                                local __spine = zc.createSpine({
                                    fileName = "qianghua_jinjie",
                                    actName = "animation2",
                                    loop = false,
                                    needInit = false,
                                    autoRemove = true,
                                    removeCallback = function()
                                        getGuideManager():removeMaskLayer()
                                        if _callback then
                                            _callback()
                                        end
                                    end
                                })
                                __spine:setScale( 3 )
                                __spine:setPosition( _endPos )
                                _bg:addChild( __spine, 6 )
                            end
                        ),
                        cc.RemoveSelf:create(true)
                    )
                )
            else
                _particle:runAction(
                    cc.Sequence:create(
                        cc.DelayTime:create( i*_interval ),
                        cc.MoveTo:create( 1, _endPos ),
                        cc.RemoveSelf:create(true)
                    )
                )
            end
        end
    else
        getGuideManager():removeMaskLayer()
        if _callback then
            _callback()
        end
    end
end

return RoleGemUpgradePop