--[[
    FileName: SettingPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local SettingPop = class( "SettingPop", function ()
    return ZCPopLayer:create()
end)

function SettingPop:create(params)
    return SettingPop.new(params)
end

function SettingPop:ctor(params)
    local popSize = cc.size(500, 300)
    local popBg = cc.Sprite:create("res/Main/common/popBg/popup_Bg_blue.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    local _bgSize = popBg:getContentSize()

    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    popBg:addChild(middleBg)

    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)

    local title = zc.getTipPopTitle( "xitongshezhi" )
    title:setPosition( popBg:getContentSize().width/2, popBg:getContentSize().height-30 )
    popBg:addChild(title)
    

    local _partW = 60
    local _partH = 40
    local sound = zc.createLabel({
        text = zc.lang("sount_effect_ctrl"),
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(91 + _partW, 224 + _partH),
        color = cc.c3b(97, 37, 0),
    })
    popBg:addChild(sound)
    local greenBtn_sound, grayBtn_sound = self:createOpenBtn(popBg, cc.p( sound:getPositionX()+sound:getContentSize().width+35, 224 + _partH))

    local moveBtn_sound = zc.createPushButton({
        normalFile = "res/Main/setting/btn_move.png",
        selectedFile = "res/Main/setting/btn_move.png",
        needSwallow = false,
        touchSize = cc.size(106 + _partW, 35),
        endCallback = function()
            if self._moveBtn_sound._isRuning == false then
                self:clickButton(self._moveBtn_sound)
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(greenBtn_sound:getPositionX(), greenBtn_sound:getPositionY()-1)
    })
    popBg:addChild(moveBtn_sound)
    moveBtn_sound:setName("moveBtn_sound")
    moveBtn_sound:setPositionX(greenBtn_sound:getPositionX()+(53-22))
    self._moveBtn_sound = moveBtn_sound
    moveBtn_sound._isRuning = false

    local music = zc.createLabel({
        text = zc.lang("sount_music_ctrl"),
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(91 + _partW, 178 + _partH),
        color = cc.c3b(97, 37, 0),
    })
    popBg:addChild(music)
    local greenBtn_music, grayBtn_music = self:createOpenBtn(popBg, cc.p( music:getPositionX()+music:getContentSize().width+35, 178 + _partH))

    local moveBtn_music = zc.createPushButton({
        normalFile = "res/Main/setting/btn_move.png",
        selectedFile = "res/Main/setting/btn_move.png",
        needSwallow = false,
        touchSize = cc.size(106 + _partW, 35),
        endCallback = function()
            if self._moveBtn_music._isRuning == false then
                self:clickButton(self._moveBtn_music)
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(greenBtn_music:getPositionX(), greenBtn_music:getPositionY()-1)
    })
    popBg:addChild(moveBtn_music)
    moveBtn_music:setName("moveBtn_music")
    moveBtn_music:setPositionX(greenBtn_sound:getPositionX()+(53-22))
    self._moveBtn_music = moveBtn_music
    moveBtn_music._isRuning = false


    local EFFECT_IS_OPEN = musicManager.isEffectEnable()
    local MUSIC_IS_OPEN = musicManager.isMusicEnable()
    self._EFFECT_IS_OPEN = EFFECT_IS_OPEN
    self._MUSIC_IS_OPEN = MUSIC_IS_OPEN
    --state 1为关闭，2为开启
    moveBtn_sound.state = EFFECT_IS_OPEN == true and 2 or 1
    moveBtn_sound.greenBtn = greenBtn_sound
    moveBtn_sound.grayBtn = grayBtn_sound
    moveBtn_music.state = MUSIC_IS_OPEN == true and 2 or 1
    moveBtn_music.greenBtn = greenBtn_music
    moveBtn_music.grayBtn = grayBtn_music

    if tonumber(moveBtn_sound.state) == 1 then  --state 1为关闭
        moveBtn_sound.greenBtn:setVisible(false)
        moveBtn_sound.grayBtn:setVisible(true)
        moveBtn_sound:setPositionX(moveBtn_sound:getPositionX()-62)
    else
        moveBtn_sound.greenBtn:setVisible(true)
        moveBtn_sound.grayBtn:setVisible(false)
    end
    if tonumber(moveBtn_music.state) == 1 then --state 1为关闭
        moveBtn_music.greenBtn:setVisible(false)
        moveBtn_music.grayBtn:setVisible(true)
        moveBtn_music:setPositionX(moveBtn_music:getPositionX()-62)
    else
        moveBtn_music.greenBtn:setVisible(true)
        moveBtn_music.grayBtn:setVisible(false)
    end
    --
    if not APPSTORE_REVIEW then
        local exchangeBtn = zc.createCommomBtn({
            tag = 1,
            text = zc.lang("exchange_code"),
            needSwallow = false,
            pos = cc.p(popBg:getContentSize().width/2 - 155, 70),
            ap = cc.p(0.5, 0.5),
            endCallback = function()
                zc.createSourcePop("Exchange", "src/layer/setting/ExchangePop.lua", {})
            end
        })
        popBg:addChild(exchangeBtn)
    end
    
    local reloginBtn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("change_account"),
        needSwallow = false,
        pos = cc.p(popBg:getContentSize().width/2 + 155, 70),
        ap = cc.p(0.5, 0.5),
        endCallback = function()
            zc.sendHttp({
                apiName = "User_logout",
                params = {key=GAMETOKEN},
                successCallback = function ()
                    zc.goReturnLogin()
                end,
            }) 
        end
    })
    popBg:addChild(reloginBtn)

    local chengmiBtn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("true_name_certification"),
        needSwallow = false,
        pos = cc.p(popBg:getContentSize().width/2 , 70),
        ap = cc.p(0.5, 0.5),
        endCallback = function()
            local _isRealName = PlayerData:getBaseInfoByTag("isRealName")
            if not _isRealName or _isRealName == 0 then
                self:hide()
                zc.createSourcePop("idCardSign", "src/layer/setting/IdCardSignPop.lua")
            else
                zc.tipInfo(zc.lang("tips_have_already_pass_certification"))
            end
        end
    })
    popBg:addChild(chengmiBtn)

    chengmiBtn:setVisible(false)
    if exchangeBtn then
        exchangeBtn:setPositionX(exchangeBtn:getPositionX() + 20)
    end
    reloginBtn:setPositionX(reloginBtn:getPositionX() - 20)
    
    self:show()
end
function SettingPop:clickButton(_node)

    local EFFECT_IS_OPEN = self._EFFECT_IS_OPEN
    local MUSIC_IS_OPEN = self._MUSIC_IS_OPEN
    _node._isRuning = true
    if tonumber(_node.state) == 1 then
        --move
        local _arr = {}
        for i = 1, 5 do
            _arr[#_arr+1] = cc.MoveBy:create(0.01, cc.p(62/5, 0))
        end
        --滑动完成结束操作
        _arr[#_arr+1] = cc.CallFunc:create(function()
            --改变状态
            _node.state = 2
            _node.greenBtn:setVisible(true)
            _node.grayBtn:setVisible(false)
            _node._isRuning = false
            --doing 
            if _node:getName() == "moveBtn_music" then
                --开启音乐
                self._MUSIC_IS_OPEN = true
                self:setMusic("music")
            elseif _node:getName() == "moveBtn_sound" then
                --开启音效
                self._EFFECT_IS_OPEN = true
                self:setMusic("sound")
            end
        end)
        _node:runAction(cc.Sequence:create(_arr))
    elseif tonumber(_node.state) == 2 then
        --move
        local _arr = {}
        for i = 1, 5 do
            _arr[#_arr+1] = cc.MoveBy:create(0.01, cc.p(-62/5, 0))
        end
        --滑动完成结束操作
        _arr[#_arr+1] = cc.CallFunc:create(function()
            --改变状态
            _node.state = 1
            _node.greenBtn:setVisible(false)
            _node.grayBtn:setVisible(true)
            _node._isRuning = false
            --doing 
            if _node:getName() == "moveBtn_music" then
                --关闭音乐
                self._MUSIC_IS_OPEN = false
                self:setMusic("music")
            elseif _node:getName() == "moveBtn_sound" then
                --关闭音效
                self._EFFECT_IS_OPEN = false
                self:setMusic("sound")
            end
        end)
        _node:runAction(cc.Sequence:create(_arr))
    end
end
function SettingPop:registerScriptHandler(_node)

    local EFFECT_IS_OPEN = self._EFFECT_IS_OPEN
    local MUSIC_IS_OPEN = self._MUSIC_IS_OPEN

    --开始注册点击事件
    local listener = cc.EventListenerTouchOneByOne:create()
    listener:setSwallowTouches(false)
    --触摸开始
    local _beginPosX = 0
    listener:registerScriptHandler(function(touch, event)
        local point = _node:getParent():convertToNodeSpace(touch:getLocation())
        if cc.rectContainsPoint(_node:getContentSize(), point ) then 
            _beginPosX = touch:getLocation().x
            return true
        end
    end, cc.Handler.EVENT_TOUCH_BEGAN)
    --触摸滑动
    listener:registerScriptHandler(function(touch, event)
    end, cc.Handler.EVENT_TOUCH_MOVED)
    --触摸结束
    listener:registerScriptHandler(function(touch, event)
            local move_dis = tonumber(touch:getLocation().x)-tonumber(_beginPosX)
            if math.abs(move_dis) > 10 then
                --向右滑动(开启)
                if move_dis > 0 then
                    if tonumber(_node.state) == 1 then
                        --move
                        local _arr = {}
                        for i = 1, 5 do
                            _arr[#_arr+1] = cc.MoveBy:create(0.01, cc.p(62/5, 0))
                        end
                        --滑动完成结束操作
                        _arr[#_arr+1] = cc.CallFunc:create(function()
                            --改变状态
                            _node.state = 2
                            _node.greenBtn:setVisible(true)
                            _node.grayBtn:setVisible(false)
                            --doing 
                            if _node:getName() == "moveBtn_music" then
                                --开启音乐
                                MUSIC_IS_OPEN = true
                                self:setMusic("music")
                            elseif _node:getName() == "moveBtn_sound" then
                                --开启音效
                                EFFECT_IS_OPEN = true
                                self:setMusic("sound")
                            end
                        end)
                        _node:runAction(cc.Sequence:create(_arr))
                    end
                --向左滑动(关闭)
                elseif move_dis < 0 then
                    if tonumber(_node.state) == 2 then
                        --move
                        local _arr = {}
                        for i = 1, 5 do
                            _arr[#_arr+1] = cc.MoveBy:create(0.01, cc.p(-62/5, 0))
                        end
                        --滑动完成结束操作
                        _arr[#_arr+1] = cc.CallFunc:create(function()
                            --改变状态
                            _node.state = 1
                            _node.greenBtn:setVisible(false)
                            _node.grayBtn:setVisible(true)
                            --doing 
                            if _node:getName() == "moveBtn_music" then
                                --关闭音乐
                                MUSIC_IS_OPEN = false
                                self:setMusic("music")
                            elseif _node:getName() == "moveBtn_sound" then
                                --关闭音效
                                EFFECT_IS_OPEN = false
                                self:setMusic("sound")
                            end
                        end)
                        _node:runAction(cc.Sequence:create(_arr))
                    end
                end
            end
    end, cc.Handler.EVENT_TOUCH_ENDED)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    --给精灵添加点击事件
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, _node)
end
function SettingPop:setMusic(_type)
    local EFFECT_IS_OPEN = self._EFFECT_IS_OPEN
    local MUSIC_IS_OPEN = self._MUSIC_IS_OPEN
    if _type == "music" then
        if MUSIC_IS_OPEN then
            musicManager.setMusicEnable(true)
        else
            musicManager.setMusicEnable(false)
        end
    elseif _type == "sound" then
        if EFFECT_IS_OPEN then
            musicManager.setEffectEnable(true)
        else
            musicManager.setEffectEnable(false)
        end
    end
end
function SettingPop:createOpenBtn(_node, _pos)
    local grayBtn = zc.createImageView({
        src = "res/Main/setting/btn_open_d.png",
        pos = _pos,
    })
    _node:addChild(grayBtn)
    local greenBtn = zc.createImageView({
        src = "res/Main/setting/btn_open_u.png",
        pos = _pos,
    })
    _node:addChild(greenBtn)
    return greenBtn, grayBtn
end


function SettingPop:onCleanup()
    -- print("onCleanup ====")
end


return SettingPop