--[[
    FileName: WeaponClearLayer.lua
    Author: andong
    Date: 2016-07-06
    Purpose: 兵器洗练
]]
local WeaponClearLayer = class( "WeaponClearLayer", function ()
    return ZCDialog:create(200)
end)
function WeaponClearLayer:create(params)
    return WeaponClearLayer.new(params)
end
function WeaponClearLayer:onCleanup()
    zc.autoShowFightingChange()
end
function WeaponClearLayer:ctor(params)
    self:initData(params)
    self:initUI()
    self:show()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12905 then
        zc.setGuideFuncNextStep(_currentGID, false)
        LayerManager.addShieldLayout(nil, 0.3)
        performWithDelay(self, function()
            getGuideManager():setObjTarget(self._clearBtn)
            getGuideManager():startGuide()
        end, 0.3)
    end
end
function WeaponClearLayer:initData(params)
    self._nowWeapon = table.copy(params.nowWeapon)
    self._targetWeapon = table.copy(params.targetWeapon)
    self._tag = params.tag ----1洗练 2转移
end
function WeaponClearLayer:initUI()
    local popBg = cc.Sprite:create("res/Main/ornaments/replaceAttr_bg.png")
    popBg:setAnchorPoint(cc.p(0.5,0.5))
    popBg:setPosition(zc.width/2, zc.height/2-10)
    self:addChild(popBg)
    self._popBg = popBg
    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-40, popBg:getContentSize().height-10),
        listener = function () 
            LayerManager.removeLayout()
        end,
    })
    popBg:addChild(close)

    local _bg = zc.createImageView({
        src = "res/Main/ornaments/replaceAttr_bg_1.png",
        ap = cc.p(0.5,1),
        pos = cc.p(zc.width/2, popBg:getContentSize().height-20)
    })
    popBg:addChild(_bg)
    self._bg = _bg

    --洗炼或者转移中间标题 
    local _strPath = "res/Main/ornaments/trinket_title_zy.png"
    if self._tag == 1 then
        _strPath = "res/Main/ornaments/trinket_title_xl.png"
    end
    local _title_xl = zc.createImageView({
        src =  _strPath,
        pos = cc.p(_bg:getBoundingBox().width/2+50, _bg:getBoundingBox().height/2-40),
    })
    _bg:addChild(_title_xl,9)
    self._title_xl = _title_xl

    self:createEffectInfo()
    
    --
    self:createButton()
    --
    if self._tag == 2 then
        self:createZhuanyiAction()
    else
        --左侧提示
        local _left_text_bg = cc.Sprite:create("res/Main/ornaments/trinket_text_bg.png")
        _left_text_bg:setPosition(50, 19)
        _left_text_bg:setAnchorPoint(cc.p(0,0.5))
        _bg:addChild(_left_text_bg)
        local _left_tips = zc.createLabel({
            text = zc.lang("please_select_property_xilian"),
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(80, 15),
            color = cc.c3b( 217, 202, 169 ),
            outLine = true,
        })
        _left_text_bg:addChild(_left_tips)

        --右侧提示
        local _right_text_bg = cc.Sprite:create("res/Main/ornaments/trinket_text_bg.png")
        _right_text_bg:setPosition(_bg:getBoundingBox().width/2, 19)
        _right_text_bg:setAnchorPoint(cc.p(0,0.5))
        _bg:addChild(_right_text_bg)
        local _right_tips = zc.createLabel({
            text = zc.lang("xilian_cover_origin_property"),
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(180, 15),
            color = cc.c3b( 217, 202, 169 ),
            outLine = true,
        })
        _right_text_bg:addChild(_right_tips)
    end
end
function WeaponClearLayer:createZhuanyiAction()
    local _arrow_bg = cc.Sprite:create()
    _arrow_bg:setContentSize(self._title_xl:getContentSize())
    _arrow_bg:setPosition(self._title_xl:getContentSize().width/2, self._title_xl:getContentSize().height/2)
    self._title_xl:addChild(_arrow_bg)
    self._arrow_bg = _arrow_bg
    local _arrow_1 = cc.Sprite:create("res/Main/ornaments/trinket_arrow_1.png")
    _arrow_1:setPosition(85, 173)
    _arrow_bg:addChild(_arrow_1)
    _arrow_1:setOpacity(100)
    self._arrow_1 = _arrow_1
    local _arrow_2 = cc.Sprite:create("res/Main/ornaments/trinket_arrow_1.png")
    _arrow_2:setScale(-1)
    _arrow_2:setPosition(120, 10)
    _arrow_bg:addChild(_arrow_2)
    _arrow_2:setOpacity(100)
    self._arrow_2 = _arrow_2
    local leftLight = zc.createSprite("res/Main/ornaments/trinket_choosedBox_big_left.png")
    leftLight:setAnchorPoint(0, 0.5)
    leftLight:setPosition(-5, self._left_bg_s_1:getContentSize().height/2-43)
    self._left_bg_s_1:addChild(leftLight)
    local rightLight = zc.createSprite("res/Main/ornaments/trinket_choosedBox_big_right.png")
    rightLight:setAnchorPoint(1, 0.5)
    rightLight:setPosition(self._right_bg_s_1:getContentSize().width+60, self._right_bg_s_1:getContentSize().height/2-43)
    self._right_bg_s_1:addChild(rightLight)
    local _seq = cc.Sequence:create(cc.FadeTo:create(1.0,50),cc.FadeTo:create(1.0,255))
    rightLight:runAction(cc.RepeatForever:create(_seq))
    local _seq = cc.Sequence:create(cc.FadeTo:create(1.0,50),cc.FadeTo:create(1.0,255))
    leftLight:runAction(cc.RepeatForever:create(_seq))
    self._right_light = rightLight
    self._left_light = leftLight
end

function WeaponClearLayer:createButton()
    local _bg_1 = self._popBg
    if self._tag == 1 then
        --撤销按钮
        local _revokeBtn = zc.createCommomBtn({
            tag = 2,
            text = zc.lang("revoke_2"),
            pos = cc.p(200, 45), 
            listener = function () 
                zc.sendHttp({
                    apiName = "Weapon_cancle_clear",
                    params = {weaponId=self._targetWeapon["id"],stuffWeaponId=self._nowWeapon["id"]},
                    successCallback = function (net_data)
                        PlayerData:updataData(net_data)
                        --去掉保存数据
                        zc.saveFightingChange()
                        self._needRefreshData = false
                        local SmithyClear = zc.getScene("SmithyClear")
                        if  SmithyClear then
                            SmithyClear:setChangeIdx(nil)
                        end
                        LayerManager.removeLayout()
                    end,
                })
            end,
        })
        _bg_1:addChild(_revokeBtn)
        _revokeBtn:setVisible(false)
        local priceInfo = gameData.getDataFromCache("consume_price", {["type"]=36} )
        if priceInfo and priceInfo["price"] then
            local gold10 = zc.createSprite(zc.getImgByType(1))
            gold10:setAnchorPoint(0, 0.5)
            gold10:setPosition(_revokeBtn:getPositionX()+_revokeBtn:getContentSize().width/2+20, _revokeBtn:getPositionY() )
            _bg_1:addChild(gold10)
            _revokeBtn.gold10 = gold10
            gold10:setVisible(false)
            local goldNum1 = zc.createLabel({
                text = priceInfo["price"],
                outLine = true,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(gold10:getContentSize().width+10, gold10:getContentSize().height/2),
                pixel = 1.3
            })
            gold10:addChild(goldNum1)
        end

        --洗练按钮 (洗练的时候删除被洗装备，先不更新兵器数据，在oncleanUp里面更新兵器数据，如果撤消的时候相当于没有变化)
        local clearBtn = zc.createCommomBtn({
            tag = 1,
            text = zc.lang("xilian_2"),
            pos = cc.p(_bg_1:getBoundingBox().width-110, 45), 
            endCallback = function ()
                for i = 1, #self._left_extAttr_bg do
                    local selectBg = self._left_extAttr_bg[i]:getChildByName("_left_choosedBox_1")
                    selectBg:setTouchEndedCall(function() end)
                end
                local SmithyClear = zc.getScene("SmithyClear")
                if  SmithyClear then
                    SmithyClear:setChangeIdx(self._selectIdx)
                end
                zc.sendHttp({
                    apiName = "Weapon_clear",
                    params = {id=self._targetWeapon["id"],stuffId=self._nowWeapon["id"],index=self._selectIdx},
                    successCallback = function (data)
                        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_12906 then
                            zc.setGuideFuncNextStep(_currentGID, false)
                            getGuideManager():addMaskLayer()
                        end
                        PlayerData:updataData(data)
                        PlayerData:subWeapon(self._nowWeapon["id"])
                        -- dump(data, "clear data ==================== ")
                        --更新属性
                        if data["weaponEtt"] then
                            for i = 1, 6 do
                                if data["weaponEtt"]["teffectId"..i] then
                                    self._targetWeapon["teffectColor"..i] = data["weaponEtt"]["teffectColor"..i]
                                    self._targetWeapon["teffectId"..i]    = data["weaponEtt"]["teffectId"..i]
                                    self._targetWeapon["teffectValue"..i] = data["weaponEtt"]["teffectValue"..i]
                                end
                            end
                        end
                        self._needRefreshData = true
                        self._clearBtn:setTouchEndedCall(function()  end)
                        
                        --动画
                        local action = {}
                        local totalList = #self._actionList
                        local replaceId = tonumber(data["replaceId"])
                        for i=1,#self._actionList do
                            local tag = self._actionList[i]:getTag()
                            if replaceId == tag then
                                replaceId = i
                                break
                            end
                        end
                        local actionNum = totalList*4 + replaceId
                        for i=1,actionNum do
                            local idx = i - math.floor((i-1)/totalList)*totalList
                            action[i] = idx
                        end
                        local _arr = {}
                        for i = 2,actionNum do
                            local nowIdx = action[i]
                            _arr[#_arr+1] = cc.CallFunc:create(function() 
                                if i > 1 then
                                    local lastIdx = action[i-1]
                                    self._actionList[lastIdx]:setVisible(false)
                                end
                            end)
                            local _delay = 0.05
                            if i < actionNum - 3 then
                                _delay = 0.1
                            else
                                _delay = 0.1 + (i+3-actionNum)*0.02
                            end
                            _arr[#_arr+1] = cc.DelayTime:create(_delay)
                            _arr[#_arr+1] = cc.CallFunc:create(function()
                                self._actionList[nowIdx]:setVisible(true)
                            end)
                            _arr[#_arr+1] = cc.DelayTime:create(_delay)
                        end
                        _arr[#_arr+1] = cc.CallFunc:create(function()
                            --交换
                            local _left_extAttr_bg = self._left_extAttr_bg[self._selectIdx]
                            local _left_extAttr_1 = _left_extAttr_bg:getChildByName("_left_extAttr_1")
                            local _right_bg_s = self._right_extAttr_bg[replaceId]
                            local _right_extAttr_1 = _right_bg_s:getChildByName("_right_extAttr_1")
                            local targetPos = _left_extAttr_bg:convertToWorldSpace(cc.p(_left_extAttr_1:getPositionX(),_left_extAttr_1:getPositionY()))
                            local nowPos = _right_bg_s:convertToWorldSpace(cc.p(_right_extAttr_1:getPositionX(),_right_extAttr_1:getPositionY()))
                            local exchangeLab = zc.createLabel({
                                text = _right_extAttr_1:getString(),
                                outLine = true,
                                fontSize = 24,
                                ap = cc.p(0, 0.5),
                                pos = cc.p(nowPos.x,nowPos.y),
                                color = _right_extAttr_1:getColor(),
                                pixel = 1.3
                            })
                            self:addChild(exchangeLab)
                            self._exchangeLab = exchangeLab
                            exchangeLab:runAction(
                                cc.Sequence:create(
                                cc.Spawn:create(
                                    cc.MoveBy:create(0.8,cc.p(targetPos.x-nowPos.x,targetPos.y-nowPos.y)),
                                    cc.Sequence:create(cc.ScaleTo:create(0.4,1.5),cc.ScaleTo:create(0.4,1))
                                ),
                                cc.CallFunc:create(function() _left_extAttr_1:setVisible(false) end),
                                cc.CallFunc:create(function()
                                        zc.numChangeAnimation({
                                            label = exchangeLab,
                                            pos = cc.p( exchangeLab:getContentSize().width/2, 20 ),
                                            callback = function()
                                            end
                                        })
                                        zc.autoShowFightingChange()
                                end)))
                        end)
                        _arr[#_arr+1] = cc.CallFunc:create(function()
                            local _currentGID = getGuideManager():getCurrentGID()
                            if _currentGID == GuideKey.KEY_12907 then
                                getGuideManager():setObjTarget(self._clearBtn)
                                getGuideManager():startGuide()
                                getGuideManager():removeMaskLayer()
                            end
                            self._clearBtn:setText(zc.lang("finish_2"))
                            _revokeBtn:setVisible(true)
                            if _revokeBtn.gold10 then
                                _revokeBtn.gold10:setVisible(true)
                            end
                            self._clearBtn:setTouchEndedCall(function() 
                                local _currentGID = getGuideManager():getCurrentGID()
                                if _currentGID == GuideKey.KEY_12907 then
                                    zc.setGuideFuncNextStep(_currentGID, false)
                                end
                                LayerManager.removeLayout()
                            end)
                        end)

                        self:runAction(cc.Sequence:create(_arr))
                    end,
                })
            end,
        })
        _bg_1:addChild(clearBtn, 10)
        self._clearBtn = clearBtn

        local huafei_xilian = zc.createSprite(zc.getImgByType(2))
        huafei_xilian:setPosition(_bg_1:getBoundingBox().width-280, 45)
        _bg_1:addChild(huafei_xilian)
        local huafei_xilianNum = zc.createLabel({
            text = self._targetWeapon["replacePrice"],
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(huafei_xilian:getPositionX()+huafei_xilian:getContentSize().width/2, huafei_xilian:getPositionY()),
            outLine = true,
            color = display.COLOR_WHITE ,
        })
        _bg_1:addChild(huafei_xilianNum)

    elseif self._tag == 2 then
        --转移按钮
        local exchangeBtn = zc.createCommomBtn({
            tag = 1,
            text = zc.lang("transfer_2"),
            pos = cc.p(_bg_1:getBoundingBox().width-110, 45), 
            endCallback = function ()
                zc.sendHttp({
                    apiName = "Weapon_swapAttr",
                    params = {weaponId=self._targetWeapon["id"],stuffWeaponId=self._nowWeapon["id"]},
                    successCallback = function (data)
                        PlayerData:updataData(data)
                        self._exchangeBtn:setEnable(false)
                        self._exchangeBtn:setText(zc.lang("already_transfer"))
                        --附加属性互换
                        for i = 1, 6 do
                            local teffectId    = self._targetWeapon["teffectId"..i]
                            if teffectId then
                                local teffectColor = self._targetWeapon["teffectColor"..i]
                                local teffectValue = self._targetWeapon["teffectValue"..i]
                                self._targetWeapon["teffectColor"..i] = self._nowWeapon["teffectColor"..i]
                                self._targetWeapon["teffectId"..i]    = self._nowWeapon["teffectId"..i]
                                self._targetWeapon["teffectValue"..i] = self._nowWeapon["teffectValue"..i]
                                self._nowWeapon["teffectColor"..i] = teffectColor
                                self._nowWeapon["teffectId"..i]    = teffectId
                                self._nowWeapon["teffectValue"..i] = teffectValue
                            end
                        end
                        --更新属性
                        PlayerData:updateWeaponsInfoById(self._targetWeapon)
                        PlayerData:updateWeaponsInfoById(self._nowWeapon)
                        self._right_light:setOpacity(255)
                        self._left_light:setOpacity(255)
                        self._left_light:stopAllActions()
                        self._right_light:stopAllActions()

                        self._arrow_1:setOpacity(255)
                        self._arrow_2:setOpacity(255)
                        self._arrow_bg:runAction(cc.Sequence:create(
                            cc.RotateBy:create(0.8,-120),
                            cc.CallFunc:create( function() 
                                self:initLeftTrinketExtAttr()
                                self:initRightTrinketExtAttr()
                            end)
                        ))
                    end,
                })
            end,
        })
        _bg_1:addChild(exchangeBtn, 10)
        self._exchangeBtn = exchangeBtn 
        local huafei_zhuanyi = zc.createSprite(zc.getImgByType(2))
        huafei_zhuanyi:setPosition(_bg_1:getBoundingBox().width-280, 45)
        _bg_1:addChild(huafei_zhuanyi)
        local huafei_zhuanyiNum = zc.createLabel({
            text = self._targetWeapon["transferPrice"],
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(huafei_zhuanyi:getPositionX()+huafei_zhuanyi:getContentSize().width/2, huafei_zhuanyi:getPositionY()),
            outLine = true,
            color = display.COLOR_WHITE ,
        })
        _bg_1:addChild(huafei_zhuanyiNum)
    end

end
function WeaponClearLayer:createEffectInfo()

    local _bg =  self._bg
    local leftWeapon = self._targetWeapon
    --左侧
    local _left_bg_s = cc.Sprite:create()
    _left_bg_s:setContentSize(cc.size(324,407))
    _left_bg_s:setPosition(50, _bg:getContentSize().height-10)
    _left_bg_s:setAnchorPoint(cc.p(0,1))
    _bg:addChild(_left_bg_s)
    --左侧icon
    --统一创建
    local _level = zc.getWeaponLevel(leftWeapon.id)
    local icon_left = zc.createIconByData({
        data = {
            mainType = zc.mainTypeWeapon,
            type = 1,
            id = leftWeapon.weaponId,
            quality = leftWeapon.color,
            level = zc.getLevelTipShow().._level, --主键id
        }, 
        showLevel = true,
        pos = cc.p( 10, _left_bg_s:getBoundingBox().height-5), 
    })
    icon_left:setScale(80/120)
    icon_left:setAnchorPoint(cc.p(0,1))
    _left_bg_s:addChild(icon_left)
    --名称
    local _trinketName = zc.createLabel({
        text = leftWeapon.name,
        fontSize = 24,
        ap = cc.p(0, 1),
        pos = cc.p(100, _left_bg_s:getBoundingBox().height-10),
        color = zc.getColorByQuality(leftWeapon.color),
        outLine = true,
    })
    _left_bg_s:addChild(_trinketName)
    local equiped = zc.createLabel({
        text = "(" .. zc.lang("equiped") .. ")",
        outLine = true,
        fontSize = 24,
        ap = cc.p(0, 1),
        pos = cc.p(_trinketName:getPositionX()+_trinketName:getContentSize().width, _trinketName:getPositionY()),
        pixel = 1.3
    })
    _left_bg_s:addChild(equiped)
    --属性背景
    self._left_bg_s_1 = _left_bg_s
    --创建左侧附加属性
    self:initLeftTrinketExtAttr()

    --右侧
    local rightWeapon = self._nowWeapon
    local _right_bg_s = cc.Sprite:create()
    _right_bg_s:setContentSize(cc.size(324,407))
    _right_bg_s:setPosition(_bg:getContentSize().width-20, _bg:getContentSize().height-10)
    _right_bg_s:setAnchorPoint(cc.p(1,1))
    _bg:addChild(_right_bg_s)
    --属性背景
    self._right_bg_s_1 = _right_bg_s

     --右侧icon
     --统一创建饰品
    local _level = zc.getWeaponLevel(rightWeapon.id)
    local icon_right = zc.createIconByData({
        data = {
            mainType = zc.mainTypeWeapon,
            type = 1,
            id = rightWeapon.weaponId,
            quality = rightWeapon.color,
            level = zc.getLevelTipShow().._level, --主键id
        }, 
        showLevel = true,
        pos = cc.p( 10, _right_bg_s:getBoundingBox().height-5), 
    })
    icon_right:setScale(80/120)
    icon_right:setAnchorPoint(cc.p(0,1))
    _right_bg_s:addChild(icon_right)
    --名称
    local _trinketName = zc.createLabel({
        text = rightWeapon.name,
        fontSize = 24,
        ap = cc.p(0, 1),
        pos = cc.p(100, _right_bg_s:getBoundingBox().height-10),
        color = zc.getColorByQuality(rightWeapon.color),
        outLine = true,
    })
    _right_bg_s:addChild(_trinketName)  

    --创建右侧附加属性
    self:initRightTrinketExtAttr()
end

--创建左侧附加属性
function WeaponClearLayer:initLeftTrinketExtAttr()
    if self._left_extAttr_bg and next(self._left_extAttr_bg) then
        for i = 1, #self._left_extAttr_bg do
            self._left_extAttr_bg[i]:removeFromParent()
        end
    end
    self._left_extAttr_bg = {}

    local leftWeapon = self._targetWeapon
    local teffectNum = 6
    for i = 1, teffectNum do
        if self._left_bg_s_1:getChildByName("_left_extAttr_bg_s_1"..i) then
            self._left_bg_s_1:getChildByName("_left_extAttr_bg_s_1"..i):removeFromParent()
        end
        local _id = i
        local _str_effectId = "teffectId" .. _id
        local _str_effectValue = "teffectValue" .. _id
        local _str_color = "teffectColor".._id

        local _left_extAttr = ""
        local _isEmpty = false

        if not leftWeapon[_str_effectId] or tonumber(leftWeapon[_str_effectId]) == 0 then 
            _left_extAttr = zc.lang("empty")
            _isEmpty = true
            if not self._selectIdx then
                self._selectIdx = _id
            end
        else
            local effectNum = zc.getAttributeNumById(leftWeapon[_str_effectId],leftWeapon[_str_effectValue])
            _left_extAttr = LANGUAGE_getAttributeTextById(leftWeapon[_str_effectId]).."："..effectNum
        end
        if _id == teffectNum and not self._selectIdx then
            self._selectIdx = _id
        end
        if _isEmpty and self._tag == 2 then
            break
        end

         --属性背景
        local _str = "res/Main/ornaments/trinket_attr_bg_1.png"
        if _id % 2 == 0 then
            _str = "res/Main/ornaments/trinket_attr_bg_2.png"
        end
        local _left_extAttr_bg_s_1 = cc.Sprite:create(_str)
        _left_extAttr_bg_s_1:setPosition(0, self._left_bg_s_1:getBoundingBox().height-99 - (tonumber(_id)-1)*48)
        _left_extAttr_bg_s_1:setAnchorPoint(cc.p(0,1))
        _left_extAttr_bg_s_1:setName("_left_extAttr_bg_s_1"..i)
        self._left_bg_s_1:addChild(_left_extAttr_bg_s_1,2)
        self._left_extAttr_bg[#self._left_extAttr_bg+1] = _left_extAttr_bg_s_1

        --选中框
        local _sprite_box = cc.Sprite:create("res/Main/common/check_bg2.png")
        _sprite_box:setPosition(10, 25)
        _sprite_box:setAnchorPoint(cc.p(0, 0.5))
        _left_extAttr_bg_s_1:addChild(_sprite_box)
        
        --属性1
        local _left_extAttr_1 = zc.createLabel({
            text = _left_extAttr,
            fontSize = 24,
            ap = cc.p(0, 0.5),
            pos = cc.p(80, 25),
            outLine = true,
            color = _isEmpty and display.COLOR_WHITE or zc.getColorByQuality(leftWeapon[_str_color]),
        })
        _left_extAttr_1:setName("_left_extAttr_1")
        _left_extAttr_bg_s_1:addChild(_left_extAttr_1,2)
        
        --小箭头1
        local _left_arrow_1 = zc.createImageView({
            src = "res/Main/common/check.png",
            pos = cc.p(10, 25),
            ap = cc.p(0, 0.5),
        })
        _left_arrow_1:setScale( 0.6 )
        _left_extAttr_bg_s_1:addChild(_left_arrow_1,2)
        _left_arrow_1:setVisible(false)
        --选中框1
        local _left_choosedBox_1
        _left_choosedBox_1 = zc.createPushButton({
            disableFile = "res/Main/ornaments/trinket_choosedBox.png",
            needSwallow = false,
            endCallback = function()
                if self._selectIdx == _id then
                    return
                end
                self._selectIdx = _id
                self._select_box:setEnable(true)
                _left_choosedBox_1:setEnable(false)
                self._select_box = _left_choosedBox_1
                self._select_arrow:setVisible(false)
                _left_arrow_1:setVisible(true)
                self._select_arrow = _left_arrow_1
            end,
            anchor = cc.p(0, 0.5),
            pos = cc.p(0, 25)
        })
        _left_choosedBox_1:setName("_left_choosedBox_1")
        _left_extAttr_bg_s_1:addChild(_left_choosedBox_1)

        if self._selectIdx and _id == self._selectIdx then
            _left_choosedBox_1:setEnable(false)
            _left_arrow_1:setVisible(true)
            self._select_box = _left_choosedBox_1
            self._select_arrow = _left_arrow_1
        end
        
        if self._tag == 2 then
            _sprite_box:setVisible(false)
            _left_choosedBox_1:setVisible(false)
            _left_arrow_1:setVisible(false)
        end

        if _isEmpty then
            break
        end
    end
end
--创建右侧附加属性
function WeaponClearLayer:initRightTrinketExtAttr()
    if self._right_extAttr_bg and next(self._right_extAttr_bg) then
        for i = 1, #self._right_extAttr_bg do
            self._right_extAttr_bg[i]:removeFromParent()
        end
    end
    self._actionList = {}
    self._right_extAttr_bg = {}

    local rightWeapon = self._nowWeapon
    local teffectInfoList = {}
    for i = 1, 6 do
        local teffectId = rightWeapon["teffectId"..i]
        if teffectId and tonumber(teffectId) > 0 then
            local idx = #teffectInfoList + 1
            teffectInfoList[idx] = {}
            teffectInfoList[idx].teffectId    = rightWeapon["teffectId"..i]
            teffectInfoList[idx].teffectValue = rightWeapon["teffectValue"..i]
            teffectInfoList[idx].teffectColor = rightWeapon["teffectColor"..i]
            teffectInfoList[idx].idx = i
        end
    end
    table.sort( teffectInfoList, function( a,b )
        local _aColor = tonumber(a.teffectColor)
        local _bColor = tonumber(b.teffectColor)
        if  _aColor ~= _bColor then
            return _aColor > _bColor
        else
            return tonumber(a.teffectId) < tonumber(b.teffectId)
        end
    end)

    for i = 1, #teffectInfoList do
        local _v = teffectInfoList[i]
        if self._right_bg_s_1:getChildByName("_right_extAttr_bg_s_1"..i) then
            self._right_bg_s_1:getChildByName("_right_extAttr_bg_s_1"..i):removeFromParent()
        end

        local _str_effectId = _v["teffectId"]
        local _str_effectValue = _v["teffectValue"]
        local _str_color = _v["teffectColor"]
        local _isEmpty = false
        local _right_extAttr_text_1 = ""
        if not _str_effectId or tonumber(_str_effectId) == 0 then 
            _right_extAttr_text_1 = zc.lang("empty")
            _isEmpty = true
        else
            local effectNum = zc.getAttributeNumById(_str_effectId,_str_effectValue)
            _right_extAttr_text_1 =  LANGUAGE_getAttributeTextById(_str_effectId).."："..effectNum
        end
        if not _isEmpty then
             --属性背景
            local _right_extAttr_bg_s_1 = zc.createScale9Sprite({
                size = cc.size(280, 47),
                file = "res/Main/common/img_empty.png",
                pos = cc.p(0, self._right_bg_s_1:getBoundingBox().height-99 - (i-1)*48),
            })
            _right_extAttr_bg_s_1:setName("_right_extAttr_bg_s_1"..i)
            _right_extAttr_bg_s_1:setAnchorPoint(cc.p(0,1))
            self._right_bg_s_1:addChild(_right_extAttr_bg_s_1,2)
            self._right_extAttr_bg[#self._right_extAttr_bg+1] = _right_extAttr_bg_s_1
             local _str = "res/Main/ornaments/trinket_attr_bg_1.png"
            if i % 2 == 0 then
                _str = "res/Main/ornaments/trinket_attr_bg_2.png"
            end
            local _right_extAttr_ = cc.Sprite:create(_str)
            _right_extAttr_:setAnchorPoint(cc.p(0.5,0.5))
            _right_extAttr_:setPosition(_right_extAttr_bg_s_1:getContentSize().width/2, _right_extAttr_bg_s_1:getContentSize().height/2)
            _right_extAttr_bg_s_1:addChild(_right_extAttr_)
            _right_extAttr_:setScaleX(-1)
            
            --属性1
            local _right_extAttr_1 = zc.createLabel({
                text = _right_extAttr_text_1,
                fontSize = 24,
                ap = cc.p(0, 0.5),
                pos = cc.p(80, 25),
                outLine = true,
                color = _isEmpty and display.COLOR_WHITE or zc.getColorByQuality(_str_color),
            })
            _right_extAttr_1:setName("_right_extAttr_1")
            _right_extAttr_bg_s_1:addChild(_right_extAttr_1,2)

            --选中框1
            local _right_choosedBox_1 = zc.createImageView({
                src = "res/Main/ornaments/trinket_choosedBox.png",
                pos = cc.p(380, 25),
                ap = cc.p(0, 0.5),
            })
            _right_choosedBox_1:setScaleX(-1)
            _right_choosedBox_1:setTag(_v["idx"])
            _right_extAttr_bg_s_1:addChild(_right_choosedBox_1)
            _right_choosedBox_1:setVisible(false)
            if self._tag == 1 then
                if i == 1 then
                    _right_choosedBox_1:setVisible(true)
                else
                    _right_choosedBox_1:setVisible(false)
                end
            end
            self._actionList[#self._actionList+1] = _right_choosedBox_1
        end
    end
end

function WeaponClearLayer:onCleanup()
    if self._targetWeapon and self._needRefreshData then
        PlayerData:updateWeaponsInfoById(self._targetWeapon)
    end
end

return WeaponClearLayer